// This is a mutant program.
// Author : ysma

package org.apache.tools.ant;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintStream;
import java.io.StringReader;
import java.util.Date;
import java.text.DateFormat;
import org.apache.tools.ant.util.DateUtils;
import org.apache.tools.ant.util.StringUtils;
import org.apache.tools.ant.util.FileUtils;


public class DefaultLogger implements org.apache.tools.ant.BuildLogger
{

    public static final int LEFT_COLUMN_SIZE = 12;

    protected java.io.PrintStream out;

    protected java.io.PrintStream err;

    protected int msgOutputLevel = Project.MSG_ERR;

    private long startTime = System.currentTimeMillis();

    protected static final java.lang.String lSep = StringUtils.LINE_SEP;

    protected boolean emacsMode = false;

    public DefaultLogger()
    {
    }

    public  void setMessageOutputLevel( int level )
    {
        this.msgOutputLevel = level;
    }

    public  void setOutputPrintStream( java.io.PrintStream output )
    {
        this.out = new java.io.PrintStream( output, true );
    }

    public  void setErrorPrintStream( java.io.PrintStream err )
    {
        this.err = new java.io.PrintStream( err, true );
    }

    public  void setEmacsMode( boolean emacsMode )
    {
        this.emacsMode = emacsMode;
    }

    public  void buildStarted( org.apache.tools.ant.BuildEvent event )
    {
        startTime = System.currentTimeMillis();
    }

    static  void throwableMessage( java.lang.StringBuffer m, java.lang.Throwable error, boolean verbose )
    {
        while (error instanceof org.apache.tools.ant.BuildException) {
            java.lang.Throwable cause = error.getCause();
            if (cause == null) {
                break;
            }
            java.lang.String msg1 = error.toString();
            java.lang.String msg2 = cause.toString();
            if (msg1.endsWith( msg2 )) {
                m.append( msg1.substring( 0, msg1.length() - msg2.length() ) );
                error = cause;
            } else {
                break;
            }
        }
        if (verbose || !(error instanceof org.apache.tools.ant.BuildException)) {
            m.append( StringUtils.getStackTrace( error ) );
        } else {
            m.append( error ).append( lSep );
        }
    }

    public  void buildFinished( org.apache.tools.ant.BuildEvent event )
    {
        java.lang.Throwable error = event.getException();
        java.lang.StringBuffer message = new java.lang.StringBuffer();
        if (error == null) {
            message.append( StringUtils.LINE_SEP );
            message.append( getBuildSuccessfulMessage() );
        } else {
            message.append( StringUtils.LINE_SEP );
            message.append( getBuildFailedMessage() );
            message.append( StringUtils.LINE_SEP );
            throwableMessage( message, error, Project.MSG_VERBOSE <= msgOutputLevel );
        }
        message.append( StringUtils.LINE_SEP );
        message.append( "Total time: " );
        message.append( formatTime( System.currentTimeMillis() - startTime ) );
        java.lang.String msg = message.toString();
        if (error == null) {
            printMessage( msg, out, Project.MSG_VERBOSE );
        } else {
            printMessage( msg, err, Project.MSG_ERR );
        }
        log( msg );
    }

    protected  java.lang.String getBuildFailedMessage()
    {
        return "BUILD FAILED";
    }

    protected  java.lang.String getBuildSuccessfulMessage()
    {
        return "BUILD SUCCESSFUL";
    }

    public  void targetStarted( org.apache.tools.ant.BuildEvent event )
    {
        if (Project.MSG_INFO <= msgOutputLevel && !event.getTarget().getName().equals( "" )) {
            java.lang.String msg = StringUtils.LINE_SEP + event.getTarget().getName() + ":";
            printMessage( msg, out, event.getPriority() );
            log( msg );
        }
    }

    public  void targetFinished( org.apache.tools.ant.BuildEvent event )
    {
    }

    public  void taskStarted( org.apache.tools.ant.BuildEvent event )
    {
    }

    public  void taskFinished( org.apache.tools.ant.BuildEvent event )
    {
    }

    public  void messageLogged( org.apache.tools.ant.BuildEvent event )
    {
        int priority = event.getPriority();
        if (priority <= msgOutputLevel) {
            java.lang.StringBuffer message = new java.lang.StringBuffer();
            if (event.getTask() != null && !emacsMode) {
                java.lang.String name = event.getTask().getTaskName();
                java.lang.String label = "[" + name + "] ";
                int size = LEFT_COLUMN_SIZE - label.length();
                java.lang.StringBuffer tmp = new java.lang.StringBuffer();
                for (int i = 0; i < size; i++) {
                    tmp.append( " " );
                }
                tmp.append( label );
                label = tmp.toString();
                java.io.BufferedReader r = null;
                try {
                    r = new java.io.BufferedReader( new java.io.StringReader( event.getMessage() ) );
                    java.lang.String line = r.readLine();
                    boolean first = true;
                    do {
                        if (first) {
                            if (line == null) {
                                message.append( label );
                                break;
                            }
                        } else {
                            message.append( StringUtils.LINE_SEP );
                        }
                        first = false;
                        message.append( label ).append( line );
                        line = r.readLine();
                    } while (line != null);
                } catch ( java.io.IOException e ) {
                    message.append( label ).append( event.getMessage() );
                } finally 
{
                    if (r != null) {
                        FileUtils.close( r );
                    }
                }
            } else {
                message.append( event.getMessage() );
            }
            java.lang.Throwable ex = event.getException();
            if (Project.MSG_DEBUG <= msgOutputLevel && ex != null) {
                message.append( StringUtils.getStackTrace( ex ) );
            }
            java.lang.String msg = message.toString();
            if (priority != Project.MSG_ERR) {
                printMessage( msg, out, priority );
            } else {
                printMessage( msg, err, priority );
            }
            log( msg );
        }
    }

    protected static  java.lang.String formatTime( final long millis )
    {
        return DateUtils.formatElapsedTime( millis );
    }

    protected  void printMessage( final java.lang.String message, final java.io.PrintStream stream, final int priority )
    {
        stream.println( message );
    }

    protected  void log( java.lang.String message )
    {
    }

    protected  java.lang.String getTimestamp()
    {
        java.util.Date date = new java.util.Date( System.currentTimeMillis() );
        java.text.DateFormat formatter = DateFormat.getDateTimeInstance( DateFormat.SHORT, DateFormat.SHORT );
        java.lang.String finishTime = formatter.format( date );
        return finishTime;
    }

    protected  java.lang.String extractProjectName( org.apache.tools.ant.BuildEvent event )
    {
        org.apache.tools.ant.Project project = event.getProject();
        return project != null ? project.getName() : null;
    }

}
