// This is a mutant program.
// Author : ysma

package org.apache.tools.ant;


import java.io.File;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;
import java.util.Locale;
import java.util.Vector;
import org.apache.tools.ant.types.Resource;
import org.apache.tools.ant.types.resources.FileResource;
import org.apache.tools.ant.util.LoaderUtils;
import org.xml.sax.AttributeList;


public class ProjectHelper
{

    public static final java.lang.String ANT_CORE_URI = "antlib:org.apache.tools.ant";

    public static final java.lang.String ANT_CURRENT_URI = "ant:current";

    public static final java.lang.String ANTLIB_URI = "antlib:";

    public static final java.lang.String ANT_TYPE = "ant-type";

    public static final java.lang.String HELPER_PROPERTY = MagicNames.PROJECT_HELPER_CLASS;

    public static final java.lang.String SERVICE_ID = MagicNames.PROJECT_HELPER_SERVICE;

    public static final java.lang.String PROJECTHELPER_REFERENCE = MagicNames.REFID_PROJECT_HELPER;

    public static  void configureProject( org.apache.tools.ant.Project project, java.io.File buildFile )
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.types.resources.FileResource resource = new org.apache.tools.ant.types.resources.FileResource( buildFile );
        org.apache.tools.ant.ProjectHelper helper = ProjectHelperRepository.getInstance().getProjectHelperForBuildFile( resource );
        project.addReference( PROJECTHELPER_REFERENCE, helper );
        helper.parse( project, buildFile );
    }

    public static final class OnMissingExtensionPoint
    {

        public static final org.apache.tools.ant.ProjectHelper.OnMissingExtensionPoint FAIL = new org.apache.tools.ant.ProjectHelper.OnMissingExtensionPoint( "fail" );

        public static final org.apache.tools.ant.ProjectHelper.OnMissingExtensionPoint WARN = new org.apache.tools.ant.ProjectHelper.OnMissingExtensionPoint( "warn" );

        public static final org.apache.tools.ant.ProjectHelper.OnMissingExtensionPoint IGNORE = new org.apache.tools.ant.ProjectHelper.OnMissingExtensionPoint( "ignore" );

        private static final org.apache.tools.ant.ProjectHelper.OnMissingExtensionPoint[] values = new org.apache.tools.ant.ProjectHelper.OnMissingExtensionPoint[]{ FAIL, WARN, IGNORE };

        private final java.lang.String name;

        private OnMissingExtensionPoint( java.lang.String name )
        {
            this.name = name;
        }

        public  java.lang.String name()
        {
            return name;
        }

        public  java.lang.String toString()
        {
            return name;
        }

        public static  org.apache.tools.ant.ProjectHelper.OnMissingExtensionPoint valueOf( java.lang.String name )
        {
            if (name == null) {
                throw new java.lang.NullPointerException();
            }
            for (int i = 0; i < values.length; i++) {
                if (name.equals( values[i].name() )) {
                    return values[i];
                }
            }
            throw new java.lang.IllegalArgumentException( "Unknown onMissingExtensionPoint " + name );
        }

    }

    public ProjectHelper()
    {
    }

    private java.util.Vector importStack = new java.util.Vector();

    private java.util.List extensionStack = new java.util.LinkedList();

    public  java.util.Vector getImportStack()
    {
        return importStack;
    }

    public  java.util.List getExtensionStack()
    {
        return extensionStack;
    }

    private static final java.lang.ThreadLocal targetPrefix = new java.lang.ThreadLocal(){
        protected  java.lang.Object initialValue()
        {
            return (java.lang.String) null;
        }
    };

    public static  java.lang.String getCurrentTargetPrefix()
    {
        return (java.lang.String) targetPrefix.get();
    }

    public static  void setCurrentTargetPrefix( java.lang.String prefix )
    {
        targetPrefix.set( prefix );
    }

    private static final java.lang.ThreadLocal prefixSeparator = new java.lang.ThreadLocal(){
        protected  java.lang.Object initialValue()
        {
            return ".";
        }
    };

    public static  java.lang.String getCurrentPrefixSeparator()
    {
        return (java.lang.String) prefixSeparator.get();
    }

    public static  void setCurrentPrefixSeparator( java.lang.String sep )
    {
        prefixSeparator.set( sep );
    }

    private static final java.lang.ThreadLocal inIncludeMode = new java.lang.ThreadLocal(){
        protected  java.lang.Object initialValue()
        {
            return Boolean.FALSE;
        }
    };

    public static  boolean isInIncludeMode()
    {
        return inIncludeMode.get() == Boolean.TRUE;
    }

    public static  void setInIncludeMode( boolean includeMode )
    {
        inIncludeMode.set( includeMode ? Boolean.TRUE : Boolean.FALSE );
    }

    public  void parse( org.apache.tools.ant.Project project, java.lang.Object source )
        throws org.apache.tools.ant.BuildException
    {
        throw new org.apache.tools.ant.BuildException( "ProjectHelper.parse() must be implemented " + "in a helper plugin " + this.getClass().getName() );
    }

    public static  org.apache.tools.ant.ProjectHelper getProjectHelper()
    {
        return (org.apache.tools.ant.ProjectHelper) ProjectHelperRepository.getInstance().getHelpers().next();
    }

    public static  java.lang.ClassLoader getContextClassLoader()
    {
        return LoaderUtils.isContextLoaderAvailable() ? LoaderUtils.getContextClassLoader() : null;
    }

    public static  void configure( java.lang.Object target, org.xml.sax.AttributeList attrs, org.apache.tools.ant.Project project )
        throws org.apache.tools.ant.BuildException
    {
        if (target instanceof org.apache.tools.ant.TypeAdapter) {
            target = ((org.apache.tools.ant.TypeAdapter) target).getProxy();
        }
        org.apache.tools.ant.IntrospectionHelper ih = IntrospectionHelper.getHelper( project, target.getClass() );
        for (int i = 0, length = attrs.getLength(); i < length; i++) {
            java.lang.String value = replaceProperties( project, attrs.getValue( i ), project.getProperties() );
            try {
                ih.setAttribute( project, target, attrs.getName( i ).toLowerCase( Locale.ENGLISH ), value );
            } catch ( org.apache.tools.ant.BuildException be ) {
                if (!attrs.getName( i ).equals( "id" )) {
                    throw be;
                }
            }
        }
    }

    public static  void addText( org.apache.tools.ant.Project project, java.lang.Object target, char[] buf, int start, int count )
        throws org.apache.tools.ant.BuildException
    {
        addText( project, target, new java.lang.String( buf, start, count ) );
    }

    public static  void addText( org.apache.tools.ant.Project project, java.lang.Object target, java.lang.String text )
        throws org.apache.tools.ant.BuildException
    {
        if (text == null) {
            return;
        }
        if (target instanceof org.apache.tools.ant.TypeAdapter) {
            target = ((org.apache.tools.ant.TypeAdapter) target).getProxy();
        }
        IntrospectionHelper.getHelper( project, target.getClass() ).addText( project, target, text );
    }

    public static  void storeChild( org.apache.tools.ant.Project project, java.lang.Object parent, java.lang.Object child, java.lang.String tag )
    {
        org.apache.tools.ant.IntrospectionHelper ih = IntrospectionHelper.getHelper( project, parent.getClass() );
        ih.storeElement( project, parent, child, tag );
    }

    public static  java.lang.String replaceProperties( org.apache.tools.ant.Project project, java.lang.String value )
        throws org.apache.tools.ant.BuildException
    {
        return project.replaceProperties( value );
    }

    public static  java.lang.String replaceProperties( org.apache.tools.ant.Project project, java.lang.String value, java.util.Hashtable keys )
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.PropertyHelper ph = PropertyHelper.getPropertyHelper( project );
        return ph.replaceProperties( null, value, keys );
    }

    public static  void parsePropertyString( java.lang.String value, java.util.Vector fragments, java.util.Vector propertyRefs )
        throws org.apache.tools.ant.BuildException
    {
        PropertyHelper.parsePropertyStringDefault( value, fragments, propertyRefs );
    }

    public static  java.lang.String genComponentName( java.lang.String uri, java.lang.String name )
    {
        if (uri == null || uri.equals( "" ) || uri.equals( ANT_CORE_URI )) {
            return name;
        }
        return uri + ":" + name;
    }

    public static  java.lang.String extractUriFromComponentName( java.lang.String componentName )
    {
        if (componentName == null) {
            return "";
        }
        int index = componentName.lastIndexOf( ':' );
        if (index == -1) {
            return "";
        }
        return componentName.substring( 0, index );
    }

    public static  java.lang.String extractNameFromComponentName( java.lang.String componentName )
    {
        int index = componentName.lastIndexOf( ':' );
        if (index == -1) {
            return componentName;
        }
        return componentName.substring( index + 1 );
    }

    public static  org.apache.tools.ant.BuildException addLocationToBuildException( org.apache.tools.ant.BuildException ex, org.apache.tools.ant.Location newLocation )
    {
        if (ex.getLocation() == null || ex.getMessage() == null) {
            return ex;
        }
        java.lang.String errorMessage = "The following error occurred while executing this line:" + System.getProperty( "line.separator" ) + ex.getLocation().toString() + ex.getMessage();
        if (newLocation == null) {
            return new org.apache.tools.ant.BuildException( errorMessage, ex );
        }
        return new org.apache.tools.ant.BuildException( errorMessage, ex, newLocation );
    }

    public  boolean canParseAntlibDescriptor( org.apache.tools.ant.types.Resource r )
    {
        return false;
    }

    public  org.apache.tools.ant.UnknownElement parseAntlibDescriptor( org.apache.tools.ant.Project containingProject, org.apache.tools.ant.types.Resource source )
    {
        throw new org.apache.tools.ant.BuildException( "can't parse antlib descriptors" );
    }

    public  boolean canParseBuildFile( org.apache.tools.ant.types.Resource buildFile )
    {
        return true;
    }

    public  java.lang.String getDefaultBuildFile()
    {
        return Main.DEFAULT_BUILD_FILENAME;
    }

}
