// This is a mutant program.
// Author : ysma

package org.apache.tools.ant;


import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.lang.reflect.Constructor;
import java.net.URL;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;
import org.apache.tools.ant.helper.ProjectHelper2;
import org.apache.tools.ant.types.Resource;
import org.apache.tools.ant.util.LoaderUtils;


public class ProjectHelperRepository
{

    private static final java.lang.String DEBUG_PROJECT_HELPER_REPOSITORY = "ant.project-helper-repo.debug";

    private static final boolean DEBUG = "true".equals( System.getProperty( DEBUG_PROJECT_HELPER_REPOSITORY ) );

    private static org.apache.tools.ant.ProjectHelperRepository instance = new org.apache.tools.ant.ProjectHelperRepository();

    private java.util.List helpers = new java.util.ArrayList();

    private static final java.lang.Class[] NO_CLASS = new java.lang.Class[0];

    private static final java.lang.Object[] NO_OBJECT = new java.lang.Object[0];

    private static java.lang.reflect.Constructor PROJECTHELPER2_CONSTRUCTOR;

    static {
        try {
            PROJECTHELPER2_CONSTRUCTOR = (org.apache.tools.ant.helper.ProjectHelper2.class).getConstructor( NO_CLASS );
        } catch ( java.lang.Exception e ) {
            throw new java.lang.RuntimeException( e );
        }
    }

    public static  org.apache.tools.ant.ProjectHelperRepository getInstance()
    {
        return instance;
    }

    private ProjectHelperRepository()
    {
        collectProjectHelpers();
    }

    private  void collectProjectHelpers()
    {
        java.lang.reflect.Constructor projectHelper = getProjectHelperBySystemProperty();
        registerProjectHelper( projectHelper );
        try {
            java.lang.ClassLoader classLoader = LoaderUtils.getContextClassLoader();
            if (classLoader != null) {
                java.util.Enumeration resources = classLoader.getResources( ProjectHelper.SERVICE_ID );
                while (resources.hasMoreElements()) {
                    java.net.URL resource = (java.net.URL) resources.nextElement();
                    projectHelper = getProjectHelperByService( resource.openStream() );
                    registerProjectHelper( projectHelper );
                }
            }
            java.io.InputStream systemResource = ClassLoader.getSystemResourceAsStream( ProjectHelper.SERVICE_ID );
            if (systemResource != null) {
                projectHelper = getProjectHelperByService( systemResource );
                registerProjectHelper( projectHelper );
            }
        } catch ( java.lang.Exception e ) {
            System.err.println( "Unable to load ProjectHelper from service " + ProjectHelper.SERVICE_ID + " (" + e.getClass().getName() + ": " + e.getMessage() + ")" );
            if (DEBUG) {
                e.printStackTrace( System.err );
            }
        }
    }

    public  void registerProjectHelper( java.lang.String helperClassName )
        throws org.apache.tools.ant.BuildException
    {
        registerProjectHelper( getHelperConstructor( helperClassName ) );
    }

    public  void registerProjectHelper( java.lang.Class helperClass )
        throws org.apache.tools.ant.BuildException
    {
        try {
            registerProjectHelper( helperClass.getConstructor( NO_CLASS ) );
        } catch ( java.lang.NoSuchMethodException e ) {
            throw new org.apache.tools.ant.BuildException( "Couldn't find no-arg constructor in " + helperClass.getName() );
        }
    }

    private  void registerProjectHelper( java.lang.reflect.Constructor helperConstructor )
    {
        if (helperConstructor == null) {
            return;
        }
        if (DEBUG) {
            System.out.println( "ProjectHelper " + helperConstructor.getClass().getName() + " registered." );
        }
        helpers.add( helperConstructor );
    }

    private  java.lang.reflect.Constructor getProjectHelperBySystemProperty()
    {
        java.lang.String helperClass = System.getProperty( ProjectHelper.HELPER_PROPERTY );
        try {
            if (helperClass != null) {
                return getHelperConstructor( helperClass );
            }
        } catch ( java.lang.SecurityException e ) {
            System.err.println( "Unable to load ProjectHelper class \"" + helperClass + " specified in system property " + ProjectHelper.HELPER_PROPERTY + " (" + e.getMessage() + ")" );
            if (DEBUG) {
                e.printStackTrace( System.err );
            }
        }
        return null;
    }

    private  java.lang.reflect.Constructor getProjectHelperByService( java.io.InputStream is )
    {
        try {
            java.io.InputStreamReader isr;
            try {
                isr = new java.io.InputStreamReader( is, "UTF-8" );
            } catch ( java.io.UnsupportedEncodingException e ) {
                isr = new java.io.InputStreamReader( is );
            }
            java.io.BufferedReader rd = new java.io.BufferedReader( isr );
            java.lang.String helperClassName = rd.readLine();
            rd.close();
            if (helperClassName != null && !"".equals( helperClassName )) {
                return getHelperConstructor( helperClassName );
            }
        } catch ( java.lang.Exception e ) {
            System.out.println( "Unable to load ProjectHelper from service " + ProjectHelper.SERVICE_ID + " (" + e.getMessage() + ")" );
            if (DEBUG) {
                e.printStackTrace( System.err );
            }
        }
        return null;
    }

    private  java.lang.reflect.Constructor getHelperConstructor( java.lang.String helperClass )
        throws org.apache.tools.ant.BuildException
    {
        java.lang.ClassLoader classLoader = LoaderUtils.getContextClassLoader();
        try {
            java.lang.Class clazz = null;
            if (classLoader != null) {
                try {
                    clazz = classLoader.loadClass( helperClass );
                } catch ( java.lang.ClassNotFoundException ex ) {
                }
            }
            if (clazz == null) {
                clazz = Class.forName( helperClass );
            }
            return clazz.getConstructor( NO_CLASS );
        } catch ( java.lang.Exception e ) {
            throw new org.apache.tools.ant.BuildException( e );
        }
    }

    public  org.apache.tools.ant.ProjectHelper getProjectHelperForBuildFile( org.apache.tools.ant.types.Resource buildFile )
        throws org.apache.tools.ant.BuildException
    {
        java.util.Iterator it = getHelpers();
        while (it.hasNext()) {
            org.apache.tools.ant.ProjectHelper helper = (org.apache.tools.ant.ProjectHelper) it.next();
            if (helper.canParseBuildFile( buildFile )) {
                if (DEBUG) {
                    System.out.println( "ProjectHelper " + helper.getClass().getName() + " selected for the build file " + buildFile );
                }
                return helper;
            }
        }
        throw new java.lang.RuntimeException( "BUG: at least the ProjectHelper2 should " + "have supported the file " + buildFile );
    }

    public  org.apache.tools.ant.ProjectHelper getProjectHelperForAntlib( org.apache.tools.ant.types.Resource antlib )
        throws org.apache.tools.ant.BuildException
    {
        java.util.Iterator it = getHelpers();
        while (it.hasNext()) {
            org.apache.tools.ant.ProjectHelper helper = (org.apache.tools.ant.ProjectHelper) it.next();
            if (helper.canParseAntlibDescriptor( antlib )) {
                if (DEBUG) {
                    System.out.println( "ProjectHelper " + helper.getClass().getName() + " selected for the antlib " + antlib );
                }
                return helper;
            }
        }
        throw new java.lang.RuntimeException( "BUG: at least the ProjectHelper2 should " + "have supported the file " + antlib );
    }

    public  java.util.Iterator getHelpers()
    {
        return new org.apache.tools.ant.ProjectHelperRepository.ConstructingIterator( helpers.iterator() );
    }

    private static class ConstructingIterator implements java.util.Iterator
    {

        private final java.util.Iterator nested;

        private boolean empty = false;

        ConstructingIterator( java.util.Iterator nested )
        {
            this.nested = nested;
        }

        public  boolean hasNext()
        {
            return nested.hasNext() || !empty;
        }

        public  java.lang.Object next()
        {
            java.lang.reflect.Constructor c;
            if (nested.hasNext()) {
                c = (java.lang.reflect.Constructor) nested.next();
            } else {
                empty = true;
                c = PROJECTHELPER2_CONSTRUCTOR;
            }
            try {
                return c.newInstance( NO_OBJECT );
            } catch ( java.lang.Exception e ) {
                throw new org.apache.tools.ant.BuildException( "Failed to invoke no-arg constructor" + " on " + c.getName() );
            }
        }

        public  void remove()
        {
            throw new java.lang.UnsupportedOperationException( "remove is not supported" );
        }

    }

}
