// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.filters;


import java.io.IOException;
import java.io.Reader;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.taskdefs.condition.Os;
import org.apache.tools.ant.types.EnumeratedAttribute;


public final class FixCrLfFilter extends org.apache.tools.ant.filters.BaseParamFilterReader implements org.apache.tools.ant.filters.ChainableReader
{

    private static final int DEFAULT_TAB_LENGTH = 8;

    private static final int MIN_TAB_LENGTH = 2;

    private static final int MAX_TAB_LENGTH = 80;

    private static final char CTRLZ = '';

    private int tabLength = DEFAULT_TAB_LENGTH;

    private org.apache.tools.ant.filters.FixCrLfFilter.CrLf eol;

    private org.apache.tools.ant.filters.FixCrLfFilter.AddAsisRemove ctrlz;

    private org.apache.tools.ant.filters.FixCrLfFilter.AddAsisRemove tabs;

    private boolean javafiles = false;

    private boolean fixlast = true;

    private boolean initialized = false;

    public FixCrLfFilter()
    {
        super();
    }

    public FixCrLfFilter( final java.io.Reader in )
        throws java.io.IOException
    {
        super( in );
    }

    {
        tabs = AddAsisRemove.ASIS;
        if (Os.isFamily( "mac" ) && !Os.isFamily( "unix" )) {
            ctrlz = AddAsisRemove.REMOVE;
            setEol( CrLf.MAC );
        } else {
            if (Os.isFamily( "dos" )) {
                ctrlz = AddAsisRemove.ASIS;
                setEol( CrLf.DOS );
            } else {
                ctrlz = AddAsisRemove.REMOVE;
                setEol( CrLf.UNIX );
            }
        }
    }

    public  java.io.Reader chain( final java.io.Reader rdr )
    {
        try {
            org.apache.tools.ant.filters.FixCrLfFilter newFilter = new org.apache.tools.ant.filters.FixCrLfFilter( rdr );
            newFilter.setJavafiles( getJavafiles() );
            newFilter.setEol( getEol() );
            newFilter.setTab( getTab() );
            newFilter.setTablength( getTablength() );
            newFilter.setEof( getEof() );
            newFilter.setFixlast( getFixlast() );
            newFilter.initInternalFilters();
            return newFilter;
        } catch ( java.io.IOException e ) {
            throw new org.apache.tools.ant.BuildException( e );
        }
    }

    public  org.apache.tools.ant.filters.FixCrLfFilter.AddAsisRemove getEof()
    {
        return ctrlz.newInstance();
    }

    public  org.apache.tools.ant.filters.FixCrLfFilter.CrLf getEol()
    {
        return eol.newInstance();
    }

    public  boolean getFixlast()
    {
        return fixlast;
    }

    public  boolean getJavafiles()
    {
        return javafiles;
    }

    public  org.apache.tools.ant.filters.FixCrLfFilter.AddAsisRemove getTab()
    {
        return tabs.newInstance();
    }

    public  int getTablength()
    {
        return tabLength;
    }

    private static  java.lang.String calculateEolString( org.apache.tools.ant.filters.FixCrLfFilter.CrLf eol )
    {
        if (eol == CrLf.ASIS) {
            return System.getProperty( "line.separator" );
        }
        if (eol == CrLf.CR || eol == CrLf.MAC) {
            return "\r";
        }
        if (eol == CrLf.CRLF || eol == CrLf.DOS) {
            return "\r\n";
        }
        return "\n";
    }

    private  void initInternalFilters()
    {
        in = ctrlz == AddAsisRemove.REMOVE ? new org.apache.tools.ant.filters.FixCrLfFilter.RemoveEofFilter( in ) : in;
        in = new org.apache.tools.ant.filters.FixCrLfFilter.NormalizeEolFilter( in, calculateEolString( eol ), getFixlast() );
        if (tabs != AddAsisRemove.ASIS) {
            if (getJavafiles()) {
                in = new org.apache.tools.ant.filters.FixCrLfFilter.MaskJavaTabLiteralsFilter( in );
            }
            in = tabs == AddAsisRemove.ADD ? (java.io.Reader) new org.apache.tools.ant.filters.FixCrLfFilter.AddTabFilter( in, getTablength() ) : (java.io.Reader) new org.apache.tools.ant.filters.FixCrLfFilter.RemoveTabFilter( in, getTablength() );
        }
        in = ctrlz == AddAsisRemove.ADD ? new org.apache.tools.ant.filters.FixCrLfFilter.AddEofFilter( in ) : in;
        initialized = true;
    }

    public synchronized  int read()
        throws java.io.IOException
    {
        if (!initialized) {
            initInternalFilters();
        }
        return in.read();
    }

    public  void setEof( org.apache.tools.ant.filters.FixCrLfFilter.AddAsisRemove attr )
    {
        ctrlz = attr.resolve();
    }

    public  void setEol( org.apache.tools.ant.filters.FixCrLfFilter.CrLf attr )
    {
        eol = attr.resolve();
    }

    public  void setFixlast( boolean fixlast )
    {
        this.fixlast = fixlast;
    }

    public  void setJavafiles( boolean javafiles )
    {
        this.javafiles = javafiles;
    }

    public  void setTab( org.apache.tools.ant.filters.FixCrLfFilter.AddAsisRemove attr )
    {
        tabs = attr.resolve();
    }

    public  void setTablength( int tabLength )
        throws java.io.IOException
    {
        if (tabLength < MIN_TAB_LENGTH || tabLength > MAX_TAB_LENGTH) {
            throw new java.io.IOException( "tablength must be between " + MIN_TAB_LENGTH + " and " + MAX_TAB_LENGTH );
        }
        this.tabLength = tabLength;
    }

    private static class SimpleFilterReader extends java.io.Reader
    {

        private static final int PREEMPT_BUFFER_LENGTH = 16;

        private java.io.Reader in;

        private int[] preempt = new int[PREEMPT_BUFFER_LENGTH];

        private int preemptIndex = 0;

        public SimpleFilterReader( java.io.Reader in )
        {
            this.in = in;
        }

        public  void push( char c )
        {
            push( (int) c );
        }

        public  void push( int c )
        {
            try {
                preempt[preemptIndex++] = c;
            } catch ( java.lang.ArrayIndexOutOfBoundsException e ) {
                int[] p2 = new int[preempt.length * 2];
                System.arraycopy( preempt, 0, p2, 0, preempt.length );
                preempt = p2;
                push( c );
            }
        }

        public  void push( char[] cs, int start, int length )
        {
            for (int i = start + length - 1; i >= start;) {
                push( cs[i--] );
            }
        }

        public  void push( char[] cs )
        {
            push( cs, 0, cs.length );
        }

        public  void push( java.lang.String s )
        {
            push( s.toCharArray() );
        }

        public  boolean editsBlocked()
        {
            return in instanceof org.apache.tools.ant.filters.FixCrLfFilter.SimpleFilterReader && ((org.apache.tools.ant.filters.FixCrLfFilter.SimpleFilterReader) in).editsBlocked();
        }

        public  int read()
                throws java.io.IOException
        {
            return preemptIndex > 0 ? preempt[--preemptIndex] : in.read();
        }

        public  void close()
                throws java.io.IOException
        {
            in.close();
        }

        public  void reset()
                throws java.io.IOException
        {
            in.reset();
        }

        public  boolean markSupported()
        {
            return in.markSupported();
        }

        public  boolean ready()
                throws java.io.IOException
        {
            return in.ready();
        }

        public  void mark( int i )
                throws java.io.IOException
        {
            in.mark( i );
        }

        public  long skip( long i )
                throws java.io.IOException
        {
            return in.skip( i );
        }

        public  int read( char[] buf )
                throws java.io.IOException
        {
            return read( buf, 0, buf.length );
        }

        public  int read( char[] buf, int start, int length )
                throws java.io.IOException
        {
            int count = 0;
            int c = 0;
            while (length-- > 0 && (c = this.read()) != -1) {
                buf[start++] = (char) c;
                count++;
            }
            return count == 0 && c == -1 ? -1 : count;
        }

    }

    private static class MaskJavaTabLiteralsFilter extends org.apache.tools.ant.filters.FixCrLfFilter.SimpleFilterReader
    {

        private boolean editsBlocked = false;

        private static final int JAVA = 1;

        private static final int IN_CHAR_CONST = 2;

        private static final int IN_STR_CONST = 3;

        private static final int IN_SINGLE_COMMENT = 4;

        private static final int IN_MULTI_COMMENT = 5;

        private static final int TRANS_TO_COMMENT = 6;

        private static final int TRANS_FROM_MULTI = 8;

        private int state;

        public MaskJavaTabLiteralsFilter( java.io.Reader in )
        {
            super( in );
            state = JAVA;
        }

        public  boolean editsBlocked()
        {
            return editsBlocked || super.editsBlocked();
        }

        public  int read()
                throws java.io.IOException
        {
            int thisChar = super.read();
            editsBlocked = state == IN_CHAR_CONST || state == IN_STR_CONST;
            switch (state) {
            case JAVA :
                switch (thisChar) {
                case '\'' :
                    state = IN_CHAR_CONST;
                    break;

                case '"' :
                    state = IN_STR_CONST;
                    break;

                case '/' :
                    state = TRANS_TO_COMMENT;
                    break;

                default  :

                }
                break;

            case IN_CHAR_CONST :
                switch (thisChar) {
                case '\'' :
                    state = JAVA;
                    break;

                default  :

                }
                break;

            case IN_STR_CONST :
                switch (thisChar) {
                case '"' :
                    state = JAVA;
                    break;

                default  :

                }
                break;

            case IN_SINGLE_COMMENT :
                switch (thisChar) {
                case '\n' :
                case '\r' :
                    state = JAVA;
                    break;

                default  :

                }
                break;

            case IN_MULTI_COMMENT :
                switch (thisChar) {
                case '*' :
                    state = TRANS_FROM_MULTI;
                    break;

                default  :

                }
                break;

            case TRANS_TO_COMMENT :
                switch (thisChar) {
                case '*' :
                    state = IN_MULTI_COMMENT;
                    break;

                case '/' :
                    state = IN_SINGLE_COMMENT;
                    break;

                case '\'' :
                    state = IN_CHAR_CONST;
                    break;

                case '"' :
                    state = IN_STR_CONST;
                    break;

                default  :
                    state = JAVA;

                }
                break;

            case TRANS_FROM_MULTI :
                switch (thisChar) {
                case '/' :
                    state = JAVA;
                    break;

                default  :

                }
                break;

            default  :

            }
            return thisChar;
        }

    }

    private static class NormalizeEolFilter extends org.apache.tools.ant.filters.FixCrLfFilter.SimpleFilterReader
    {

        private boolean previousWasEOL;

        private boolean fixLast;

        private int normalizedEOL = 0;

        private char[] eol = null;

        public NormalizeEolFilter( java.io.Reader in, java.lang.String eolString, boolean fixLast )
        {
            super( in );
            eol = eolString.toCharArray();
            this.fixLast = fixLast;
        }

        public  int read()
                throws java.io.IOException
        {
            int thisChar = super.read();
            if (normalizedEOL == 0) {
                int numEOL = 0;
                boolean atEnd = false;
                switch (thisChar) {
                case CTRLZ :
                    int c = super.read();
                    if (c == -1) {
                        atEnd = true;
                        if (fixLast && !previousWasEOL) {
                            numEOL = 1;
                            push( thisChar );
                        }
                    } else {
                        push( c );
                    }
                    break;

                case -1 :
                    atEnd = true;
                    if (fixLast && !previousWasEOL) {
                        numEOL = 1;
                    }
                    break;

                case '\n' :
                    numEOL = 1;
                    break;

                case '\r' :
                    numEOL = 1;
                    int c1 = super.read();
                    int c2 = super.read();
                    if (c1 == '\r' && c2 == '\n') {
                    } else {
                        if (c1 == '\r') {
                            numEOL = 2;
                            push( c2 );
                        } else {
                            if (c1 == '\n') {
                                push( c2 );
                            } else {
                                push( c2 );
                                push( c1 );
                            }
                        }
                    }

                default  :

                }
                if (numEOL > 0) {
                    while (numEOL-- > 0) {
                        push( eol );
                        normalizedEOL += eol.length;
                    }
                    previousWasEOL = true;
                    thisChar = read();
                } else {
                    if (!atEnd) {
                        previousWasEOL = false;
                    }
                }
            } else {
                normalizedEOL--;
            }
            return thisChar;
        }

    }

    private static class AddEofFilter extends org.apache.tools.ant.filters.FixCrLfFilter.SimpleFilterReader
    {

        private int lastChar = -1;

        public AddEofFilter( java.io.Reader in )
        {
            super( in );
        }

        public  int read()
                throws java.io.IOException
        {
            int thisChar = super.read();
            if (thisChar == -1) {
                if (lastChar != CTRLZ) {
                    lastChar = CTRLZ;
                    return lastChar;
                }
            } else {
                lastChar = thisChar;
            }
            return thisChar;
        }

    }

    private static class RemoveEofFilter extends org.apache.tools.ant.filters.FixCrLfFilter.SimpleFilterReader
    {

        private int lookAhead = -1;

        public RemoveEofFilter( java.io.Reader in )
        {
            super( in );
            try {
                lookAhead = in.read();
            } catch ( java.io.IOException e ) {
                lookAhead = -1;
            }
        }

        public  int read()
                throws java.io.IOException
        {
            int lookAhead2 = super.read();
            if (lookAhead2 == -1 && lookAhead == CTRLZ) {
                return -1;
            }
            int i = lookAhead;
            lookAhead = lookAhead2;
            return i;
        }

    }

    private static class AddTabFilter extends org.apache.tools.ant.filters.FixCrLfFilter.SimpleFilterReader
    {

        private int columnNumber = 0;

        private int tabLength = 0;

        public AddTabFilter( java.io.Reader in, int tabLength )
        {
            super( in );
            this.tabLength = tabLength;
        }

        public  int read()
                throws java.io.IOException
        {
            int c = super.read();
            switch (c) {
            case '\r' :
            case '\n' :
                columnNumber = 0;
                break;

            case ' ' :
                columnNumber++;
                if (!editsBlocked()) {
                    int colNextTab = (columnNumber + tabLength - 1) / tabLength * tabLength;
                    int countSpaces = 1;
                    int numTabs = 0;
                    scanWhitespace : 
                    while ((c = super.read()) != -1) {
                        switch (c) {
                        case ' ' :
                            if (++columnNumber == colNextTab) {
                                numTabs++;
                                countSpaces = 0;
                                colNextTab += tabLength;
                            } else {
                                countSpaces++;
                            }
                            break;

                        case '\t' :
                            columnNumber = colNextTab;
                            numTabs++;
                            countSpaces = 0;
                            colNextTab += tabLength;
                            break;

                        default  :
                            push( c );
                            break scanWhitespace;

                        }
                    }
                    while (countSpaces-- > 0) {
                        push( ' ' );
                        columnNumber--;
                    }
                    while (numTabs-- > 0) {
                        push( '\t' );
                        columnNumber -= tabLength;
                    }
                    c = super.read();
                    switch (c) {
                    case ' ' :
                        columnNumber++;
                        break;

                    case '\t' :
                        columnNumber += tabLength;
                        break;

                    default  :

                    }
                }
                break;

            case '\t' :
                columnNumber = (columnNumber + tabLength - 1) / tabLength * tabLength;
                break;

            default  :
                columnNumber++;

            }
            return c;
        }

    }

    private static class RemoveTabFilter extends org.apache.tools.ant.filters.FixCrLfFilter.SimpleFilterReader
    {

        private int columnNumber = 0;

        private int tabLength = 0;

        public RemoveTabFilter( java.io.Reader in, int tabLength )
        {
            super( in );
            this.tabLength = tabLength;
        }

        public  int read()
                throws java.io.IOException
        {
            int c = super.read();
            switch (c) {
            case '\r' :
            case '\n' :
                columnNumber = 0;
                break;

            case '\t' :
                int width = tabLength - columnNumber % tabLength;
                if (!editsBlocked()) {
                    for (; width > 1; width--) {
                        push( ' ' );
                    }
                    c = ' ';
                }
                columnNumber += width;
                break;

            default  :
                columnNumber++;

            }
            return c;
        }

    }

    public static class AddAsisRemove extends org.apache.tools.ant.types.EnumeratedAttribute
    {

        private static final org.apache.tools.ant.filters.FixCrLfFilter.AddAsisRemove ASIS = newInstance( "asis" );

        private static final org.apache.tools.ant.filters.FixCrLfFilter.AddAsisRemove ADD = newInstance( "add" );

        private static final org.apache.tools.ant.filters.FixCrLfFilter.AddAsisRemove REMOVE = newInstance( "remove" );

        public  java.lang.String[] getValues()
        {
            return new java.lang.String[]{ "add", "asis", "remove" };
        }

        public  boolean equals( java.lang.Object other )
        {
            return other instanceof org.apache.tools.ant.filters.FixCrLfFilter.AddAsisRemove && getIndex() == ((org.apache.tools.ant.filters.FixCrLfFilter.AddAsisRemove) other).getIndex();
        }

        public  int hashCode()
        {
            return getIndex();
        }

         org.apache.tools.ant.filters.FixCrLfFilter.AddAsisRemove resolve()
                throws java.lang.IllegalStateException
        {
            if (this.equals( ASIS )) {
                return ASIS;
            }
            if (this.equals( ADD )) {
                return ADD;
            }
            if (this.equals( REMOVE )) {
                return REMOVE;
            }
            throw new java.lang.IllegalStateException( "No replacement for " + this );
        }

        private  org.apache.tools.ant.filters.FixCrLfFilter.AddAsisRemove newInstance()
        {
            return newInstance( getValue() );
        }

        public static  org.apache.tools.ant.filters.FixCrLfFilter.AddAsisRemove newInstance( java.lang.String value )
        {
            org.apache.tools.ant.filters.FixCrLfFilter.AddAsisRemove a = new org.apache.tools.ant.filters.FixCrLfFilter.AddAsisRemove();
            a.setValue( value );
            return a;
        }

    }

    public static class CrLf extends org.apache.tools.ant.types.EnumeratedAttribute
    {

        private static final org.apache.tools.ant.filters.FixCrLfFilter.CrLf ASIS = newInstance( "asis" );

        private static final org.apache.tools.ant.filters.FixCrLfFilter.CrLf CR = newInstance( "cr" );

        private static final org.apache.tools.ant.filters.FixCrLfFilter.CrLf CRLF = newInstance( "crlf" );

        private static final org.apache.tools.ant.filters.FixCrLfFilter.CrLf DOS = newInstance( "dos" );

        private static final org.apache.tools.ant.filters.FixCrLfFilter.CrLf LF = newInstance( "lf" );

        private static final org.apache.tools.ant.filters.FixCrLfFilter.CrLf MAC = newInstance( "mac" );

        private static final org.apache.tools.ant.filters.FixCrLfFilter.CrLf UNIX = newInstance( "unix" );

        public  java.lang.String[] getValues()
        {
            return new java.lang.String[]{ "asis", "cr", "lf", "crlf", "mac", "unix", "dos" };
        }

        public  boolean equals( java.lang.Object other )
        {
            return other instanceof org.apache.tools.ant.filters.FixCrLfFilter.CrLf && getIndex() == ((org.apache.tools.ant.filters.FixCrLfFilter.CrLf) other).getIndex();
        }

        public  int hashCode()
        {
            return getIndex();
        }

         org.apache.tools.ant.filters.FixCrLfFilter.CrLf resolve()
        {
            if (this.equals( ASIS )) {
                return ASIS;
            }
            if (this.equals( CR ) || this.equals( MAC )) {
                return CR;
            }
            if (this.equals( CRLF ) || this.equals( DOS )) {
                return CRLF;
            }
            if (this.equals( LF ) || this.equals( UNIX )) {
                return LF;
            }
            throw new java.lang.IllegalStateException( "No replacement for " + this );
        }

        private  org.apache.tools.ant.filters.FixCrLfFilter.CrLf newInstance()
        {
            return newInstance( getValue() );
        }

        public static  org.apache.tools.ant.filters.FixCrLfFilter.CrLf newInstance( java.lang.String value )
        {
            org.apache.tools.ant.filters.FixCrLfFilter.CrLf c = new org.apache.tools.ant.filters.FixCrLfFilter.CrLf();
            c.setValue( value );
            return c;
        }

    }

}
