// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.helper;


import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.Locale;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.IntrospectionHelper;
import org.apache.tools.ant.Location;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.ProjectHelper;
import org.apache.tools.ant.RuntimeConfigurable;
import org.apache.tools.ant.Target;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.TypeAdapter;
import org.apache.tools.ant.TaskContainer;
import org.apache.tools.ant.UnknownElement;
import org.apache.tools.ant.util.FileUtils;
import org.apache.tools.ant.util.JAXPUtils;
import org.xml.sax.AttributeList;
import org.xml.sax.DocumentHandler;
import org.xml.sax.HandlerBase;
import org.xml.sax.InputSource;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.helpers.XMLReaderAdapter;


public class ProjectHelperImpl extends org.apache.tools.ant.ProjectHelper
{

    private static final org.apache.tools.ant.util.FileUtils FILE_UTILS = FileUtils.getFileUtils();

    private org.xml.sax.Parser parser;

    private org.apache.tools.ant.Project project;

    private java.io.File buildFile;

    private java.io.File buildFileParent;

    private org.xml.sax.Locator locator;

    private org.apache.tools.ant.Target implicitTarget = new org.apache.tools.ant.Target();

    public ProjectHelperImpl()
    {
        implicitTarget.setName( "" );
    }

    public  void parse( org.apache.tools.ant.Project project, java.lang.Object source )
        throws org.apache.tools.ant.BuildException
    {
        if (!(source instanceof java.io.File)) {
            throw new org.apache.tools.ant.BuildException( "Only File source supported by " + "default plugin" );
        }
        java.io.File bFile = (java.io.File) source;
        java.io.FileInputStream inputStream = null;
        org.xml.sax.InputSource inputSource = null;
        this.project = project;
        this.buildFile = new java.io.File( bFile.getAbsolutePath() );
        buildFileParent = new java.io.File( this.buildFile.getParent() );
        try {
            try {
                parser = JAXPUtils.getParser();
            } catch ( org.apache.tools.ant.BuildException e ) {
                parser = new org.xml.sax.helpers.XMLReaderAdapter( JAXPUtils.getXMLReader() );
            }
            java.lang.String uri = FILE_UTILS.toURI( bFile.getAbsolutePath() );
            inputStream = new java.io.FileInputStream( bFile );
            inputSource = new org.xml.sax.InputSource( inputStream );
            inputSource.setSystemId( uri );
            project.log( "parsing buildfile " + bFile + " with URI = " + uri, Project.MSG_VERBOSE );
            org.xml.sax.HandlerBase hb = new org.apache.tools.ant.helper.ProjectHelperImpl.RootHandler( this );
            parser.setDocumentHandler( hb );
            parser.setEntityResolver( hb );
            parser.setErrorHandler( hb );
            parser.setDTDHandler( hb );
            parser.parse( inputSource );
        } catch ( org.xml.sax.SAXParseException exc ) {
            org.apache.tools.ant.Location location = new org.apache.tools.ant.Location( exc.getSystemId(), exc.getLineNumber(), exc.getColumnNumber() );
            java.lang.Throwable t = exc.getException();
            if (t instanceof org.apache.tools.ant.BuildException) {
                org.apache.tools.ant.BuildException be = (org.apache.tools.ant.BuildException) t;
                if (be.getLocation() == Location.UNKNOWN_LOCATION) {
                    be.setLocation( location );
                }
                throw be;
            }
            throw new org.apache.tools.ant.BuildException( exc.getMessage(), t, location );
        } catch ( org.xml.sax.SAXException exc ) {
            java.lang.Throwable t = exc.getException();
            if (t instanceof org.apache.tools.ant.BuildException) {
                throw (org.apache.tools.ant.BuildException) t;
            }
            throw new org.apache.tools.ant.BuildException( exc.getMessage(), t );
        } catch ( java.io.FileNotFoundException exc ) {
            throw new org.apache.tools.ant.BuildException( exc );
        } catch ( java.io.UnsupportedEncodingException exc ) {
            throw new org.apache.tools.ant.BuildException( "Encoding of project file is invalid.", exc );
        } catch ( java.io.IOException exc ) {
            throw new org.apache.tools.ant.BuildException( "Error reading project file: " + exc.getMessage(), exc );
        } finally 
{
            FileUtils.close( inputStream );
        }
    }

    static class AbstractHandler extends org.xml.sax.HandlerBase
    {

        protected org.xml.sax.DocumentHandler parentHandler;

        org.apache.tools.ant.helper.ProjectHelperImpl helperImpl;

        public AbstractHandler( org.apache.tools.ant.helper.ProjectHelperImpl helperImpl, org.xml.sax.DocumentHandler parentHandler )
        {
            this.parentHandler = parentHandler;
            this.helperImpl = helperImpl;
            helperImpl.parser.setDocumentHandler( this );
        }

        public  void startElement( java.lang.String tag, org.xml.sax.AttributeList attrs )
                throws org.xml.sax.SAXParseException
        {
            throw new org.xml.sax.SAXParseException( "Unexpected element \"" + tag + "\"", helperImpl.locator );
        }

        public  void characters( char[] buf, int start, int count )
                throws org.xml.sax.SAXParseException
        {
            java.lang.String s = (new java.lang.String( buf, start, count )).trim();
            if (s.length() > 0) {
                throw new org.xml.sax.SAXParseException( "Unexpected text \"" + s + "\"", helperImpl.locator );
            }
        }

        public  void endElement( java.lang.String name )
                throws org.xml.sax.SAXException
        {
            helperImpl.parser.setDocumentHandler( parentHandler );
        }

    }

    static class RootHandler extends org.xml.sax.HandlerBase
    {

        org.apache.tools.ant.helper.ProjectHelperImpl helperImpl;

        public RootHandler( org.apache.tools.ant.helper.ProjectHelperImpl helperImpl )
        {
            this.helperImpl = helperImpl;
        }

        public  org.xml.sax.InputSource resolveEntity( java.lang.String publicId, java.lang.String systemId )
        {
            helperImpl.project.log( "resolving systemId: " + systemId, Project.MSG_VERBOSE );
            if (systemId.startsWith( "file:" )) {
                java.lang.String path = FILE_UTILS.fromURI( systemId );
                java.io.File file = new java.io.File( path );
                if (!file.isAbsolute()) {
                    file = FILE_UTILS.resolveFile( helperImpl.buildFileParent, path );
                    helperImpl.project.log( "Warning: '" + systemId + "' in " + helperImpl.buildFile + " should be expressed simply as '" + path.replace( '\\', '/' ) + "' for compliance with other XML tools", Project.MSG_WARN );
                }
                try {
                    org.xml.sax.InputSource inputSource = new org.xml.sax.InputSource( new java.io.FileInputStream( file ) );
                    inputSource.setSystemId( FILE_UTILS.toURI( file.getAbsolutePath() ) );
                    return inputSource;
                } catch ( java.io.FileNotFoundException fne ) {
                    helperImpl.project.log( file.getAbsolutePath() + " could not be found", Project.MSG_WARN );
                }
            }
            return null;
        }

        public  void startElement( java.lang.String tag, org.xml.sax.AttributeList attrs )
                throws org.xml.sax.SAXParseException
        {
            if (tag.equals( "project" )) {
                (new org.apache.tools.ant.helper.ProjectHelperImpl.ProjectHandler( helperImpl, this )).init( tag, attrs );
            } else {
                throw new org.xml.sax.SAXParseException( "Config file is not of expected " + "XML type", helperImpl.locator );
            }
        }

        public  void setDocumentLocator( org.xml.sax.Locator locator )
        {
            helperImpl.locator = locator;
        }

    }

    static class ProjectHandler extends org.apache.tools.ant.helper.ProjectHelperImpl.AbstractHandler
    {

        public ProjectHandler( org.apache.tools.ant.helper.ProjectHelperImpl helperImpl, org.xml.sax.DocumentHandler parentHandler )
        {
            super( helperImpl, parentHandler );
        }

        public  void init( java.lang.String tag, org.xml.sax.AttributeList attrs )
                throws org.xml.sax.SAXParseException
        {
            java.lang.String def = null;
            java.lang.String name = null;
            java.lang.String id = null;
            java.lang.String baseDir = null;
            for (int i = 0; i < attrs.getLength(); i++) {
                java.lang.String key = attrs.getName( i );
                java.lang.String value = attrs.getValue( i );
                if (key.equals( "default" )) {
                    def = value;
                } else {
                    if (key.equals( "name" )) {
                        name = value;
                    } else {
                        if (key.equals( "id" )) {
                            id = value;
                        } else {
                            if (key.equals( "basedir" )) {
                                baseDir = value;
                            } else {
                                throw new org.xml.sax.SAXParseException( "Unexpected attribute \"" + attrs.getName( i ) + "\"", helperImpl.locator );
                            }
                        }
                    }
                }
            }
            if (def != null && !def.equals( "" )) {
                helperImpl.project.setDefault( def );
            } else {
                throw new org.apache.tools.ant.BuildException( "The default attribute is required" );
            }
            if (name != null) {
                helperImpl.project.setName( name );
                helperImpl.project.addReference( name, helperImpl.project );
            }
            if (id != null) {
                helperImpl.project.addReference( id, helperImpl.project );
            }
            if (helperImpl.project.getProperty( "basedir" ) != null) {
                helperImpl.project.setBasedir( helperImpl.project.getProperty( "basedir" ) );
            } else {
                if (baseDir == null) {
                    helperImpl.project.setBasedir( helperImpl.buildFileParent.getAbsolutePath() );
                } else {
                    if ((new java.io.File( baseDir )).isAbsolute()) {
                        helperImpl.project.setBasedir( baseDir );
                    } else {
                        java.io.File resolvedBaseDir = FILE_UTILS.resolveFile( helperImpl.buildFileParent, baseDir );
                        helperImpl.project.setBaseDir( resolvedBaseDir );
                    }
                }
            }
            helperImpl.project.addTarget( "", helperImpl.implicitTarget );
        }

        public  void startElement( java.lang.String name, org.xml.sax.AttributeList attrs )
                throws org.xml.sax.SAXParseException
        {
            if (name.equals( "target" )) {
                handleTarget( name, attrs );
            } else {
                handleElement( helperImpl, this, helperImpl.implicitTarget, name, attrs );
            }
        }

        private  void handleTarget( java.lang.String tag, org.xml.sax.AttributeList attrs )
                throws org.xml.sax.SAXParseException
        {
            (new org.apache.tools.ant.helper.ProjectHelperImpl.TargetHandler( helperImpl, this )).init( tag, attrs );
        }

    }

    static class TargetHandler extends org.apache.tools.ant.helper.ProjectHelperImpl.AbstractHandler
    {

        private org.apache.tools.ant.Target target;

        public TargetHandler( org.apache.tools.ant.helper.ProjectHelperImpl helperImpl, org.xml.sax.DocumentHandler parentHandler )
        {
            super( helperImpl, parentHandler );
        }

        public  void init( java.lang.String tag, org.xml.sax.AttributeList attrs )
                throws org.xml.sax.SAXParseException
        {
            java.lang.String name = null;
            java.lang.String depends = "";
            java.lang.String ifCond = null;
            java.lang.String unlessCond = null;
            java.lang.String id = null;
            java.lang.String description = null;
            for (int i = 0; i < attrs.getLength(); i++) {
                java.lang.String key = attrs.getName( i );
                java.lang.String value = attrs.getValue( i );
                if (key.equals( "name" )) {
                    name = value;
                    if (name.equals( "" )) {
                        throw new org.apache.tools.ant.BuildException( "name attribute must not" + " be empty", new org.apache.tools.ant.Location( helperImpl.locator ) );
                    }
                } else {
                    if (key.equals( "depends" )) {
                        depends = value;
                    } else {
                        if (key.equals( "if" )) {
                            ifCond = value;
                        } else {
                            if (key.equals( "unless" )) {
                                unlessCond = value;
                            } else {
                                if (key.equals( "id" )) {
                                    id = value;
                                } else {
                                    if (key.equals( "description" )) {
                                        description = value;
                                    } else {
                                        throw new org.xml.sax.SAXParseException( "Unexpected attribute \"" + key + "\"", helperImpl.locator );
                                    }
                                }
                            }
                        }
                    }
                }
            }
            if (name == null) {
                throw new org.xml.sax.SAXParseException( "target element appears without a name attribute", helperImpl.locator );
            }
            target = new org.apache.tools.ant.Target();
            target.addDependency( "" );
            target.setName( name );
            target.setIf( ifCond );
            target.setUnless( unlessCond );
            target.setDescription( description );
            helperImpl.project.addTarget( name, target );
            if (id != null && !id.equals( "" )) {
                helperImpl.project.addReference( id, target );
            }
            if (depends.length() > 0) {
                target.setDepends( depends );
            }
        }

        public  void startElement( java.lang.String name, org.xml.sax.AttributeList attrs )
                throws org.xml.sax.SAXParseException
        {
            handleElement( helperImpl, this, target, name, attrs );
        }

    }

    private static  void handleElement( org.apache.tools.ant.helper.ProjectHelperImpl helperImpl, org.xml.sax.DocumentHandler parent, org.apache.tools.ant.Target target, java.lang.String elementName, org.xml.sax.AttributeList attrs )
        throws org.xml.sax.SAXParseException
    {
        if (elementName.equals( "description" )) {
            new org.apache.tools.ant.helper.ProjectHelperImpl.DescriptionHandler( helperImpl, parent );
        } else {
            if (helperImpl.project.getDataTypeDefinitions().get( elementName ) != null) {
                (new org.apache.tools.ant.helper.ProjectHelperImpl.DataTypeHandler( helperImpl, parent, target )).init( elementName, attrs );
            } else {
                (new org.apache.tools.ant.helper.ProjectHelperImpl.TaskHandler( helperImpl, parent, target, null, target )).init( elementName, attrs );
            }
        }
    }

    static class DescriptionHandler extends org.apache.tools.ant.helper.ProjectHelperImpl.AbstractHandler
    {

        public DescriptionHandler( org.apache.tools.ant.helper.ProjectHelperImpl helperImpl, org.xml.sax.DocumentHandler parentHandler )
        {
            super( helperImpl, parentHandler );
        }

        public  void characters( char[] buf, int start, int count )
        {
            java.lang.String text = new java.lang.String( buf, start, count );
            java.lang.String currentDescription = helperImpl.project.getDescription();
            if (currentDescription == null) {
                helperImpl.project.setDescription( text );
            } else {
                helperImpl.project.setDescription( currentDescription + text );
            }
        }

    }

    static class TaskHandler extends org.apache.tools.ant.helper.ProjectHelperImpl.AbstractHandler
    {

        private org.apache.tools.ant.Target target;

        private org.apache.tools.ant.TaskContainer container;

        private org.apache.tools.ant.Task task;

        private org.apache.tools.ant.RuntimeConfigurable parentWrapper;

        private org.apache.tools.ant.RuntimeConfigurable wrapper = null;

        public TaskHandler( org.apache.tools.ant.helper.ProjectHelperImpl helperImpl, org.xml.sax.DocumentHandler parentHandler, org.apache.tools.ant.TaskContainer container, org.apache.tools.ant.RuntimeConfigurable parentWrapper, org.apache.tools.ant.Target target )
        {
            super( helperImpl, parentHandler );
            this.container = container;
            this.parentWrapper = parentWrapper;
            this.target = target;
        }

        public  void init( java.lang.String tag, org.xml.sax.AttributeList attrs )
                throws org.xml.sax.SAXParseException
        {
            try {
                task = helperImpl.project.createTask( tag );
            } catch ( org.apache.tools.ant.BuildException e ) {
            }
            if (task == null) {
                task = new org.apache.tools.ant.UnknownElement( tag );
                task.setProject( helperImpl.project );
                task.setTaskName( tag );
            }
            task.setLocation( new org.apache.tools.ant.Location( helperImpl.locator ) );
            helperImpl.configureId( task, attrs );
            task.setOwningTarget( target );
            container.addTask( task );
            task.init();
            wrapper = task.getRuntimeConfigurableWrapper();
            wrapper.setAttributes( attrs );
            if (parentWrapper != null) {
                parentWrapper.addChild( wrapper );
            }
        }

        public  void characters( char[] buf, int start, int count )
        {
            wrapper.addText( buf, start, count );
        }

        public  void startElement( java.lang.String name, org.xml.sax.AttributeList attrs )
                throws org.xml.sax.SAXParseException
        {
            if (task instanceof org.apache.tools.ant.TaskContainer) {
                (new org.apache.tools.ant.helper.ProjectHelperImpl.TaskHandler( helperImpl, this, (org.apache.tools.ant.TaskContainer) task, wrapper, target )).init( name, attrs );
            } else {
                (new org.apache.tools.ant.helper.ProjectHelperImpl.NestedElementHandler( helperImpl, this, task, wrapper, target )).init( name, attrs );
            }
        }

    }

    static class NestedElementHandler extends org.apache.tools.ant.helper.ProjectHelperImpl.AbstractHandler
    {

        private java.lang.Object parent;

        private java.lang.Object child;

        private org.apache.tools.ant.RuntimeConfigurable parentWrapper;

        private org.apache.tools.ant.RuntimeConfigurable childWrapper = null;

        private org.apache.tools.ant.Target target;

        public NestedElementHandler( org.apache.tools.ant.helper.ProjectHelperImpl helperImpl, org.xml.sax.DocumentHandler parentHandler, java.lang.Object parent, org.apache.tools.ant.RuntimeConfigurable parentWrapper, org.apache.tools.ant.Target target )
        {
            super( helperImpl, parentHandler );
            if (parent instanceof org.apache.tools.ant.TypeAdapter) {
                this.parent = ((org.apache.tools.ant.TypeAdapter) parent).getProxy();
            } else {
                this.parent = parent;
            }
            this.parentWrapper = parentWrapper;
            this.target = target;
        }

        public  void init( java.lang.String propType, org.xml.sax.AttributeList attrs )
                throws org.xml.sax.SAXParseException
        {
            java.lang.Class parentClass = parent.getClass();
            org.apache.tools.ant.IntrospectionHelper ih = IntrospectionHelper.getHelper( helperImpl.project, parentClass );
            try {
                java.lang.String elementName = propType.toLowerCase( Locale.ENGLISH );
                if (parent instanceof org.apache.tools.ant.UnknownElement) {
                    org.apache.tools.ant.UnknownElement uc = new org.apache.tools.ant.UnknownElement( elementName );
                    uc.setProject( helperImpl.project );
                    ((org.apache.tools.ant.UnknownElement) parent).addChild( uc );
                    child = uc;
                } else {
                    child = ih.createElement( helperImpl.project, parent, elementName );
                }
                helperImpl.configureId( child, attrs );
                childWrapper = new org.apache.tools.ant.RuntimeConfigurable( child, propType );
                childWrapper.setAttributes( attrs );
                parentWrapper.addChild( childWrapper );
            } catch ( org.apache.tools.ant.BuildException exc ) {
                throw new org.xml.sax.SAXParseException( exc.getMessage(), helperImpl.locator, exc );
            }
        }

        public  void characters( char[] buf, int start, int count )
        {
            childWrapper.addText( buf, start, count );
        }

        public  void startElement( java.lang.String name, org.xml.sax.AttributeList attrs )
                throws org.xml.sax.SAXParseException
        {
            if (child instanceof org.apache.tools.ant.TaskContainer) {
                (new org.apache.tools.ant.helper.ProjectHelperImpl.TaskHandler( helperImpl, this, (org.apache.tools.ant.TaskContainer) child, childWrapper, target )).init( name, attrs );
            } else {
                (new org.apache.tools.ant.helper.ProjectHelperImpl.NestedElementHandler( helperImpl, this, child, childWrapper, target )).init( name, attrs );
            }
        }

    }

    static class DataTypeHandler extends org.apache.tools.ant.helper.ProjectHelperImpl.AbstractHandler
    {

        private org.apache.tools.ant.Target target;

        private java.lang.Object element;

        private org.apache.tools.ant.RuntimeConfigurable wrapper = null;

        public DataTypeHandler( org.apache.tools.ant.helper.ProjectHelperImpl helperImpl, org.xml.sax.DocumentHandler parentHandler, org.apache.tools.ant.Target target )
        {
            super( helperImpl, parentHandler );
            this.target = target;
        }

        public  void init( java.lang.String propType, org.xml.sax.AttributeList attrs )
                throws org.xml.sax.SAXParseException
        {
            try {
                element = helperImpl.project.createDataType( propType );
                if (element == null) {
                    throw new org.apache.tools.ant.BuildException( "Unknown data type " + propType );
                }
                wrapper = new org.apache.tools.ant.RuntimeConfigurable( element, propType );
                wrapper.setAttributes( attrs );
                target.addDataType( wrapper );
            } catch ( org.apache.tools.ant.BuildException exc ) {
                throw new org.xml.sax.SAXParseException( exc.getMessage(), helperImpl.locator, exc );
            }
        }

        public  void characters( char[] buf, int start, int count )
        {
            wrapper.addText( buf, start, count );
        }

        public  void startElement( java.lang.String name, org.xml.sax.AttributeList attrs )
                throws org.xml.sax.SAXParseException
        {
            (new org.apache.tools.ant.helper.ProjectHelperImpl.NestedElementHandler( helperImpl, this, element, wrapper, target )).init( name, attrs );
        }

    }

    private  void configureId( java.lang.Object target, org.xml.sax.AttributeList attr )
    {
        java.lang.String id = attr.getValue( "id" );
        if (id != null) {
            project.addReference( id, target );
        }
    }

}
