// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.compilers;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.util.ClasspathUtils;
import org.apache.tools.ant.util.JavaEnvUtils;


public final class CompilerAdapterFactory
{

    private static final java.lang.String MODERN_COMPILER = "com.sun.tools.javac.Main";

    private CompilerAdapterFactory()
    {
    }

    public static  org.apache.tools.ant.taskdefs.compilers.CompilerAdapter getCompiler( java.lang.String compilerType, org.apache.tools.ant.Task task )
        throws org.apache.tools.ant.BuildException
    {
        return getCompiler( compilerType, task, null );
    }

    public static  org.apache.tools.ant.taskdefs.compilers.CompilerAdapter getCompiler( java.lang.String compilerType, org.apache.tools.ant.Task task, org.apache.tools.ant.types.Path classpath )
        throws org.apache.tools.ant.BuildException
    {
        if (compilerType.equalsIgnoreCase( "jikes" )) {
            return new org.apache.tools.ant.taskdefs.compilers.Jikes();
        }
        if (compilerType.equalsIgnoreCase( "extjavac" )) {
            return new org.apache.tools.ant.taskdefs.compilers.JavacExternal();
        }
        if (compilerType.equalsIgnoreCase( "classic" ) || compilerType.equalsIgnoreCase( "javac1.1" ) || compilerType.equalsIgnoreCase( "javac1.2" )) {
            task.log( "This version of java does " + "not support the classic " + "compiler; upgrading to modern", Project.MSG_WARN );
            compilerType = "modern";
        }
        if (compilerType.equalsIgnoreCase( "modern" ) || compilerType.equalsIgnoreCase( "javac1.3" ) || compilerType.equalsIgnoreCase( "javac1.4" ) || compilerType.equalsIgnoreCase( "javac1.5" ) || compilerType.equalsIgnoreCase( "javac1.6" ) || compilerType.equalsIgnoreCase( "javac1.7" )) {
            if (doesModernCompilerExist()) {
                return new org.apache.tools.ant.taskdefs.compilers.Javac13();
            } else {
                throw new org.apache.tools.ant.BuildException( "Unable to find a javac " + "compiler;\n" + MODERN_COMPILER + " is not on the " + "classpath.\n" + "Perhaps JAVA_HOME does not" + " point to the JDK.\n" + "It is currently set to \"" + JavaEnvUtils.getJavaHome() + "\"" );
            }
        }
        if (compilerType.equalsIgnoreCase( "jvc" ) || compilerType.equalsIgnoreCase( "microsoft" )) {
            return new org.apache.tools.ant.taskdefs.compilers.Jvc();
        }
        if (compilerType.equalsIgnoreCase( "kjc" )) {
            return new org.apache.tools.ant.taskdefs.compilers.Kjc();
        }
        if (compilerType.equalsIgnoreCase( "gcj" )) {
            return new org.apache.tools.ant.taskdefs.compilers.Gcj();
        }
        if (compilerType.equalsIgnoreCase( "sj" ) || compilerType.equalsIgnoreCase( "symantec" )) {
            return new org.apache.tools.ant.taskdefs.compilers.Sj();
        }
        return resolveClassName( compilerType, task.getProject().createClassLoader( classpath ) );
    }

    private static  boolean doesModernCompilerExist()
    {
        try {
            Class.forName( MODERN_COMPILER );
            return true;
        } catch ( java.lang.ClassNotFoundException cnfe ) {
            try {
                java.lang.ClassLoader cl = (org.apache.tools.ant.taskdefs.compilers.CompilerAdapterFactory.class).getClassLoader();
                if (cl != null) {
                    cl.loadClass( MODERN_COMPILER );
                    return true;
                }
            } catch ( java.lang.ClassNotFoundException cnfe2 ) {
            }
        }
        return false;
    }

    private static  org.apache.tools.ant.taskdefs.compilers.CompilerAdapter resolveClassName( java.lang.String className, java.lang.ClassLoader loader )
        throws org.apache.tools.ant.BuildException
    {
        return (org.apache.tools.ant.taskdefs.compilers.CompilerAdapter) ClasspathUtils.newInstance( className, loader != null ? loader : (org.apache.tools.ant.taskdefs.compilers.CompilerAdapterFactory.class).getClassLoader(), org.apache.tools.ant.taskdefs.compilers.CompilerAdapter.class );
    }

}
