// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.cvslib;


import java.io.IOException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Enumeration;
import java.util.TimeZone;
import org.apache.tools.ant.util.DOMElementWriter;
import org.apache.tools.ant.util.DOMUtils;
import org.w3c.dom.Document;
import org.w3c.dom.Element;


public class ChangeLogWriter
{

    private static final java.text.SimpleDateFormat OUTPUT_DATE = new java.text.SimpleDateFormat( "yyyy-MM-dd" );

    private static final java.text.SimpleDateFormat OUTPUT_TIME = new java.text.SimpleDateFormat( "HH:mm" );

    private static final org.apache.tools.ant.util.DOMElementWriter DOM_WRITER = new org.apache.tools.ant.util.DOMElementWriter();

    static {
        java.util.TimeZone utc = TimeZone.getTimeZone( "UTC" );
        OUTPUT_DATE.setTimeZone( utc );
        OUTPUT_TIME.setTimeZone( utc );
    }

    public  void printChangeLog( final java.io.PrintWriter output, final org.apache.tools.ant.taskdefs.cvslib.CVSEntry[] entries )
    {
        try {
            output.println( "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" );
            org.w3c.dom.Document doc = DOMUtils.newDocument();
            org.w3c.dom.Element root = doc.createElement( "changelog" );
            DOM_WRITER.openElement( root, output, 0, "\t" );
            output.println();
            for (int i = 0; i < entries.length; i++) {
                final org.apache.tools.ant.taskdefs.cvslib.CVSEntry entry = entries[i];
                printEntry( doc, output, entry );
            }
            DOM_WRITER.closeElement( root, output, 0, "\t", true );
            output.flush();
            output.close();
        } catch ( java.io.IOException e ) {
            throw new org.apache.tools.ant.BuildException( e );
        }
    }

    private  void printEntry( org.w3c.dom.Document doc, final java.io.PrintWriter output, final org.apache.tools.ant.taskdefs.cvslib.CVSEntry entry )
        throws java.io.IOException
    {
        org.w3c.dom.Element ent = doc.createElement( "entry" );
        DOMUtils.appendTextElement( ent, "date", OUTPUT_DATE.format( entry.getDate() ) );
        DOMUtils.appendTextElement( ent, "time", OUTPUT_TIME.format( entry.getDate() ) );
        DOMUtils.appendCDATAElement( ent, "author", entry.getAuthor() );
        final java.util.Enumeration enumeration = entry.getFiles().elements();
        while (enumeration.hasMoreElements()) {
            final org.apache.tools.ant.taskdefs.cvslib.RCSFile file = (org.apache.tools.ant.taskdefs.cvslib.RCSFile) enumeration.nextElement();
            org.w3c.dom.Element f = DOMUtils.createChildElement( ent, "file" );
            DOMUtils.appendCDATAElement( f, "name", file.getName() );
            DOMUtils.appendTextElement( f, "revision", file.getRevision() );
            final java.lang.String previousRevision = file.getPreviousRevision();
            if (previousRevision != null) {
                DOMUtils.appendTextElement( f, "prevrevision", previousRevision );
            }
        }
        DOMUtils.appendCDATAElement( ent, "msg", entry.getComment() );
        DOM_WRITER.write( ent, output, 1, "\t" );
    }

}
