// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional;


import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import org.apache.tools.ant.AntClassLoader;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.taskdefs.Execute;
import org.apache.tools.ant.taskdefs.LogOutputStream;
import org.apache.tools.ant.taskdefs.PumpStreamHandler;
import org.apache.tools.ant.taskdefs.condition.Os;
import org.apache.tools.ant.types.Commandline;
import org.apache.tools.ant.types.CommandlineJava;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.util.JavaEnvUtils;
import org.apache.tools.ant.util.LoaderUtils;
import org.apache.tools.ant.util.TeeOutputStream;
import org.apache.tools.ant.util.FileUtils;


public class ANTLR extends org.apache.tools.ant.Task
{

    private org.apache.tools.ant.types.CommandlineJava commandline = new org.apache.tools.ant.types.CommandlineJava();

    private java.io.File targetFile;

    private java.io.File outputDirectory;

    private java.io.File superGrammar;

    private boolean html;

    private boolean diagnostic;

    private boolean trace;

    private boolean traceParser;

    private boolean traceLexer;

    private boolean traceTreeWalker;

    private java.io.File workingdir = null;

    private java.io.ByteArrayOutputStream bos = new java.io.ByteArrayOutputStream();

    private boolean debug;

    private static final org.apache.tools.ant.util.FileUtils FILE_UTILS = FileUtils.getFileUtils();

    public ANTLR()
    {
        commandline.setVm( JavaEnvUtils.getJreExecutable( "java" ) );
        commandline.setClassname( "antlr.Tool" );
    }

    public  void setTarget( java.io.File target )
    {
        log( "Setting target to: " + target.toString(), Project.MSG_VERBOSE );
        this.targetFile = target;
    }

    public  void setOutputdirectory( java.io.File outputDirectory )
    {
        log( "Setting output directory to: " + outputDirectory.toString(), Project.MSG_VERBOSE );
        this.outputDirectory = outputDirectory;
    }

    public  void setGlib( java.lang.String superGrammar )
    {
        java.lang.String sg = null;
        if (Os.isFamily( "dos" )) {
            sg = superGrammar.replace( '\\', '/' );
        } else {
            sg = superGrammar;
        }
        setGlib( FILE_UTILS.resolveFile( getProject().getBaseDir(), sg ) );
    }

    public  void setGlib( java.io.File superGrammar )
    {
        this.superGrammar = superGrammar;
    }

    public  void setDebug( boolean enable )
    {
        this.debug = enable;
    }

    public  void setHtml( boolean enable )
    {
        html = enable;
    }

    public  void setDiagnostic( boolean enable )
    {
        diagnostic = enable;
    }

    public  void setTrace( boolean enable )
    {
        trace = enable;
    }

    public  void setTraceParser( boolean enable )
    {
        traceParser = enable;
    }

    public  void setTraceLexer( boolean enable )
    {
        traceLexer = enable;
    }

    public  void setTraceTreeWalker( boolean enable )
    {
        traceTreeWalker = enable;
    }

    public  void setFork( boolean s )
    {
    }

    public  void setDir( java.io.File d )
    {
        this.workingdir = d;
    }

    public  org.apache.tools.ant.types.Path createClasspath()
    {
        return commandline.createClasspath( getProject() ).createPath();
    }

    public  org.apache.tools.ant.types.Commandline.Argument createJvmarg()
    {
        return commandline.createVmArgument();
    }

    public  void init()
        throws org.apache.tools.ant.BuildException
    {
        addClasspathEntry( "/antlr/ANTLRGrammarParseBehavior.class" );
    }

    protected  void addClasspathEntry( java.lang.String resource )
    {
        if (resource.startsWith( "/" )) {
            resource = resource.substring( 1 );
        } else {
            resource = "org/apache/tools/ant/taskdefs/optional/" + resource;
        }
        java.io.File f = LoaderUtils.getResourceSource( getClass().getClassLoader(), resource );
        if (f != null) {
            log( "Found " + f.getAbsolutePath(), Project.MSG_DEBUG );
            createClasspath().setLocation( f );
        } else {
            log( "Couldn\'t find " + resource, Project.MSG_VERBOSE );
        }
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        validateAttributes();
        java.io.File generatedFile = getGeneratedFile();
        boolean targetIsOutOfDate = targetFile.lastModified() > generatedFile.lastModified();
        boolean superGrammarIsOutOfDate = superGrammar != null && superGrammar.lastModified() > generatedFile.lastModified();
        if (targetIsOutOfDate || superGrammarIsOutOfDate) {
            if (targetIsOutOfDate) {
                log( "Compiling " + targetFile + " as it is newer than " + generatedFile, Project.MSG_VERBOSE );
            } else {
                log( "Compiling " + targetFile + " as " + superGrammar + " is newer than " + generatedFile, Project.MSG_VERBOSE );
            }
            populateAttributes();
            commandline.createArgument().setValue( targetFile.toString() );
            log( commandline.describeCommand(), Project.MSG_VERBOSE );
            int err = run( commandline.getCommandline() );
            if (err != 0) {
                throw new org.apache.tools.ant.BuildException( "ANTLR returned: " + err, getLocation() );
            } else {
                java.lang.String output = bos.toString();
                if (output.indexOf( "error:" ) > -1) {
                    throw new org.apache.tools.ant.BuildException( "ANTLR signaled an error: " + output, getLocation() );
                }
            }
        } else {
            log( "Skipped grammar file. Generated file " + generatedFile + " is newer.", Project.MSG_VERBOSE );
        }
    }

    private  void populateAttributes()
    {
        commandline.createArgument().setValue( "-o" );
        commandline.createArgument().setValue( outputDirectory.toString() );
        if (superGrammar != null) {
            commandline.createArgument().setValue( "-glib" );
            commandline.createArgument().setValue( superGrammar.toString() );
        }
        if (html) {
            commandline.createArgument().setValue( "-html" );
        }
        if (diagnostic) {
            commandline.createArgument().setValue( "-diagnostic" );
        }
        if (trace) {
            commandline.createArgument().setValue( "-trace" );
        }
        if (traceParser) {
            commandline.createArgument().setValue( "-traceParser" );
        }
        if (traceLexer) {
            commandline.createArgument().setValue( "-traceLexer" );
        }
        if (traceTreeWalker) {
            if (is272()) {
                commandline.createArgument().setValue( "-traceTreeParser" );
            } else {
                commandline.createArgument().setValue( "-traceTreeWalker" );
            }
        }
        if (debug) {
            commandline.createArgument().setValue( "-debug" );
        }
    }

    private  void validateAttributes()
        throws org.apache.tools.ant.BuildException
    {
        if (targetFile == null || !targetFile.isFile()) {
            throw new org.apache.tools.ant.BuildException( "Invalid target: " + targetFile );
        }
        if (outputDirectory == null) {
            setOutputdirectory( new java.io.File( targetFile.getParent() ) );
        }
        if (!outputDirectory.isDirectory()) {
            throw new org.apache.tools.ant.BuildException( "Invalid output directory: " + outputDirectory );
        }
    }

    private  java.io.File getGeneratedFile()
        throws org.apache.tools.ant.BuildException
    {
        java.lang.String generatedFileName = null;
        try {
            java.io.BufferedReader in = new java.io.BufferedReader( new java.io.FileReader( targetFile ) );
            java.lang.String line;
            while ((line = in.readLine()) != null) {
                int extendsIndex = line.indexOf( " extends " );
                if (line.startsWith( "class " ) && extendsIndex > -1) {
                    generatedFileName = line.substring( "class ".length(), extendsIndex ).trim();
                    break;
                }
            }
            in.close();
        } catch ( java.lang.Exception e ) {
            throw new org.apache.tools.ant.BuildException( "Unable to determine generated class", e );
        }
        if (generatedFileName == null) {
            throw new org.apache.tools.ant.BuildException( "Unable to determine generated class" );
        }
        return new java.io.File( outputDirectory, generatedFileName + (html ? ".html" : ".java") );
    }

    private  int run( java.lang.String[] command )
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.taskdefs.PumpStreamHandler psh = new org.apache.tools.ant.taskdefs.PumpStreamHandler( new org.apache.tools.ant.taskdefs.LogOutputStream( this, Project.MSG_INFO ), new org.apache.tools.ant.util.TeeOutputStream( new org.apache.tools.ant.taskdefs.LogOutputStream( this, Project.MSG_WARN ), bos ) );
        org.apache.tools.ant.taskdefs.Execute exe = new org.apache.tools.ant.taskdefs.Execute( psh, null );
        exe.setAntRun( getProject() );
        if (workingdir != null) {
            exe.setWorkingDirectory( workingdir );
        }
        exe.setCommandline( command );
        try {
            return exe.execute();
        } catch ( java.io.IOException e ) {
            throw new org.apache.tools.ant.BuildException( e, getLocation() );
        } finally 
{
            FileUtils.close( bos );
        }
    }

    protected  boolean is272()
    {
        org.apache.tools.ant.AntClassLoader l = null;
        try {
            l = getProject().createClassLoader( commandline.getClasspath() );
            l.loadClass( "antlr.Version" );
            return true;
        } catch ( java.lang.ClassNotFoundException e ) {
            return false;
        } finally 
{
            if (l != null) {
                l.cleanup();
            }
        }
    }

}
