// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional;


import java.io.File;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.DirectoryScanner;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.MatchingTask;
import org.apache.tools.ant.taskdefs.optional.native2ascii.Native2AsciiAdapter;
import org.apache.tools.ant.taskdefs.optional.native2ascii.Native2AsciiAdapterFactory;
import org.apache.tools.ant.types.Mapper;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.util.FileNameMapper;
import org.apache.tools.ant.util.IdentityMapper;
import org.apache.tools.ant.util.SourceFileScanner;
import org.apache.tools.ant.util.facade.FacadeTaskHelper;
import org.apache.tools.ant.util.facade.ImplementationSpecificArgument;


public class Native2Ascii extends org.apache.tools.ant.taskdefs.MatchingTask
{

    private boolean reverse = false;

    private java.lang.String encoding = null;

    private java.io.File srcDir = null;

    private java.io.File destDir = null;

    private java.lang.String extension = null;

    private org.apache.tools.ant.types.Mapper mapper;

    private org.apache.tools.ant.util.facade.FacadeTaskHelper facade = null;

    private org.apache.tools.ant.taskdefs.optional.native2ascii.Native2AsciiAdapter nestedAdapter = null;

    public Native2Ascii()
    {
        facade = new org.apache.tools.ant.util.facade.FacadeTaskHelper( Native2AsciiAdapterFactory.getDefault() );
    }

    public  void setReverse( boolean reverse )
    {
        this.reverse = reverse;
    }

    public  boolean getReverse()
    {
        return reverse;
    }

    public  void setEncoding( java.lang.String encoding )
    {
        this.encoding = encoding;
    }

    public  java.lang.String getEncoding()
    {
        return encoding;
    }

    public  void setSrc( java.io.File srcDir )
    {
        this.srcDir = srcDir;
    }

    public  void setDest( java.io.File destDir )
    {
        this.destDir = destDir;
    }

    public  void setExt( java.lang.String ext )
    {
        this.extension = ext;
    }

    public  void setImplementation( java.lang.String impl )
    {
        if ("default".equals( impl )) {
            facade.setImplementation( Native2AsciiAdapterFactory.getDefault() );
        } else {
            facade.setImplementation( impl );
        }
    }

    public  org.apache.tools.ant.types.Mapper createMapper()
        throws org.apache.tools.ant.BuildException
    {
        if (mapper != null) {
            throw new org.apache.tools.ant.BuildException( "Cannot define more than one mapper", getLocation() );
        }
        mapper = new org.apache.tools.ant.types.Mapper( getProject() );
        return mapper;
    }

    public  void add( org.apache.tools.ant.util.FileNameMapper fileNameMapper )
    {
        createMapper().add( fileNameMapper );
    }

    public  org.apache.tools.ant.util.facade.ImplementationSpecificArgument createArg()
    {
        org.apache.tools.ant.util.facade.ImplementationSpecificArgument arg = new org.apache.tools.ant.util.facade.ImplementationSpecificArgument();
        facade.addImplementationArgument( arg );
        return arg;
    }

    public  org.apache.tools.ant.types.Path createImplementationClasspath()
    {
        return facade.getImplementationClasspath( getProject() );
    }

    public  void add( org.apache.tools.ant.taskdefs.optional.native2ascii.Native2AsciiAdapter adapter )
    {
        if (nestedAdapter != null) {
            throw new org.apache.tools.ant.BuildException( "Can't have more than one native2ascii" + " adapter" );
        }
        nestedAdapter = adapter;
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.DirectoryScanner scanner = null;
        java.lang.String[] files;
        if (srcDir == null) {
            srcDir = getProject().resolveFile( "." );
        }
        if (destDir == null) {
            throw new org.apache.tools.ant.BuildException( "The dest attribute must be set." );
        }
        if (srcDir.equals( destDir ) && extension == null && mapper == null) {
            throw new org.apache.tools.ant.BuildException( "The ext attribute or a mapper must be set if" + " src and dest dirs are the same." );
        }
        org.apache.tools.ant.util.FileNameMapper m = null;
        if (mapper == null) {
            if (extension == null) {
                m = new org.apache.tools.ant.util.IdentityMapper();
            } else {
                m = new org.apache.tools.ant.taskdefs.optional.Native2Ascii.ExtMapper();
            }
        } else {
            m = mapper.getImplementation();
        }
        scanner = getDirectoryScanner( srcDir );
        files = scanner.getIncludedFiles();
        org.apache.tools.ant.util.SourceFileScanner sfs = new org.apache.tools.ant.util.SourceFileScanner( this );
        files = sfs.restrict( files, srcDir, destDir, m );
        int count = files.length;
        if (count == 0) {
            return;
        }
        java.lang.String message = "Converting " + count + " file" + (count != 1 ? "s" : "") + " from ";
        log( message + srcDir + " to " + destDir );
        for (int i = 0; i < files.length; i++) {
            convert( files[i], m.mapFileName( files[i] )[0] );
        }
    }

    private  void convert( java.lang.String srcName, java.lang.String destName )
        throws org.apache.tools.ant.BuildException
    {
        java.io.File srcFile;
        java.io.File destFile;
        srcFile = new java.io.File( srcDir, srcName );
        destFile = new java.io.File( destDir, destName );
        if (srcFile.equals( destFile )) {
            throw new org.apache.tools.ant.BuildException( "file " + srcFile + " would overwrite its self" );
        }
        java.lang.String parentName = destFile.getParent();
        if (parentName != null) {
            java.io.File parentFile = new java.io.File( parentName );
            if (!parentFile.exists() && !parentFile.mkdirs()) {
                throw new org.apache.tools.ant.BuildException( "cannot create parent directory " + parentName );
            }
        }
        log( "converting " + srcName, Project.MSG_VERBOSE );
        org.apache.tools.ant.taskdefs.optional.native2ascii.Native2AsciiAdapter ad = nestedAdapter != null ? nestedAdapter : Native2AsciiAdapterFactory.getAdapter( facade.getImplementation(), this, createImplementationClasspath() );
        if (!ad.convert( this, srcFile, destFile )) {
            throw new org.apache.tools.ant.BuildException( "conversion failed" );
        }
    }

    public  java.lang.String[] getCurrentArgs()
    {
        return facade.getArgs();
    }

    private class ExtMapper implements org.apache.tools.ant.util.FileNameMapper
    {

        public  void setFrom( java.lang.String s )
        {
        }

        public  void setTo( java.lang.String s )
        {
        }

        public  java.lang.String[] mapFileName( java.lang.String fileName )
        {
            int lastDot = fileName.lastIndexOf( '.' );
            if (lastDot >= 0) {
                return new java.lang.String[]{ fileName.substring( 0, lastDot ) + extension };
            } else {
                return new java.lang.String[]{ fileName + extension };
            }
        }

    }

}
