// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional;


import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Enumeration;
import java.util.Map;
import java.util.Vector;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.util.FileUtils;
import org.apache.tools.ant.taskdefs.Execute;
import org.apache.tools.ant.taskdefs.ExecuteStreamHandler;
import org.apache.tools.ant.taskdefs.LogOutputStream;
import org.apache.tools.ant.taskdefs.LogStreamHandler;
import org.apache.tools.ant.taskdefs.PumpStreamHandler;
import org.apache.tools.ant.taskdefs.condition.Os;
import org.apache.tools.ant.types.Commandline;
import org.apache.tools.ant.types.Path;


public class Rpm extends org.apache.tools.ant.Task
{

    private static final java.lang.String PATH1 = "PATH";

    private static final java.lang.String PATH2 = "Path";

    private static final java.lang.String PATH3 = "path";

    private java.lang.String specFile;

    private java.io.File topDir;

    private java.lang.String command = "-bb";

    private java.lang.String rpmBuildCommand = null;

    private boolean cleanBuildDir = false;

    private boolean removeSpec = false;

    private boolean removeSource = false;

    private java.io.File output;

    private java.io.File error;

    private boolean failOnError = false;

    private boolean quiet = false;

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.types.Commandline toExecute = new org.apache.tools.ant.types.Commandline();
        toExecute.setExecutable( rpmBuildCommand == null ? guessRpmBuildCommand() : rpmBuildCommand );
        if (topDir != null) {
            toExecute.createArgument().setValue( "--define" );
            toExecute.createArgument().setValue( "_topdir " + topDir );
        }
        toExecute.createArgument().setLine( command );
        if (cleanBuildDir) {
            toExecute.createArgument().setValue( "--clean" );
        }
        if (removeSpec) {
            toExecute.createArgument().setValue( "--rmspec" );
        }
        if (removeSource) {
            toExecute.createArgument().setValue( "--rmsource" );
        }
        toExecute.createArgument().setValue( "SPECS/" + specFile );
        org.apache.tools.ant.taskdefs.ExecuteStreamHandler streamhandler = null;
        java.io.OutputStream outputstream = null;
        java.io.OutputStream errorstream = null;
        if (error == null && output == null) {
            if (!quiet) {
                streamhandler = new org.apache.tools.ant.taskdefs.LogStreamHandler( this, Project.MSG_INFO, Project.MSG_WARN );
            } else {
                streamhandler = new org.apache.tools.ant.taskdefs.LogStreamHandler( this, Project.MSG_DEBUG, Project.MSG_DEBUG );
            }
        } else {
            if (output != null) {
                try {
                    java.io.BufferedOutputStream bos = new java.io.BufferedOutputStream( new java.io.FileOutputStream( output ) );
                    outputstream = new java.io.PrintStream( bos );
                } catch ( java.io.IOException e ) {
                    throw new org.apache.tools.ant.BuildException( e, getLocation() );
                }
            } else {
                if (!quiet) {
                    outputstream = new org.apache.tools.ant.taskdefs.LogOutputStream( this, Project.MSG_INFO );
                } else {
                    outputstream = new org.apache.tools.ant.taskdefs.LogOutputStream( this, Project.MSG_DEBUG );
                }
            }
            if (error != null) {
                try {
                    java.io.BufferedOutputStream bos = new java.io.BufferedOutputStream( new java.io.FileOutputStream( error ) );
                    errorstream = new java.io.PrintStream( bos );
                } catch ( java.io.IOException e ) {
                    throw new org.apache.tools.ant.BuildException( e, getLocation() );
                }
            } else {
                if (!quiet) {
                    errorstream = new org.apache.tools.ant.taskdefs.LogOutputStream( this, Project.MSG_WARN );
                } else {
                    errorstream = new org.apache.tools.ant.taskdefs.LogOutputStream( this, Project.MSG_DEBUG );
                }
            }
            streamhandler = new org.apache.tools.ant.taskdefs.PumpStreamHandler( outputstream, errorstream );
        }
        org.apache.tools.ant.taskdefs.Execute exe = getExecute( toExecute, streamhandler );
        try {
            log( "Building the RPM based on the " + specFile + " file" );
            int returncode = exe.execute();
            if (Execute.isFailure( returncode )) {
                java.lang.String msg = "'" + toExecute.getExecutable() + "' failed with exit code " + returncode;
                if (failOnError) {
                    throw new org.apache.tools.ant.BuildException( msg );
                }
                log( msg, Project.MSG_ERR );
            }
        } catch ( java.io.IOException e ) {
            throw new org.apache.tools.ant.BuildException( e, getLocation() );
        } finally 
{
            FileUtils.close( outputstream );
            FileUtils.close( errorstream );
        }
    }

    public  void setTopDir( java.io.File td )
    {
        this.topDir = td;
    }

    public  void setCommand( java.lang.String c )
    {
        this.command = c;
    }

    public  void setSpecFile( java.lang.String sf )
    {
        if (sf == null || sf.trim().length() == 0) {
            throw new org.apache.tools.ant.BuildException( "You must specify a spec file", getLocation() );
        }
        this.specFile = sf;
    }

    public  void setCleanBuildDir( boolean cbd )
    {
        cleanBuildDir = cbd;
    }

    public  void setRemoveSpec( boolean rs )
    {
        removeSpec = rs;
    }

    public  void setRemoveSource( boolean rs )
    {
        removeSource = rs;
    }

    public  void setOutput( java.io.File output )
    {
        this.output = output;
    }

    public  void setError( java.io.File error )
    {
        this.error = error;
    }

    public  void setRpmBuildCommand( java.lang.String c )
    {
        this.rpmBuildCommand = c;
    }

    public  void setFailOnError( boolean value )
    {
        failOnError = value;
    }

    public  void setQuiet( boolean value )
    {
        quiet = value;
    }

    protected  java.lang.String guessRpmBuildCommand()
    {
        java.util.Map env = Execute.getEnvironmentVariables();
        java.lang.String path = (java.lang.String) env.get( PATH1 );
        if (path == null) {
            path = (java.lang.String) env.get( PATH2 );
            if (path == null) {
                path = (java.lang.String) env.get( PATH3 );
            }
        }
        if (path != null) {
            org.apache.tools.ant.types.Path p = new org.apache.tools.ant.types.Path( getProject(), path );
            java.lang.String[] pElements = p.list();
            for (int i = 0; i < pElements.length; i++) {
                java.io.File f = new java.io.File( pElements[i], "rpmbuild" + (Os.isFamily( "dos" ) ? ".exe" : "") );
                if (f.canRead()) {
                    return f.getAbsolutePath();
                }
            }
        }
        return "rpm";
    }

    protected  org.apache.tools.ant.taskdefs.Execute getExecute( org.apache.tools.ant.types.Commandline toExecute, org.apache.tools.ant.taskdefs.ExecuteStreamHandler streamhandler )
    {
        org.apache.tools.ant.taskdefs.Execute exe = new org.apache.tools.ant.taskdefs.Execute( streamhandler, null );
        exe.setAntRun( getProject() );
        if (topDir == null) {
            topDir = getProject().getBaseDir();
        }
        exe.setWorkingDirectory( topDir );
        exe.setCommandline( toExecute.getCommandline() );
        return exe;
    }

}
