// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional;


import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.util.FileUtils;
import org.apache.tools.ant.util.XmlConstants;
import org.xml.sax.XMLReader;
import org.xml.sax.SAXNotRecognizedException;
import org.xml.sax.SAXNotSupportedException;
import org.xml.sax.SAXException;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.ParserConfigurationException;
import java.util.Iterator;
import java.util.HashMap;
import java.io.File;
import java.net.MalformedURLException;


public class SchemaValidate extends org.apache.tools.ant.taskdefs.optional.XMLValidateTask
{

    private java.util.HashMap schemaLocations = new java.util.HashMap();

    private boolean fullChecking = true;

    private boolean disableDTD = false;

    private org.apache.tools.ant.taskdefs.optional.SchemaValidate.SchemaLocation anonymousSchema;

    public static final java.lang.String ERROR_SAX_1 = "SAX1 parsers are not supported";

    public static final java.lang.String ERROR_NO_XSD_SUPPORT = "Parser does not support Xerces or JAXP schema features";

    public static final java.lang.String ERROR_TOO_MANY_DEFAULT_SCHEMAS = "Only one of defaultSchemaFile and defaultSchemaURL allowed";

    public static final java.lang.String ERROR_PARSER_CREATION_FAILURE = "Could not create parser";

    public static final java.lang.String MESSAGE_ADDING_SCHEMA = "Adding schema ";

    public static final java.lang.String ERROR_DUPLICATE_SCHEMA = "Duplicate declaration of schema ";

    public  void init()
        throws org.apache.tools.ant.BuildException
    {
        super.init();
        setLenient( false );
    }

    public  boolean enableXercesSchemaValidation()
    {
        try {
            setFeature( XmlConstants.FEATURE_XSD, true );
            setNoNamespaceSchemaProperty( XmlConstants.PROPERTY_NO_NAMESPACE_SCHEMA_LOCATION );
        } catch ( org.apache.tools.ant.BuildException e ) {
            log( e.toString(), Project.MSG_VERBOSE );
            return false;
        }
        return true;
    }

    private  void setNoNamespaceSchemaProperty( java.lang.String property )
    {
        java.lang.String anonSchema = getNoNamespaceSchemaURL();
        if (anonSchema != null) {
            setProperty( property, anonSchema );
        }
    }

    public  boolean enableJAXP12SchemaValidation()
    {
        try {
            setProperty( XmlConstants.FEATURE_JAXP12_SCHEMA_LANGUAGE, XmlConstants.URI_XSD );
            setNoNamespaceSchemaProperty( XmlConstants.FEATURE_JAXP12_SCHEMA_SOURCE );
        } catch ( org.apache.tools.ant.BuildException e ) {
            log( e.toString(), Project.MSG_VERBOSE );
            return false;
        }
        return true;
    }

    public  void addConfiguredSchema( org.apache.tools.ant.taskdefs.optional.SchemaValidate.SchemaLocation location )
    {
        log( "adding schema " + location, Project.MSG_DEBUG );
        location.validateNamespace();
        org.apache.tools.ant.taskdefs.optional.SchemaValidate.SchemaLocation old = (org.apache.tools.ant.taskdefs.optional.SchemaValidate.SchemaLocation) schemaLocations.get( location.getNamespace() );
        if (old != null && !old.equals( location )) {
            throw new org.apache.tools.ant.BuildException( ERROR_DUPLICATE_SCHEMA + location );
        }
        schemaLocations.put( location.getNamespace(), location );
    }

    public  void setFullChecking( boolean fullChecking )
    {
        this.fullChecking = fullChecking;
    }

    protected  void createAnonymousSchema()
    {
        if (anonymousSchema == null) {
            anonymousSchema = new org.apache.tools.ant.taskdefs.optional.SchemaValidate.SchemaLocation();
        }
        anonymousSchema.setNamespace( "(no namespace)" );
    }

    public  void setNoNamespaceURL( java.lang.String defaultSchemaURL )
    {
        createAnonymousSchema();
        this.anonymousSchema.setUrl( defaultSchemaURL );
    }

    public  void setNoNamespaceFile( java.io.File defaultSchemaFile )
    {
        createAnonymousSchema();
        this.anonymousSchema.setFile( defaultSchemaFile );
    }

    public  void setDisableDTD( boolean disableDTD )
    {
        this.disableDTD = disableDTD;
    }

    protected  void initValidator()
    {
        super.initValidator();
        if (isSax1Parser()) {
            throw new org.apache.tools.ant.BuildException( ERROR_SAX_1 );
        }
        setFeature( XmlConstants.FEATURE_NAMESPACES, true );
        if (!enableXercesSchemaValidation() && !enableJAXP12SchemaValidation()) {
            throw new org.apache.tools.ant.BuildException( ERROR_NO_XSD_SUPPORT );
        }
        setFeature( XmlConstants.FEATURE_XSD_FULL_VALIDATION, fullChecking );
        setFeatureIfSupported( XmlConstants.FEATURE_DISALLOW_DTD, disableDTD );
        addSchemaLocations();
    }

    protected  org.xml.sax.XMLReader createDefaultReader()
    {
        javax.xml.parsers.SAXParserFactory factory = SAXParserFactory.newInstance();
        factory.setValidating( true );
        factory.setNamespaceAware( true );
        org.xml.sax.XMLReader reader = null;
        try {
            javax.xml.parsers.SAXParser saxParser = factory.newSAXParser();
            reader = saxParser.getXMLReader();
        } catch ( javax.xml.parsers.ParserConfigurationException e ) {
            throw new org.apache.tools.ant.BuildException( ERROR_PARSER_CREATION_FAILURE, e );
        } catch ( org.xml.sax.SAXException e ) {
            throw new org.apache.tools.ant.BuildException( ERROR_PARSER_CREATION_FAILURE, e );
        }
        return reader;
    }

    protected  void addSchemaLocations()
    {
        java.util.Iterator it = schemaLocations.values().iterator();
        java.lang.StringBuffer buffer = new java.lang.StringBuffer();
        int count = 0;
        while (it.hasNext()) {
            if (count > 0) {
                buffer.append( ' ' );
            }
            org.apache.tools.ant.taskdefs.optional.SchemaValidate.SchemaLocation schemaLocation = (org.apache.tools.ant.taskdefs.optional.SchemaValidate.SchemaLocation) it.next();
            java.lang.String tuple = schemaLocation.getURIandLocation();
            buffer.append( tuple );
            log( "Adding schema " + tuple, Project.MSG_VERBOSE );
            count++;
        }
        if (count > 0) {
            setProperty( XmlConstants.PROPERTY_SCHEMA_LOCATION, buffer.toString() );
        }
    }

    protected  java.lang.String getNoNamespaceSchemaURL()
    {
        if (anonymousSchema == null) {
            return null;
        } else {
            return anonymousSchema.getSchemaLocationURL();
        }
    }

    protected  void setFeatureIfSupported( java.lang.String feature, boolean value )
    {
        try {
            getXmlReader().setFeature( feature, value );
        } catch ( org.xml.sax.SAXNotRecognizedException e ) {
            log( "Not recognizied: " + feature, Project.MSG_VERBOSE );
        } catch ( org.xml.sax.SAXNotSupportedException e ) {
            log( "Not supported: " + feature, Project.MSG_VERBOSE );
        }
    }

    protected  void onSuccessfulValidation( int fileProcessed )
    {
        log( fileProcessed + MESSAGE_FILES_VALIDATED, Project.MSG_VERBOSE );
    }

    public static class SchemaLocation
    {

        private java.lang.String namespace;

        private java.io.File file;

        private java.lang.String url;

        public static final java.lang.String ERROR_NO_URI = "No namespace URI";

        public static final java.lang.String ERROR_TWO_LOCATIONS = "Both URL and File were given for schema ";

        public static final java.lang.String ERROR_NO_FILE = "File not found: ";

        public static final java.lang.String ERROR_NO_URL_REPRESENTATION = "Cannot make a URL of ";

        public static final java.lang.String ERROR_NO_LOCATION = "No file or URL supplied for the schema ";

        public SchemaLocation()
        {
        }

        public  java.lang.String getNamespace()
        {
            return namespace;
        }

        public  void setNamespace( java.lang.String namespace )
        {
            this.namespace = namespace;
        }

        public  java.io.File getFile()
        {
            return file;
        }

        public  void setFile( java.io.File file )
        {
            this.file = file;
        }

        public  java.lang.String getUrl()
        {
            return url;
        }

        public  void setUrl( java.lang.String url )
        {
            this.url = url;
        }

        public  java.lang.String getSchemaLocationURL()
        {
            boolean hasFile = file != null;
            boolean hasURL = isSet( url );
            if (!hasFile && !hasURL) {
                throw new org.apache.tools.ant.BuildException( ERROR_NO_LOCATION + namespace );
            }
            if (hasFile && hasURL) {
                throw new org.apache.tools.ant.BuildException( ERROR_TWO_LOCATIONS + namespace );
            }
            java.lang.String schema = url;
            if (hasFile) {
                if (!file.exists()) {
                    throw new org.apache.tools.ant.BuildException( ERROR_NO_FILE + file );
                }
                try {
                    schema = FileUtils.getFileUtils().getFileURL( file ).toString();
                } catch ( java.net.MalformedURLException e ) {
                    throw new org.apache.tools.ant.BuildException( ERROR_NO_URL_REPRESENTATION + file, e );
                }
            }
            return schema;
        }

        public  java.lang.String getURIandLocation()
                throws org.apache.tools.ant.BuildException
        {
            validateNamespace();
            java.lang.StringBuffer buffer = new java.lang.StringBuffer();
            buffer.append( namespace );
            buffer.append( ' ' );
            buffer.append( getSchemaLocationURL() );
            return new java.lang.String( buffer );
        }

        public  void validateNamespace()
        {
            if (!isSet( getNamespace() )) {
                throw new org.apache.tools.ant.BuildException( ERROR_NO_URI );
            }
        }

        private  boolean isSet( java.lang.String property )
        {
            return property != null && property.length() != 0;
        }

        public  boolean equals( java.lang.Object o )
        {
            if (this == o) {
                return true;
            }
            if (!(o instanceof org.apache.tools.ant.taskdefs.optional.SchemaValidate.SchemaLocation)) {
                return false;
            }
            final org.apache.tools.ant.taskdefs.optional.SchemaValidate.SchemaLocation schemaLocation = (org.apache.tools.ant.taskdefs.optional.SchemaValidate.SchemaLocation) o;
            if (file != null ? !file.equals( schemaLocation.file ) : schemaLocation.file != null) {
                return false;
            }
            if (namespace != null ? !namespace.equals( schemaLocation.namespace ) : schemaLocation.namespace != null) {
                return false;
            }
            if (url != null ? !url.equals( schemaLocation.url ) : schemaLocation.url != null) {
                return false;
            }
            return true;
        }

        public  int hashCode()
        {
            int result;
            result = namespace != null ? namespace.hashCode() : 0;
            result = 29 * result + (file != null ? file.hashCode() : 0);
            result = 29 * result + (url != null ? url.hashCode() : 0);
            return result;
        }

        public  java.lang.String toString()
        {
            java.lang.StringBuffer buffer = new java.lang.StringBuffer();
            buffer.append( namespace != null ? namespace : "(anonymous)" );
            buffer.append( ' ' );
            buffer.append( url != null ? url + " " : "" );
            buffer.append( file != null ? file.getAbsolutePath() : "" );
            return buffer.toString();
        }

    }

}
