// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional;


import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Vector;
import org.apache.tools.ant.AntClassLoader;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.DirectoryScanner;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.types.DTDLocation;
import org.apache.tools.ant.types.FileSet;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.types.Reference;
import org.apache.tools.ant.types.XMLCatalog;
import org.apache.tools.ant.util.FileUtils;
import org.apache.tools.ant.util.JAXPUtils;
import org.apache.tools.ant.util.XmlConstants;
import org.xml.sax.EntityResolver;
import org.xml.sax.ErrorHandler;
import org.xml.sax.InputSource;
import org.xml.sax.Parser;
import org.xml.sax.SAXException;
import org.xml.sax.SAXNotRecognizedException;
import org.xml.sax.SAXNotSupportedException;
import org.xml.sax.SAXParseException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.ParserAdapter;


public class XMLValidateTask extends org.apache.tools.ant.Task
{

    private static final org.apache.tools.ant.util.FileUtils FILE_UTILS = FileUtils.getFileUtils();

    protected static final java.lang.String INIT_FAILED_MSG = "Could not start xml validation: ";

    protected boolean failOnError = true;

    protected boolean warn = true;

    protected boolean lenient = false;

    protected java.lang.String readerClassName = null;

    protected java.io.File file = null;

    protected java.util.Vector filesets = new java.util.Vector();

    protected org.apache.tools.ant.types.Path classpath;

    protected org.xml.sax.XMLReader xmlReader = null;

    protected org.apache.tools.ant.taskdefs.optional.XMLValidateTask.ValidatorErrorHandler errorHandler = new org.apache.tools.ant.taskdefs.optional.XMLValidateTask.ValidatorErrorHandler();

    private java.util.Vector attributeList = new java.util.Vector();

    private final java.util.Vector propertyList = new java.util.Vector();

    private org.apache.tools.ant.types.XMLCatalog xmlCatalog = new org.apache.tools.ant.types.XMLCatalog();

    public static final java.lang.String MESSAGE_FILES_VALIDATED = " file(s) have been successfully validated.";

    private org.apache.tools.ant.AntClassLoader readerLoader = null;

    public  void setFailOnError( boolean fail )
    {
        failOnError = fail;
    }

    public  void setWarn( boolean bool )
    {
        warn = bool;
    }

    public  void setLenient( boolean bool )
    {
        lenient = bool;
    }

    public  void setClassName( java.lang.String className )
    {
        readerClassName = className;
    }

    public  void setClasspath( org.apache.tools.ant.types.Path classpath )
    {
        if (this.classpath == null) {
            this.classpath = classpath;
        } else {
            this.classpath.append( classpath );
        }
    }

    public  org.apache.tools.ant.types.Path createClasspath()
    {
        if (this.classpath == null) {
            this.classpath = new org.apache.tools.ant.types.Path( getProject() );
        }
        return this.classpath.createPath();
    }

    public  void setClasspathRef( org.apache.tools.ant.types.Reference r )
    {
        createClasspath().setRefid( r );
    }

    public  void setFile( java.io.File file )
    {
        this.file = file;
    }

    public  void addConfiguredXMLCatalog( org.apache.tools.ant.types.XMLCatalog catalog )
    {
        xmlCatalog.addConfiguredXMLCatalog( catalog );
    }

    public  void addFileset( org.apache.tools.ant.types.FileSet set )
    {
        filesets.addElement( set );
    }

    public  org.apache.tools.ant.taskdefs.optional.XMLValidateTask.Attribute createAttribute()
    {
        final org.apache.tools.ant.taskdefs.optional.XMLValidateTask.Attribute feature = new org.apache.tools.ant.taskdefs.optional.XMLValidateTask.Attribute();
        attributeList.addElement( feature );
        return feature;
    }

    public  org.apache.tools.ant.taskdefs.optional.XMLValidateTask.Property createProperty()
    {
        final org.apache.tools.ant.taskdefs.optional.XMLValidateTask.Property prop = new org.apache.tools.ant.taskdefs.optional.XMLValidateTask.Property();
        propertyList.addElement( prop );
        return prop;
    }

    public  void init()
        throws org.apache.tools.ant.BuildException
    {
        super.init();
        xmlCatalog.setProject( getProject() );
    }

    public  org.apache.tools.ant.types.DTDLocation createDTD()
    {
        org.apache.tools.ant.types.DTDLocation dtdLocation = new org.apache.tools.ant.types.DTDLocation();
        xmlCatalog.addDTD( dtdLocation );
        return dtdLocation;
    }

    protected  org.xml.sax.EntityResolver getEntityResolver()
    {
        return xmlCatalog;
    }

    protected  org.xml.sax.XMLReader getXmlReader()
    {
        return xmlReader;
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        try {
            int fileProcessed = 0;
            if (file == null && filesets.size() == 0) {
                throw new org.apache.tools.ant.BuildException( "Specify at least one source - " + "a file or a fileset." );
            }
            if (file != null) {
                if (file.exists() && file.canRead() && file.isFile()) {
                    doValidate( file );
                    fileProcessed++;
                } else {
                    java.lang.String errorMsg = "File " + file + " cannot be read";
                    if (failOnError) {
                        throw new org.apache.tools.ant.BuildException( errorMsg );
                    } else {
                        log( errorMsg, Project.MSG_ERR );
                    }
                }
            }
            final int size = filesets.size();
            for (int i = 0; i < size; i++) {
                org.apache.tools.ant.types.FileSet fs = (org.apache.tools.ant.types.FileSet) filesets.elementAt( i );
                org.apache.tools.ant.DirectoryScanner ds = fs.getDirectoryScanner( getProject() );
                java.lang.String[] files = ds.getIncludedFiles();
                for (int j = 0; j < files.length; j++) {
                    java.io.File srcFile = new java.io.File( fs.getDir( getProject() ), files[j] );
                    doValidate( srcFile );
                    fileProcessed++;
                }
            }
            onSuccessfulValidation( fileProcessed );
        } finally 
{
            cleanup();
        }
    }

    protected  void onSuccessfulValidation( int fileProcessed )
    {
        log( fileProcessed + MESSAGE_FILES_VALIDATED );
    }

    protected  void initValidator()
    {
        xmlReader = createXmlReader();
        xmlReader.setEntityResolver( getEntityResolver() );
        xmlReader.setErrorHandler( errorHandler );
        if (!isSax1Parser()) {
            if (!lenient) {
                setFeature( XmlConstants.FEATURE_VALIDATION, true );
            }
            final int attSize = attributeList.size();
            for (int i = 0; i < attSize; i++) {
                org.apache.tools.ant.taskdefs.optional.XMLValidateTask.Attribute feature = (org.apache.tools.ant.taskdefs.optional.XMLValidateTask.Attribute) attributeList.elementAt( i );
                setFeature( feature.getName(), feature.getValue() );
            }
            final int propSize = propertyList.size();
            for (int i = 0; i < propSize; i++) {
                final org.apache.tools.ant.taskdefs.optional.XMLValidateTask.Property prop = (org.apache.tools.ant.taskdefs.optional.XMLValidateTask.Property) propertyList.elementAt( i );
                setProperty( prop.getName(), prop.getValue() );
            }
        }
    }

    protected  boolean isSax1Parser()
    {
        return xmlReader instanceof org.xml.sax.helpers.ParserAdapter;
    }

    protected  org.xml.sax.XMLReader createXmlReader()
    {
        java.lang.Object reader = null;
        if (readerClassName == null) {
            reader = createDefaultReaderOrParser();
        } else {
            java.lang.Class readerClass = null;
            try {
                if (classpath != null) {
                    readerLoader = getProject().createClassLoader( classpath );
                    readerClass = Class.forName( readerClassName, true, readerLoader );
                } else {
                    readerClass = Class.forName( readerClassName );
                }
                reader = readerClass.newInstance();
            } catch ( java.lang.ClassNotFoundException e ) {
                throw new org.apache.tools.ant.BuildException( INIT_FAILED_MSG + readerClassName, e );
            } catch ( java.lang.InstantiationException e ) {
                throw new org.apache.tools.ant.BuildException( INIT_FAILED_MSG + readerClassName, e );
            } catch ( java.lang.IllegalAccessException e ) {
                throw new org.apache.tools.ant.BuildException( INIT_FAILED_MSG + readerClassName, e );
            }
        }
        org.xml.sax.XMLReader newReader;
        if (reader instanceof org.xml.sax.XMLReader) {
            newReader = (org.xml.sax.XMLReader) reader;
            log( "Using SAX2 reader " + reader.getClass().getName(), Project.MSG_VERBOSE );
        } else {
            if (reader instanceof org.xml.sax.Parser) {
                newReader = new org.xml.sax.helpers.ParserAdapter( (org.xml.sax.Parser) reader );
                log( "Using SAX1 parser " + reader.getClass().getName(), Project.MSG_VERBOSE );
            } else {
                throw new org.apache.tools.ant.BuildException( INIT_FAILED_MSG + reader.getClass().getName() + " implements nor SAX1 Parser nor SAX2 XMLReader." );
            }
        }
        return newReader;
    }

    protected  void cleanup()
    {
        if (readerLoader != null) {
            readerLoader.cleanup();
            readerLoader = null;
        }
    }

    private  java.lang.Object createDefaultReaderOrParser()
    {
        java.lang.Object reader;
        try {
            reader = createDefaultReader();
        } catch ( org.apache.tools.ant.BuildException exc ) {
            reader = JAXPUtils.getParser();
        }
        return reader;
    }

    protected  org.xml.sax.XMLReader createDefaultReader()
    {
        return JAXPUtils.getXMLReader();
    }

    protected  void setFeature( java.lang.String feature, boolean value )
        throws org.apache.tools.ant.BuildException
    {
        log( "Setting feature " + feature + "=" + value, Project.MSG_DEBUG );
        try {
            xmlReader.setFeature( feature, value );
        } catch ( org.xml.sax.SAXNotRecognizedException e ) {
            throw new org.apache.tools.ant.BuildException( "Parser " + xmlReader.getClass().getName() + " doesn't recognize feature " + feature, e, getLocation() );
        } catch ( org.xml.sax.SAXNotSupportedException e ) {
            throw new org.apache.tools.ant.BuildException( "Parser " + xmlReader.getClass().getName() + " doesn't support feature " + feature, e, getLocation() );
        }
    }

    protected  void setProperty( java.lang.String name, java.lang.String value )
        throws org.apache.tools.ant.BuildException
    {
        if (name == null || value == null) {
            throw new org.apache.tools.ant.BuildException( "Property name and value must be specified." );
        }
        try {
            xmlReader.setProperty( name, value );
        } catch ( org.xml.sax.SAXNotRecognizedException e ) {
            throw new org.apache.tools.ant.BuildException( "Parser " + xmlReader.getClass().getName() + " doesn't recognize property " + name, e, getLocation() );
        } catch ( org.xml.sax.SAXNotSupportedException e ) {
            throw new org.apache.tools.ant.BuildException( "Parser " + xmlReader.getClass().getName() + " doesn't support property " + name, e, getLocation() );
        }
    }

    protected  boolean doValidate( java.io.File afile )
    {
        initValidator();
        boolean result = true;
        try {
            log( "Validating " + afile.getName() + "... ", Project.MSG_VERBOSE );
            errorHandler.init( afile );
            org.xml.sax.InputSource is = new org.xml.sax.InputSource( new java.io.FileInputStream( afile ) );
            java.lang.String uri = FILE_UTILS.toURI( afile.getAbsolutePath() );
            is.setSystemId( uri );
            xmlReader.parse( is );
        } catch ( org.xml.sax.SAXException ex ) {
            log( "Caught when validating: " + ex.toString(), Project.MSG_DEBUG );
            if (failOnError) {
                throw new org.apache.tools.ant.BuildException( "Could not validate document " + afile );
            }
            log( "Could not validate document " + afile + ": " + ex.toString() );
            result = false;
        } catch ( java.io.IOException ex ) {
            throw new org.apache.tools.ant.BuildException( "Could not validate document " + afile, ex );
        }
        if (errorHandler.getFailure()) {
            if (failOnError) {
                throw new org.apache.tools.ant.BuildException( afile + " is not a valid XML document." );
            }
            result = false;
            log( afile + " is not a valid XML document", Project.MSG_ERR );
        }
        return result;
    }

    protected class ValidatorErrorHandler implements org.xml.sax.ErrorHandler
    {

        protected java.io.File currentFile = null;

        protected java.lang.String lastErrorMessage = null;

        protected boolean failed = false;

        public  void init( java.io.File file )
        {
            currentFile = file;
            failed = false;
        }

        public  boolean getFailure()
        {
            return failed;
        }

        public  void fatalError( org.xml.sax.SAXParseException exception )
        {
            failed = true;
            doLog( exception, Project.MSG_ERR );
        }

        public  void error( org.xml.sax.SAXParseException exception )
        {
            failed = true;
            doLog( exception, Project.MSG_ERR );
        }

        public  void warning( org.xml.sax.SAXParseException exception )
        {
            if (warn) {
                doLog( exception, Project.MSG_WARN );
            }
        }

        private  void doLog( org.xml.sax.SAXParseException e, int logLevel )
        {
            log( getMessage( e ), logLevel );
        }

        private  java.lang.String getMessage( org.xml.sax.SAXParseException e )
        {
            java.lang.String sysID = e.getSystemId();
            if (sysID != null) {
                java.lang.String name = sysID;
                if (sysID.startsWith( "file:" )) {
                    try {
                        name = FILE_UTILS.fromURI( sysID );
                    } catch ( java.lang.Exception ex ) {
                    }
                }
                int line = e.getLineNumber();
                int col = e.getColumnNumber();
                return name + (line == -1 ? "" : ":" + line + (col == -1 ? "" : ":" + col)) + ": " + e.getMessage();
            }
            return e.getMessage();
        }

    }

    public static class Attribute
    {

        private java.lang.String attributeName = null;

        private boolean attributeValue;

        public  void setName( java.lang.String name )
        {
            attributeName = name;
        }

        public  void setValue( boolean value )
        {
            attributeValue = value;
        }

        public  java.lang.String getName()
        {
            return attributeName;
        }

        public  boolean getValue()
        {
            return attributeValue;
        }

    }

    public static final class Property
    {

        private java.lang.String name;

        private java.lang.String value;

        public  java.lang.String getName()
        {
            return name;
        }

        public  void setName( java.lang.String name )
        {
            this.name = name;
        }

        public  java.lang.String getValue()
        {
            return value;
        }

        public  void setValue( java.lang.String value )
        {
            this.value = value;
        }

    }

}
