// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.ejb;


import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.StringTokenizer;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import org.xml.sax.AttributeList;
import org.xml.sax.HandlerBase;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;


public class IPlanetEjbc
{

    private static final int MIN_NUM_ARGS = 2;

    private static final int MAX_NUM_ARGS = 8;

    private static final int NUM_CLASSES_WITH_IIOP = 15;

    private static final int NUM_CLASSES_WITHOUT_IIOP = 9;

    private static final java.lang.String ENTITY_BEAN = "entity";

    private static final java.lang.String STATELESS_SESSION = "stateless";

    private static final java.lang.String STATEFUL_SESSION = "stateful";

    private java.io.File stdDescriptor;

    private java.io.File iasDescriptor;

    private java.io.File destDirectory;

    private java.lang.String classpath;

    private java.lang.String[] classpathElements;

    private boolean retainSource = false;

    private boolean debugOutput = false;

    private java.io.File iasHomeDir;

    private javax.xml.parsers.SAXParser parser;

    private org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbcHandler handler = new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbcHandler();

    private java.util.Hashtable ejbFiles = new java.util.Hashtable();

    private java.lang.String displayName;

    public IPlanetEjbc( java.io.File stdDescriptor, java.io.File iasDescriptor, java.io.File destDirectory, java.lang.String classpath, javax.xml.parsers.SAXParser parser )
    {
        this.stdDescriptor = stdDescriptor;
        this.iasDescriptor = iasDescriptor;
        this.destDirectory = destDirectory;
        this.classpath = classpath;
        this.parser = parser;
        java.util.List elements = new java.util.ArrayList();
        if (classpath != null) {
            java.util.StringTokenizer st = new java.util.StringTokenizer( classpath, File.pathSeparator );
            while (st.hasMoreTokens()) {
                elements.add( st.nextToken() );
            }
            classpathElements = (java.lang.String[]) elements.toArray( new java.lang.String[elements.size()] );
        }
    }

    public  void setRetainSource( boolean retainSource )
    {
        this.retainSource = retainSource;
    }

    public  void setDebugOutput( boolean debugOutput )
    {
        this.debugOutput = debugOutput;
    }

    public  void registerDTD( java.lang.String publicID, java.lang.String location )
    {
        handler.registerDTD( publicID, location );
    }

    public  void setIasHomeDir( java.io.File iasHomeDir )
    {
        this.iasHomeDir = iasHomeDir;
    }

    public  java.util.Hashtable getEjbFiles()
    {
        return ejbFiles;
    }

    public  java.lang.String getDisplayName()
    {
        return displayName;
    }

    public  java.lang.String[] getCmpDescriptors()
    {
        java.util.List returnList = new java.util.ArrayList();
        org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbInfo[] ejbs = handler.getEjbs();
        for (int i = 0; i < ejbs.length; i++) {
            java.util.List descriptors = (java.util.List) ejbs[i].getCmpDescriptors();
            returnList.addAll( descriptors );
        }
        return (java.lang.String[]) returnList.toArray( new java.lang.String[returnList.size()] );
    }

    public static  void main( java.lang.String[] args )
    {
        java.io.File stdDescriptor;
        java.io.File iasDescriptor;
        java.io.File destDirectory = null;
        java.lang.String classpath = null;
        javax.xml.parsers.SAXParser parser = null;
        boolean debug = false;
        boolean retainSource = false;
        org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc ejbc;
        if (args.length < MIN_NUM_ARGS || args.length > MAX_NUM_ARGS) {
            usage();
            return;
        }
        stdDescriptor = new java.io.File( args[args.length - 2] );
        iasDescriptor = new java.io.File( args[args.length - 1] );
        for (int i = 0; i < args.length - 2; i++) {
            if (args[i].equals( "-classpath" )) {
                classpath = args[++i];
            } else {
                if (args[i].equals( "-d" )) {
                    destDirectory = new java.io.File( args[++i] );
                } else {
                    if (args[i].equals( "-debug" )) {
                        debug = true;
                    } else {
                        if (args[i].equals( "-keepsource" )) {
                            retainSource = true;
                        } else {
                            usage();
                            return;
                        }
                    }
                }
            }
        }
        if (classpath == null) {
            java.util.Properties props = System.getProperties();
            classpath = props.getProperty( "java.class.path" );
        }
        if (destDirectory == null) {
            java.util.Properties props = System.getProperties();
            destDirectory = new java.io.File( props.getProperty( "user.dir" ) );
        }
        javax.xml.parsers.SAXParserFactory parserFactory = SAXParserFactory.newInstance();
        parserFactory.setValidating( true );
        try {
            parser = parserFactory.newSAXParser();
        } catch ( java.lang.Exception e ) {
            System.out.println( "An exception was generated while trying to " );
            System.out.println( "create a new SAXParser." );
            e.printStackTrace();
            return;
        }
        ejbc = new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc( stdDescriptor, iasDescriptor, destDirectory, classpath, parser );
        ejbc.setDebugOutput( debug );
        ejbc.setRetainSource( retainSource );
        try {
            ejbc.execute();
        } catch ( java.io.IOException e ) {
            System.out.println( "An IOException has occurred while reading the " + "XML descriptors (" + e.getMessage() + ")." );
            return;
        } catch ( org.xml.sax.SAXException e ) {
            System.out.println( "A SAXException has occurred while reading the " + "XML descriptors (" + e.getMessage() + ")." );
            return;
        } catch ( org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbcException e ) {
            System.out.println( "An error has occurred while executing the ejbc " + "utility (" + e.getMessage() + ")." );
            return;
        }
    }

    private static  void usage()
    {
        System.out.println( "java org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc \\" );
        System.out.println( "  [OPTIONS] [EJB 1.1 descriptor] [iAS EJB descriptor]" );
        System.out.println( "" );
        System.out.println( "Where OPTIONS are:" );
        System.out.println( "  -debug -- for additional debugging output" );
        System.out.println( "  -keepsource -- to retain Java source files generated" );
        System.out.println( "  -classpath [classpath] -- classpath used for compilation" );
        System.out.println( "  -d [destination directory] -- directory for compiled classes" );
        System.out.println( "" );
        System.out.println( "If a classpath is not specified, the system classpath" );
        System.out.println( "will be used.  If a destination directory is not specified," );
        System.out.println( "the current working directory will be used (classes will" );
        System.out.println( "still be placed in subfolders which correspond to their" );
        System.out.println( "package name)." );
        System.out.println( "" );
        System.out.println( "The EJB home interface, remote interface, and implementation" );
        System.out.println( "class must be found in the destination directory.  In" );
        System.out.println( "addition, the destination will look for the stubs and skeletons" );
        System.out.println( "in the destination directory to ensure they are up to date." );
    }

    public  void execute()
        throws org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbcException, java.io.IOException, org.xml.sax.SAXException
    {
        checkConfiguration();
        org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbInfo[] ejbs = getEjbs();
        for (int i = 0; i < ejbs.length; i++) {
            log( "EJBInfo..." );
            log( ejbs[i].toString() );
        }
        for (int i = 0; i < ejbs.length; i++) {
            org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbInfo ejb = ejbs[i];
            ejb.checkConfiguration( destDirectory );
            if (ejb.mustBeRecompiled( destDirectory )) {
                log( ejb.getName() + " must be recompiled using ejbc." );
                java.lang.String[] arguments = buildArgumentList( ejb );
                callEjbc( arguments );
            } else {
                log( ejb.getName() + " is up to date." );
            }
        }
    }

    private  void callEjbc( java.lang.String[] arguments )
    {
        java.lang.StringBuffer args = new java.lang.StringBuffer();
        for (int i = 0; i < arguments.length; i++) {
            args.append( arguments[i] ).append( " " );
        }
        java.lang.String command;
        if (iasHomeDir == null) {
            command = "";
        } else {
            command = iasHomeDir.toString() + File.separator + "bin" + File.separator;
        }
        command += "ejbc ";
        log( command + args );
        try {
            java.lang.Process p = Runtime.getRuntime().exec( command + args );
            org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.RedirectOutput output = new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.RedirectOutput( p.getInputStream() );
            org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.RedirectOutput error = new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.RedirectOutput( p.getErrorStream() );
            output.start();
            error.start();
            p.waitFor();
            p.destroy();
        } catch ( java.io.IOException e ) {
            log( "An IOException has occurred while trying to execute ejbc." );
            e.printStackTrace();
        } catch ( java.lang.InterruptedException e ) {
        }
    }

    protected  void checkConfiguration()
        throws org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbcException
    {
        java.lang.String msg = "";
        if (stdDescriptor == null) {
            msg += "A standard XML descriptor file must be specified.  ";
        }
        if (iasDescriptor == null) {
            msg += "An iAS-specific XML descriptor file must be specified.  ";
        }
        if (classpath == null) {
            msg += "A classpath must be specified.    ";
        }
        if (parser == null) {
            msg += "An XML parser must be specified.    ";
        }
        if (destDirectory == null) {
            msg += "A destination directory must be specified.  ";
        } else {
            if (!destDirectory.exists()) {
                msg += "The destination directory specified does not exist.  ";
            } else {
                if (!destDirectory.isDirectory()) {
                    msg += "The destination specified is not a directory.  ";
                }
            }
        }
        if (msg.length() > 0) {
            throw new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbcException( msg );
        }
    }

    private  org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbInfo[] getEjbs()
        throws java.io.IOException, org.xml.sax.SAXException
    {
        org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbInfo[] ejbs = null;
        parser.parse( stdDescriptor, handler );
        parser.parse( iasDescriptor, handler );
        ejbs = handler.getEjbs();
        return ejbs;
    }

    private  java.lang.String[] buildArgumentList( org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbInfo ejb )
    {
        java.util.List arguments = new java.util.ArrayList();
        if (debugOutput) {
            arguments.add( "-debug" );
        }
        if (ejb.getBeantype().equals( STATELESS_SESSION )) {
            arguments.add( "-sl" );
        } else {
            if (ejb.getBeantype().equals( STATEFUL_SESSION )) {
                arguments.add( "-sf" );
            }
        }
        if (ejb.getIiop()) {
            arguments.add( "-iiop" );
        }
        if (ejb.getCmp()) {
            arguments.add( "-cmp" );
        }
        if (retainSource) {
            arguments.add( "-gs" );
        }
        if (ejb.getHasession()) {
            arguments.add( "-fo" );
        }
        arguments.add( "-classpath" );
        arguments.add( classpath );
        arguments.add( "-d" );
        arguments.add( destDirectory.toString() );
        arguments.add( ejb.getHome().getQualifiedClassName() );
        arguments.add( ejb.getRemote().getQualifiedClassName() );
        arguments.add( ejb.getImplementation().getQualifiedClassName() );
        return (java.lang.String[]) arguments.toArray( new java.lang.String[arguments.size()] );
    }

    private  void log( java.lang.String msg )
    {
        if (debugOutput) {
            System.out.println( msg );
        }
    }

    public class EjbcException extends java.lang.Exception
    {

        public EjbcException( java.lang.String msg )
        {
            super( msg );
        }

    }

    private class EjbcHandler extends org.xml.sax.HandlerBase
    {

        private static final java.lang.String PUBLICID_EJB11 = "-//Sun Microsystems, Inc.//DTD Enterprise JavaBeans 1.1//EN";

        private static final java.lang.String PUBLICID_IPLANET_EJB_60 = "-//Sun Microsystems, Inc.//DTD iAS Enterprise JavaBeans 1.0//EN";

        private static final java.lang.String DEFAULT_IAS60_EJB11_DTD_LOCATION = "ejb-jar_1_1.dtd";

        private static final java.lang.String DEFAULT_IAS60_DTD_LOCATION = "IASEjb_jar_1_0.dtd";

        private java.util.Map resourceDtds = new java.util.HashMap();

        private java.util.Map fileDtds = new java.util.HashMap();

        private java.util.Map ejbs = new java.util.HashMap();

        private org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbInfo currentEjb;

        private boolean iasDescriptor = false;

        private java.lang.String currentLoc = "";

        private java.lang.String currentText;

        private java.lang.String ejbType;

        public EjbcHandler()
        {
            registerDTD( PUBLICID_EJB11, DEFAULT_IAS60_EJB11_DTD_LOCATION );
            registerDTD( PUBLICID_IPLANET_EJB_60, DEFAULT_IAS60_DTD_LOCATION );
        }

        public  org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbInfo[] getEjbs()
        {
            return (org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbInfo[]) ejbs.values().toArray( new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbInfo[ejbs.size()] );
        }

        public  java.lang.String getDisplayName()
        {
            return displayName;
        }

        public  void registerDTD( java.lang.String publicID, java.lang.String location )
        {
            log( "Registering: " + location );
            if (publicID == null || location == null) {
                return;
            }
            if (ClassLoader.getSystemResource( location ) != null) {
                log( "Found resource: " + location );
                resourceDtds.put( publicID, location );
            } else {
                java.io.File dtdFile = new java.io.File( location );
                if (dtdFile.exists() && dtdFile.isFile()) {
                    log( "Found file: " + location );
                    fileDtds.put( publicID, location );
                }
            }
        }

        public  org.xml.sax.InputSource resolveEntity( java.lang.String publicId, java.lang.String systemId )
                throws org.xml.sax.SAXException
        {
            java.io.InputStream inputStream = null;
            try {
                java.lang.String location = (java.lang.String) resourceDtds.get( publicId );
                if (location != null) {
                    inputStream = ClassLoader.getSystemResource( location ).openStream();
                } else {
                    location = (java.lang.String) fileDtds.get( publicId );
                    if (location != null) {
                        inputStream = new java.io.FileInputStream( location );
                    }
                }
            } catch ( java.io.IOException e ) {
                return super.resolveEntity( publicId, systemId );
            }
            if (inputStream == null) {
                return super.resolveEntity( publicId, systemId );
            } else {
                return new org.xml.sax.InputSource( inputStream );
            }
        }

        public  void startElement( java.lang.String name, org.xml.sax.AttributeList atts )
                throws org.xml.sax.SAXException
        {
            currentLoc += "\\" + name;
            currentText = "";
            if (currentLoc.equals( "\\ejb-jar" )) {
                iasDescriptor = false;
            } else {
                if (currentLoc.equals( "\\ias-ejb-jar" )) {
                    iasDescriptor = true;
                }
            }
            if (name.equals( "session" ) || name.equals( "entity" )) {
                ejbType = name;
            }
        }

        public  void characters( char[] ch, int start, int len )
                throws org.xml.sax.SAXException
        {
            currentText += (new java.lang.String( ch )).substring( start, start + len );
        }

        public  void endElement( java.lang.String name )
                throws org.xml.sax.SAXException
        {
            if (iasDescriptor) {
                iasCharacters( currentText );
            } else {
                stdCharacters( currentText );
            }
            int nameLength = name.length() + 1;
            int locLength = currentLoc.length();
            currentLoc = currentLoc.substring( 0, locLength - nameLength );
        }

        private  void stdCharacters( java.lang.String value )
        {
            if (currentLoc.equals( "\\ejb-jar\\display-name" )) {
                displayName = value;
                return;
            }
            java.lang.String base = "\\ejb-jar\\enterprise-beans\\" + ejbType;
            if (currentLoc.equals( base + "\\ejb-name" )) {
                currentEjb = (org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbInfo) ejbs.get( value );
                if (currentEjb == null) {
                    currentEjb = new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbInfo( value );
                    ejbs.put( value, currentEjb );
                }
            } else {
                if (currentLoc.equals( base + "\\home" )) {
                    currentEjb.setHome( value );
                } else {
                    if (currentLoc.equals( base + "\\remote" )) {
                        currentEjb.setRemote( value );
                    } else {
                        if (currentLoc.equals( base + "\\ejb-class" )) {
                            currentEjb.setImplementation( value );
                        } else {
                            if (currentLoc.equals( base + "\\prim-key-class" )) {
                                currentEjb.setPrimaryKey( value );
                            } else {
                                if (currentLoc.equals( base + "\\session-type" )) {
                                    currentEjb.setBeantype( value );
                                } else {
                                    if (currentLoc.equals( base + "\\persistence-type" )) {
                                        currentEjb.setCmp( value );
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        private  void iasCharacters( java.lang.String value )
        {
            java.lang.String base = "\\ias-ejb-jar\\enterprise-beans\\" + ejbType;
            if (currentLoc.equals( base + "\\ejb-name" )) {
                currentEjb = (org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbInfo) ejbs.get( value );
                if (currentEjb == null) {
                    currentEjb = new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbInfo( value );
                    ejbs.put( value, currentEjb );
                }
            } else {
                if (currentLoc.equals( base + "\\iiop" )) {
                    currentEjb.setIiop( value );
                } else {
                    if (currentLoc.equals( base + "\\failover-required" )) {
                        currentEjb.setHasession( value );
                    } else {
                        if (currentLoc.equals( base + "\\persistence-manager" + "\\properties-file-location" )) {
                            currentEjb.addCmpDescriptor( value );
                        }
                    }
                }
            }
        }

    }

    private class EjbInfo
    {

        private java.lang.String name;

        private org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.Classname home;

        private org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.Classname remote;

        private org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.Classname implementation;

        private org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.Classname primaryKey;

        private java.lang.String beantype = "entity";

        private boolean cmp = false;

        private boolean iiop = false;

        private boolean hasession = false;

        private java.util.List cmpDescriptors = new java.util.ArrayList();

        public EjbInfo( java.lang.String name )
        {
            this.name = name;
        }

        public  java.lang.String getName()
        {
            if (name == null) {
                if (implementation == null) {
                    return "[unnamed]";
                } else {
                    return implementation.getClassName();
                }
            }
            return name;
        }

        public  void setHome( java.lang.String home )
        {
            setHome( new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.Classname( home ) );
        }

        public  void setHome( org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.Classname home )
        {
            this.home = home;
        }

        public  org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.Classname getHome()
        {
            return home;
        }

        public  void setRemote( java.lang.String remote )
        {
            setRemote( new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.Classname( remote ) );
        }

        public  void setRemote( org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.Classname remote )
        {
            this.remote = remote;
        }

        public  org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.Classname getRemote()
        {
            return remote;
        }

        public  void setImplementation( java.lang.String implementation )
        {
            setImplementation( new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.Classname( implementation ) );
        }

        public  void setImplementation( org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.Classname implementation )
        {
            this.implementation = implementation;
        }

        public  org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.Classname getImplementation()
        {
            return implementation;
        }

        public  void setPrimaryKey( java.lang.String primaryKey )
        {
            setPrimaryKey( new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.Classname( primaryKey ) );
        }

        public  void setPrimaryKey( org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.Classname primaryKey )
        {
            this.primaryKey = primaryKey;
        }

        public  org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.Classname getPrimaryKey()
        {
            return primaryKey;
        }

        public  void setBeantype( java.lang.String beantype )
        {
            this.beantype = beantype.toLowerCase();
        }

        public  java.lang.String getBeantype()
        {
            return beantype;
        }

        public  void setCmp( boolean cmp )
        {
            this.cmp = cmp;
        }

        public  void setCmp( java.lang.String cmp )
        {
            setCmp( cmp.equals( "Container" ) );
        }

        public  boolean getCmp()
        {
            return cmp;
        }

        public  void setIiop( boolean iiop )
        {
            this.iiop = iiop;
        }

        public  void setIiop( java.lang.String iiop )
        {
            setIiop( iiop.equals( "true" ) );
        }

        public  boolean getIiop()
        {
            return iiop;
        }

        public  void setHasession( boolean hasession )
        {
            this.hasession = hasession;
        }

        public  void setHasession( java.lang.String hasession )
        {
            setHasession( hasession.equals( "true" ) );
        }

        public  boolean getHasession()
        {
            return hasession;
        }

        public  void addCmpDescriptor( java.lang.String descriptor )
        {
            cmpDescriptors.add( descriptor );
        }

        public  java.util.List getCmpDescriptors()
        {
            return cmpDescriptors;
        }

        private  void checkConfiguration( java.io.File buildDir )
                throws org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbcException
        {
            if (home == null) {
                throw new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbcException( "A home interface was not found " + "for the " + name + " EJB." );
            }
            if (remote == null) {
                throw new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbcException( "A remote interface was not found " + "for the " + name + " EJB." );
            }
            if (implementation == null) {
                throw new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbcException( "An EJB implementation class was not " + "found for the " + name + " EJB." );
            }
            if (!beantype.equals( ENTITY_BEAN ) && !beantype.equals( STATELESS_SESSION ) && !beantype.equals( STATEFUL_SESSION )) {
                throw new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbcException( "The beantype found (" + beantype + ") " + "isn't valid in the " + name + " EJB." );
            }
            if (cmp && !beantype.equals( ENTITY_BEAN )) {
                System.out.println( "CMP stubs and skeletons may not be generated" + " for a Session Bean -- the \"cmp\" attribute will be" + " ignoredfor the " + name + " EJB." );
            }
            if (hasession && !beantype.equals( STATEFUL_SESSION )) {
                System.out.println( "Highly available stubs and skeletons may " + "only be generated for a Stateful Session Bean -- the " + "\"hasession\" attribute will be ignored for the " + name + " EJB." );
            }
            if (!remote.getClassFile( buildDir ).exists()) {
                throw new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbcException( "The remote interface " + remote.getQualifiedClassName() + " could not be " + "found." );
            }
            if (!home.getClassFile( buildDir ).exists()) {
                throw new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbcException( "The home interface " + home.getQualifiedClassName() + " could not be " + "found." );
            }
            if (!implementation.getClassFile( buildDir ).exists()) {
                throw new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbcException( "The EJB implementation class " + implementation.getQualifiedClassName() + " could " + "not be found." );
            }
        }

        public  boolean mustBeRecompiled( java.io.File destDir )
        {
            long sourceModified = sourceClassesModified( destDir );
            long destModified = destClassesModified( destDir );
            return destModified < sourceModified;
        }

        private  long sourceClassesModified( java.io.File buildDir )
        {
            long latestModified;
            long modified;
            java.io.File remoteFile;
            java.io.File homeFile;
            java.io.File implFile;
            java.io.File pkFile;
            remoteFile = remote.getClassFile( buildDir );
            modified = remoteFile.lastModified();
            if (modified == -1) {
                System.out.println( "The class " + remote.getQualifiedClassName() + " couldn't " + "be found on the classpath" );
                return -1;
            }
            latestModified = modified;
            homeFile = home.getClassFile( buildDir );
            modified = homeFile.lastModified();
            if (modified == -1) {
                System.out.println( "The class " + home.getQualifiedClassName() + " couldn't be " + "found on the classpath" );
                return -1;
            }
            latestModified = Math.max( latestModified, modified );
            if (primaryKey != null) {
                pkFile = primaryKey.getClassFile( buildDir );
                modified = pkFile.lastModified();
                if (modified == -1) {
                    System.out.println( "The class " + primaryKey.getQualifiedClassName() + "couldn't be " + "found on the classpath" );
                    return -1;
                }
                latestModified = Math.max( latestModified, modified );
            } else {
                pkFile = null;
            }
            implFile = implementation.getClassFile( buildDir );
            modified = implFile.lastModified();
            if (modified == -1) {
                System.out.println( "The class " + implementation.getQualifiedClassName() + " couldn't be found on the classpath" );
                return -1;
            }
            java.lang.String pathToFile = remote.getQualifiedClassName();
            pathToFile = pathToFile.replace( '.', File.separatorChar ) + ".class";
            ejbFiles.put( pathToFile, remoteFile );
            pathToFile = home.getQualifiedClassName();
            pathToFile = pathToFile.replace( '.', File.separatorChar ) + ".class";
            ejbFiles.put( pathToFile, homeFile );
            pathToFile = implementation.getQualifiedClassName();
            pathToFile = pathToFile.replace( '.', File.separatorChar ) + ".class";
            ejbFiles.put( pathToFile, implFile );
            if (pkFile != null) {
                pathToFile = primaryKey.getQualifiedClassName();
                pathToFile = pathToFile.replace( '.', File.separatorChar ) + ".class";
                ejbFiles.put( pathToFile, pkFile );
            }
            return latestModified;
        }

        private  long destClassesModified( java.io.File destDir )
        {
            java.lang.String[] classnames = classesToGenerate();
            long destClassesModified = (new java.util.Date()).getTime();
            boolean allClassesFound = true;
            for (int i = 0; i < classnames.length; i++) {
                java.lang.String pathToClass = classnames[i].replace( '.', File.separatorChar ) + ".class";
                java.io.File classFile = new java.io.File( destDir, pathToClass );
                ejbFiles.put( pathToClass, classFile );
                allClassesFound = allClassesFound && classFile.exists();
                if (allClassesFound) {
                    long fileMod = classFile.lastModified();
                    destClassesModified = Math.min( destClassesModified, fileMod );
                }
            }
            return allClassesFound ? destClassesModified : -1;
        }

        private  java.lang.String[] classesToGenerate()
        {
            java.lang.String[] classnames = iiop ? new java.lang.String[NUM_CLASSES_WITH_IIOP] : new java.lang.String[NUM_CLASSES_WITHOUT_IIOP];
            final java.lang.String remotePkg = remote.getPackageName() + ".";
            final java.lang.String remoteClass = remote.getClassName();
            final java.lang.String homePkg = home.getPackageName() + ".";
            final java.lang.String homeClass = home.getClassName();
            final java.lang.String implPkg = implementation.getPackageName() + ".";
            final java.lang.String implFullClass = implementation.getQualifiedWithUnderscores();
            int index = 0;
            classnames[index++] = implPkg + "ejb_fac_" + implFullClass;
            classnames[index++] = implPkg + "ejb_home_" + implFullClass;
            classnames[index++] = implPkg + "ejb_skel_" + implFullClass;
            classnames[index++] = remotePkg + "ejb_kcp_skel_" + remoteClass;
            classnames[index++] = homePkg + "ejb_kcp_skel_" + homeClass;
            classnames[index++] = remotePkg + "ejb_kcp_stub_" + remoteClass;
            classnames[index++] = homePkg + "ejb_kcp_stub_" + homeClass;
            classnames[index++] = remotePkg + "ejb_stub_" + remoteClass;
            classnames[index++] = homePkg + "ejb_stub_" + homeClass;
            if (!iiop) {
                return classnames;
            }
            classnames[index++] = "org.omg.stub." + remotePkg + "_" + remoteClass + "_Stub";
            classnames[index++] = "org.omg.stub." + homePkg + "_" + homeClass + "_Stub";
            classnames[index++] = "org.omg.stub." + remotePkg + "_ejb_RmiCorbaBridge_" + remoteClass + "_Tie";
            classnames[index++] = "org.omg.stub." + homePkg + "_ejb_RmiCorbaBridge_" + homeClass + "_Tie";
            classnames[index++] = remotePkg + "ejb_RmiCorbaBridge_" + remoteClass;
            classnames[index++] = homePkg + "ejb_RmiCorbaBridge_" + homeClass;
            return classnames;
        }

        public  java.lang.String toString()
        {
            java.lang.String s = "EJB name: " + name + "\n\r              home:      " + home + "\n\r              remote:    " + remote + "\n\r              impl:      " + implementation + "\n\r              primaryKey: " + primaryKey + "\n\r              beantype:  " + beantype + "\n\r              cmp:       " + cmp + "\n\r              iiop:      " + iiop + "\n\r              hasession: " + hasession;
            java.util.Iterator i = cmpDescriptors.iterator();
            while (i.hasNext()) {
                s += "\n\r              CMP Descriptor: " + i.next();
            }
            return s;
        }

    }

    private static class Classname
    {

        private java.lang.String qualifiedName;

        private java.lang.String packageName;

        private java.lang.String className;

        public Classname( java.lang.String qualifiedName )
        {
            if (qualifiedName == null) {
                return;
            }
            this.qualifiedName = qualifiedName;
            int index = qualifiedName.lastIndexOf( '.' );
            if (index == -1) {
                className = qualifiedName;
                packageName = "";
            } else {
                packageName = qualifiedName.substring( 0, index );
                className = qualifiedName.substring( index + 1 );
            }
        }

        public  java.lang.String getQualifiedClassName()
        {
            return qualifiedName;
        }

        public  java.lang.String getPackageName()
        {
            return packageName;
        }

        public  java.lang.String getClassName()
        {
            return className;
        }

        public  java.lang.String getQualifiedWithUnderscores()
        {
            return qualifiedName.replace( '.', '_' );
        }

        public  java.io.File getClassFile( java.io.File directory )
        {
            java.lang.String pathToFile = qualifiedName.replace( '.', File.separatorChar ) + ".class";
            return new java.io.File( directory, pathToFile );
        }

        public  java.lang.String toString()
        {
            return getQualifiedClassName();
        }

    }

    private static class RedirectOutput extends java.lang.Thread
    {

        private java.io.InputStream stream;

        public RedirectOutput( java.io.InputStream stream )
        {
            this.stream = stream;
        }

        public  void run()
        {
            java.io.BufferedReader reader = new java.io.BufferedReader( new java.io.InputStreamReader( stream ) );
            java.lang.String text;
            try {
                while ((text = reader.readLine()) != null) {
                    System.out.println( text );
                }
            } catch ( java.io.IOException e ) {
                e.printStackTrace();
            } finally 
{
                try {
                    reader.close();
                } catch ( java.io.IOException e ) {
                }
            }
        }

    }

}
