// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.ejb;


import java.io.File;
import java.io.IOException;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.types.Path;
import org.xml.sax.SAXException;


public class IPlanetEjbcTask extends org.apache.tools.ant.Task
{

    private java.io.File ejbdescriptor;

    private java.io.File iasdescriptor;

    private java.io.File dest;

    private org.apache.tools.ant.types.Path classpath;

    private boolean keepgenerated = false;

    private boolean debug = false;

    private java.io.File iashome;

    public  void setEjbdescriptor( java.io.File ejbdescriptor )
    {
        this.ejbdescriptor = ejbdescriptor;
    }

    public  void setIasdescriptor( java.io.File iasdescriptor )
    {
        this.iasdescriptor = iasdescriptor;
    }

    public  void setDest( java.io.File dest )
    {
        this.dest = dest;
    }

    public  void setClasspath( org.apache.tools.ant.types.Path classpath )
    {
        if (this.classpath == null) {
            this.classpath = classpath;
        } else {
            this.classpath.append( classpath );
        }
    }

    public  org.apache.tools.ant.types.Path createClasspath()
    {
        if (classpath == null) {
            classpath = new org.apache.tools.ant.types.Path( getProject() );
        }
        return classpath.createPath();
    }

    public  void setKeepgenerated( boolean keepgenerated )
    {
        this.keepgenerated = keepgenerated;
    }

    public  void setDebug( boolean debug )
    {
        this.debug = debug;
    }

    public  void setIashome( java.io.File iashome )
    {
        this.iashome = iashome;
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        checkConfiguration();
        executeEjbc( getParser() );
    }

    private  void checkConfiguration()
        throws org.apache.tools.ant.BuildException
    {
        if (ejbdescriptor == null) {
            java.lang.String msg = "The standard EJB descriptor must be specified using " + "the \"ejbdescriptor\" attribute.";
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        }
        if (!ejbdescriptor.exists() || !ejbdescriptor.isFile()) {
            java.lang.String msg = "The standard EJB descriptor (" + ejbdescriptor + ") was not found or isn't a file.";
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        }
        if (iasdescriptor == null) {
            java.lang.String msg = "The iAS-speific XML descriptor must be specified using" + " the \"iasdescriptor\" attribute.";
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        }
        if (!iasdescriptor.exists() || !iasdescriptor.isFile()) {
            java.lang.String msg = "The iAS-specific XML descriptor (" + iasdescriptor + ") was not found or isn't a file.";
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        }
        if (dest == null) {
            java.lang.String msg = "The destination directory must be specified using " + "the \"dest\" attribute.";
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        }
        if (!dest.exists() || !dest.isDirectory()) {
            java.lang.String msg = "The destination directory (" + dest + ") was not " + "found or isn't a directory.";
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        }
        if (iashome != null && !iashome.isDirectory()) {
            java.lang.String msg = "If \"iashome\" is specified, it must be a valid " + "directory (it was set to " + iashome + ").";
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        }
    }

    private  javax.xml.parsers.SAXParser getParser()
        throws org.apache.tools.ant.BuildException
    {
        javax.xml.parsers.SAXParser saxParser = null;
        try {
            javax.xml.parsers.SAXParserFactory saxParserFactory = SAXParserFactory.newInstance();
            saxParserFactory.setValidating( true );
            saxParser = saxParserFactory.newSAXParser();
        } catch ( org.xml.sax.SAXException e ) {
            java.lang.String msg = "Unable to create a SAXParser: " + e.getMessage();
            throw new org.apache.tools.ant.BuildException( msg, e, getLocation() );
        } catch ( javax.xml.parsers.ParserConfigurationException e ) {
            java.lang.String msg = "Unable to create a SAXParser: " + e.getMessage();
            throw new org.apache.tools.ant.BuildException( msg, e, getLocation() );
        }
        return saxParser;
    }

    private  void executeEjbc( javax.xml.parsers.SAXParser saxParser )
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc ejbc = new org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc( ejbdescriptor, iasdescriptor, dest, getClasspath().toString(), saxParser );
        ejbc.setRetainSource( keepgenerated );
        ejbc.setDebugOutput( debug );
        if (iashome != null) {
            ejbc.setIasHomeDir( iashome );
        }
        try {
            ejbc.execute();
        } catch ( java.io.IOException e ) {
            java.lang.String msg = "An IOException occurred while trying to read the XML " + "descriptor file: " + e.getMessage();
            throw new org.apache.tools.ant.BuildException( msg, e, getLocation() );
        } catch ( org.xml.sax.SAXException e ) {
            java.lang.String msg = "A SAXException occurred while trying to read the XML " + "descriptor file: " + e.getMessage();
            throw new org.apache.tools.ant.BuildException( msg, e, getLocation() );
        } catch ( org.apache.tools.ant.taskdefs.optional.ejb.IPlanetEjbc.EjbcException e ) {
            java.lang.String msg = "An exception occurred while trying to run the ejbc " + "utility: " + e.getMessage();
            throw new org.apache.tools.ant.BuildException( msg, e, getLocation() );
        }
    }

    private  org.apache.tools.ant.types.Path getClasspath()
    {
        org.apache.tools.ant.types.Path cp = null;
        if (classpath == null) {
            cp = (new org.apache.tools.ant.types.Path( getProject() )).concatSystemClasspath( "last" );
        } else {
            cp = classpath.concatSystemClasspath( "ignore" );
        }
        return cp;
    }

}
