// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.extension;


import java.util.ArrayList;
import java.util.Iterator;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.jar.Attributes;
import java.util.jar.Manifest;
import org.apache.tools.ant.util.DeweyDecimal;
import org.apache.tools.ant.util.StringUtils;


public final class Extension
{

    public static final java.util.jar.Attributes.Name EXTENSION_LIST = new java.util.jar.Attributes.Name( "Extension-List" );

    public static final java.util.jar.Attributes.Name OPTIONAL_EXTENSION_LIST = new java.util.jar.Attributes.Name( "Optional-Extension-List" );

    public static final java.util.jar.Attributes.Name EXTENSION_NAME = new java.util.jar.Attributes.Name( "Extension-Name" );

    public static final java.util.jar.Attributes.Name SPECIFICATION_VERSION = Attributes.Name.SPECIFICATION_VERSION;

    public static final java.util.jar.Attributes.Name SPECIFICATION_VENDOR = Attributes.Name.SPECIFICATION_VENDOR;

    public static final java.util.jar.Attributes.Name IMPLEMENTATION_VERSION = Attributes.Name.IMPLEMENTATION_VERSION;

    public static final java.util.jar.Attributes.Name IMPLEMENTATION_VENDOR = Attributes.Name.IMPLEMENTATION_VENDOR;

    public static final java.util.jar.Attributes.Name IMPLEMENTATION_URL = new java.util.jar.Attributes.Name( "Implementation-URL" );

    public static final java.util.jar.Attributes.Name IMPLEMENTATION_VENDOR_ID = new java.util.jar.Attributes.Name( "Implementation-Vendor-Id" );

    public static final org.apache.tools.ant.taskdefs.optional.extension.Compatibility COMPATIBLE = new org.apache.tools.ant.taskdefs.optional.extension.Compatibility( "COMPATIBLE" );

    public static final org.apache.tools.ant.taskdefs.optional.extension.Compatibility REQUIRE_SPECIFICATION_UPGRADE = new org.apache.tools.ant.taskdefs.optional.extension.Compatibility( "REQUIRE_SPECIFICATION_UPGRADE" );

    public static final org.apache.tools.ant.taskdefs.optional.extension.Compatibility REQUIRE_VENDOR_SWITCH = new org.apache.tools.ant.taskdefs.optional.extension.Compatibility( "REQUIRE_VENDOR_SWITCH" );

    public static final org.apache.tools.ant.taskdefs.optional.extension.Compatibility REQUIRE_IMPLEMENTATION_UPGRADE = new org.apache.tools.ant.taskdefs.optional.extension.Compatibility( "REQUIRE_IMPLEMENTATION_UPGRADE" );

    public static final org.apache.tools.ant.taskdefs.optional.extension.Compatibility INCOMPATIBLE = new org.apache.tools.ant.taskdefs.optional.extension.Compatibility( "INCOMPATIBLE" );

    private java.lang.String extensionName;

    private org.apache.tools.ant.util.DeweyDecimal specificationVersion;

    private java.lang.String specificationVendor;

    private java.lang.String implementationVendorID;

    private java.lang.String implementationVendor;

    private org.apache.tools.ant.util.DeweyDecimal implementationVersion;

    private java.lang.String implementationURL;

    public static  org.apache.tools.ant.taskdefs.optional.extension.Extension[] getAvailable( final java.util.jar.Manifest manifest )
    {
        if (null == manifest) {
            return new org.apache.tools.ant.taskdefs.optional.extension.Extension[0];
        }
        final java.util.ArrayList results = new java.util.ArrayList();
        final java.util.jar.Attributes mainAttributes = manifest.getMainAttributes();
        if (null != mainAttributes) {
            final org.apache.tools.ant.taskdefs.optional.extension.Extension extension = getExtension( "", mainAttributes );
            if (null != extension) {
                results.add( extension );
            }
        }
        final java.util.Map entries = manifest.getEntries();
        final java.util.Iterator keys = entries.keySet().iterator();
        while (keys.hasNext()) {
            final java.lang.String key = (java.lang.String) keys.next();
            final java.util.jar.Attributes attributes = (java.util.jar.Attributes) entries.get( key );
            final org.apache.tools.ant.taskdefs.optional.extension.Extension extension = getExtension( "", attributes );
            if (null != extension) {
                results.add( extension );
            }
        }
        return (org.apache.tools.ant.taskdefs.optional.extension.Extension[]) results.toArray( new org.apache.tools.ant.taskdefs.optional.extension.Extension[results.size()] );
    }

    public static  org.apache.tools.ant.taskdefs.optional.extension.Extension[] getRequired( final java.util.jar.Manifest manifest )
    {
        return getListed( manifest, Attributes.Name.EXTENSION_LIST );
    }

    public static  org.apache.tools.ant.taskdefs.optional.extension.Extension[] getOptions( final java.util.jar.Manifest manifest )
    {
        return getListed( manifest, OPTIONAL_EXTENSION_LIST );
    }

    public static  void addExtension( final org.apache.tools.ant.taskdefs.optional.extension.Extension extension, final java.util.jar.Attributes attributes )
    {
        addExtension( extension, "", attributes );
    }

    public static  void addExtension( final org.apache.tools.ant.taskdefs.optional.extension.Extension extension, final java.lang.String prefix, final java.util.jar.Attributes attributes )
    {
        attributes.putValue( prefix + EXTENSION_NAME, extension.getExtensionName() );
        final java.lang.String specificationVendor = extension.getSpecificationVendor();
        if (null != specificationVendor) {
            attributes.putValue( prefix + SPECIFICATION_VENDOR, specificationVendor );
        }
        final org.apache.tools.ant.util.DeweyDecimal specificationVersion = extension.getSpecificationVersion();
        if (null != specificationVersion) {
            attributes.putValue( prefix + SPECIFICATION_VERSION, specificationVersion.toString() );
        }
        final java.lang.String implementationVendorID = extension.getImplementationVendorID();
        if (null != implementationVendorID) {
            attributes.putValue( prefix + IMPLEMENTATION_VENDOR_ID, implementationVendorID );
        }
        final java.lang.String implementationVendor = extension.getImplementationVendor();
        if (null != implementationVendor) {
            attributes.putValue( prefix + IMPLEMENTATION_VENDOR, implementationVendor );
        }
        final org.apache.tools.ant.util.DeweyDecimal implementationVersion = extension.getImplementationVersion();
        if (null != implementationVersion) {
            attributes.putValue( prefix + IMPLEMENTATION_VERSION, implementationVersion.toString() );
        }
        final java.lang.String implementationURL = extension.getImplementationURL();
        if (null != implementationURL) {
            attributes.putValue( prefix + IMPLEMENTATION_URL, implementationURL );
        }
    }

    public Extension( final java.lang.String extensionName, final java.lang.String specificationVersion, final java.lang.String specificationVendor, final java.lang.String implementationVersion, final java.lang.String implementationVendor, final java.lang.String implementationVendorId, final java.lang.String implementationURL )
    {
        this.extensionName = extensionName;
        this.specificationVendor = specificationVendor;
        if (null != specificationVersion) {
            try {
                this.specificationVersion = new org.apache.tools.ant.util.DeweyDecimal( specificationVersion );
            } catch ( final java.lang.NumberFormatException nfe ) {
                final java.lang.String error = "Bad specification version format '" + specificationVersion + "' in '" + extensionName + "'. (Reason: " + nfe + ")";
                throw new java.lang.IllegalArgumentException( error );
            }
        }
        this.implementationURL = implementationURL;
        this.implementationVendor = implementationVendor;
        this.implementationVendorID = implementationVendorId;
        if (null != implementationVersion) {
            try {
                this.implementationVersion = new org.apache.tools.ant.util.DeweyDecimal( implementationVersion );
            } catch ( final java.lang.NumberFormatException nfe ) {
                final java.lang.String error = "Bad implementation version format '" + implementationVersion + "' in '" + extensionName + "'. (Reason: " + nfe + ")";
                throw new java.lang.IllegalArgumentException( error );
            }
        }
        if (null == this.extensionName) {
            throw new java.lang.NullPointerException( "extensionName property is null" );
        }
    }

    public  java.lang.String getExtensionName()
    {
        return extensionName;
    }

    public  java.lang.String getSpecificationVendor()
    {
        return specificationVendor;
    }

    public  org.apache.tools.ant.util.DeweyDecimal getSpecificationVersion()
    {
        return specificationVersion;
    }

    public  java.lang.String getImplementationURL()
    {
        return implementationURL;
    }

    public  java.lang.String getImplementationVendor()
    {
        return implementationVendor;
    }

    public  java.lang.String getImplementationVendorID()
    {
        return implementationVendorID;
    }

    public  org.apache.tools.ant.util.DeweyDecimal getImplementationVersion()
    {
        return implementationVersion;
    }

    public  org.apache.tools.ant.taskdefs.optional.extension.Compatibility getCompatibilityWith( final org.apache.tools.ant.taskdefs.optional.extension.Extension required )
    {
        if (!extensionName.equals( required.getExtensionName() )) {
            return INCOMPATIBLE;
        }
        final org.apache.tools.ant.util.DeweyDecimal requiredSpecificationVersion = required.getSpecificationVersion();
        if (null != requiredSpecificationVersion) {
            if (null == specificationVersion || !isCompatible( specificationVersion, requiredSpecificationVersion )) {
                return REQUIRE_SPECIFICATION_UPGRADE;
            }
        }
        final java.lang.String requiredImplementationVendorID = required.getImplementationVendorID();
        if (null != requiredImplementationVendorID) {
            if (null == implementationVendorID || !implementationVendorID.equals( requiredImplementationVendorID )) {
                return REQUIRE_VENDOR_SWITCH;
            }
        }
        final org.apache.tools.ant.util.DeweyDecimal requiredImplementationVersion = required.getImplementationVersion();
        if (null != requiredImplementationVersion) {
            if (null == implementationVersion || !isCompatible( implementationVersion, requiredImplementationVersion )) {
                return REQUIRE_IMPLEMENTATION_UPGRADE;
            }
        }
        return COMPATIBLE;
    }

    public  boolean isCompatibleWith( final org.apache.tools.ant.taskdefs.optional.extension.Extension required )
    {
        return COMPATIBLE == getCompatibilityWith( required );
    }

    public  java.lang.String toString()
    {
        final java.lang.String brace = ": ";
        final java.lang.StringBuffer sb = new java.lang.StringBuffer( EXTENSION_NAME.toString() );
        sb.append( brace );
        sb.append( extensionName );
        sb.append( StringUtils.LINE_SEP );
        if (null != specificationVersion) {
            sb.append( SPECIFICATION_VERSION );
            sb.append( brace );
            sb.append( specificationVersion );
            sb.append( StringUtils.LINE_SEP );
        }
        if (null != specificationVendor) {
            sb.append( SPECIFICATION_VENDOR );
            sb.append( brace );
            sb.append( specificationVendor );
            sb.append( StringUtils.LINE_SEP );
        }
        if (null != implementationVersion) {
            sb.append( IMPLEMENTATION_VERSION );
            sb.append( brace );
            sb.append( implementationVersion );
            sb.append( StringUtils.LINE_SEP );
        }
        if (null != implementationVendorID) {
            sb.append( IMPLEMENTATION_VENDOR_ID );
            sb.append( brace );
            sb.append( implementationVendorID );
            sb.append( StringUtils.LINE_SEP );
        }
        if (null != implementationVendor) {
            sb.append( IMPLEMENTATION_VENDOR );
            sb.append( brace );
            sb.append( implementationVendor );
            sb.append( StringUtils.LINE_SEP );
        }
        if (null != implementationURL) {
            sb.append( IMPLEMENTATION_URL );
            sb.append( brace );
            sb.append( implementationURL );
            sb.append( StringUtils.LINE_SEP );
        }
        return sb.toString();
    }

    private  boolean isCompatible( final org.apache.tools.ant.util.DeweyDecimal first, final org.apache.tools.ant.util.DeweyDecimal second )
    {
        return first.isGreaterThanOrEqual( second );
    }

    private static  org.apache.tools.ant.taskdefs.optional.extension.Extension[] getListed( final java.util.jar.Manifest manifest, final java.util.jar.Attributes.Name listKey )
    {
        final java.util.ArrayList results = new java.util.ArrayList();
        final java.util.jar.Attributes mainAttributes = manifest.getMainAttributes();
        if (null != mainAttributes) {
            getExtension( mainAttributes, results, listKey );
        }
        final java.util.Map entries = manifest.getEntries();
        final java.util.Iterator keys = entries.keySet().iterator();
        while (keys.hasNext()) {
            final java.lang.String key = (java.lang.String) keys.next();
            final java.util.jar.Attributes attributes = (java.util.jar.Attributes) entries.get( key );
            getExtension( attributes, results, listKey );
        }
        return (org.apache.tools.ant.taskdefs.optional.extension.Extension[]) results.toArray( new org.apache.tools.ant.taskdefs.optional.extension.Extension[results.size()] );
    }

    private static  void getExtension( final java.util.jar.Attributes attributes, final java.util.ArrayList required, final java.util.jar.Attributes.Name listKey )
    {
        final java.lang.String names = attributes.getValue( listKey );
        if (null == names) {
            return;
        }
        final java.lang.String[] extentions = split( names, " " );
        for (int i = 0; i < extentions.length; i++) {
            final java.lang.String prefix = extentions[i] + "-";
            final org.apache.tools.ant.taskdefs.optional.extension.Extension extension = getExtension( prefix, attributes );
            if (null != extension) {
                required.add( extension );
            }
        }
    }

    private static  java.lang.String[] split( final java.lang.String string, final java.lang.String onToken )
    {
        final java.util.StringTokenizer tokenizer = new java.util.StringTokenizer( string, onToken );
        final java.lang.String[] result = new java.lang.String[tokenizer.countTokens()];
        for (int i = 0; i < result.length; i++) {
            result[i] = tokenizer.nextToken();
        }
        return result;
    }

    private static  org.apache.tools.ant.taskdefs.optional.extension.Extension getExtension( final java.lang.String prefix, final java.util.jar.Attributes attributes )
    {
        final java.lang.String nameKey = prefix + EXTENSION_NAME;
        final java.lang.String name = getTrimmedString( attributes.getValue( nameKey ) );
        if (null == name) {
            return null;
        }
        final java.lang.String specVendorKey = prefix + SPECIFICATION_VENDOR;
        final java.lang.String specVendor = getTrimmedString( attributes.getValue( specVendorKey ) );
        final java.lang.String specVersionKey = prefix + SPECIFICATION_VERSION;
        final java.lang.String specVersion = getTrimmedString( attributes.getValue( specVersionKey ) );
        final java.lang.String impVersionKey = prefix + IMPLEMENTATION_VERSION;
        final java.lang.String impVersion = getTrimmedString( attributes.getValue( impVersionKey ) );
        final java.lang.String impVendorKey = prefix + IMPLEMENTATION_VENDOR;
        final java.lang.String impVendor = getTrimmedString( attributes.getValue( impVendorKey ) );
        final java.lang.String impVendorIDKey = prefix + IMPLEMENTATION_VENDOR_ID;
        final java.lang.String impVendorId = getTrimmedString( attributes.getValue( impVendorIDKey ) );
        final java.lang.String impURLKey = prefix + IMPLEMENTATION_URL;
        final java.lang.String impURL = getTrimmedString( attributes.getValue( impURLKey ) );
        return new org.apache.tools.ant.taskdefs.optional.extension.Extension( name, specVersion, specVendor, impVersion, impVendor, impVendorId, impURL );
    }

    private static  java.lang.String getTrimmedString( final java.lang.String value )
    {
        return null == value ? null : value.trim();
    }

}
