// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.extension;


import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.jar.Attributes;
import java.util.jar.Manifest;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.MagicNames;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.Task;


public final class JarLibManifestTask extends org.apache.tools.ant.Task
{

    private static final java.lang.String MANIFEST_VERSION = "1.0";

    private static final java.lang.String CREATED_BY = "Created-By";

    private java.io.File destFile;

    private org.apache.tools.ant.taskdefs.optional.extension.Extension extension;

    private final java.util.ArrayList dependencies = new java.util.ArrayList();

    private final java.util.ArrayList optionals = new java.util.ArrayList();

    private final java.util.ArrayList extraAttributes = new java.util.ArrayList();

    public  void setDestfile( final java.io.File destFile )
    {
        this.destFile = destFile;
    }

    public  void addConfiguredExtension( final org.apache.tools.ant.taskdefs.optional.extension.ExtensionAdapter extensionAdapter )
        throws org.apache.tools.ant.BuildException
    {
        if (null != extension) {
            throw new org.apache.tools.ant.BuildException( "Can not have multiple extensions defined in one library." );
        }
        extension = extensionAdapter.toExtension();
    }

    public  void addConfiguredDepends( final org.apache.tools.ant.taskdefs.optional.extension.ExtensionSet extensionSet )
    {
        dependencies.add( extensionSet );
    }

    public  void addConfiguredOptions( final org.apache.tools.ant.taskdefs.optional.extension.ExtensionSet extensionSet )
    {
        optionals.add( extensionSet );
    }

    public  void addConfiguredAttribute( final org.apache.tools.ant.taskdefs.optional.extension.ExtraAttribute attribute )
    {
        extraAttributes.add( attribute );
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        validate();
        final java.util.jar.Manifest manifest = new java.util.jar.Manifest();
        final java.util.jar.Attributes attributes = manifest.getMainAttributes();
        attributes.put( Attributes.Name.MANIFEST_VERSION, MANIFEST_VERSION );
        attributes.putValue( CREATED_BY, "Apache Ant " + getProject().getProperty( MagicNames.ANT_VERSION ) );
        appendExtraAttributes( attributes );
        if (null != extension) {
            Extension.addExtension( extension, attributes );
        }
        final java.util.ArrayList depends = toExtensions( dependencies );
        appendExtensionList( attributes, Extension.EXTENSION_LIST, "lib", depends.size() );
        appendLibraryList( attributes, "lib", depends );
        final java.util.ArrayList option = toExtensions( optionals );
        appendExtensionList( attributes, Extension.OPTIONAL_EXTENSION_LIST, "opt", option.size() );
        appendLibraryList( attributes, "opt", option );
        try {
            log( "Generating manifest " + destFile.getAbsoluteFile(), Project.MSG_INFO );
            writeManifest( manifest );
        } catch ( final java.io.IOException ioe ) {
            throw new org.apache.tools.ant.BuildException( ioe.getMessage(), ioe );
        }
    }

    private  void validate()
        throws org.apache.tools.ant.BuildException
    {
        if (null == destFile) {
            throw new org.apache.tools.ant.BuildException( "Destfile attribute not specified." );
        }
        if (destFile.exists() && !destFile.isFile()) {
            throw new org.apache.tools.ant.BuildException( destFile + " is not a file." );
        }
    }

    private  void appendExtraAttributes( final java.util.jar.Attributes attributes )
    {
        final java.util.Iterator iterator = extraAttributes.iterator();
        while (iterator.hasNext()) {
            final org.apache.tools.ant.taskdefs.optional.extension.ExtraAttribute attribute = (org.apache.tools.ant.taskdefs.optional.extension.ExtraAttribute) iterator.next();
            attributes.putValue( attribute.getName(), attribute.getValue() );
        }
    }

    private  void writeManifest( final java.util.jar.Manifest manifest )
        throws java.io.IOException
    {
        java.io.FileOutputStream output = null;
        try {
            output = new java.io.FileOutputStream( destFile );
            manifest.write( output );
            output.flush();
        } finally 
{
            if (null != output) {
                try {
                    output.close();
                } catch ( java.io.IOException e ) {
                }
            }
        }
    }

    private  void appendLibraryList( final java.util.jar.Attributes attributes, final java.lang.String listPrefix, final java.util.ArrayList extensions )
        throws org.apache.tools.ant.BuildException
    {
        final int size = extensions.size();
        for (int i = 0; i < size; i++) {
            final org.apache.tools.ant.taskdefs.optional.extension.Extension ext = (org.apache.tools.ant.taskdefs.optional.extension.Extension) extensions.get( i );
            final java.lang.String prefix = listPrefix + i + "-";
            Extension.addExtension( ext, prefix, attributes );
        }
    }

    private  void appendExtensionList( final java.util.jar.Attributes attributes, final java.util.jar.Attributes.Name extensionKey, final java.lang.String listPrefix, final int size )
    {
        final java.lang.StringBuffer sb = new java.lang.StringBuffer();
        for (int i = 0; i < size; i++) {
            sb.append( listPrefix );
            sb.append( i );
            sb.append( ' ' );
        }
        attributes.put( extensionKey, sb.toString() );
    }

    private  java.util.ArrayList toExtensions( final java.util.ArrayList extensionSets )
        throws org.apache.tools.ant.BuildException
    {
        final java.util.ArrayList results = new java.util.ArrayList();
        final int size = extensionSets.size();
        for (int i = 0; i < size; i++) {
            final org.apache.tools.ant.taskdefs.optional.extension.ExtensionSet set = (org.apache.tools.ant.taskdefs.optional.extension.ExtensionSet) extensionSets.get( i );
            final org.apache.tools.ant.taskdefs.optional.extension.Extension[] extensions = set.toExtensions( getProject() );
            for (int j = 0; j < extensions.length; j++) {
                results.add( extensions[j] );
            }
        }
        return results;
    }

}
