// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.extension;


import java.io.File;
import java.util.ArrayList;
import java.util.jar.Manifest;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.taskdefs.optional.extension.resolvers.AntResolver;
import org.apache.tools.ant.taskdefs.optional.extension.resolvers.LocationResolver;
import org.apache.tools.ant.taskdefs.optional.extension.resolvers.URLResolver;


public class JarLibResolveTask extends org.apache.tools.ant.Task
{

    private java.lang.String propertyName;

    private org.apache.tools.ant.taskdefs.optional.extension.Extension requiredExtension;

    private final java.util.ArrayList resolvers = new java.util.ArrayList();

    private boolean checkExtension = true;

    private boolean failOnError = true;

    public  void setProperty( final java.lang.String property )
    {
        this.propertyName = property;
    }

    public  void setCheckExtension( final boolean checkExtension )
    {
        this.checkExtension = checkExtension;
    }

    public  void setFailOnError( final boolean failOnError )
    {
        this.failOnError = failOnError;
    }

    public  void addConfiguredLocation( final org.apache.tools.ant.taskdefs.optional.extension.resolvers.LocationResolver loc )
    {
        resolvers.add( loc );
    }

    public  void addConfiguredUrl( final org.apache.tools.ant.taskdefs.optional.extension.resolvers.URLResolver url )
    {
        resolvers.add( url );
    }

    public  void addConfiguredAnt( final org.apache.tools.ant.taskdefs.optional.extension.resolvers.AntResolver ant )
    {
        resolvers.add( ant );
    }

    public  void addConfiguredExtension( final org.apache.tools.ant.taskdefs.optional.extension.ExtensionAdapter extension )
    {
        if (null != requiredExtension) {
            final java.lang.String message = "Can not specify extension to " + "resolve multiple times.";
            throw new org.apache.tools.ant.BuildException( message );
        }
        requiredExtension = extension.toExtension();
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        validate();
        getProject().log( "Resolving extension: " + requiredExtension, Project.MSG_VERBOSE );
        java.lang.String candidate = getProject().getProperty( propertyName );
        if (null != candidate) {
            final java.lang.String message = "Property Already set to: " + candidate;
            if (failOnError) {
                throw new org.apache.tools.ant.BuildException( message );
            }
            getProject().log( message, Project.MSG_ERR );
            return;
        }
        final int size = resolvers.size();
        for (int i = 0; i < size; i++) {
            final org.apache.tools.ant.taskdefs.optional.extension.ExtensionResolver resolver = (org.apache.tools.ant.taskdefs.optional.extension.ExtensionResolver) resolvers.get( i );
            getProject().log( "Searching for extension using Resolver:" + resolver, Project.MSG_VERBOSE );
            try {
                final java.io.File file = resolver.resolve( requiredExtension, getProject() );
                try {
                    checkExtension( file );
                    return;
                } catch ( final org.apache.tools.ant.BuildException be ) {
                    final java.lang.String message = "File " + file + " returned by " + "resolver failed to satisfy extension due to: " + be.getMessage();
                    getProject().log( message, Project.MSG_WARN );
                }
            } catch ( final org.apache.tools.ant.BuildException be ) {
                final java.lang.String message = "Failed to resolve extension to file " + "using resolver " + resolver + " due to: " + be;
                getProject().log( message, Project.MSG_WARN );
            }
        }
        missingExtension();
    }

    private  void missingExtension()
    {
        final java.lang.String message = "Unable to resolve extension to a file";
        if (failOnError) {
            throw new org.apache.tools.ant.BuildException( message );
        }
        getProject().log( message, Project.MSG_ERR );
    }

    private  void checkExtension( final java.io.File file )
    {
        if (!file.exists()) {
            throw new org.apache.tools.ant.BuildException( "File " + file + " does not exist" );
        }
        if (!file.isFile()) {
            throw new org.apache.tools.ant.BuildException( "File " + file + " is not a file" );
        }
        if (!checkExtension) {
            getProject().log( "Setting property to " + file + " without verifying library satisfies extension", Project.MSG_VERBOSE );
            setLibraryProperty( file );
        } else {
            getProject().log( "Checking file " + file + " to see if it satisfies extension", Project.MSG_VERBOSE );
            final java.util.jar.Manifest manifest = ExtensionUtil.getManifest( file );
            final org.apache.tools.ant.taskdefs.optional.extension.Extension[] extensions = Extension.getAvailable( manifest );
            for (int i = 0; i < extensions.length; i++) {
                final org.apache.tools.ant.taskdefs.optional.extension.Extension extension = extensions[i];
                if (extension.isCompatibleWith( requiredExtension )) {
                    setLibraryProperty( file );
                    return;
                }
            }
            final java.lang.String message = "File " + file + " skipped as it " + "does not satisfy extension";
            getProject().log( message, Project.MSG_VERBOSE );
            throw new org.apache.tools.ant.BuildException( message );
        }
    }

    private  void setLibraryProperty( final java.io.File file )
    {
        getProject().setNewProperty( propertyName, file.getAbsolutePath() );
    }

    private  void validate()
        throws org.apache.tools.ant.BuildException
    {
        if (null == propertyName) {
            final java.lang.String message = "Property attribute must be specified.";
            throw new org.apache.tools.ant.BuildException( message );
        }
        if (null == requiredExtension) {
            final java.lang.String message = "Extension element must be specified.";
            throw new org.apache.tools.ant.BuildException( message );
        }
    }

}
