// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.extension;


import java.text.ParseException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.Map;
import java.util.jar.Attributes;
import java.util.jar.Manifest;
import org.apache.tools.ant.util.DeweyDecimal;
import org.apache.tools.ant.util.StringUtils;


public final class Specification
{

    private static final java.lang.String MISSING = "Missing ";

    public static final java.util.jar.Attributes.Name SPECIFICATION_TITLE = Attributes.Name.SPECIFICATION_TITLE;

    public static final java.util.jar.Attributes.Name SPECIFICATION_VERSION = Attributes.Name.SPECIFICATION_VERSION;

    public static final java.util.jar.Attributes.Name SPECIFICATION_VENDOR = Attributes.Name.SPECIFICATION_VENDOR;

    public static final java.util.jar.Attributes.Name IMPLEMENTATION_TITLE = Attributes.Name.IMPLEMENTATION_TITLE;

    public static final java.util.jar.Attributes.Name IMPLEMENTATION_VERSION = Attributes.Name.IMPLEMENTATION_VERSION;

    public static final java.util.jar.Attributes.Name IMPLEMENTATION_VENDOR = Attributes.Name.IMPLEMENTATION_VENDOR;

    public static final org.apache.tools.ant.taskdefs.optional.extension.Compatibility COMPATIBLE = new org.apache.tools.ant.taskdefs.optional.extension.Compatibility( "COMPATIBLE" );

    public static final org.apache.tools.ant.taskdefs.optional.extension.Compatibility REQUIRE_SPECIFICATION_UPGRADE = new org.apache.tools.ant.taskdefs.optional.extension.Compatibility( "REQUIRE_SPECIFICATION_UPGRADE" );

    public static final org.apache.tools.ant.taskdefs.optional.extension.Compatibility REQUIRE_VENDOR_SWITCH = new org.apache.tools.ant.taskdefs.optional.extension.Compatibility( "REQUIRE_VENDOR_SWITCH" );

    public static final org.apache.tools.ant.taskdefs.optional.extension.Compatibility REQUIRE_IMPLEMENTATION_CHANGE = new org.apache.tools.ant.taskdefs.optional.extension.Compatibility( "REQUIRE_IMPLEMENTATION_CHANGE" );

    public static final org.apache.tools.ant.taskdefs.optional.extension.Compatibility INCOMPATIBLE = new org.apache.tools.ant.taskdefs.optional.extension.Compatibility( "INCOMPATIBLE" );

    private java.lang.String specificationTitle;

    private org.apache.tools.ant.util.DeweyDecimal specificationVersion;

    private java.lang.String specificationVendor;

    private java.lang.String implementationTitle;

    private java.lang.String implementationVendor;

    private java.lang.String implementationVersion;

    private java.lang.String[] sections;

    public static  org.apache.tools.ant.taskdefs.optional.extension.Specification[] getSpecifications( final java.util.jar.Manifest manifest )
        throws java.text.ParseException
    {
        if (null == manifest) {
            return new org.apache.tools.ant.taskdefs.optional.extension.Specification[0];
        }
        final java.util.ArrayList results = new java.util.ArrayList();
        final java.util.Map entries = manifest.getEntries();
        final java.util.Iterator keys = entries.keySet().iterator();
        while (keys.hasNext()) {
            final java.lang.String key = (java.lang.String) keys.next();
            final java.util.jar.Attributes attributes = (java.util.jar.Attributes) entries.get( key );
            final org.apache.tools.ant.taskdefs.optional.extension.Specification specification = getSpecification( key, attributes );
            if (null != specification) {
                results.add( specification );
            }
        }
        final java.util.ArrayList trimmedResults = removeDuplicates( results );
        return (org.apache.tools.ant.taskdefs.optional.extension.Specification[]) trimmedResults.toArray( new org.apache.tools.ant.taskdefs.optional.extension.Specification[trimmedResults.size()] );
    }

    public Specification( final java.lang.String specificationTitle, final java.lang.String specificationVersion, final java.lang.String specificationVendor, final java.lang.String implementationTitle, final java.lang.String implementationVersion, final java.lang.String implementationVendor )
    {
        this( specificationTitle, specificationVersion, specificationVendor, implementationTitle, implementationVersion, implementationVendor, null );
    }

    public Specification( final java.lang.String specificationTitle, final java.lang.String specificationVersion, final java.lang.String specificationVendor, final java.lang.String implementationTitle, final java.lang.String implementationVersion, final java.lang.String implementationVendor, final java.lang.String[] sections )
    {
        this.specificationTitle = specificationTitle;
        this.specificationVendor = specificationVendor;
        if (null != specificationVersion) {
            try {
                this.specificationVersion = new org.apache.tools.ant.util.DeweyDecimal( specificationVersion );
            } catch ( final java.lang.NumberFormatException nfe ) {
                final java.lang.String error = "Bad specification version format '" + specificationVersion + "' in '" + specificationTitle + "'. (Reason: " + nfe + ")";
                throw new java.lang.IllegalArgumentException( error );
            }
        }
        this.implementationTitle = implementationTitle;
        this.implementationVendor = implementationVendor;
        this.implementationVersion = implementationVersion;
        if (null == this.specificationTitle) {
            throw new java.lang.NullPointerException( "specificationTitle" );
        }
        java.lang.String[] copy = null;
        if (null != sections) {
            copy = new java.lang.String[sections.length];
            System.arraycopy( sections, 0, copy, 0, sections.length );
        }
        this.sections = copy;
    }

    public  java.lang.String getSpecificationTitle()
    {
        return specificationTitle;
    }

    public  java.lang.String getSpecificationVendor()
    {
        return specificationVendor;
    }

    public  java.lang.String getImplementationTitle()
    {
        return implementationTitle;
    }

    public  org.apache.tools.ant.util.DeweyDecimal getSpecificationVersion()
    {
        return specificationVersion;
    }

    public  java.lang.String getImplementationVendor()
    {
        return implementationVendor;
    }

    public  java.lang.String getImplementationVersion()
    {
        return implementationVersion;
    }

    public  java.lang.String[] getSections()
    {
        if (null == sections) {
            return null;
        }
        final java.lang.String[] newSections = new java.lang.String[sections.length];
        System.arraycopy( sections, 0, newSections, 0, sections.length );
        return newSections;
    }

    public  org.apache.tools.ant.taskdefs.optional.extension.Compatibility getCompatibilityWith( final org.apache.tools.ant.taskdefs.optional.extension.Specification other )
    {
        if (!specificationTitle.equals( other.getSpecificationTitle() )) {
            return INCOMPATIBLE;
        }
        final org.apache.tools.ant.util.DeweyDecimal otherSpecificationVersion = other.getSpecificationVersion();
        if (null != specificationVersion) {
            if (null == otherSpecificationVersion || !isCompatible( specificationVersion, otherSpecificationVersion )) {
                return REQUIRE_SPECIFICATION_UPGRADE;
            }
        }
        final java.lang.String otherImplementationVendor = other.getImplementationVendor();
        if (null != implementationVendor) {
            if (null == otherImplementationVendor || !implementationVendor.equals( otherImplementationVendor )) {
                return REQUIRE_VENDOR_SWITCH;
            }
        }
        final java.lang.String otherImplementationVersion = other.getImplementationVersion();
        if (null != implementationVersion) {
            if (null == otherImplementationVersion || !implementationVersion.equals( otherImplementationVersion )) {
                return REQUIRE_IMPLEMENTATION_CHANGE;
            }
        }
        return COMPATIBLE;
    }

    public  boolean isCompatibleWith( final org.apache.tools.ant.taskdefs.optional.extension.Specification other )
    {
        return COMPATIBLE == getCompatibilityWith( other );
    }

    public  java.lang.String toString()
    {
        final java.lang.String brace = ": ";
        final java.lang.StringBuffer sb = new java.lang.StringBuffer( SPECIFICATION_TITLE.toString() );
        sb.append( brace );
        sb.append( specificationTitle );
        sb.append( StringUtils.LINE_SEP );
        if (null != specificationVersion) {
            sb.append( SPECIFICATION_VERSION );
            sb.append( brace );
            sb.append( specificationVersion );
            sb.append( StringUtils.LINE_SEP );
        }
        if (null != specificationVendor) {
            sb.append( SPECIFICATION_VENDOR );
            sb.append( brace );
            sb.append( specificationVendor );
            sb.append( StringUtils.LINE_SEP );
        }
        if (null != implementationTitle) {
            sb.append( IMPLEMENTATION_TITLE );
            sb.append( brace );
            sb.append( implementationTitle );
            sb.append( StringUtils.LINE_SEP );
        }
        if (null != implementationVersion) {
            sb.append( IMPLEMENTATION_VERSION );
            sb.append( brace );
            sb.append( implementationVersion );
            sb.append( StringUtils.LINE_SEP );
        }
        if (null != implementationVendor) {
            sb.append( IMPLEMENTATION_VENDOR );
            sb.append( brace );
            sb.append( implementationVendor );
            sb.append( StringUtils.LINE_SEP );
        }
        return sb.toString();
    }

    private  boolean isCompatible( final org.apache.tools.ant.util.DeweyDecimal first, final org.apache.tools.ant.util.DeweyDecimal second )
    {
        return first.isGreaterThanOrEqual( second );
    }

    private static  java.util.ArrayList removeDuplicates( final java.util.ArrayList list )
    {
        final java.util.ArrayList results = new java.util.ArrayList();
        final java.util.ArrayList sections = new java.util.ArrayList();
        while (list.size() > 0) {
            final org.apache.tools.ant.taskdefs.optional.extension.Specification specification = (org.apache.tools.ant.taskdefs.optional.extension.Specification) list.remove( 0 );
            final java.util.Iterator iterator = list.iterator();
            while (iterator.hasNext()) {
                final org.apache.tools.ant.taskdefs.optional.extension.Specification other = (org.apache.tools.ant.taskdefs.optional.extension.Specification) iterator.next();
                if (isEqual( specification, other )) {
                    final java.lang.String[] otherSections = other.getSections();
                    if (null != otherSections) {
                        sections.addAll( Arrays.asList( otherSections ) );
                    }
                    iterator.remove();
                }
            }
            final org.apache.tools.ant.taskdefs.optional.extension.Specification merged = mergeInSections( specification, sections );
            results.add( merged );
            sections.clear();
        }
        return results;
    }

    private static  boolean isEqual( final org.apache.tools.ant.taskdefs.optional.extension.Specification specification, final org.apache.tools.ant.taskdefs.optional.extension.Specification other )
    {
        return specification.getSpecificationTitle().equals( other.getSpecificationTitle() ) && specification.getSpecificationVersion().isEqual( other.getSpecificationVersion() ) && specification.getSpecificationVendor().equals( other.getSpecificationVendor() ) && specification.getImplementationTitle().equals( other.getImplementationTitle() ) && specification.getImplementationVersion().equals( other.getImplementationVersion() ) && specification.getImplementationVendor().equals( other.getImplementationVendor() );
    }

    private static  org.apache.tools.ant.taskdefs.optional.extension.Specification mergeInSections( final org.apache.tools.ant.taskdefs.optional.extension.Specification specification, final java.util.ArrayList sectionsToAdd )
    {
        if (0 == sectionsToAdd.size()) {
            return specification;
        }
        sectionsToAdd.addAll( Arrays.asList( specification.getSections() ) );
        final java.lang.String[] sections = (java.lang.String[]) sectionsToAdd.toArray( new java.lang.String[sectionsToAdd.size()] );
        return new org.apache.tools.ant.taskdefs.optional.extension.Specification( specification.getSpecificationTitle(), specification.getSpecificationVersion().toString(), specification.getSpecificationVendor(), specification.getImplementationTitle(), specification.getImplementationVersion(), specification.getImplementationVendor(), sections );
    }

    private static  java.lang.String getTrimmedString( final java.lang.String value )
    {
        return value == null ? null : value.trim();
    }

    private static  org.apache.tools.ant.taskdefs.optional.extension.Specification getSpecification( final java.lang.String section, final java.util.jar.Attributes attributes )
        throws java.text.ParseException
    {
        final java.lang.String name = getTrimmedString( attributes.getValue( SPECIFICATION_TITLE ) );
        if (null == name) {
            return null;
        }
        final java.lang.String specVendor = getTrimmedString( attributes.getValue( SPECIFICATION_VENDOR ) );
        if (null == specVendor) {
            throw new java.text.ParseException( MISSING + SPECIFICATION_VENDOR, 0 );
        }
        final java.lang.String specVersion = getTrimmedString( attributes.getValue( SPECIFICATION_VERSION ) );
        if (null == specVersion) {
            throw new java.text.ParseException( MISSING + SPECIFICATION_VERSION, 0 );
        }
        final java.lang.String impTitle = getTrimmedString( attributes.getValue( IMPLEMENTATION_TITLE ) );
        if (null == impTitle) {
            throw new java.text.ParseException( MISSING + IMPLEMENTATION_TITLE, 0 );
        }
        final java.lang.String impVersion = getTrimmedString( attributes.getValue( IMPLEMENTATION_VERSION ) );
        if (null == impVersion) {
            throw new java.text.ParseException( MISSING + IMPLEMENTATION_VERSION, 0 );
        }
        final java.lang.String impVendor = getTrimmedString( attributes.getValue( IMPLEMENTATION_VENDOR ) );
        if (null == impVendor) {
            throw new java.text.ParseException( MISSING + IMPLEMENTATION_VENDOR, 0 );
        }
        return new org.apache.tools.ant.taskdefs.optional.extension.Specification( name, specVersion, specVendor, impTitle, impVersion, impVendor, new java.lang.String[]{ section } );
    }

}
