// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.jsp.compilers;


import java.io.File;
import org.apache.tools.ant.AntClassLoader;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.Java;
import org.apache.tools.ant.taskdefs.optional.jsp.JspC;
import org.apache.tools.ant.taskdefs.optional.jsp.JspMangler;
import org.apache.tools.ant.types.CommandlineJava;
import org.apache.tools.ant.types.Path;


public class JasperC extends org.apache.tools.ant.taskdefs.optional.jsp.compilers.DefaultJspCompilerAdapter
{

    org.apache.tools.ant.taskdefs.optional.jsp.JspMangler mangler;

    public JasperC( org.apache.tools.ant.taskdefs.optional.jsp.JspMangler mangler )
    {
        this.mangler = mangler;
    }

    public  boolean execute()
        throws org.apache.tools.ant.BuildException
    {
        getJspc().log( "Using jasper compiler", Project.MSG_VERBOSE );
        org.apache.tools.ant.types.CommandlineJava cmd = setupJasperCommand();
        try {
            org.apache.tools.ant.taskdefs.Java java = new org.apache.tools.ant.taskdefs.Java( owner );
            org.apache.tools.ant.types.Path p = getClasspath();
            if (getJspc().getClasspath() != null) {
                getProject().log( "using user supplied classpath: " + p, Project.MSG_DEBUG );
            } else {
                getProject().log( "using system classpath: " + p, Project.MSG_DEBUG );
            }
            java.setClasspath( p );
            java.setDir( getProject().getBaseDir() );
            java.setClassname( "org.apache.jasper.JspC" );
            java.lang.String[] args = cmd.getJavaCommand().getArguments();
            for (int i = 0; i < args.length; i++) {
                java.createArg().setValue( args[i] );
            }
            java.setFailonerror( getJspc().getFailonerror() );
            java.setFork( true );
            java.setTaskName( "jasperc" );
            java.execute();
            return true;
        } catch ( java.lang.Exception ex ) {
            if (ex instanceof org.apache.tools.ant.BuildException) {
                throw (org.apache.tools.ant.BuildException) ex;
            } else {
                throw new org.apache.tools.ant.BuildException( "Error running jsp compiler: ", ex, getJspc().getLocation() );
            }
        } finally 
{
            getJspc().deleteEmptyJavaFiles();
        }
    }

    private  org.apache.tools.ant.types.CommandlineJava setupJasperCommand()
    {
        org.apache.tools.ant.types.CommandlineJava cmd = new org.apache.tools.ant.types.CommandlineJava();
        org.apache.tools.ant.taskdefs.optional.jsp.JspC jspc = getJspc();
        addArg( cmd, "-d", jspc.getDestdir() );
        addArg( cmd, "-p", jspc.getPackage() );
        if (!isTomcat5x()) {
            addArg( cmd, "-v" + jspc.getVerbose() );
        } else {
            getProject().log( "this task doesn't support Tomcat 5.x properly, " + "please use the Tomcat provided jspc task " + "instead" );
        }
        addArg( cmd, "-uriroot", jspc.getUriroot() );
        addArg( cmd, "-uribase", jspc.getUribase() );
        addArg( cmd, "-ieplugin", jspc.getIeplugin() );
        addArg( cmd, "-webinc", jspc.getWebinc() );
        addArg( cmd, "-webxml", jspc.getWebxml() );
        addArg( cmd, "-die9" );
        if (jspc.isMapped()) {
            addArg( cmd, "-mapped" );
        }
        if (jspc.getWebApp() != null) {
            java.io.File dir = jspc.getWebApp().getDirectory();
            addArg( cmd, "-webapp", dir );
        }
        logAndAddFilesToCompile( getJspc(), getJspc().getCompileList(), cmd );
        return cmd;
    }

    public  org.apache.tools.ant.taskdefs.optional.jsp.JspMangler createMangler()
    {
        return mangler;
    }

    private  org.apache.tools.ant.types.Path getClasspath()
    {
        org.apache.tools.ant.types.Path p = getJspc().getClasspath();
        if (p == null) {
            p = new org.apache.tools.ant.types.Path( getProject() );
            return p.concatSystemClasspath( "only" );
        } else {
            return p.concatSystemClasspath( "ignore" );
        }
    }

    private  boolean isTomcat5x()
    {
        org.apache.tools.ant.AntClassLoader l = null;
        try {
            l = getProject().createClassLoader( getClasspath() );
            l.loadClass( "org.apache.jasper.tagplugins.jstl.If" );
            return true;
        } catch ( java.lang.ClassNotFoundException e ) {
            return false;
        } finally 
{
            if (l != null) {
                l.cleanup();
            }
        }
    }

}
