// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.junit;


import java.io.BufferedWriter;
import java.io.IOException;
import java.io.OutputStream;
import java.io.StringWriter;
import java.text.NumberFormat;
import junit.framework.AssertionFailedError;
import junit.framework.Test;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.util.FileUtils;
import org.apache.tools.ant.util.StringUtils;


public class BriefJUnitResultFormatter implements org.apache.tools.ant.taskdefs.optional.junit.JUnitResultFormatter
{

    private static final double ONE_SECOND = 1000.0;

    private java.io.OutputStream out;

    private java.io.BufferedWriter output;

    private java.io.StringWriter results;

    private java.io.BufferedWriter resultWriter;

    private java.text.NumberFormat numberFormat = NumberFormat.getInstance();

    private java.lang.String systemOutput = null;

    private java.lang.String systemError = null;

    public BriefJUnitResultFormatter()
    {
        results = new java.io.StringWriter();
        resultWriter = new java.io.BufferedWriter( results );
    }

    public  void setOutput( java.io.OutputStream out )
    {
        this.out = out;
        output = new java.io.BufferedWriter( new java.io.OutputStreamWriter( out ) );
    }

    public  void setSystemOutput( java.lang.String out )
    {
        systemOutput = out;
    }

    public  void setSystemError( java.lang.String err )
    {
        systemError = err;
    }

    public  void startTestSuite( org.apache.tools.ant.taskdefs.optional.junit.JUnitTest suite )
    {
        if (output == null) {
            return;
        }
        java.lang.StringBuffer sb = new java.lang.StringBuffer( "Testsuite: " );
        sb.append( suite.getName() );
        sb.append( StringUtils.LINE_SEP );
        try {
            output.write( sb.toString() );
            output.flush();
        } catch ( java.io.IOException ex ) {
            throw new org.apache.tools.ant.BuildException( ex );
        }
    }

    public  void endTestSuite( org.apache.tools.ant.taskdefs.optional.junit.JUnitTest suite )
    {
        java.lang.StringBuffer sb = new java.lang.StringBuffer( "Tests run: " );
        sb.append( suite.runCount() );
        sb.append( ", Failures: " );
        sb.append( suite.failureCount() );
        sb.append( ", Errors: " );
        sb.append( suite.errorCount() );
        sb.append( ", Time elapsed: " );
        sb.append( numberFormat.format( suite.getRunTime() / ONE_SECOND ) );
        sb.append( " sec" );
        sb.append( StringUtils.LINE_SEP );
        sb.append( StringUtils.LINE_SEP );
        if (systemOutput != null && systemOutput.length() > 0) {
            sb.append( "------------- Standard Output ---------------" ).append( StringUtils.LINE_SEP ).append( systemOutput ).append( "------------- ---------------- ---------------" ).append( StringUtils.LINE_SEP );
        }
        if (systemError != null && systemError.length() > 0) {
            sb.append( "------------- Standard Error -----------------" ).append( StringUtils.LINE_SEP ).append( systemError ).append( "------------- ---------------- ---------------" ).append( StringUtils.LINE_SEP );
        }
        if (output != null) {
            try {
                output.write( sb.toString() );
                resultWriter.close();
                output.write( results.toString() );
            } catch ( java.io.IOException ex ) {
                throw new org.apache.tools.ant.BuildException( ex );
            } finally 
{
                try {
                    output.flush();
                } catch ( java.io.IOException ex ) {
                }
                if (out != System.out && out != System.err) {
                    FileUtils.close( out );
                }
            }
        }
    }

    public  void startTest( junit.framework.Test test )
    {
    }

    public  void endTest( junit.framework.Test test )
    {
    }

    public  void addFailure( junit.framework.Test test, java.lang.Throwable t )
    {
        formatError( "\tFAILED", test, t );
    }

    public  void addFailure( junit.framework.Test test, junit.framework.AssertionFailedError t )
    {
        addFailure( test, (java.lang.Throwable) t );
    }

    public  void addError( junit.framework.Test test, java.lang.Throwable error )
    {
        formatError( "\tCaused an ERROR", test, error );
    }

    protected  java.lang.String formatTest( junit.framework.Test test )
    {
        if (test == null) {
            return "Null Test: ";
        } else {
            return "Testcase: " + test.toString() + ":";
        }
    }

    protected synchronized  void formatError( java.lang.String type, junit.framework.Test test, java.lang.Throwable error )
    {
        if (test != null) {
            endTest( test );
        }
        try {
            resultWriter.write( formatTest( test ) + type );
            resultWriter.newLine();
            resultWriter.write( String.valueOf( error.getMessage() ) );
            resultWriter.newLine();
            java.lang.String strace = JUnitTestRunner.getFilteredTrace( error );
            resultWriter.write( strace );
            resultWriter.newLine();
            resultWriter.newLine();
        } catch ( java.io.IOException ex ) {
            throw new org.apache.tools.ant.BuildException( ex );
        }
    }

}
