// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.junit;


import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.BufferedOutputStream;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.PropertyHelper;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.types.EnumeratedAttribute;
import org.apache.tools.ant.util.KeepAliveOutputStream;


public class FormatterElement
{

    private java.lang.String classname;

    private java.lang.String extension;

    private java.io.OutputStream out = new org.apache.tools.ant.util.KeepAliveOutputStream( System.out );

    private java.io.File outFile;

    private boolean useFile = true;

    private java.lang.Object ifCond;

    private java.lang.Object unlessCond;

    private org.apache.tools.ant.Project project;

    public static final java.lang.String XML_FORMATTER_CLASS_NAME = "org.apache.tools.ant.taskdefs.optional.junit.XMLJUnitResultFormatter";

    public static final java.lang.String BRIEF_FORMATTER_CLASS_NAME = "org.apache.tools.ant.taskdefs.optional.junit.BriefJUnitResultFormatter";

    public static final java.lang.String PLAIN_FORMATTER_CLASS_NAME = "org.apache.tools.ant.taskdefs.optional.junit.PlainJUnitResultFormatter";

    public static final java.lang.String FAILURE_RECORDER_CLASS_NAME = "org.apache.tools.ant.taskdefs.optional.junit.FailureRecorder";

    public  void setType( org.apache.tools.ant.taskdefs.optional.junit.FormatterElement.TypeAttribute type )
    {
        if ("xml".equals( type.getValue() )) {
            setClassname( XML_FORMATTER_CLASS_NAME );
        } else {
            if ("brief".equals( type.getValue() )) {
                setClassname( BRIEF_FORMATTER_CLASS_NAME );
            } else {
                if ("failure".equals( type.getValue() )) {
                    setClassname( FAILURE_RECORDER_CLASS_NAME );
                } else {
                    setClassname( PLAIN_FORMATTER_CLASS_NAME );
                }
            }
        }
    }

    public  void setClassname( java.lang.String classname )
    {
        this.classname = classname;
        if (XML_FORMATTER_CLASS_NAME.equals( classname )) {
            setExtension( ".xml" );
        } else {
            if (PLAIN_FORMATTER_CLASS_NAME.equals( classname )) {
                setExtension( ".txt" );
            } else {
                if (BRIEF_FORMATTER_CLASS_NAME.equals( classname )) {
                    setExtension( ".txt" );
                }
            }
        }
    }

    public  java.lang.String getClassname()
    {
        return classname;
    }

    public  void setExtension( java.lang.String ext )
    {
        this.extension = ext;
    }

    public  java.lang.String getExtension()
    {
        return extension;
    }

     void setOutfile( java.io.File out )
    {
        this.outFile = out;
    }

    public  void setOutput( java.io.OutputStream out )
    {
        if (out == System.out || out == System.err) {
            out = new org.apache.tools.ant.util.KeepAliveOutputStream( out );
        }
        this.out = out;
    }

    public  void setUseFile( boolean useFile )
    {
        this.useFile = useFile;
    }

     boolean getUseFile()
    {
        return useFile;
    }

    public  void setIf( java.lang.Object ifCond )
    {
        this.ifCond = ifCond;
    }

    public  void setIf( java.lang.String ifCond )
    {
        setIf( (java.lang.Object) ifCond );
    }

    public  void setUnless( java.lang.Object unlessCond )
    {
        this.unlessCond = unlessCond;
    }

    public  void setUnless( java.lang.String unlessCond )
    {
        setUnless( (java.lang.Object) unlessCond );
    }

    public  boolean shouldUse( org.apache.tools.ant.Task t )
    {
        org.apache.tools.ant.PropertyHelper ph = PropertyHelper.getPropertyHelper( t.getProject() );
        return ph.testIfCondition( ifCond ) && ph.testUnlessCondition( unlessCond );
    }

     org.apache.tools.ant.taskdefs.optional.junit.JUnitTaskMirror.JUnitResultFormatterMirror createFormatter()
        throws org.apache.tools.ant.BuildException
    {
        return createFormatter( null );
    }

    public  void setProject( org.apache.tools.ant.Project project )
    {
        this.project = project;
    }

     org.apache.tools.ant.taskdefs.optional.junit.JUnitTaskMirror.JUnitResultFormatterMirror createFormatter( java.lang.ClassLoader loader )
        throws org.apache.tools.ant.BuildException
    {
        if (classname == null) {
            throw new org.apache.tools.ant.BuildException( "you must specify type or classname" );
        }
        java.lang.Class f = null;
        try {
            if (loader == null) {
                f = Class.forName( classname );
            } else {
                f = Class.forName( classname, true, loader );
            }
        } catch ( java.lang.ClassNotFoundException e ) {
            throw new org.apache.tools.ant.BuildException( "Using loader " + loader + " on class " + classname + ": " + e, e );
        } catch ( java.lang.NoClassDefFoundError e ) {
            throw new org.apache.tools.ant.BuildException( "Using loader " + loader + " on class " + classname + ": " + e, e );
        }
        java.lang.Object o = null;
        try {
            o = f.newInstance();
        } catch ( java.lang.InstantiationException e ) {
            throw new org.apache.tools.ant.BuildException( e );
        } catch ( java.lang.IllegalAccessException e ) {
            throw new org.apache.tools.ant.BuildException( e );
        }
        if (!(o instanceof org.apache.tools.ant.taskdefs.optional.junit.JUnitTaskMirror.JUnitResultFormatterMirror)) {
            throw new org.apache.tools.ant.BuildException( classname + " is not a JUnitResultFormatter" );
        }
        org.apache.tools.ant.taskdefs.optional.junit.JUnitTaskMirror.JUnitResultFormatterMirror r = (org.apache.tools.ant.taskdefs.optional.junit.JUnitTaskMirror.JUnitResultFormatterMirror) o;
        if (useFile && outFile != null) {
            try {
                out = new java.io.BufferedOutputStream( new java.io.FileOutputStream( outFile ) );
            } catch ( java.io.IOException e ) {
                throw new org.apache.tools.ant.BuildException( "Unable to open file " + outFile, e );
            }
        }
        r.setOutput( out );
        boolean needToSetProjectReference = true;
        try {
            java.lang.reflect.Field field = r.getClass().getField( "project" );
            java.lang.Object value = field.get( r );
            if (value instanceof org.apache.tools.ant.Project) {
                needToSetProjectReference = false;
            }
        } catch ( java.lang.NoSuchFieldException e ) {
        } catch ( java.lang.IllegalAccessException e ) {
            throw new org.apache.tools.ant.BuildException( e );
        }
        if (needToSetProjectReference) {
            java.lang.reflect.Method setter;
            try {
                setter = r.getClass().getMethod( "setProject", new java.lang.Class[]{ org.apache.tools.ant.Project.class } );
                setter.invoke( r, new java.lang.Object[]{ project } );
            } catch ( java.lang.NoSuchMethodException e ) {
            } catch ( java.lang.IllegalAccessException e ) {
                throw new org.apache.tools.ant.BuildException( e );
            } catch ( java.lang.reflect.InvocationTargetException e ) {
                throw new org.apache.tools.ant.BuildException( e );
            }
        }
        return r;
    }

    public static class TypeAttribute extends org.apache.tools.ant.types.EnumeratedAttribute
    {

        public  java.lang.String[] getValues()
        {
            return new java.lang.String[]{ "plain", "xml", "brief", "failure" };
        }

    }

}
