// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.junit;


import java.util.Iterator;
import java.util.List;
import junit.framework.JUnit4TestAdapterCache;
import junit.framework.Test;
import junit.framework.TestResult;
import org.junit.runner.Description;
import org.junit.runner.Request;
import org.junit.runner.Runner;
import org.junit.runner.manipulation.Filter;
import org.junit.runner.notification.Failure;
import org.junit.runner.notification.RunListener;
import org.junit.runner.notification.RunNotifier;


public class JUnit4TestMethodAdapter implements junit.framework.Test
{

    private final java.lang.Class testClass;

    private final java.lang.String[] methodNames;

    private final org.junit.runner.Runner runner;

    private final org.apache.tools.ant.taskdefs.optional.junit.JUnit4TestMethodAdapter.Cache cache;

    public JUnit4TestMethodAdapter( final java.lang.Class testClass, final java.lang.String[] methodNames )
    {
        if (testClass == null) {
            throw new java.lang.IllegalArgumentException( "testClass is <null>" );
        }
        if (methodNames == null) {
            throw new java.lang.IllegalArgumentException( "methodNames is <null>" );
        }
        for (int i = 0; i < methodNames.length; i++) {
            if (methodNames[i] == null) {
                throw new java.lang.IllegalArgumentException( "method name #" + i + " is <null>" );
            }
            if (methodNames[i].length() == 0) {
                throw new java.lang.IllegalArgumentException( "method name #" + i + " is empty" );
            }
        }
        this.testClass = testClass;
        this.methodNames = (java.lang.String[]) methodNames.clone();
        this.cache = Cache.instance;
        org.junit.runner.Request request;
        if (methodNames.length == 1) {
            request = Request.method( testClass, methodNames[0] );
        } else {
            request = Request.aClass( testClass ).filterWith( new org.apache.tools.ant.taskdefs.optional.junit.JUnit4TestMethodAdapter.MultipleMethodsFilter( testClass, methodNames ) );
        }
        runner = request.getRunner();
    }

    public  int countTestCases()
    {
        return runner.testCount();
    }

    public  org.junit.runner.Description getDescription()
    {
        return runner.getDescription();
    }

    public  java.util.List getTests()
    {
        return cache.asTestList( getDescription() );
    }

    public  java.lang.Class getTestClass()
    {
        return testClass;
    }

    public  void run( final junit.framework.TestResult result )
    {
        runner.run( cache.getNotifier( result ) );
    }

    public  java.lang.String toString()
    {
        java.lang.String testClassName = testClass.getName();
        java.lang.StringBuilder buf = (new java.lang.StringBuilder( testClassName.length() + 12 * methodNames.length )).append( ':' );
        if (methodNames.length != 0) {
            buf.append( methodNames[0] );
            for (int i = 1; i < methodNames.length; i++) {
                buf.append( ',' ).append( methodNames[i] );
            }
        }
        return buf.toString();
    }

    private static final class MultipleMethodsFilter extends org.junit.runner.manipulation.Filter
    {

        private final org.junit.runner.Description methodsListDescription;

        private final java.lang.Class testClass;

        private final java.lang.String[] methodNames;

        private MultipleMethodsFilter( java.lang.Class testClass, java.lang.String[] methodNames )
        {
            if (testClass == null) {
                throw new java.lang.IllegalArgumentException( "testClass is <null>" );
            }
            if (methodNames == null) {
                throw new java.lang.IllegalArgumentException( "methodNames is <null>" );
            }
            methodsListDescription = Description.createSuiteDescription( testClass );
            for (int i = 0; i < methodNames.length; i++) {
                methodsListDescription.addChild( Description.createTestDescription( testClass, methodNames[i] ) );
            }
            this.testClass = testClass;
            this.methodNames = methodNames;
        }

        public  boolean shouldRun( org.junit.runner.Description description )
        {
            if (methodNames.length == 0) {
                return false;
            }
            if (description.isTest()) {
                java.util.Iterator it = methodsListDescription.getChildren().iterator();
                while (it.hasNext()) {
                    org.junit.runner.Description methodDescription = (org.junit.runner.Description) it.next();
                    if (methodDescription.equals( description )) {
                        return true;
                    }
                }
            } else {
                java.util.Iterator it = description.getChildren().iterator();
                while (it.hasNext()) {
                    org.junit.runner.Description each = (org.junit.runner.Description) it.next();
                    if (shouldRun( each )) {
                        return true;
                    }
                }
            }
            return false;
        }

        public  java.lang.String describe()
        {
            java.lang.StringBuilder buf = new java.lang.StringBuilder( 40 );
            if (methodNames.length == 0) {
                buf.append( "No methods" );
            } else {
                buf.append( methodNames.length == 1 ? "Method" : "Methods" );
                buf.append( ' ' );
                buf.append( methodNames[0] );
                for (int i = 1; i < methodNames.length; i++) {
                    buf.append( ',' ).append( methodNames[i] );
                }
            }
            buf.append( '(' ).append( testClass.getName() ).append( ')' );
            return buf.toString();
        }

    }

    private static final class Cache extends junit.framework.JUnit4TestAdapterCache
    {

        private static final long serialVersionUID = 8454901854293461610L;

        private static final org.apache.tools.ant.taskdefs.optional.junit.JUnit4TestMethodAdapter.Cache instance = new org.apache.tools.ant.taskdefs.optional.junit.JUnit4TestMethodAdapter.Cache();

        public static  junit.framework.JUnit4TestAdapterCache getDefault()
        {
            return instance;
        }

        public  org.junit.runner.notification.RunNotifier getNotifier( final junit.framework.TestResult result )
        {
            org.junit.runner.notification.RunNotifier notifier = new org.junit.runner.notification.RunNotifier();
            notifier.addListener( new org.junit.runner.notification.RunListener(){
                public  void testFailure( org.junit.runner.notification.Failure failure )
                                throws java.lang.Exception
                {
                    result.addError( asTest( failure.getDescription() ), failure.getException() );
                }

                public  void testFinished( org.junit.runner.Description description )
                                throws java.lang.Exception
                {
                    result.endTest( asTest( description ) );
                }

                public  void testStarted( org.junit.runner.Description description )
                                throws java.lang.Exception
                {
                    result.startTest( asTest( description ) );
                }
            } );
            return notifier;
        }

    }

}
