// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.junit;


import java.io.BufferedWriter;
import java.io.IOException;
import java.io.OutputStream;
import java.io.StringWriter;
import java.text.NumberFormat;
import java.util.Hashtable;
import junit.framework.AssertionFailedError;
import junit.framework.Test;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.util.FileUtils;
import org.apache.tools.ant.util.StringUtils;


public class PlainJUnitResultFormatter implements org.apache.tools.ant.taskdefs.optional.junit.JUnitResultFormatter
{

    private static final double ONE_SECOND = 1000.0;

    private java.text.NumberFormat nf = NumberFormat.getInstance();

    private java.util.Hashtable testStarts = new java.util.Hashtable();

    private java.io.OutputStream out;

    private java.io.StringWriter inner;

    private java.io.BufferedWriter wri;

    private java.util.Hashtable failed = new java.util.Hashtable();

    private java.lang.String systemOutput = null;

    private java.lang.String systemError = null;

    public PlainJUnitResultFormatter()
    {
        inner = new java.io.StringWriter();
        wri = new java.io.BufferedWriter( inner );
    }

    public  void setOutput( java.io.OutputStream out )
    {
        this.out = out;
    }

    public  void setSystemOutput( java.lang.String out )
    {
        systemOutput = out;
    }

    public  void setSystemError( java.lang.String err )
    {
        systemError = err;
    }

    public  void startTestSuite( org.apache.tools.ant.taskdefs.optional.junit.JUnitTest suite )
        throws org.apache.tools.ant.BuildException
    {
        if (out == null) {
            return;
        }
        java.lang.StringBuffer sb = new java.lang.StringBuffer( "Testsuite: " );
        sb.append( suite.getName() );
        sb.append( StringUtils.LINE_SEP );
        try {
            out.write( sb.toString().getBytes() );
            out.flush();
        } catch ( java.io.IOException ex ) {
            throw new org.apache.tools.ant.BuildException( "Unable to write output", ex );
        }
    }

    public  void endTestSuite( org.apache.tools.ant.taskdefs.optional.junit.JUnitTest suite )
        throws org.apache.tools.ant.BuildException
    {
        java.lang.StringBuffer sb = new java.lang.StringBuffer( "Tests run: " );
        sb.append( suite.runCount() );
        sb.append( ", Failures: " );
        sb.append( suite.failureCount() );
        sb.append( ", Errors: " );
        sb.append( suite.errorCount() );
        sb.append( ", Time elapsed: " );
        sb.append( nf.format( suite.getRunTime() / ONE_SECOND ) );
        sb.append( " sec" );
        sb.append( StringUtils.LINE_SEP );
        if (systemOutput != null && systemOutput.length() > 0) {
            sb.append( "------------- Standard Output ---------------" ).append( StringUtils.LINE_SEP ).append( systemOutput ).append( "------------- ---------------- ---------------" ).append( StringUtils.LINE_SEP );
        }
        if (systemError != null && systemError.length() > 0) {
            sb.append( "------------- Standard Error -----------------" ).append( StringUtils.LINE_SEP ).append( systemError ).append( "------------- ---------------- ---------------" ).append( StringUtils.LINE_SEP );
        }
        sb.append( StringUtils.LINE_SEP );
        if (out != null) {
            try {
                out.write( sb.toString().getBytes() );
                wri.close();
                out.write( inner.toString().getBytes() );
                out.flush();
            } catch ( java.io.IOException ioex ) {
                throw new org.apache.tools.ant.BuildException( "Unable to write output", ioex );
            } finally 
{
                if (out != System.out && out != System.err) {
                    FileUtils.close( out );
                }
            }
        }
    }

    public  void startTest( junit.framework.Test t )
    {
        testStarts.put( t, new java.lang.Long( System.currentTimeMillis() ) );
        failed.put( t, Boolean.FALSE );
    }

    public  void endTest( junit.framework.Test test )
    {
        if (Boolean.TRUE.equals( failed.get( test ) )) {
            return;
        }
        synchronized (wri)
{
            try {
                wri.write( "Testcase: " + JUnitVersionHelper.getTestCaseName( test ) );
                java.lang.Long l = (java.lang.Long) testStarts.get( test );
                double seconds = 0;
                if (l != null) {
                    seconds = (System.currentTimeMillis() - l.longValue()) / ONE_SECOND;
                }
                wri.write( " took " + nf.format( seconds ) + " sec" );
                wri.newLine();
            } catch ( java.io.IOException ex ) {
                throw new org.apache.tools.ant.BuildException( ex );
            }
        }
    }

    public  void addFailure( junit.framework.Test test, java.lang.Throwable t )
    {
        formatError( "\tFAILED", test, t );
    }

    public  void addFailure( junit.framework.Test test, junit.framework.AssertionFailedError t )
    {
        addFailure( test, (java.lang.Throwable) t );
    }

    public  void addError( junit.framework.Test test, java.lang.Throwable t )
    {
        formatError( "\tCaused an ERROR", test, t );
    }

    private  void formatError( java.lang.String type, junit.framework.Test test, java.lang.Throwable t )
    {
        synchronized (wri)
{
            if (test != null) {
                endTest( test );
                failed.put( test, Boolean.TRUE );
            }
            try {
                wri.write( type );
                wri.newLine();
                wri.write( String.valueOf( t.getMessage() ) );
                wri.newLine();
                java.lang.String strace = JUnitTestRunner.getFilteredTrace( t );
                wri.write( strace );
                wri.newLine();
            } catch ( java.io.IOException ex ) {
                throw new org.apache.tools.ant.BuildException( ex );
            }
        }
    }

}
