// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.junit;


import java.io.BufferedWriter;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Properties;
import java.util.Date;
import java.net.InetAddress;
import java.net.UnknownHostException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import junit.framework.AssertionFailedError;
import junit.framework.Test;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.util.DOMElementWriter;
import org.apache.tools.ant.util.DateUtils;
import org.apache.tools.ant.util.FileUtils;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Text;


public class XMLJUnitResultFormatter implements org.apache.tools.ant.taskdefs.optional.junit.JUnitResultFormatter, org.apache.tools.ant.taskdefs.optional.junit.XMLConstants
{

    private static final double ONE_SECOND = 1000.0;

    private static final java.lang.String UNKNOWN = "unknown";

    private static  javax.xml.parsers.DocumentBuilder getDocumentBuilder()
    {
        try {
            return DocumentBuilderFactory.newInstance().newDocumentBuilder();
        } catch ( java.lang.Exception exc ) {
            throw new java.lang.ExceptionInInitializerError( exc );
        }
    }

    private org.w3c.dom.Document doc;

    private org.w3c.dom.Element rootElement;

    private java.util.Hashtable testElements = new java.util.Hashtable();

    private java.util.Hashtable failedTests = new java.util.Hashtable();

    private java.util.Hashtable testStarts = new java.util.Hashtable();

    private java.io.OutputStream out;

    public XMLJUnitResultFormatter()
    {
    }

    public  void setOutput( java.io.OutputStream out )
    {
        this.out = out;
    }

    public  void setSystemOutput( java.lang.String out )
    {
        formatOutput( SYSTEM_OUT, out );
    }

    public  void setSystemError( java.lang.String out )
    {
        formatOutput( SYSTEM_ERR, out );
    }

    public  void startTestSuite( org.apache.tools.ant.taskdefs.optional.junit.JUnitTest suite )
    {
        doc = getDocumentBuilder().newDocument();
        rootElement = doc.createElement( TESTSUITE );
        java.lang.String n = suite.getName();
        rootElement.setAttribute( ATTR_NAME, n == null ? UNKNOWN : n );
        final java.lang.String timestamp = DateUtils.format( new java.util.Date(), DateUtils.ISO8601_DATETIME_PATTERN );
        rootElement.setAttribute( TIMESTAMP, timestamp );
        rootElement.setAttribute( HOSTNAME, getHostname() );
        org.w3c.dom.Element propsElement = doc.createElement( PROPERTIES );
        rootElement.appendChild( propsElement );
        java.util.Properties props = suite.getProperties();
        if (props != null) {
            java.util.Enumeration e = props.propertyNames();
            while (e.hasMoreElements()) {
                java.lang.String name = (java.lang.String) e.nextElement();
                org.w3c.dom.Element propElement = doc.createElement( PROPERTY );
                propElement.setAttribute( ATTR_NAME, name );
                propElement.setAttribute( ATTR_VALUE, props.getProperty( name ) );
                propsElement.appendChild( propElement );
            }
        }
    }

    private  java.lang.String getHostname()
    {
        try {
            return InetAddress.getLocalHost().getHostName();
        } catch ( java.net.UnknownHostException e ) {
            return "localhost";
        }
    }

    public  void endTestSuite( org.apache.tools.ant.taskdefs.optional.junit.JUnitTest suite )
        throws org.apache.tools.ant.BuildException
    {
        rootElement.setAttribute( ATTR_TESTS, "" + suite.runCount() );
        rootElement.setAttribute( ATTR_FAILURES, "" + suite.failureCount() );
        rootElement.setAttribute( ATTR_ERRORS, "" + suite.errorCount() );
        rootElement.setAttribute( ATTR_TIME, "" + suite.getRunTime() / ONE_SECOND );
        if (out != null) {
            java.io.Writer wri = null;
            try {
                wri = new java.io.BufferedWriter( new java.io.OutputStreamWriter( out, "UTF8" ) );
                wri.write( "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n" );
                (new org.apache.tools.ant.util.DOMElementWriter()).write( rootElement, wri, 0, "  " );
            } catch ( java.io.IOException exc ) {
                throw new org.apache.tools.ant.BuildException( "Unable to write log file", exc );
            } finally 
{
                if (wri != null) {
                    try {
                        wri.flush();
                    } catch ( java.io.IOException ex ) {
                    }
                }
                if (out != System.out && out != System.err) {
                    FileUtils.close( wri );
                }
            }
        }
    }

    public  void startTest( junit.framework.Test t )
    {
        testStarts.put( t, new java.lang.Long( System.currentTimeMillis() ) );
    }

    public  void endTest( junit.framework.Test test )
    {
        if (!testStarts.containsKey( test )) {
            startTest( test );
        }
        org.w3c.dom.Element currentTest = null;
        if (!failedTests.containsKey( test )) {
            currentTest = doc.createElement( TESTCASE );
            java.lang.String n = JUnitVersionHelper.getTestCaseName( test );
            currentTest.setAttribute( ATTR_NAME, n == null ? UNKNOWN : n );
            currentTest.setAttribute( ATTR_CLASSNAME, JUnitVersionHelper.getTestCaseClassName( test ) );
            rootElement.appendChild( currentTest );
            testElements.put( test, currentTest );
        } else {
            currentTest = (org.w3c.dom.Element) testElements.get( test );
        }
        java.lang.Long l = (java.lang.Long) testStarts.get( test );
        currentTest.setAttribute( ATTR_TIME, "" + (System.currentTimeMillis() - l.longValue()) / ONE_SECOND );
    }

    public  void addFailure( junit.framework.Test test, java.lang.Throwable t )
    {
        formatError( FAILURE, test, t );
    }

    public  void addFailure( junit.framework.Test test, junit.framework.AssertionFailedError t )
    {
        addFailure( test, (java.lang.Throwable) t );
    }

    public  void addError( junit.framework.Test test, java.lang.Throwable t )
    {
        formatError( ERROR, test, t );
    }

    private  void formatError( java.lang.String type, junit.framework.Test test, java.lang.Throwable t )
    {
        if (test != null) {
            endTest( test );
            failedTests.put( test, test );
        }
        org.w3c.dom.Element nested = doc.createElement( type );
        org.w3c.dom.Element currentTest = null;
        if (test != null) {
            currentTest = (org.w3c.dom.Element) testElements.get( test );
        } else {
            currentTest = rootElement;
        }
        currentTest.appendChild( nested );
        java.lang.String message = t.getMessage();
        if (message != null && message.length() > 0) {
            nested.setAttribute( ATTR_MESSAGE, t.getMessage() );
        }
        nested.setAttribute( ATTR_TYPE, t.getClass().getName() );
        java.lang.String strace = JUnitTestRunner.getFilteredTrace( t );
        org.w3c.dom.Text trace = doc.createTextNode( strace );
        nested.appendChild( trace );
    }

    private  void formatOutput( java.lang.String type, java.lang.String output )
    {
        org.w3c.dom.Element nested = doc.createElement( type );
        rootElement.appendChild( nested );
        nested.appendChild( doc.createCDATASection( output ) );
    }

}
