// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.pvcs;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.MessageFormat;
import java.text.ParseException;
import java.util.Enumeration;
import java.util.Random;
import java.util.Vector;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.taskdefs.Execute;
import org.apache.tools.ant.taskdefs.ExecuteStreamHandler;
import org.apache.tools.ant.taskdefs.LogOutputStream;
import org.apache.tools.ant.taskdefs.LogStreamHandler;
import org.apache.tools.ant.taskdefs.PumpStreamHandler;
import org.apache.tools.ant.types.Commandline;
import org.apache.tools.ant.util.FileUtils;


public class Pvcs extends org.apache.tools.ant.Task
{

    private static final int POS_1 = 1;

    private static final int POS_2 = 2;

    private static final int POS_3 = 3;

    private java.lang.String pvcsbin;

    private java.lang.String repository;

    private java.lang.String pvcsProject;

    private java.util.Vector pvcsProjects;

    private java.lang.String workspace;

    private java.lang.String force;

    private java.lang.String promotiongroup;

    private java.lang.String label;

    private java.lang.String revision;

    private boolean ignorerc;

    private boolean updateOnly;

    private java.lang.String filenameFormat;

    private java.lang.String lineStart;

    private java.lang.String userId;

    private java.lang.String config;

    private static final java.lang.String PCLI_EXE = "pcli";

    private static final java.lang.String GET_EXE = "get";

    protected  int runCmd( org.apache.tools.ant.types.Commandline cmd, org.apache.tools.ant.taskdefs.ExecuteStreamHandler out )
    {
        try {
            org.apache.tools.ant.Project aProj = getProject();
            org.apache.tools.ant.taskdefs.Execute exe = new org.apache.tools.ant.taskdefs.Execute( out );
            exe.setAntRun( aProj );
            exe.setWorkingDirectory( aProj.getBaseDir() );
            exe.setCommandline( cmd.getCommandline() );
            return exe.execute();
        } catch ( java.io.IOException e ) {
            java.lang.String msg = "Failed executing: " + cmd.toString() + ". Exception: " + e.getMessage();
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        }
    }

    private  java.lang.String getExecutable( java.lang.String exe )
    {
        java.lang.StringBuffer correctedExe = new java.lang.StringBuffer();
        if (getPvcsbin() != null) {
            if (pvcsbin.endsWith( File.separator )) {
                correctedExe.append( pvcsbin );
            } else {
                correctedExe.append( pvcsbin ).append( File.separator );
            }
        }
        return correctedExe.append( exe ).toString();
    }

    public  void execute()
        throws org.apache.tools.ant.BuildException
    {
        int result = 0;
        if (repository == null || repository.trim().equals( "" )) {
            throw new org.apache.tools.ant.BuildException( "Required argument repository not specified" );
        }
        org.apache.tools.ant.types.Commandline commandLine = new org.apache.tools.ant.types.Commandline();
        commandLine.setExecutable( getExecutable( PCLI_EXE ) );
        commandLine.createArgument().setValue( "lvf" );
        commandLine.createArgument().setValue( "-z" );
        commandLine.createArgument().setValue( "-aw" );
        if (getWorkspace() != null) {
            commandLine.createArgument().setValue( "-sp" + getWorkspace() );
        }
        commandLine.createArgument().setValue( "-pr" + getRepository() );
        java.lang.String uid = getUserId();
        if (uid != null) {
            commandLine.createArgument().setValue( "-id" + uid );
        }
        if (getPvcsproject() == null && getPvcsprojects().isEmpty()) {
            pvcsProject = "/";
        }
        if (getPvcsproject() != null) {
            commandLine.createArgument().setValue( getPvcsproject() );
        }
        if (!getPvcsprojects().isEmpty()) {
            java.util.Enumeration e = getPvcsprojects().elements();
            while (e.hasMoreElements()) {
                java.lang.String projectName = ((org.apache.tools.ant.taskdefs.optional.pvcs.PvcsProject) e.nextElement()).getName();
                if (projectName == null || projectName.trim().equals( "" )) {
                    throw new org.apache.tools.ant.BuildException( "name is a required attribute " + "of pvcsproject" );
                }
                commandLine.createArgument().setValue( projectName );
            }
        }
        java.io.File tmp = null;
        java.io.File tmp2 = null;
        try {
            java.util.Random rand = new java.util.Random( System.currentTimeMillis() );
            tmp = new java.io.File( "pvcs_ant_" + rand.nextLong() + ".log" );
            java.io.FileOutputStream fos = new java.io.FileOutputStream( tmp );
            tmp2 = new java.io.File( "pvcs_ant_" + rand.nextLong() + ".log" );
            log( commandLine.describeCommand(), Project.MSG_VERBOSE );
            try {
                result = runCmd( commandLine, new org.apache.tools.ant.taskdefs.PumpStreamHandler( fos, new org.apache.tools.ant.taskdefs.LogOutputStream( this, Project.MSG_WARN ) ) );
            } finally 
{
                FileUtils.close( fos );
            }
            if (Execute.isFailure( result ) && !ignorerc) {
                java.lang.String msg = "Failed executing: " + commandLine.toString();
                throw new org.apache.tools.ant.BuildException( msg, getLocation() );
            }
            if (!tmp.exists()) {
                throw new org.apache.tools.ant.BuildException( "Communication between ant and pvcs " + "failed. No output generated from executing PVCS " + "commandline interface \"pcli\" and \"get\"" );
            }
            log( "Creating folders", Project.MSG_INFO );
            createFolders( tmp );
            massagePCLI( tmp, tmp2 );
            commandLine.clearArgs();
            commandLine.setExecutable( getExecutable( GET_EXE ) );
            if (getConfig() != null && getConfig().length() > 0) {
                commandLine.createArgument().setValue( "-c" + getConfig() );
            }
            if (getForce() != null && getForce().equals( "yes" )) {
                commandLine.createArgument().setValue( "-Y" );
            } else {
                commandLine.createArgument().setValue( "-N" );
            }
            if (getPromotiongroup() != null) {
                commandLine.createArgument().setValue( "-G" + getPromotiongroup() );
            } else {
                if (getLabel() != null) {
                    commandLine.createArgument().setValue( "-v" + getLabel() );
                } else {
                    if (getRevision() != null) {
                        commandLine.createArgument().setValue( "-r" + getRevision() );
                    }
                }
            }
            if (updateOnly) {
                commandLine.createArgument().setValue( "-U" );
            }
            commandLine.createArgument().setValue( "@" + tmp2.getAbsolutePath() );
            log( "Getting files", Project.MSG_INFO );
            log( "Executing " + commandLine.toString(), Project.MSG_VERBOSE );
            result = runCmd( commandLine, new org.apache.tools.ant.taskdefs.LogStreamHandler( this, Project.MSG_INFO, Project.MSG_WARN ) );
            if (result != 0 && !ignorerc) {
                java.lang.String msg = "Failed executing: " + commandLine.toString() + ". Return code was " + result;
                throw new org.apache.tools.ant.BuildException( msg, getLocation() );
            }
        } catch ( java.io.FileNotFoundException e ) {
            java.lang.String msg = "Failed executing: " + commandLine.toString() + ". Exception: " + e.getMessage();
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        } catch ( java.io.IOException e ) {
            java.lang.String msg = "Failed executing: " + commandLine.toString() + ". Exception: " + e.getMessage();
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        } catch ( java.text.ParseException e ) {
            java.lang.String msg = "Failed executing: " + commandLine.toString() + ". Exception: " + e.getMessage();
            throw new org.apache.tools.ant.BuildException( msg, getLocation() );
        } finally 
{
            if (tmp != null) {
                tmp.delete();
            }
            if (tmp2 != null) {
                tmp2.delete();
            }
        }
    }

    private  void createFolders( java.io.File file )
        throws java.io.IOException, java.text.ParseException
    {
        java.io.BufferedReader in = null;
        try {
            in = new java.io.BufferedReader( new java.io.FileReader( file ) );
            java.text.MessageFormat mf = new java.text.MessageFormat( getFilenameFormat() );
            java.lang.String line = in.readLine();
            while (line != null) {
                log( "Considering \"" + line + "\"", Project.MSG_VERBOSE );
                if (line.startsWith( "\"\\" ) || line.startsWith( "\"/" ) || line.length() > POS_3 && line.startsWith( "\"" ) && Character.isLetter( line.charAt( POS_1 ) ) && String.valueOf( line.charAt( POS_2 ) ).equals( ":" ) && String.valueOf( line.charAt( POS_3 ) ).equals( "\\" )) {
                    java.lang.Object[] objs = mf.parse( line );
                    java.lang.String f = (java.lang.String) objs[1];
                    int index = f.lastIndexOf( File.separator );
                    if (index > -1) {
                        java.io.File dir = new java.io.File( f.substring( 0, index ) );
                        if (!dir.exists()) {
                            log( "Creating " + dir.getAbsolutePath(), Project.MSG_VERBOSE );
                            if (dir.mkdirs()) {
                                log( "Created " + dir.getAbsolutePath(), Project.MSG_INFO );
                            } else {
                                log( "Failed to create " + dir.getAbsolutePath(), Project.MSG_INFO );
                            }
                        } else {
                            log( dir.getAbsolutePath() + " exists. Skipping", Project.MSG_VERBOSE );
                        }
                    } else {
                        log( "File separator problem with " + line, Project.MSG_WARN );
                    }
                } else {
                    log( "Skipped \"" + line + "\"", Project.MSG_VERBOSE );
                }
                line = in.readLine();
            }
        } finally 
{
            FileUtils.close( in );
        }
    }

    private  void massagePCLI( java.io.File in, java.io.File out )
        throws java.io.IOException
    {
        java.io.BufferedReader inReader = null;
        java.io.BufferedWriter outWriter = null;
        try {
            inReader = new java.io.BufferedReader( new java.io.FileReader( in ) );
            outWriter = new java.io.BufferedWriter( new java.io.FileWriter( out ) );
            java.lang.String s = null;
            while ((s = inReader.readLine()) != null) {
                java.lang.String sNormal = s.replace( '\\', '/' );
                outWriter.write( sNormal );
                outWriter.newLine();
            }
        } finally 
{
            FileUtils.close( inReader );
            FileUtils.close( outWriter );
        }
    }

    public  java.lang.String getRepository()
    {
        return repository;
    }

    public  java.lang.String getFilenameFormat()
    {
        return filenameFormat;
    }

    public  void setFilenameFormat( java.lang.String f )
    {
        filenameFormat = f;
    }

    public  java.lang.String getLineStart()
    {
        return lineStart;
    }

    public  void setLineStart( java.lang.String l )
    {
        lineStart = l;
    }

    public  void setRepository( java.lang.String repo )
    {
        repository = repo;
    }

    public  java.lang.String getPvcsproject()
    {
        return pvcsProject;
    }

    public  void setPvcsproject( java.lang.String prj )
    {
        pvcsProject = prj;
    }

    public  java.util.Vector getPvcsprojects()
    {
        return pvcsProjects;
    }

    public  java.lang.String getWorkspace()
    {
        return workspace;
    }

    public  void setWorkspace( java.lang.String ws )
    {
        workspace = ws;
    }

    public  java.lang.String getPvcsbin()
    {
        return pvcsbin;
    }

    public  void setPvcsbin( java.lang.String bin )
    {
        pvcsbin = bin;
    }

    public  java.lang.String getForce()
    {
        return force;
    }

    public  void setForce( java.lang.String f )
    {
        if (f != null && f.equalsIgnoreCase( "yes" )) {
            force = "yes";
        } else {
            force = "no";
        }
    }

    public  java.lang.String getPromotiongroup()
    {
        return promotiongroup;
    }

    public  void setPromotiongroup( java.lang.String w )
    {
        promotiongroup = w;
    }

    public  java.lang.String getLabel()
    {
        return label;
    }

    public  void setLabel( java.lang.String l )
    {
        label = l;
    }

    public  java.lang.String getRevision()
    {
        return revision;
    }

    public  void setRevision( java.lang.String r )
    {
        revision = r;
    }

    public  boolean getIgnoreReturnCode()
    {
        return ignorerc;
    }

    public  void setIgnoreReturnCode( boolean b )
    {
        ignorerc = b;
    }

    public  void addPvcsproject( org.apache.tools.ant.taskdefs.optional.pvcs.PvcsProject p )
    {
        pvcsProjects.addElement( p );
    }

    public  boolean getUpdateOnly()
    {
        return updateOnly;
    }

    public  void setUpdateOnly( boolean l )
    {
        updateOnly = l;
    }

    public  java.lang.String getConfig()
    {
        return config;
    }

    public  void setConfig( java.io.File f )
    {
        config = f.toString();
    }

    public  java.lang.String getUserId()
    {
        return userId;
    }

    public  void setUserId( java.lang.String u )
    {
        userId = u;
    }

    public Pvcs()
    {
        super();
        pvcsProject = null;
        pvcsProjects = new java.util.Vector();
        workspace = null;
        repository = null;
        pvcsbin = null;
        force = null;
        promotiongroup = null;
        label = null;
        ignorerc = false;
        updateOnly = false;
        lineStart = "\"P:";
        filenameFormat = "{0}-arc({1})";
    }

}
