// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.taskdefs.optional.sound;


import java.io.File;
import java.io.IOException;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.Line;
import javax.sound.sampled.LineEvent;
import javax.sound.sampled.LineListener;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.UnsupportedAudioFileException;
import org.apache.tools.ant.BuildEvent;
import org.apache.tools.ant.BuildListener;
import org.apache.tools.ant.Project;


public class AntSoundPlayer implements javax.sound.sampled.LineListener, org.apache.tools.ant.BuildListener
{

    private java.io.File fileSuccess = null;

    private int loopsSuccess = 0;

    private java.lang.Long durationSuccess = null;

    private java.io.File fileFail = null;

    private int loopsFail = 0;

    private java.lang.Long durationFail = null;

    public AntSoundPlayer()
    {
    }

    public  void addBuildSuccessfulSound( java.io.File file, int loops, java.lang.Long duration )
    {
        this.fileSuccess = file;
        this.loopsSuccess = loops;
        this.durationSuccess = duration;
    }

    public  void addBuildFailedSound( java.io.File fileFail, int loopsFail, java.lang.Long durationFail )
    {
        this.fileFail = fileFail;
        this.loopsFail = loopsFail;
        this.durationFail = durationFail;
    }

    private  void play( org.apache.tools.ant.Project project, java.io.File file, int loops, java.lang.Long duration )
    {
        javax.sound.sampled.Clip audioClip = null;
        javax.sound.sampled.AudioInputStream audioInputStream = null;
        try {
            audioInputStream = AudioSystem.getAudioInputStream( file );
        } catch ( javax.sound.sampled.UnsupportedAudioFileException uafe ) {
            project.log( "Audio format is not yet supported: " + uafe.getMessage() );
        } catch ( java.io.IOException ioe ) {
            ioe.printStackTrace();
        }
        if (audioInputStream != null) {
            javax.sound.sampled.AudioFormat format = audioInputStream.getFormat();
            javax.sound.sampled.DataLine.Info info = new javax.sound.sampled.DataLine.Info( javax.sound.sampled.Clip.class, format, AudioSystem.NOT_SPECIFIED );
            try {
                audioClip = (javax.sound.sampled.Clip) AudioSystem.getLine( info );
                audioClip.addLineListener( this );
                audioClip.open( audioInputStream );
            } catch ( javax.sound.sampled.LineUnavailableException e ) {
                project.log( "The sound device is currently unavailable" );
                return;
            } catch ( java.io.IOException e ) {
                e.printStackTrace();
            }
            if (duration != null) {
                playClip( audioClip, duration.longValue() );
            } else {
                playClip( audioClip, loops );
            }
            audioClip.drain();
            audioClip.close();
        } else {
            project.log( "Can't get data from file " + file.getName() );
        }
    }

    private  void playClip( javax.sound.sampled.Clip clip, int loops )
    {
        clip.loop( loops );
        do {
            try {
                long timeLeft = (clip.getMicrosecondLength() - clip.getMicrosecondPosition()) / 1000;
                if (timeLeft > 0) {
                    Thread.sleep( timeLeft );
                }
            } catch ( java.lang.InterruptedException e ) {
                break;
            }
        } while (clip.isRunning());
        if (clip.isRunning()) {
            clip.stop();
        }
    }

    private  void playClip( javax.sound.sampled.Clip clip, long duration )
    {
        clip.loop( Clip.LOOP_CONTINUOUSLY );
        try {
            Thread.sleep( duration );
        } catch ( java.lang.InterruptedException e ) {
        }
        clip.stop();
    }

    public  void update( javax.sound.sampled.LineEvent event )
    {
        if (event.getType().equals( LineEvent.Type.STOP )) {
            javax.sound.sampled.Line line = event.getLine();
            line.close();
        }
    }

    public  void buildStarted( org.apache.tools.ant.BuildEvent event )
    {
    }

    public  void buildFinished( org.apache.tools.ant.BuildEvent event )
    {
        if (event.getException() == null && fileSuccess != null) {
            play( event.getProject(), fileSuccess, loopsSuccess, durationSuccess );
        } else {
            if (event.getException() != null && fileFail != null) {
                play( event.getProject(), fileFail, loopsFail, durationFail );
            }
        }
    }

    public  void targetStarted( org.apache.tools.ant.BuildEvent event )
    {
    }

    public  void targetFinished( org.apache.tools.ant.BuildEvent event )
    {
    }

    public  void taskStarted( org.apache.tools.ant.BuildEvent event )
    {
    }

    public  void taskFinished( org.apache.tools.ant.BuildEvent event )
    {
    }

    public  void messageLogged( org.apache.tools.ant.BuildEvent event )
    {
    }

}
