// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types;


import java.io.File;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.ArrayList;
import java.util.List;
import java.util.ListIterator;
import java.util.LinkedList;
import java.util.Iterator;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.ProjectComponent;
import org.apache.tools.ant.util.StringUtils;
import org.apache.tools.ant.taskdefs.condition.Os;


public class Commandline implements java.lang.Cloneable
{

    private static final boolean IS_WIN_9X = Os.isFamily( "win9x" );

    private java.util.Vector arguments = new java.util.Vector();

    private java.lang.String executable = null;

    protected static final java.lang.String DISCLAIMER = StringUtils.LINE_SEP + "The \' characters around the executable and arguments are" + StringUtils.LINE_SEP + "not part of the command." + StringUtils.LINE_SEP;

    public Commandline( java.lang.String toProcess )
    {
        super();
        java.lang.String[] tmp = translateCommandline( toProcess );
        if (tmp != null && tmp.length > 0) {
            setExecutable( tmp[0] );
            for (int i = 1; i < tmp.length; i++) {
                createArgument().setValue( tmp[i] );
            }
        }
    }

    public Commandline()
    {
        super();
    }

    public static class Argument extends org.apache.tools.ant.ProjectComponent
    {

        private java.lang.String[] parts;

        private java.lang.String prefix = "";

        private java.lang.String suffix = "";

        public  void setValue( java.lang.String value )
        {
            parts = new java.lang.String[]{ value };
        }

        public  void setLine( java.lang.String line )
        {
            if (line == null) {
                return;
            }
            parts = translateCommandline( line );
        }

        public  void setPath( org.apache.tools.ant.types.Path value )
        {
            parts = new java.lang.String[]{ value.toString() };
        }

        public  void setPathref( org.apache.tools.ant.types.Reference value )
        {
            org.apache.tools.ant.types.Path p = new org.apache.tools.ant.types.Path( getProject() );
            p.setRefid( value );
            parts = new java.lang.String[]{ p.toString() };
        }

        public  void setFile( java.io.File value )
        {
            parts = new java.lang.String[]{ value.getAbsolutePath() };
        }

        public  void setPrefix( java.lang.String prefix )
        {
            this.prefix = prefix != null ? prefix : "";
        }

        public  void setSuffix( java.lang.String suffix )
        {
            this.suffix = suffix != null ? suffix : "";
        }

        public  java.lang.String[] getParts()
        {
            if (parts == null || parts.length == 0 || prefix.length() == 0 && suffix.length() == 0) {
                return parts;
            }
            java.lang.String[] fullParts = new java.lang.String[parts.length];
            for (int i = 0; i < fullParts.length; ++i) {
                fullParts[i] = prefix + parts[i] + suffix;
            }
            return fullParts;
        }

    }

    public class Marker
    {

        private int position;

        private int realPos = -1;

        private java.lang.String prefix = "";

        private java.lang.String suffix = "";

        Marker( int position )
        {
            this.position = position;
        }

        public  int getPosition()
        {
            if (realPos == -1) {
                realPos = executable == null ? 0 : 1;
                for (int i = 0; i < position; i++) {
                    org.apache.tools.ant.types.Commandline.Argument arg = (org.apache.tools.ant.types.Commandline.Argument) arguments.elementAt( i );
                    realPos += arg.getParts().length;
                }
            }
            return realPos;
        }

        public  void setPrefix( java.lang.String prefix )
        {
            this.prefix = prefix != null ? prefix : "";
        }

        public  java.lang.String getPrefix()
        {
            return prefix;
        }

        public  void setSuffix( java.lang.String suffix )
        {
            this.suffix = suffix != null ? suffix : "";
        }

        public  java.lang.String getSuffix()
        {
            return suffix;
        }

    }

    public  org.apache.tools.ant.types.Commandline.Argument createArgument()
    {
        return this.createArgument( false );
    }

    public  org.apache.tools.ant.types.Commandline.Argument createArgument( boolean insertAtStart )
    {
        org.apache.tools.ant.types.Commandline.Argument argument = new org.apache.tools.ant.types.Commandline.Argument();
        if (insertAtStart) {
            arguments.insertElementAt( argument, 0 );
        } else {
            arguments.addElement( argument );
        }
        return argument;
    }

    public  void setExecutable( java.lang.String executable )
    {
        if (executable == null || executable.length() == 0) {
            return;
        }
        this.executable = executable.replace( '/', File.separatorChar ).replace( '\\', File.separatorChar );
    }

    public  java.lang.String getExecutable()
    {
        return executable;
    }

    public  void addArguments( java.lang.String[] line )
    {
        for (int i = 0; i < line.length; i++) {
            createArgument().setValue( line[i] );
        }
    }

    public  java.lang.String[] getCommandline()
    {
        java.util.List commands = new java.util.LinkedList();
        java.util.ListIterator list = commands.listIterator();
        addCommandToList( list );
        final java.lang.String[] result = new java.lang.String[commands.size()];
        return (java.lang.String[]) commands.toArray( result );
    }

    public  void addCommandToList( java.util.ListIterator list )
    {
        if (executable != null) {
            list.add( executable );
        }
        addArgumentsToList( list );
    }

    public  java.lang.String[] getArguments()
    {
        java.util.List result = new java.util.ArrayList( arguments.size() * 2 );
        addArgumentsToList( result.listIterator() );
        java.lang.String[] res = new java.lang.String[result.size()];
        return (java.lang.String[]) result.toArray( res );
    }

    public  void addArgumentsToList( java.util.ListIterator list )
    {
        final int size = arguments.size();
        for (int i = 0; i < size; i++) {
            org.apache.tools.ant.types.Commandline.Argument arg = (org.apache.tools.ant.types.Commandline.Argument) arguments.elementAt( i );
            java.lang.String[] s = arg.getParts();
            if (s != null) {
                for (int j = 0; j < s.length; j++) {
                    list.add( s[j] );
                }
            }
        }
    }

    public  java.lang.String toString()
    {
        return toString( getCommandline() );
    }

    public static  java.lang.String quoteArgument( java.lang.String argument )
    {
        if (argument.indexOf( "\"" ) > -1) {
            if (argument.indexOf( "\'" ) > -1) {
                throw new org.apache.tools.ant.BuildException( "Can\'t handle single and double" + " quotes in same argument" );
            } else {
                return '\'' + argument + '\'';
            }
        } else {
            if (argument.indexOf( "\'" ) > -1 || argument.indexOf( " " ) > -1 || IS_WIN_9X && argument.indexOf( ';' ) != -1) {
                return '\"' + argument + '\"';
            } else {
                return argument;
            }
        }
    }

    public static  java.lang.String toString( java.lang.String[] line )
    {
        if (line == null || line.length == 0) {
            return "";
        }
        final java.lang.StringBuffer result = new java.lang.StringBuffer();
        for (int i = 0; i < line.length; i++) {
            if (i > 0) {
                result.append( ' ' );
            }
            result.append( quoteArgument( line[i] ) );
        }
        return result.toString();
    }

    public static  java.lang.String[] translateCommandline( java.lang.String toProcess )
    {
        if (toProcess == null || toProcess.length() == 0) {
            return new java.lang.String[0];
        }
        final int normal = 0;
        final int inQuote = 1;
        final int inDoubleQuote = 2;
        int state = normal;
        java.util.StringTokenizer tok = new java.util.StringTokenizer( toProcess, "\"\' ", true );
        java.util.Vector v = new java.util.Vector();
        java.lang.StringBuffer current = new java.lang.StringBuffer();
        boolean lastTokenHasBeenQuoted = false;
        while (tok.hasMoreTokens()) {
            java.lang.String nextTok = tok.nextToken();
            switch (state) {
            case inQuote :
                if ("\'".equals( nextTok )) {
                    lastTokenHasBeenQuoted = true;
                    state = normal;
                } else {
                    current.append( nextTok );
                }
                break;

            case inDoubleQuote :
                if ("\"".equals( nextTok )) {
                    lastTokenHasBeenQuoted = true;
                    state = normal;
                } else {
                    current.append( nextTok );
                }
                break;

            default  :
                if ("\'".equals( nextTok )) {
                    state = inQuote;
                } else {
                    if ("\"".equals( nextTok )) {
                        state = inDoubleQuote;
                    } else {
                        if (" ".equals( nextTok )) {
                            if (lastTokenHasBeenQuoted || current.length() != 0) {
                                v.addElement( current.toString() );
                                current = new java.lang.StringBuffer();
                            }
                        } else {
                            current.append( nextTok );
                        }
                    }
                }
                lastTokenHasBeenQuoted = false;
                break;

            }
        }
        if (lastTokenHasBeenQuoted || current.length() != 0) {
            v.addElement( current.toString() );
        }
        if (state == inQuote || state == inDoubleQuote) {
            throw new org.apache.tools.ant.BuildException( "unbalanced quotes in " + toProcess );
        }
        java.lang.String[] args = new java.lang.String[v.size()];
        v.copyInto( args );
        return args;
    }

    public  int size()
    {
        return getCommandline().length;
    }

    public  java.lang.Object clone()
    {
        try {
            org.apache.tools.ant.types.Commandline c = (org.apache.tools.ant.types.Commandline) super.clone();
            c.arguments = (java.util.Vector) arguments.clone();
            return c;
        } catch ( java.lang.CloneNotSupportedException e ) {
            throw new org.apache.tools.ant.BuildException( e );
        }
    }

    public  void clear()
    {
        executable = null;
        arguments.removeAllElements();
    }

    public  void clearArgs()
    {
        arguments.removeAllElements();
    }

    public  org.apache.tools.ant.types.Commandline.Marker createMarker()
    {
        return new org.apache.tools.ant.types.Commandline.Marker( arguments.size() );
    }

    public  java.lang.String describeCommand()
    {
        return describeCommand( this );
    }

    public  java.lang.String describeArguments()
    {
        return describeArguments( this );
    }

    public static  java.lang.String describeCommand( org.apache.tools.ant.types.Commandline line )
    {
        return describeCommand( line.getCommandline() );
    }

    public static  java.lang.String describeArguments( org.apache.tools.ant.types.Commandline line )
    {
        return describeArguments( line.getArguments() );
    }

    public static  java.lang.String describeCommand( java.lang.String[] args )
    {
        if (args == null || args.length == 0) {
            return "";
        }
        java.lang.StringBuffer buf = new java.lang.StringBuffer( "Executing \'" );
        buf.append( args[0] );
        buf.append( "\'" );
        if (args.length > 1) {
            buf.append( " with " );
            buf.append( describeArguments( args, 1 ) );
        } else {
            buf.append( DISCLAIMER );
        }
        return buf.toString();
    }

    public static  java.lang.String describeArguments( java.lang.String[] args )
    {
        return describeArguments( args, 0 );
    }

    protected static  java.lang.String describeArguments( java.lang.String[] args, int offset )
    {
        if (args == null || args.length <= offset) {
            return "";
        }
        java.lang.StringBuffer buf = new java.lang.StringBuffer( "argument" );
        if (args.length > offset) {
            buf.append( "s" );
        }
        buf.append( ":" ).append( StringUtils.LINE_SEP );
        for (int i = offset; i < args.length; i++) {
            buf.append( "\'" ).append( args[i] ).append( "\'" ).append( StringUtils.LINE_SEP );
        }
        buf.append( DISCLAIMER );
        return buf.toString();
    }

    public  java.util.Iterator iterator()
    {
        return arguments.iterator();
    }

}
