// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types;


import java.io.File;
import java.lang.reflect.Method;
import java.util.Collections;
import java.util.Iterator;
import java.util.Locale;
import java.util.Stack;
import java.util.Vector;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.MagicNames;
import org.apache.tools.ant.PathTokenizer;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.types.resources.Union;
import org.apache.tools.ant.types.resources.FileResourceIterator;
import org.apache.tools.ant.util.FileUtils;
import org.apache.tools.ant.util.JavaEnvUtils;


public class Path extends org.apache.tools.ant.types.DataType implements java.lang.Cloneable, org.apache.tools.ant.types.ResourceCollection
{

    public static org.apache.tools.ant.types.Path systemClasspath = new org.apache.tools.ant.types.Path( null, System.getProperty( "java.class.path" ) );

    public static org.apache.tools.ant.types.Path systemBootClasspath = new org.apache.tools.ant.types.Path( null, System.getProperty( "sun.boot.class.path" ) );

    private static final java.util.Iterator EMPTY_ITERATOR = Collections.EMPTY_SET.iterator();

    public class PathElement implements org.apache.tools.ant.types.ResourceCollection
    {

        private java.lang.String[] parts;

        public  void setLocation( java.io.File loc )
        {
            parts = new java.lang.String[]{ translateFile( loc.getAbsolutePath() ) };
        }

        public  void setPath( java.lang.String path )
        {
            parts = Path.translatePath( getProject(), path );
        }

        public  java.lang.String[] getParts()
        {
            return parts;
        }

        public  java.util.Iterator iterator()
        {
            return new org.apache.tools.ant.types.resources.FileResourceIterator( getProject(), null, parts );
        }

        public  boolean isFilesystemOnly()
        {
            return true;
        }

        public  int size()
        {
            return parts == null ? 0 : parts.length;
        }

    }

    private java.lang.Boolean preserveBC;

    private org.apache.tools.ant.types.resources.Union union = null;

    private boolean cache = false;

    public Path( org.apache.tools.ant.Project p, java.lang.String path )
    {
        this( p );
        createPathElement().setPath( path );
    }

    public Path( org.apache.tools.ant.Project project )
    {
        setProject( project );
    }

    public  void setLocation( java.io.File location )
        throws org.apache.tools.ant.BuildException
    {
        checkAttributesAllowed();
        createPathElement().setLocation( location );
    }

    public  void setPath( java.lang.String path )
        throws org.apache.tools.ant.BuildException
    {
        checkAttributesAllowed();
        createPathElement().setPath( path );
    }

    public  void setRefid( org.apache.tools.ant.types.Reference r )
        throws org.apache.tools.ant.BuildException
    {
        if (union != null) {
            throw tooManyAttributes();
        }
        super.setRefid( r );
    }

    public  org.apache.tools.ant.types.Path.PathElement createPathElement()
        throws org.apache.tools.ant.BuildException
    {
        if (isReference()) {
            throw noChildrenAllowed();
        }
        org.apache.tools.ant.types.Path.PathElement pe = new org.apache.tools.ant.types.Path.PathElement();
        add( pe );
        return pe;
    }

    public  void addFileset( org.apache.tools.ant.types.FileSet fs )
        throws org.apache.tools.ant.BuildException
    {
        if (fs.getProject() == null) {
            fs.setProject( getProject() );
        }
        add( fs );
    }

    public  void addFilelist( org.apache.tools.ant.types.FileList fl )
        throws org.apache.tools.ant.BuildException
    {
        if (fl.getProject() == null) {
            fl.setProject( getProject() );
        }
        add( fl );
    }

    public  void addDirset( org.apache.tools.ant.types.DirSet dset )
        throws org.apache.tools.ant.BuildException
    {
        if (dset.getProject() == null) {
            dset.setProject( getProject() );
        }
        add( dset );
    }

    public  void add( org.apache.tools.ant.types.Path path )
        throws org.apache.tools.ant.BuildException
    {
        if (path == this) {
            throw circularReference();
        }
        if (path.getProject() == null) {
            path.setProject( getProject() );
        }
        add( (org.apache.tools.ant.types.ResourceCollection) path );
    }

    public  void add( org.apache.tools.ant.types.ResourceCollection c )
    {
        checkChildrenAllowed();
        if (c == null) {
            return;
        }
        if (union == null) {
            union = new org.apache.tools.ant.types.resources.Union();
            union.setProject( getProject() );
            union.setCache( cache );
        }
        union.add( c );
        setChecked( false );
    }

    public  org.apache.tools.ant.types.Path createPath()
        throws org.apache.tools.ant.BuildException
    {
        org.apache.tools.ant.types.Path p = new org.apache.tools.ant.types.Path( getProject() );
        add( p );
        return p;
    }

    public  void append( org.apache.tools.ant.types.Path other )
    {
        if (other == null) {
            return;
        }
        add( other );
    }

    public  void addExisting( org.apache.tools.ant.types.Path source )
    {
        addExisting( source, false );
    }

    public  void addExisting( org.apache.tools.ant.types.Path source, boolean tryUserDir )
    {
        java.lang.String[] list = source.list();
        java.io.File userDir = tryUserDir ? new java.io.File( System.getProperty( "user.dir" ) ) : null;
        for (int i = 0; i < list.length; i++) {
            java.io.File f = resolveFile( getProject(), list[i] );
            if (tryUserDir && !f.exists()) {
                f = new java.io.File( userDir, list[i] );
            }
            if (f.exists()) {
                setLocation( f );
            } else {
                if (f.getParentFile() != null && f.getParentFile().exists() && containsWildcards( f.getName() )) {
                    setLocation( f );
                    log( "adding " + f + " which contains wildcards and may not" + " do what you intend it to do depending on your OS or" + " version of Java", Project.MSG_VERBOSE );
                } else {
                    log( "dropping " + f + " from path as it doesn't exist", Project.MSG_VERBOSE );
                }
            }
        }
    }

    public  void setCache( boolean b )
    {
        checkAttributesAllowed();
        cache = b;
        if (union != null) {
            union.setCache( b );
        }
    }

    public  java.lang.String[] list()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Path) getCheckedRef()).list();
        }
        return assertFilesystemOnly( union ) == null ? new java.lang.String[0] : union.list();
    }

    public  java.lang.String toString()
    {
        return isReference() ? getCheckedRef().toString() : union == null ? "" : union.toString();
    }

    public static  java.lang.String[] translatePath( org.apache.tools.ant.Project project, java.lang.String source )
    {
        final java.util.Vector result = new java.util.Vector();
        if (source == null) {
            return new java.lang.String[0];
        }
        org.apache.tools.ant.PathTokenizer tok = new org.apache.tools.ant.PathTokenizer( source );
        java.lang.StringBuffer element = new java.lang.StringBuffer();
        while (tok.hasMoreTokens()) {
            java.lang.String pathElement = tok.nextToken();
            try {
                element.append( resolveFile( project, pathElement ).getPath() );
            } catch ( org.apache.tools.ant.BuildException e ) {
                project.log( "Dropping path element " + pathElement + " as it is not valid relative to the project", Project.MSG_VERBOSE );
            }
            for (int i = 0; i < element.length(); i++) {
                translateFileSep( element, i );
            }
            result.addElement( element.toString() );
            element = new java.lang.StringBuffer();
        }
        java.lang.String[] res = new java.lang.String[result.size()];
        result.copyInto( res );
        return res;
    }

    public static  java.lang.String translateFile( java.lang.String source )
    {
        if (source == null) {
            return "";
        }
        final java.lang.StringBuffer result = new java.lang.StringBuffer( source );
        for (int i = 0; i < result.length(); i++) {
            translateFileSep( result, i );
        }
        return result.toString();
    }

    protected static  boolean translateFileSep( java.lang.StringBuffer buffer, int pos )
    {
        if (buffer.charAt( pos ) == '/' || buffer.charAt( pos ) == '\\') {
            buffer.setCharAt( pos, File.separatorChar );
            return true;
        }
        return false;
    }

    public synchronized  int size()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Path) getCheckedRef()).size();
        }
        dieOnCircularReference();
        return union == null ? 0 : assertFilesystemOnly( union ).size();
    }

    public  java.lang.Object clone()
    {
        try {
            org.apache.tools.ant.types.Path result = (org.apache.tools.ant.types.Path) super.clone();
            result.union = union == null ? union : (org.apache.tools.ant.types.resources.Union) union.clone();
            return result;
        } catch ( java.lang.CloneNotSupportedException e ) {
            throw new org.apache.tools.ant.BuildException( e );
        }
    }

    protected synchronized  void dieOnCircularReference( java.util.Stack stk, org.apache.tools.ant.Project p )
        throws org.apache.tools.ant.BuildException
    {
        if (isChecked()) {
            return;
        }
        if (isReference()) {
            super.dieOnCircularReference( stk, p );
        } else {
            if (union != null) {
                pushAndInvokeCircularReferenceCheck( union, stk, p );
            }
            setChecked( true );
        }
    }

    private static  java.io.File resolveFile( org.apache.tools.ant.Project project, java.lang.String relativeName )
    {
        return FileUtils.getFileUtils().resolveFile( project == null ? null : project.getBaseDir(), relativeName );
    }

    public  org.apache.tools.ant.types.Path concatSystemClasspath()
    {
        return concatSystemClasspath( "last" );
    }

    public  org.apache.tools.ant.types.Path concatSystemClasspath( java.lang.String defValue )
    {
        return concatSpecialPath( defValue, Path.systemClasspath );
    }

    public  org.apache.tools.ant.types.Path concatSystemBootClasspath( java.lang.String defValue )
    {
        return concatSpecialPath( defValue, Path.systemBootClasspath );
    }

    private  org.apache.tools.ant.types.Path concatSpecialPath( java.lang.String defValue, org.apache.tools.ant.types.Path p )
    {
        org.apache.tools.ant.types.Path result = new org.apache.tools.ant.types.Path( getProject() );
        java.lang.String order = defValue;
        java.lang.String o = getProject() != null ? getProject().getProperty( MagicNames.BUILD_SYSCLASSPATH ) : System.getProperty( MagicNames.BUILD_SYSCLASSPATH );
        if (o != null) {
            order = o;
        }
        if (order.equals( "only" )) {
            result.addExisting( p, true );
        } else {
            if (order.equals( "first" )) {
                result.addExisting( p, true );
                result.addExisting( this );
            } else {
                if (order.equals( "ignore" )) {
                    result.addExisting( this );
                } else {
                    if (!order.equals( "last" )) {
                        log( "invalid value for " + MagicNames.BUILD_SYSCLASSPATH + ": " + order, Project.MSG_WARN );
                    }
                    result.addExisting( this );
                    result.addExisting( p, true );
                }
            }
        }
        return result;
    }

    public  void addJavaRuntime()
    {
        if (JavaEnvUtils.isKaffe()) {
            java.io.File kaffeShare = new java.io.File( System.getProperty( "java.home" ) + File.separator + "share" + File.separator + "kaffe" );
            if (kaffeShare.isDirectory()) {
                org.apache.tools.ant.types.FileSet kaffeJarFiles = new org.apache.tools.ant.types.FileSet();
                kaffeJarFiles.setDir( kaffeShare );
                kaffeJarFiles.setIncludes( "*.jar" );
                addFileset( kaffeJarFiles );
            }
        } else {
            if ("GNU libgcj".equals( System.getProperty( "java.vm.name" ) )) {
                addExisting( systemBootClasspath );
            }
        }
        if (System.getProperty( "java.vendor" ).toLowerCase( Locale.ENGLISH ).indexOf( "microsoft" ) >= 0) {
            org.apache.tools.ant.types.FileSet msZipFiles = new org.apache.tools.ant.types.FileSet();
            msZipFiles.setDir( new java.io.File( System.getProperty( "java.home" ) + File.separator + "Packages" ) );
            msZipFiles.setIncludes( "*.ZIP" );
            addFileset( msZipFiles );
        } else {
            addExisting( new org.apache.tools.ant.types.Path( null, System.getProperty( "java.home" ) + File.separator + "lib" + File.separator + "rt.jar" ) );
            addExisting( new org.apache.tools.ant.types.Path( null, System.getProperty( "java.home" ) + File.separator + "jre" + File.separator + "lib" + File.separator + "rt.jar" ) );
            java.lang.String[] secJars = { "jce", "jsse" };
            for (int i = 0; i < secJars.length; i++) {
                addExisting( new org.apache.tools.ant.types.Path( null, System.getProperty( "java.home" ) + File.separator + "lib" + File.separator + secJars[i] + ".jar" ) );
                addExisting( new org.apache.tools.ant.types.Path( null, System.getProperty( "java.home" ) + File.separator + ".." + File.separator + "Classes" + File.separator + secJars[i] + ".jar" ) );
            }
            java.lang.String[] ibmJars = { "core", "graphics", "security", "server", "xml" };
            for (int i = 0; i < ibmJars.length; i++) {
                addExisting( new org.apache.tools.ant.types.Path( null, System.getProperty( "java.home" ) + File.separator + "lib" + File.separator + ibmJars[i] + ".jar" ) );
            }
            addExisting( new org.apache.tools.ant.types.Path( null, System.getProperty( "java.home" ) + File.separator + ".." + File.separator + "Classes" + File.separator + "classes.jar" ) );
            addExisting( new org.apache.tools.ant.types.Path( null, System.getProperty( "java.home" ) + File.separator + ".." + File.separator + "Classes" + File.separator + "ui.jar" ) );
        }
    }

    public  void addExtdirs( org.apache.tools.ant.types.Path extdirs )
    {
        if (extdirs == null) {
            java.lang.String extProp = System.getProperty( "java.ext.dirs" );
            if (extProp != null) {
                extdirs = new org.apache.tools.ant.types.Path( getProject(), extProp );
            } else {
                return;
            }
        }
        java.lang.String[] dirs = extdirs.list();
        for (int i = 0; i < dirs.length; i++) {
            java.io.File dir = resolveFile( getProject(), dirs[i] );
            if (dir.exists() && dir.isDirectory()) {
                org.apache.tools.ant.types.FileSet fs = new org.apache.tools.ant.types.FileSet();
                fs.setDir( dir );
                fs.setIncludes( "*" );
                addFileset( fs );
            }
        }
    }

    public final synchronized  java.util.Iterator iterator()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Path) getCheckedRef()).iterator();
        }
        dieOnCircularReference();
        if (getPreserveBC()) {
            return new org.apache.tools.ant.types.resources.FileResourceIterator( getProject(), null, list() );
        }
        return union == null ? EMPTY_ITERATOR : assertFilesystemOnly( union ).iterator();
    }

    public synchronized  boolean isFilesystemOnly()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Path) getCheckedRef()).isFilesystemOnly();
        }
        dieOnCircularReference();
        assertFilesystemOnly( union );
        return true;
    }

    protected  org.apache.tools.ant.types.ResourceCollection assertFilesystemOnly( org.apache.tools.ant.types.ResourceCollection rc )
    {
        if (rc != null && !rc.isFilesystemOnly()) {
            throw new org.apache.tools.ant.BuildException( getDataTypeName() + " allows only filesystem resources." );
        }
        return rc;
    }

    protected  boolean delegateIteratorToList()
    {
        if (getClass().equals( org.apache.tools.ant.types.Path.class )) {
            return false;
        }
        try {
            java.lang.reflect.Method listMethod = getClass().getMethod( "list", (java.lang.Class[]) null );
            return !listMethod.getDeclaringClass().equals( org.apache.tools.ant.types.Path.class );
        } catch ( java.lang.Exception e ) {
            return false;
        }
    }

    private synchronized  boolean getPreserveBC()
    {
        if (preserveBC == null) {
            preserveBC = delegateIteratorToList() ? Boolean.TRUE : Boolean.FALSE;
        }
        return preserveBC.booleanValue();
    }

    private static  boolean containsWildcards( java.lang.String path )
    {
        return path != null && (path.indexOf( "*" ) > -1 || path.indexOf( "?" ) > -1);
    }

}
