// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types;


import java.lang.reflect.Method;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Enumeration;
import java.util.Stack;
import java.util.Vector;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.transform.Source;
import javax.xml.transform.TransformerException;
import javax.xml.transform.URIResolver;
import javax.xml.transform.sax.SAXSource;
import org.apache.tools.ant.AntClassLoader;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.util.FileUtils;
import org.apache.tools.ant.util.JAXPUtils;
import org.xml.sax.EntityResolver;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;


public class XMLCatalog extends org.apache.tools.ant.types.DataType implements java.lang.Cloneable, org.xml.sax.EntityResolver, javax.xml.transform.URIResolver
{

    private static final org.apache.tools.ant.util.FileUtils FILE_UTILS = FileUtils.getFileUtils();

    private java.util.Vector elements = new java.util.Vector();

    private org.apache.tools.ant.types.Path classpath;

    private org.apache.tools.ant.types.Path catalogPath;

    public static final java.lang.String APACHE_RESOLVER = "org.apache.tools.ant.types.resolver.ApacheCatalogResolver";

    public static final java.lang.String CATALOG_RESOLVER = "org.apache.xml.resolver.tools.CatalogResolver";

    public XMLCatalog()
    {
        setChecked( false );
    }

    private  java.util.Vector getElements()
    {
        return getRef().elements;
    }

    private  org.apache.tools.ant.types.Path getClasspath()
    {
        return getRef().classpath;
    }

    public  org.apache.tools.ant.types.Path createClasspath()
    {
        if (isReference()) {
            throw noChildrenAllowed();
        }
        if (this.classpath == null) {
            this.classpath = new org.apache.tools.ant.types.Path( getProject() );
        }
        setChecked( false );
        return this.classpath.createPath();
    }

    public  void setClasspath( org.apache.tools.ant.types.Path classpath )
    {
        if (isReference()) {
            throw tooManyAttributes();
        }
        if (this.classpath == null) {
            this.classpath = classpath;
        } else {
            this.classpath.append( classpath );
        }
        setChecked( false );
    }

    public  void setClasspathRef( org.apache.tools.ant.types.Reference r )
    {
        if (isReference()) {
            throw tooManyAttributes();
        }
        createClasspath().setRefid( r );
        setChecked( false );
    }

    public  org.apache.tools.ant.types.Path createCatalogPath()
    {
        if (isReference()) {
            throw noChildrenAllowed();
        }
        if (this.catalogPath == null) {
            this.catalogPath = new org.apache.tools.ant.types.Path( getProject() );
        }
        setChecked( false );
        return this.catalogPath.createPath();
    }

    public  void setCatalogPathRef( org.apache.tools.ant.types.Reference r )
    {
        if (isReference()) {
            throw tooManyAttributes();
        }
        createCatalogPath().setRefid( r );
        setChecked( false );
    }

    public  org.apache.tools.ant.types.Path getCatalogPath()
    {
        return getRef().catalogPath;
    }

    public  void addDTD( org.apache.tools.ant.types.ResourceLocation dtd )
        throws org.apache.tools.ant.BuildException
    {
        if (isReference()) {
            throw noChildrenAllowed();
        }
        getElements().addElement( dtd );
        setChecked( false );
    }

    public  void addEntity( org.apache.tools.ant.types.ResourceLocation entity )
        throws org.apache.tools.ant.BuildException
    {
        addDTD( entity );
    }

    public  void addConfiguredXMLCatalog( org.apache.tools.ant.types.XMLCatalog catalog )
    {
        if (isReference()) {
            throw noChildrenAllowed();
        }
        java.util.Vector newElements = catalog.getElements();
        java.util.Vector ourElements = getElements();
        java.util.Enumeration e = newElements.elements();
        while (e.hasMoreElements()) {
            ourElements.addElement( e.nextElement() );
        }
        org.apache.tools.ant.types.Path nestedClasspath = catalog.getClasspath();
        createClasspath().append( nestedClasspath );
        org.apache.tools.ant.types.Path nestedCatalogPath = catalog.getCatalogPath();
        createCatalogPath().append( nestedCatalogPath );
        setChecked( false );
    }

    public  void setRefid( org.apache.tools.ant.types.Reference r )
        throws org.apache.tools.ant.BuildException
    {
        if (!elements.isEmpty()) {
            throw tooManyAttributes();
        }
        super.setRefid( r );
    }

    public  org.xml.sax.InputSource resolveEntity( java.lang.String publicId, java.lang.String systemId )
        throws org.xml.sax.SAXException, java.io.IOException
    {
        if (isReference()) {
            return getRef().resolveEntity( publicId, systemId );
        }
        dieOnCircularReference();
        log( "resolveEntity: '" + publicId + "': '" + systemId + "'", Project.MSG_DEBUG );
        org.xml.sax.InputSource inputSource = getCatalogResolver().resolveEntity( publicId, systemId );
        if (inputSource == null) {
            log( "No matching catalog entry found, parser will use: '" + systemId + "'", Project.MSG_DEBUG );
        }
        return inputSource;
    }

    public  javax.xml.transform.Source resolve( java.lang.String href, java.lang.String base )
        throws javax.xml.transform.TransformerException
    {
        if (isReference()) {
            return getRef().resolve( href, base );
        }
        dieOnCircularReference();
        javax.xml.transform.sax.SAXSource source = null;
        java.lang.String uri = removeFragment( href );
        log( "resolve: '" + uri + "' with base: '" + base + "'", Project.MSG_DEBUG );
        source = (javax.xml.transform.sax.SAXSource) getCatalogResolver().resolve( uri, base );
        if (source == null) {
            log( "No matching catalog entry found, parser will use: '" + href + "'", Project.MSG_DEBUG );
            source = new javax.xml.transform.sax.SAXSource();
            java.net.URL baseURL = null;
            try {
                if (base == null) {
                    baseURL = FILE_UTILS.getFileURL( getProject().getBaseDir() );
                } else {
                    baseURL = new java.net.URL( base );
                }
                java.net.URL url = uri.length() == 0 ? baseURL : new java.net.URL( baseURL, uri );
                source.setInputSource( new org.xml.sax.InputSource( url.toString() ) );
            } catch ( java.net.MalformedURLException ex ) {
                source.setInputSource( new org.xml.sax.InputSource( uri ) );
            }
        }
        setEntityResolver( source );
        return source;
    }

    protected synchronized  void dieOnCircularReference( java.util.Stack stk, org.apache.tools.ant.Project p )
        throws org.apache.tools.ant.BuildException
    {
        if (isChecked()) {
            return;
        }
        if (isReference()) {
            super.dieOnCircularReference( stk, p );
        } else {
            if (classpath != null) {
                pushAndInvokeCircularReferenceCheck( classpath, stk, p );
            }
            if (catalogPath != null) {
                pushAndInvokeCircularReferenceCheck( catalogPath, stk, p );
            }
            setChecked( true );
        }
    }

    private  org.apache.tools.ant.types.XMLCatalog getRef()
    {
        if (!isReference()) {
            return this;
        }
        return (org.apache.tools.ant.types.XMLCatalog) getCheckedRef( org.apache.tools.ant.types.XMLCatalog.class, "xmlcatalog" );
    }

    private org.apache.tools.ant.types.XMLCatalog.CatalogResolver catalogResolver = null;

    private  org.apache.tools.ant.types.XMLCatalog.CatalogResolver getCatalogResolver()
    {
        if (catalogResolver == null) {
            org.apache.tools.ant.AntClassLoader loader = null;
            loader = getProject().createClassLoader( Path.systemClasspath );
            try {
                java.lang.Class clazz = Class.forName( APACHE_RESOLVER, true, loader );
                java.lang.ClassLoader apacheResolverLoader = clazz.getClassLoader();
                java.lang.Class baseResolverClass = Class.forName( CATALOG_RESOLVER, true, apacheResolverLoader );
                java.lang.ClassLoader baseResolverLoader = baseResolverClass.getClassLoader();
                clazz = Class.forName( APACHE_RESOLVER, true, baseResolverLoader );
                java.lang.Object obj = clazz.newInstance();
                catalogResolver = new org.apache.tools.ant.types.XMLCatalog.ExternalResolver( clazz, obj );
            } catch ( java.lang.Throwable ex ) {
                catalogResolver = new org.apache.tools.ant.types.XMLCatalog.InternalResolver();
                if (getCatalogPath() != null && getCatalogPath().list().length != 0) {
                    log( "Warning: XML resolver not found; external catalogs" + " will be ignored", Project.MSG_WARN );
                }
                log( "Failed to load Apache resolver: " + ex, Project.MSG_DEBUG );
            }
        }
        return catalogResolver;
    }

    private  void setEntityResolver( javax.xml.transform.sax.SAXSource source )
        throws javax.xml.transform.TransformerException
    {
        org.xml.sax.XMLReader reader = source.getXMLReader();
        if (reader == null) {
            javax.xml.parsers.SAXParserFactory spFactory = SAXParserFactory.newInstance();
            spFactory.setNamespaceAware( true );
            try {
                reader = spFactory.newSAXParser().getXMLReader();
            } catch ( javax.xml.parsers.ParserConfigurationException ex ) {
                throw new javax.xml.transform.TransformerException( ex );
            } catch ( org.xml.sax.SAXException ex ) {
                throw new javax.xml.transform.TransformerException( ex );
            }
        }
        reader.setEntityResolver( this );
        source.setXMLReader( reader );
    }

    private  org.apache.tools.ant.types.ResourceLocation findMatchingEntry( java.lang.String publicId )
    {
        java.util.Enumeration e = getElements().elements();
        org.apache.tools.ant.types.ResourceLocation element = null;
        while (e.hasMoreElements()) {
            java.lang.Object o = e.nextElement();
            if (o instanceof org.apache.tools.ant.types.ResourceLocation) {
                element = (org.apache.tools.ant.types.ResourceLocation) o;
                if (element.getPublicId().equals( publicId )) {
                    return element;
                }
            }
        }
        return null;
    }

    private  java.lang.String removeFragment( java.lang.String uri )
    {
        java.lang.String result = uri;
        int hashPos = uri.indexOf( "#" );
        if (hashPos >= 0) {
            result = uri.substring( 0, hashPos );
        }
        return result;
    }

    private  org.xml.sax.InputSource filesystemLookup( org.apache.tools.ant.types.ResourceLocation matchingEntry )
    {
        java.lang.String uri = matchingEntry.getLocation();
        uri = uri.replace( File.separatorChar, '/' );
        java.net.URL baseURL = null;
        if (matchingEntry.getBase() != null) {
            baseURL = matchingEntry.getBase();
        } else {
            try {
                baseURL = FILE_UTILS.getFileURL( getProject().getBaseDir() );
            } catch ( java.net.MalformedURLException ex ) {
                throw new org.apache.tools.ant.BuildException( "Project basedir cannot be converted to a URL" );
            }
        }
        org.xml.sax.InputSource source = null;
        java.net.URL url = null;
        try {
            url = new java.net.URL( baseURL, uri );
        } catch ( java.net.MalformedURLException ex ) {
            java.io.File testFile = new java.io.File( uri );
            if (testFile.exists() && testFile.canRead()) {
                log( "uri : '" + uri + "' matches a readable file", Project.MSG_DEBUG );
                try {
                    url = FILE_UTILS.getFileURL( testFile );
                } catch ( java.net.MalformedURLException ex1 ) {
                    throw new org.apache.tools.ant.BuildException( "could not find an URL for :" + testFile.getAbsolutePath() );
                }
            } else {
                log( "uri : '" + uri + "' does not match a readable file", Project.MSG_DEBUG );
            }
        }
        if (url != null && url.getProtocol().equals( "file" )) {
            java.lang.String fileName = FILE_UTILS.fromURI( url.toString() );
            if (fileName != null) {
                log( "fileName " + fileName, Project.MSG_DEBUG );
                java.io.File resFile = new java.io.File( fileName );
                if (resFile.exists() && resFile.canRead()) {
                    try {
                        source = new org.xml.sax.InputSource( new java.io.FileInputStream( resFile ) );
                        java.lang.String sysid = JAXPUtils.getSystemId( resFile );
                        source.setSystemId( sysid );
                        log( "catalog entry matched a readable file: '" + sysid + "'", Project.MSG_DEBUG );
                    } catch ( java.io.IOException ex ) {
                    }
                }
            }
        }
        return source;
    }

    private  org.xml.sax.InputSource classpathLookup( org.apache.tools.ant.types.ResourceLocation matchingEntry )
    {
        org.xml.sax.InputSource source = null;
        org.apache.tools.ant.AntClassLoader loader = null;
        org.apache.tools.ant.types.Path cp = classpath;
        if (cp != null) {
            cp = classpath.concatSystemClasspath( "ignore" );
        } else {
            cp = (new org.apache.tools.ant.types.Path( getProject() )).concatSystemClasspath( "last" );
        }
        loader = getProject().createClassLoader( cp );
        java.io.InputStream is = loader.getResourceAsStream( matchingEntry.getLocation() );
        if (is != null) {
            source = new org.xml.sax.InputSource( is );
            java.net.URL entryURL = loader.getResource( matchingEntry.getLocation() );
            java.lang.String sysid = entryURL.toExternalForm();
            source.setSystemId( sysid );
            log( "catalog entry matched a resource in the classpath: '" + sysid + "'", Project.MSG_DEBUG );
        }
        return source;
    }

    private  org.xml.sax.InputSource urlLookup( org.apache.tools.ant.types.ResourceLocation matchingEntry )
    {
        java.lang.String uri = matchingEntry.getLocation();
        java.net.URL baseURL = null;
        if (matchingEntry.getBase() != null) {
            baseURL = matchingEntry.getBase();
        } else {
            try {
                baseURL = FILE_UTILS.getFileURL( getProject().getBaseDir() );
            } catch ( java.net.MalformedURLException ex ) {
                throw new org.apache.tools.ant.BuildException( "Project basedir cannot be converted to a URL" );
            }
        }
        org.xml.sax.InputSource source = null;
        java.net.URL url = null;
        try {
            url = new java.net.URL( baseURL, uri );
        } catch ( java.net.MalformedURLException ex ) {
        }
        if (url != null) {
            try {
                java.io.InputStream is = url.openStream();
                if (is != null) {
                    source = new org.xml.sax.InputSource( is );
                    java.lang.String sysid = url.toExternalForm();
                    source.setSystemId( sysid );
                    log( "catalog entry matched as a URL: '" + sysid + "'", Project.MSG_DEBUG );
                }
            } catch ( java.io.IOException ex ) {
            }
        }
        return source;
    }

    private interface CatalogResolver extends javax.xml.transform.URIResolver, org.xml.sax.EntityResolver
    {

         org.xml.sax.InputSource resolveEntity( java.lang.String publicId, java.lang.String systemId );

         javax.xml.transform.Source resolve( java.lang.String href, java.lang.String base )
                throws javax.xml.transform.TransformerException;

    }

    private class InternalResolver implements org.apache.tools.ant.types.XMLCatalog.CatalogResolver
    {

        public InternalResolver()
        {
            log( "Apache resolver library not found, internal resolver will be used", Project.MSG_VERBOSE );
        }

        public  org.xml.sax.InputSource resolveEntity( java.lang.String publicId, java.lang.String systemId )
        {
            org.xml.sax.InputSource result = null;
            org.apache.tools.ant.types.ResourceLocation matchingEntry = findMatchingEntry( publicId );
            if (matchingEntry != null) {
                log( "Matching catalog entry found for publicId: '" + matchingEntry.getPublicId() + "' location: '" + matchingEntry.getLocation() + "'", Project.MSG_DEBUG );
                result = filesystemLookup( matchingEntry );
                if (result == null) {
                    result = classpathLookup( matchingEntry );
                }
                if (result == null) {
                    result = urlLookup( matchingEntry );
                }
            }
            return result;
        }

        public  javax.xml.transform.Source resolve( java.lang.String href, java.lang.String base )
                throws javax.xml.transform.TransformerException
        {
            javax.xml.transform.sax.SAXSource result = null;
            org.xml.sax.InputSource source = null;
            org.apache.tools.ant.types.ResourceLocation matchingEntry = findMatchingEntry( href );
            if (matchingEntry != null) {
                log( "Matching catalog entry found for uri: '" + matchingEntry.getPublicId() + "' location: '" + matchingEntry.getLocation() + "'", Project.MSG_DEBUG );
                org.apache.tools.ant.types.ResourceLocation entryCopy = matchingEntry;
                if (base != null) {
                    try {
                        java.net.URL baseURL = new java.net.URL( base );
                        entryCopy = new org.apache.tools.ant.types.ResourceLocation();
                        entryCopy.setBase( baseURL );
                    } catch ( java.net.MalformedURLException ex ) {
                    }
                }
                entryCopy.setPublicId( matchingEntry.getPublicId() );
                entryCopy.setLocation( matchingEntry.getLocation() );
                source = filesystemLookup( entryCopy );
                if (source == null) {
                    source = classpathLookup( entryCopy );
                }
                if (source == null) {
                    source = urlLookup( entryCopy );
                }
                if (source != null) {
                    result = new javax.xml.transform.sax.SAXSource( source );
                }
            }
            return result;
        }

    }

    private class ExternalResolver implements org.apache.tools.ant.types.XMLCatalog.CatalogResolver
    {

        private java.lang.reflect.Method setXMLCatalog = null;

        private java.lang.reflect.Method parseCatalog = null;

        private java.lang.reflect.Method resolveEntity = null;

        private java.lang.reflect.Method resolve = null;

        private java.lang.Object resolverImpl = null;

        private boolean externalCatalogsProcessed = false;

        public ExternalResolver( java.lang.Class resolverImplClass, java.lang.Object resolverImpl )
        {
            this.resolverImpl = resolverImpl;
            try {
                setXMLCatalog = resolverImplClass.getMethod( "setXMLCatalog", new java.lang.Class[]{ org.apache.tools.ant.types.XMLCatalog.class } );
                parseCatalog = resolverImplClass.getMethod( "parseCatalog", new java.lang.Class[]{ java.lang.String.class } );
                resolveEntity = resolverImplClass.getMethod( "resolveEntity", new java.lang.Class[]{ java.lang.String.class, java.lang.String.class } );
                resolve = resolverImplClass.getMethod( "resolve", new java.lang.Class[]{ java.lang.String.class, java.lang.String.class } );
            } catch ( java.lang.NoSuchMethodException ex ) {
                throw new org.apache.tools.ant.BuildException( ex );
            }
            log( "Apache resolver library found, xml-commons resolver will be used", Project.MSG_VERBOSE );
        }

        public  org.xml.sax.InputSource resolveEntity( java.lang.String publicId, java.lang.String systemId )
        {
            org.xml.sax.InputSource result = null;
            processExternalCatalogs();
            org.apache.tools.ant.types.ResourceLocation matchingEntry = findMatchingEntry( publicId );
            if (matchingEntry != null) {
                log( "Matching catalog entry found for publicId: '" + matchingEntry.getPublicId() + "' location: '" + matchingEntry.getLocation() + "'", Project.MSG_DEBUG );
                result = filesystemLookup( matchingEntry );
                if (result == null) {
                    result = classpathLookup( matchingEntry );
                }
                if (result == null) {
                    try {
                        result = (org.xml.sax.InputSource) resolveEntity.invoke( resolverImpl, new java.lang.Object[]{ publicId, systemId } );
                    } catch ( java.lang.Exception ex ) {
                        throw new org.apache.tools.ant.BuildException( ex );
                    }
                }
            } else {
                try {
                    result = (org.xml.sax.InputSource) resolveEntity.invoke( resolverImpl, new java.lang.Object[]{ publicId, systemId } );
                } catch ( java.lang.Exception ex ) {
                    throw new org.apache.tools.ant.BuildException( ex );
                }
            }
            return result;
        }

        public  javax.xml.transform.Source resolve( java.lang.String href, java.lang.String base )
                throws javax.xml.transform.TransformerException
        {
            javax.xml.transform.sax.SAXSource result = null;
            org.xml.sax.InputSource source = null;
            processExternalCatalogs();
            org.apache.tools.ant.types.ResourceLocation matchingEntry = findMatchingEntry( href );
            if (matchingEntry != null) {
                log( "Matching catalog entry found for uri: '" + matchingEntry.getPublicId() + "' location: '" + matchingEntry.getLocation() + "'", Project.MSG_DEBUG );
                org.apache.tools.ant.types.ResourceLocation entryCopy = matchingEntry;
                if (base != null) {
                    try {
                        java.net.URL baseURL = new java.net.URL( base );
                        entryCopy = new org.apache.tools.ant.types.ResourceLocation();
                        entryCopy.setBase( baseURL );
                    } catch ( java.net.MalformedURLException ex ) {
                    }
                }
                entryCopy.setPublicId( matchingEntry.getPublicId() );
                entryCopy.setLocation( matchingEntry.getLocation() );
                source = filesystemLookup( entryCopy );
                if (source == null) {
                    source = classpathLookup( entryCopy );
                }
                if (source != null) {
                    result = new javax.xml.transform.sax.SAXSource( source );
                } else {
                    try {
                        result = (javax.xml.transform.sax.SAXSource) resolve.invoke( resolverImpl, new java.lang.Object[]{ href, base } );
                    } catch ( java.lang.Exception ex ) {
                        throw new org.apache.tools.ant.BuildException( ex );
                    }
                }
            } else {
                try {
                    result = (javax.xml.transform.sax.SAXSource) resolve.invoke( resolverImpl, new java.lang.Object[]{ href, base } );
                } catch ( java.lang.Exception ex ) {
                    throw new org.apache.tools.ant.BuildException( ex );
                }
            }
            return result;
        }

        private  void processExternalCatalogs()
        {
            if (!externalCatalogsProcessed) {
                try {
                    setXMLCatalog.invoke( resolverImpl, new java.lang.Object[]{ XMLCatalog.this } );
                } catch ( java.lang.Exception ex ) {
                    throw new org.apache.tools.ant.BuildException( ex );
                }
                org.apache.tools.ant.types.Path catPath = getCatalogPath();
                if (catPath != null) {
                    log( "Using catalogpath '" + getCatalogPath() + "'", Project.MSG_DEBUG );
                    java.lang.String[] catPathList = getCatalogPath().list();
                    for (int i = 0; i < catPathList.length; i++) {
                        java.io.File catFile = new java.io.File( catPathList[i] );
                        log( "Parsing " + catFile, Project.MSG_DEBUG );
                        try {
                            parseCatalog.invoke( resolverImpl, new java.lang.Object[]{ catFile.getPath() } );
                        } catch ( java.lang.Exception ex ) {
                            throw new org.apache.tools.ant.BuildException( ex );
                        }
                    }
                }
            }
            externalCatalogsProcessed = true;
        }

    }

}
