// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.resources;


import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.util.FileUtils;
import org.apache.tools.ant.types.Resource;
import org.apache.tools.ant.types.Reference;
import org.apache.tools.ant.types.ResourceFactory;


public class FileResource extends org.apache.tools.ant.types.Resource implements org.apache.tools.ant.types.resources.Touchable, org.apache.tools.ant.types.resources.FileProvider, org.apache.tools.ant.types.ResourceFactory, org.apache.tools.ant.types.resources.Appendable
{

    private static final org.apache.tools.ant.util.FileUtils FILE_UTILS = FileUtils.getFileUtils();

    private static final int NULL_FILE = Resource.getMagicNumber( "null file".getBytes() );

    private java.io.File file;

    private java.io.File baseDir;

    public FileResource()
    {
    }

    public FileResource( java.io.File b, java.lang.String name )
    {
        setFile( FILE_UTILS.resolveFile( b, name ) );
        setBaseDir( b );
    }

    public FileResource( java.io.File f )
    {
        setFile( f );
    }

    public FileResource( org.apache.tools.ant.Project p, java.io.File f )
    {
        setProject( p );
        setFile( f );
    }

    public FileResource( org.apache.tools.ant.Project p, java.lang.String s )
    {
        this( p, p.resolveFile( s ) );
    }

    public  void setFile( java.io.File f )
    {
        checkAttributesAllowed();
        file = f;
    }

    public  java.io.File getFile()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.resources.FileResource) getCheckedRef()).getFile();
        }
        dieOnCircularReference();
        synchronized (this)
{
            if (file == null) {
                java.io.File d = getBaseDir();
                java.lang.String n = super.getName();
                if (n != null) {
                    setFile( FILE_UTILS.resolveFile( d, n ) );
                }
            }
        }
        return file;
    }

    public  void setBaseDir( java.io.File b )
    {
        checkAttributesAllowed();
        baseDir = b;
    }

    public  java.io.File getBaseDir()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.resources.FileResource) getCheckedRef()).getBaseDir();
        }
        dieOnCircularReference();
        return baseDir;
    }

    public  void setRefid( org.apache.tools.ant.types.Reference r )
    {
        if (file != null || baseDir != null) {
            throw tooManyAttributes();
        }
        super.setRefid( r );
    }

    public  java.lang.String getName()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).getName();
        }
        java.io.File b = getBaseDir();
        return b == null ? getNotNullFile().getName() : FILE_UTILS.removeLeadingPath( b, getNotNullFile() );
    }

    public  boolean isExists()
    {
        return isReference() ? ((org.apache.tools.ant.types.Resource) getCheckedRef()).isExists() : getNotNullFile().exists();
    }

    public  long getLastModified()
    {
        return isReference() ? ((org.apache.tools.ant.types.Resource) getCheckedRef()).getLastModified() : getNotNullFile().lastModified();
    }

    public  boolean isDirectory()
    {
        return isReference() ? ((org.apache.tools.ant.types.Resource) getCheckedRef()).isDirectory() : getNotNullFile().isDirectory();
    }

    public  long getSize()
    {
        return isReference() ? ((org.apache.tools.ant.types.Resource) getCheckedRef()).getSize() : getNotNullFile().length();
    }

    public  java.io.InputStream getInputStream()
        throws java.io.IOException
    {
        return isReference() ? ((org.apache.tools.ant.types.Resource) getCheckedRef()).getInputStream() : new java.io.FileInputStream( getNotNullFile() );
    }

    public  java.io.OutputStream getOutputStream()
        throws java.io.IOException
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.resources.FileResource) getCheckedRef()).getOutputStream();
        }
        return getOutputStream( false );
    }

    public  java.io.OutputStream getAppendOutputStream()
        throws java.io.IOException
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.resources.FileResource) getCheckedRef()).getAppendOutputStream();
        }
        return getOutputStream( true );
    }

    private  java.io.OutputStream getOutputStream( boolean append )
        throws java.io.IOException
    {
        java.io.File f = getNotNullFile();
        if (f.exists()) {
            if (f.isFile() && !append) {
                f.delete();
            }
        } else {
            java.io.File p = f.getParentFile();
            if (p != null && !p.exists()) {
                p.mkdirs();
            }
        }
        return append ? new java.io.FileOutputStream( f.getAbsolutePath(), true ) : new java.io.FileOutputStream( f );
    }

    public  int compareTo( java.lang.Object another )
    {
        if (isReference()) {
            return ((java.lang.Comparable) getCheckedRef()).compareTo( another );
        }
        if (this.equals( another )) {
            return 0;
        }
        if (another instanceof org.apache.tools.ant.types.Resource) {
            org.apache.tools.ant.types.Resource r = (org.apache.tools.ant.types.Resource) another;
            org.apache.tools.ant.types.resources.FileProvider otherFP = (org.apache.tools.ant.types.resources.FileProvider) r.as( org.apache.tools.ant.types.resources.FileProvider.class );
            if (otherFP != null) {
                java.io.File f = getFile();
                if (f == null) {
                    return -1;
                }
                java.io.File of = otherFP.getFile();
                if (of == null) {
                    return 1;
                }
                return f.compareTo( of );
            }
        }
        return super.compareTo( another );
    }

    public  boolean equals( java.lang.Object another )
    {
        if (this == another) {
            return true;
        }
        if (isReference()) {
            return getCheckedRef().equals( another );
        }
        if (!another.getClass().equals( getClass() )) {
            return false;
        }
        org.apache.tools.ant.types.resources.FileResource otherfr = (org.apache.tools.ant.types.resources.FileResource) another;
        return getFile() == null ? otherfr.getFile() == null : getFile().equals( otherfr.getFile() );
    }

    public  int hashCode()
    {
        if (isReference()) {
            return getCheckedRef().hashCode();
        }
        return MAGIC * (getFile() == null ? NULL_FILE : getFile().hashCode());
    }

    public  java.lang.String toString()
    {
        if (isReference()) {
            return getCheckedRef().toString();
        }
        if (file == null) {
            return "(unbound file resource)";
        }
        java.lang.String absolutePath = file.getAbsolutePath();
        return FILE_UTILS.normalize( absolutePath ).getAbsolutePath();
    }

    public  boolean isFilesystemOnly()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.resources.FileResource) getCheckedRef()).isFilesystemOnly();
        }
        dieOnCircularReference();
        return true;
    }

    public  void touch( long modTime )
    {
        if (isReference()) {
            ((org.apache.tools.ant.types.resources.FileResource) getCheckedRef()).touch( modTime );
            return;
        }
        if (!getNotNullFile().setLastModified( modTime )) {
            log( "Failed to change file modification time", Project.MSG_WARN );
        }
    }

    protected  java.io.File getNotNullFile()
    {
        if (getFile() == null) {
            throw new org.apache.tools.ant.BuildException( "file attribute is null!" );
        }
        dieOnCircularReference();
        return getFile();
    }

    public  org.apache.tools.ant.types.Resource getResource( java.lang.String path )
    {
        java.io.File newfile = FILE_UTILS.resolveFile( getFile(), path );
        org.apache.tools.ant.types.resources.FileResource fileResource = new org.apache.tools.ant.types.resources.FileResource( newfile );
        fileResource.setBaseDir( getBaseDir() );
        return fileResource;
    }

}
