// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.resources;


import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.FilterOutputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.types.Resource;
import org.apache.tools.ant.types.Reference;


public class StringResource extends org.apache.tools.ant.types.Resource
{

    private static final int STRING_MAGIC = Resource.getMagicNumber( "StringResource".getBytes() );

    private java.lang.String encoding = null;

    public StringResource()
    {
    }

    public StringResource( java.lang.String value )
    {
        this( null, value );
    }

    public StringResource( org.apache.tools.ant.Project project, java.lang.String value )
    {
        setProject( project );
        setValue( project == null ? value : project.replaceProperties( value ) );
    }

    public synchronized  void setName( java.lang.String s )
    {
        if (getName() != null) {
            throw new org.apache.tools.ant.BuildException( new org.apache.tools.ant.types.resources.ImmutableResourceException() );
        }
        super.setName( s );
    }

    public synchronized  void setValue( java.lang.String s )
    {
        setName( s );
    }

    public synchronized  java.lang.String getName()
    {
        return super.getName();
    }

    public synchronized  java.lang.String getValue()
    {
        return getName();
    }

    public  boolean isExists()
    {
        return getValue() != null;
    }

    public  void addText( java.lang.String text )
    {
        checkChildrenAllowed();
        setValue( getProject().replaceProperties( text ) );
    }

    public synchronized  void setEncoding( java.lang.String s )
    {
        checkAttributesAllowed();
        encoding = s;
    }

    public synchronized  java.lang.String getEncoding()
    {
        return encoding;
    }

    public synchronized  long getSize()
    {
        return isReference() ? ((org.apache.tools.ant.types.Resource) getCheckedRef()).getSize() : getContent().length();
    }

    public synchronized  int hashCode()
    {
        if (isReference()) {
            return getCheckedRef().hashCode();
        }
        return super.hashCode() * STRING_MAGIC;
    }

    public  java.lang.String toString()
    {
        return String.valueOf( getContent() );
    }

    public synchronized  java.io.InputStream getInputStream()
        throws java.io.IOException
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).getInputStream();
        }
        java.lang.String content = getContent();
        if (content == null) {
            throw new java.lang.IllegalStateException( "unset string value" );
        }
        return new java.io.ByteArrayInputStream( encoding == null ? content.getBytes() : content.getBytes( encoding ) );
    }

    public synchronized  java.io.OutputStream getOutputStream()
        throws java.io.IOException
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).getOutputStream();
        }
        if (getValue() != null) {
            throw new org.apache.tools.ant.types.resources.ImmutableResourceException();
        }
        return new org.apache.tools.ant.types.resources.StringResource.StringResourceFilterOutputStream();
    }

    public  void setRefid( org.apache.tools.ant.types.Reference r )
    {
        if (encoding != null) {
            throw tooManyAttributes();
        }
        super.setRefid( r );
    }

    protected synchronized  java.lang.String getContent()
    {
        return getValue();
    }

    private  void setValueFromOutputStream( java.lang.String output )
    {
        java.lang.String value;
        if (getProject() != null) {
            value = getProject().replaceProperties( output );
        } else {
            value = output;
        }
        setValue( value );
    }

    private class StringResourceFilterOutputStream extends java.io.FilterOutputStream
    {

        private final java.io.ByteArrayOutputStream baos;

        public StringResourceFilterOutputStream()
        {
            super( new java.io.ByteArrayOutputStream() );
            baos = (java.io.ByteArrayOutputStream) out;
        }

        public  void close()
                throws java.io.IOException
        {
            super.close();
            java.lang.String result = encoding == null ? baos.toString() : baos.toString( encoding );
            StringResource.this.setValueFromOutputStream( result );
        }

    }

}
