// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.resources;


import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
import java.net.URLConnection;
import java.net.MalformedURLException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.types.Resource;
import org.apache.tools.ant.types.Reference;
import org.apache.tools.ant.util.FileUtils;


public class URLResource extends org.apache.tools.ant.types.Resource implements org.apache.tools.ant.types.resources.URLProvider
{

    private static final org.apache.tools.ant.util.FileUtils FILE_UTILS = FileUtils.getFileUtils();

    private static final int NULL_URL = Resource.getMagicNumber( "null URL".getBytes() );

    private java.net.URL url;

    private java.net.URLConnection conn;

    private java.net.URL baseURL;

    private java.lang.String relPath;

    public URLResource()
    {
    }

    public URLResource( java.net.URL u )
    {
        setURL( u );
    }

    public URLResource( org.apache.tools.ant.types.resources.URLProvider u )
    {
        setURL( u.getURL() );
    }

    public URLResource( java.io.File f )
    {
        setFile( f );
    }

    public URLResource( java.lang.String u )
    {
        this( newURL( u ) );
    }

    public synchronized  void setURL( java.net.URL u )
    {
        checkAttributesAllowed();
        url = u;
    }

    public synchronized  void setFile( java.io.File f )
    {
        try {
            setURL( FILE_UTILS.getFileURL( f ) );
        } catch ( java.net.MalformedURLException e ) {
            throw new org.apache.tools.ant.BuildException( e );
        }
    }

    public synchronized  void setBaseURL( java.net.URL base )
    {
        checkAttributesAllowed();
        if (url != null) {
            throw new org.apache.tools.ant.BuildException( "can't define URL and baseURL attribute" );
        }
        baseURL = base;
    }

    public synchronized  void setRelativePath( java.lang.String r )
    {
        checkAttributesAllowed();
        if (url != null) {
            throw new org.apache.tools.ant.BuildException( "can't define URL and relativePath" + " attribute" );
        }
        relPath = r;
    }

    public synchronized  java.net.URL getURL()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.resources.URLResource) getCheckedRef()).getURL();
        }
        if (url == null) {
            if (baseURL != null) {
                if (relPath == null) {
                    throw new org.apache.tools.ant.BuildException( "must provide relativePath" + " attribute when using baseURL." );
                }
                try {
                    url = new java.net.URL( baseURL, relPath );
                } catch ( java.net.MalformedURLException e ) {
                    throw new org.apache.tools.ant.BuildException( e );
                }
            }
        }
        return url;
    }

    public synchronized  void setRefid( org.apache.tools.ant.types.Reference r )
    {
        if (url != null || baseURL != null || relPath != null) {
            throw tooManyAttributes();
        }
        super.setRefid( r );
    }

    public synchronized  java.lang.String getName()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).getName();
        }
        java.lang.String name = getURL().getFile();
        return "".equals( name ) ? name : name.substring( 1 );
    }

    public synchronized  java.lang.String toString()
    {
        return isReference() ? getCheckedRef().toString() : String.valueOf( getURL() );
    }

    public synchronized  boolean isExists()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).isExists();
        }
        return isExists( false );
    }

    private synchronized  boolean isExists( boolean closeConnection )
    {
        if (getURL() == null) {
            return false;
        }
        try {
            connect( Project.MSG_VERBOSE );
            return true;
        } catch ( java.io.IOException e ) {
            return false;
        } finally 
{
            if (closeConnection) {
                close();
            }
        }
    }

    public synchronized  long getLastModified()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).getLastModified();
        }
        if (!isExists( false )) {
            return 0L;
        }
        return conn.getLastModified();
    }

    public synchronized  boolean isDirectory()
    {
        return isReference() ? ((org.apache.tools.ant.types.Resource) getCheckedRef()).isDirectory() : getName().endsWith( "/" );
    }

    public synchronized  long getSize()
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).getSize();
        }
        if (!isExists( false )) {
            return 0L;
        }
        try {
            connect();
            long contentlength = conn.getContentLength();
            close();
            return contentlength;
        } catch ( java.io.IOException e ) {
            return UNKNOWN_SIZE;
        }
    }

    public synchronized  boolean equals( java.lang.Object another )
    {
        if (this == another) {
            return true;
        }
        if (isReference()) {
            return getCheckedRef().equals( another );
        }
        if (!another.getClass().equals( getClass() )) {
            return false;
        }
        org.apache.tools.ant.types.resources.URLResource otheru = (org.apache.tools.ant.types.resources.URLResource) another;
        return getURL() == null ? otheru.getURL() == null : getURL().equals( otheru.getURL() );
    }

    public synchronized  int hashCode()
    {
        if (isReference()) {
            return getCheckedRef().hashCode();
        }
        return MAGIC * (getURL() == null ? NULL_URL : getURL().hashCode());
    }

    public synchronized  java.io.InputStream getInputStream()
        throws java.io.IOException
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).getInputStream();
        }
        connect();
        try {
            return conn.getInputStream();
        } finally 
{
            conn = null;
        }
    }

    public synchronized  java.io.OutputStream getOutputStream()
        throws java.io.IOException
    {
        if (isReference()) {
            return ((org.apache.tools.ant.types.Resource) getCheckedRef()).getOutputStream();
        }
        connect();
        try {
            return conn.getOutputStream();
        } finally 
{
            conn = null;
        }
    }

    protected  void connect()
        throws java.io.IOException
    {
        connect( Project.MSG_ERR );
    }

    protected synchronized  void connect( int logLevel )
        throws java.io.IOException
    {
        java.net.URL u = getURL();
        if (u == null) {
            throw new org.apache.tools.ant.BuildException( "URL not set" );
        }
        if (conn == null) {
            try {
                conn = u.openConnection();
                conn.connect();
            } catch ( java.io.IOException e ) {
                log( e.toString(), logLevel );
                conn = null;
                throw e;
            }
        }
    }

    private synchronized  void close()
    {
        try {
            FileUtils.close( conn );
        } finally 
{
            conn = null;
        }
    }

    private static  java.net.URL newURL( java.lang.String u )
    {
        try {
            return new java.net.URL( u );
        } catch ( java.net.MalformedURLException e ) {
            throw new org.apache.tools.ant.BuildException( e );
        }
    }

}
