// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.selectors;


import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.types.Parameter;
import org.apache.tools.ant.types.RegularExpression;
import org.apache.tools.ant.types.Resource;
import org.apache.tools.ant.types.resources.FileResource;
import org.apache.tools.ant.types.resources.selectors.ResourceSelector;
import org.apache.tools.ant.util.regexp.Regexp;
import org.apache.tools.ant.util.regexp.RegexpUtil;


public class ContainsRegexpSelector extends org.apache.tools.ant.types.selectors.BaseExtendSelector implements org.apache.tools.ant.types.resources.selectors.ResourceSelector
{

    private java.lang.String userProvidedExpression = null;

    private org.apache.tools.ant.types.RegularExpression myRegExp = null;

    private org.apache.tools.ant.util.regexp.Regexp myExpression = null;

    private boolean caseSensitive = true;

    private boolean multiLine = false;

    private boolean singleLine = false;

    public static final java.lang.String EXPRESSION_KEY = "expression";

    private static final java.lang.String CS_KEY = "casesensitive";

    private static final java.lang.String ML_KEY = "multiline";

    private static final java.lang.String SL_KEY = "singleline";

    public ContainsRegexpSelector()
    {
    }

    public  java.lang.String toString()
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer( "{containsregexpselector expression: " );
        buf.append( userProvidedExpression );
        buf.append( "}" );
        return buf.toString();
    }

    public  void setExpression( java.lang.String theexpression )
    {
        this.userProvidedExpression = theexpression;
    }

    public  void setCaseSensitive( boolean b )
    {
        caseSensitive = b;
    }

    public  void setMultiLine( boolean b )
    {
        multiLine = b;
    }

    public  void setSingleLine( boolean b )
    {
        singleLine = b;
    }

    public  void setParameters( org.apache.tools.ant.types.Parameter[] parameters )
    {
        super.setParameters( parameters );
        if (parameters != null) {
            for (int i = 0; i < parameters.length; i++) {
                java.lang.String paramname = parameters[i].getName();
                if (EXPRESSION_KEY.equalsIgnoreCase( paramname )) {
                    setExpression( parameters[i].getValue() );
                } else {
                    if (CS_KEY.equalsIgnoreCase( paramname )) {
                        setCaseSensitive( Project.toBoolean( parameters[i].getValue() ) );
                    } else {
                        if (ML_KEY.equalsIgnoreCase( paramname )) {
                            setMultiLine( Project.toBoolean( parameters[i].getValue() ) );
                        } else {
                            if (SL_KEY.equalsIgnoreCase( paramname )) {
                                setSingleLine( Project.toBoolean( parameters[i].getValue() ) );
                            } else {
                                setError( "Invalid parameter " + paramname );
                            }
                        }
                    }
                }
            }
        }
    }

    public  void verifySettings()
    {
        if (userProvidedExpression == null) {
            setError( "The expression attribute is required" );
        }
    }

    public  boolean isSelected( java.io.File basedir, java.lang.String filename, java.io.File file )
    {
        return isSelected( new org.apache.tools.ant.types.resources.FileResource( file ) );
    }

    public  boolean isSelected( org.apache.tools.ant.types.Resource r )
    {
        java.lang.String teststr = null;
        java.io.BufferedReader in = null;
        validate();
        if (r.isDirectory()) {
            return true;
        }
        if (myRegExp == null) {
            myRegExp = new org.apache.tools.ant.types.RegularExpression();
            myRegExp.setPattern( userProvidedExpression );
            myExpression = myRegExp.getRegexp( getProject() );
        }
        try {
            in = new java.io.BufferedReader( new java.io.InputStreamReader( r.getInputStream() ) );
        } catch ( java.lang.Exception e ) {
            throw new org.apache.tools.ant.BuildException( "Could not get InputStream from " + r.toLongString(), e );
        }
        try {
            teststr = in.readLine();
            while (teststr != null) {
                if (myExpression.matches( teststr, RegexpUtil.asOptions( caseSensitive, multiLine, singleLine ) )) {
                    return true;
                }
                teststr = in.readLine();
            }
            return false;
        } catch ( java.io.IOException ioe ) {
            throw new org.apache.tools.ant.BuildException( "Could not read " + r.toLongString() );
        } finally 
{
            try {
                in.close();
            } catch ( java.lang.Exception e ) {
                throw new org.apache.tools.ant.BuildException( "Could not close " + r.toLongString() );
            }
        }
    }

}
