// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.selectors;


import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.types.Parameter;
import org.apache.tools.ant.types.Resource;
import org.apache.tools.ant.types.resources.FileResource;
import org.apache.tools.ant.types.resources.selectors.ResourceSelector;
import org.apache.tools.ant.util.FileUtils;


public class ContainsSelector extends org.apache.tools.ant.types.selectors.BaseExtendSelector implements org.apache.tools.ant.types.resources.selectors.ResourceSelector
{

    private java.lang.String contains = null;

    private boolean casesensitive = true;

    private boolean ignorewhitespace = false;

    public static final java.lang.String EXPRESSION_KEY = "expression";

    public static final java.lang.String CONTAINS_KEY = "text";

    public static final java.lang.String CASE_KEY = "casesensitive";

    public static final java.lang.String WHITESPACE_KEY = "ignorewhitespace";

    public ContainsSelector()
    {
    }

    public  java.lang.String toString()
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer( "{containsselector text: " );
        buf.append( '"' ).append( contains ).append( '"' );
        buf.append( " casesensitive: " );
        buf.append( casesensitive ? "true" : "false" );
        buf.append( " ignorewhitespace: " );
        buf.append( ignorewhitespace ? "true" : "false" );
        buf.append( "}" );
        return buf.toString();
    }

    public  void setText( java.lang.String contains )
    {
        this.contains = contains;
    }

    public  void setCasesensitive( boolean casesensitive )
    {
        this.casesensitive = casesensitive;
    }

    public  void setIgnorewhitespace( boolean ignorewhitespace )
    {
        this.ignorewhitespace = ignorewhitespace;
    }

    public  void setParameters( org.apache.tools.ant.types.Parameter[] parameters )
    {
        super.setParameters( parameters );
        if (parameters != null) {
            for (int i = 0; i < parameters.length; i++) {
                java.lang.String paramname = parameters[i].getName();
                if (CONTAINS_KEY.equalsIgnoreCase( paramname )) {
                    setText( parameters[i].getValue() );
                } else {
                    if (CASE_KEY.equalsIgnoreCase( paramname )) {
                        setCasesensitive( Project.toBoolean( parameters[i].getValue() ) );
                    } else {
                        if (WHITESPACE_KEY.equalsIgnoreCase( paramname )) {
                            setIgnorewhitespace( Project.toBoolean( parameters[i].getValue() ) );
                        } else {
                            setError( "Invalid parameter " + paramname );
                        }
                    }
                }
            }
        }
    }

    public  void verifySettings()
    {
        if (contains == null) {
            setError( "The text attribute is required" );
        }
    }

    public  boolean isSelected( java.io.File basedir, java.lang.String filename, java.io.File file )
    {
        return isSelected( new org.apache.tools.ant.types.resources.FileResource( file ) );
    }

    public  boolean isSelected( org.apache.tools.ant.types.Resource r )
    {
        validate();
        if (r.isDirectory() || contains.length() == 0) {
            return true;
        }
        java.lang.String userstr = contains;
        if (!casesensitive) {
            userstr = contains.toLowerCase();
        }
        if (ignorewhitespace) {
            userstr = SelectorUtils.removeWhitespace( userstr );
        }
        java.io.BufferedReader in = null;
        try {
            in = new java.io.BufferedReader( new java.io.InputStreamReader( r.getInputStream() ) );
        } catch ( java.lang.Exception e ) {
            throw new org.apache.tools.ant.BuildException( "Could not get InputStream from " + r.toLongString(), e );
        }
        try {
            java.lang.String teststr = in.readLine();
            while (teststr != null) {
                if (!casesensitive) {
                    teststr = teststr.toLowerCase();
                }
                if (ignorewhitespace) {
                    teststr = SelectorUtils.removeWhitespace( teststr );
                }
                if (teststr.indexOf( userstr ) > -1) {
                    return true;
                }
                teststr = in.readLine();
            }
            return false;
        } catch ( java.io.IOException ioe ) {
            throw new org.apache.tools.ant.BuildException( "Could not read " + r.toLongString() );
        } finally 
{
            FileUtils.close( in );
        }
    }

}
