// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.selectors;


import java.io.File;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.text.ParseException;
import java.util.Locale;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.types.Parameter;
import org.apache.tools.ant.types.TimeComparison;
import org.apache.tools.ant.util.FileUtils;


public class DateSelector extends org.apache.tools.ant.types.selectors.BaseExtendSelector
{

    private static final org.apache.tools.ant.util.FileUtils FILE_UTILS = FileUtils.getFileUtils();

    private long millis = -1;

    private java.lang.String dateTime = null;

    private boolean includeDirs = false;

    private long granularity = 0;

    private java.lang.String pattern;

    private org.apache.tools.ant.types.TimeComparison when = TimeComparison.EQUAL;

    public static final java.lang.String MILLIS_KEY = "millis";

    public static final java.lang.String DATETIME_KEY = "datetime";

    public static final java.lang.String CHECKDIRS_KEY = "checkdirs";

    public static final java.lang.String GRANULARITY_KEY = "granularity";

    public static final java.lang.String WHEN_KEY = "when";

    public static final java.lang.String PATTERN_KEY = "pattern";

    public DateSelector()
    {
        granularity = FILE_UTILS.getFileTimestampGranularity();
    }

    public  java.lang.String toString()
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer( "{dateselector date: " );
        buf.append( dateTime );
        buf.append( " compare: " ).append( when.getValue() );
        buf.append( " granularity: " );
        buf.append( granularity );
        if (pattern != null) {
            buf.append( " pattern: " ).append( pattern );
        }
        buf.append( "}" );
        return buf.toString();
    }

    public  void setMillis( long millis )
    {
        this.millis = millis;
    }

    public  long getMillis()
    {
        if (dateTime != null) {
            validate();
        }
        return millis;
    }

    public  void setDatetime( java.lang.String dateTime )
    {
        this.dateTime = dateTime;
        millis = -1;
    }

    public  void setCheckdirs( boolean includeDirs )
    {
        this.includeDirs = includeDirs;
    }

    public  void setGranularity( int granularity )
    {
        this.granularity = granularity;
    }

    public  void setWhen( org.apache.tools.ant.types.selectors.DateSelector.TimeComparisons tcmp )
    {
        setWhen( (org.apache.tools.ant.types.TimeComparison) tcmp );
    }

    public  void setWhen( org.apache.tools.ant.types.TimeComparison t )
    {
        when = t;
    }

    public  void setPattern( java.lang.String pattern )
    {
        this.pattern = pattern;
    }

    public  void setParameters( org.apache.tools.ant.types.Parameter[] parameters )
    {
        super.setParameters( parameters );
        if (parameters != null) {
            for (int i = 0; i < parameters.length; i++) {
                java.lang.String paramname = parameters[i].getName();
                if (MILLIS_KEY.equalsIgnoreCase( paramname )) {
                    try {
                        setMillis( Long.parseLong( parameters[i].getValue() ) );
                    } catch ( java.lang.NumberFormatException nfe ) {
                        setError( "Invalid millisecond setting " + parameters[i].getValue() );
                    }
                } else {
                    if (DATETIME_KEY.equalsIgnoreCase( paramname )) {
                        setDatetime( parameters[i].getValue() );
                    } else {
                        if (CHECKDIRS_KEY.equalsIgnoreCase( paramname )) {
                            setCheckdirs( Project.toBoolean( parameters[i].getValue() ) );
                        } else {
                            if (GRANULARITY_KEY.equalsIgnoreCase( paramname )) {
                                try {
                                    setGranularity( Integer.parseInt( parameters[i].getValue() ) );
                                } catch ( java.lang.NumberFormatException nfe ) {
                                    setError( "Invalid granularity setting " + parameters[i].getValue() );
                                }
                            } else {
                                if (WHEN_KEY.equalsIgnoreCase( paramname )) {
                                    setWhen( new org.apache.tools.ant.types.TimeComparison( parameters[i].getValue() ) );
                                } else {
                                    if (PATTERN_KEY.equalsIgnoreCase( paramname )) {
                                        setPattern( parameters[i].getValue() );
                                    } else {
                                        setError( "Invalid parameter " + paramname );
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    public  void verifySettings()
    {
        if (dateTime == null && millis < 0) {
            setError( "You must provide a datetime or the number of " + "milliseconds." );
        } else {
            if (millis < 0 && dateTime != null) {
                java.text.DateFormat df = pattern == null ? DateFormat.getDateTimeInstance( DateFormat.SHORT, DateFormat.SHORT, Locale.US ) : new java.text.SimpleDateFormat( pattern );
                try {
                    setMillis( df.parse( dateTime ).getTime() );
                    if (millis < 0) {
                        setError( "Date of " + dateTime + " results in negative milliseconds value" + " relative to epoch (January 1, 1970, 00:00:00 GMT)." );
                    }
                } catch ( java.text.ParseException pe ) {
                    setError( "Date of " + dateTime + " Cannot be parsed correctly. It should be in" + (pattern == null ? " MM/DD/YYYY HH:MM AM_PM" : pattern) + " format." );
                }
            }
        }
    }

    public  boolean isSelected( java.io.File basedir, java.lang.String filename, java.io.File file )
    {
        validate();
        return file.isDirectory() && !includeDirs || when.evaluate( file.lastModified(), millis, granularity );
    }

    public static class TimeComparisons extends org.apache.tools.ant.types.TimeComparison
    {
    }

}
