// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.selectors;


import java.io.File;
import java.util.StringTokenizer;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.types.Parameter;


public class DepthSelector extends org.apache.tools.ant.types.selectors.BaseExtendSelector
{

    public int min = -1;

    public int max = -1;

    public static final java.lang.String MIN_KEY = "min";

    public static final java.lang.String MAX_KEY = "max";

    public DepthSelector()
    {
    }

    public  java.lang.String toString()
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer( "{depthselector min: " );
        buf.append( min );
        buf.append( " max: " );
        buf.append( max );
        buf.append( "}" );
        return buf.toString();
    }

    public  void setMin( int min )
    {
        this.min = min;
    }

    public  void setMax( int max )
    {
        this.max = max;
    }

    public  void setParameters( org.apache.tools.ant.types.Parameter[] parameters )
    {
        super.setParameters( parameters );
        if (parameters != null) {
            for (int i = 0; i < parameters.length; i++) {
                java.lang.String paramname = parameters[i].getName();
                if (MIN_KEY.equalsIgnoreCase( paramname )) {
                    try {
                        setMin( Integer.parseInt( parameters[i].getValue() ) );
                    } catch ( java.lang.NumberFormatException nfe1 ) {
                        setError( "Invalid minimum value " + parameters[i].getValue() );
                    }
                } else {
                    if (MAX_KEY.equalsIgnoreCase( paramname )) {
                        try {
                            setMax( Integer.parseInt( parameters[i].getValue() ) );
                        } catch ( java.lang.NumberFormatException nfe1 ) {
                            setError( "Invalid maximum value " + parameters[i].getValue() );
                        }
                    } else {
                        setError( "Invalid parameter " + paramname );
                    }
                }
            }
        }
    }

    public  void verifySettings()
    {
        if (min < 0 && max < 0) {
            setError( "You must set at least one of the min or the " + "max levels." );
        }
        if (max < min && max > -1) {
            setError( "The maximum depth is lower than the minimum." );
        }
    }

    public  boolean isSelected( java.io.File basedir, java.lang.String filename, java.io.File file )
    {
        validate();
        int depth = -1;
        java.lang.String absBase = basedir.getAbsolutePath();
        java.lang.String absFile = file.getAbsolutePath();
        java.util.StringTokenizer tokBase = new java.util.StringTokenizer( absBase, File.separator );
        java.util.StringTokenizer tokFile = new java.util.StringTokenizer( absFile, File.separator );
        while (tokFile.hasMoreTokens()) {
            java.lang.String filetoken = tokFile.nextToken();
            if (tokBase.hasMoreTokens()) {
                java.lang.String basetoken = tokBase.nextToken();
                if (!basetoken.equals( filetoken )) {
                    throw new org.apache.tools.ant.BuildException( "File " + filename + " does not appear within " + absBase + "directory" );
                }
            } else {
                depth += 1;
                if (max > -1 && depth > max) {
                    return false;
                }
            }
        }
        if (tokBase.hasMoreTokens()) {
            throw new org.apache.tools.ant.BuildException( "File " + filename + " is outside of " + absBase + "directory tree" );
        }
        if (min > -1 && depth < min) {
            return false;
        }
        return true;
    }

}
