// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.selectors;


import java.io.File;
import java.util.StringTokenizer;
import java.util.Vector;
import org.apache.tools.ant.types.Resource;
import org.apache.tools.ant.util.FileUtils;


public final class SelectorUtils
{

    public static final java.lang.String DEEP_TREE_MATCH = "**";

    private static final org.apache.tools.ant.types.selectors.SelectorUtils instance = new org.apache.tools.ant.types.selectors.SelectorUtils();

    private static final org.apache.tools.ant.util.FileUtils FILE_UTILS = FileUtils.getFileUtils();

    private SelectorUtils()
    {
    }

    public static  org.apache.tools.ant.types.selectors.SelectorUtils getInstance()
    {
        return instance;
    }

    public static  boolean matchPatternStart( java.lang.String pattern, java.lang.String str )
    {
        return matchPatternStart( pattern, str, true );
    }

    public static  boolean matchPatternStart( java.lang.String pattern, java.lang.String str, boolean isCaseSensitive )
    {
        if (str.startsWith( File.separator ) != pattern.startsWith( File.separator )) {
            return false;
        }
        java.lang.String[] patDirs = tokenizePathAsArray( pattern );
        java.lang.String[] strDirs = tokenizePathAsArray( str );
        return matchPatternStart( patDirs, strDirs, isCaseSensitive );
    }

    static  boolean matchPatternStart( java.lang.String[] patDirs, java.lang.String[] strDirs, boolean isCaseSensitive )
    {
        int patIdxStart = 0;
        int patIdxEnd = patDirs.length - 1;
        int strIdxStart = 0;
        int strIdxEnd = strDirs.length - 1;
        while (patIdxStart <= patIdxEnd && strIdxStart <= strIdxEnd) {
            java.lang.String patDir = patDirs[patIdxStart];
            if (patDir.equals( DEEP_TREE_MATCH )) {
                break;
            }
            if (!match( patDir, strDirs[strIdxStart], isCaseSensitive )) {
                return false;
            }
            patIdxStart++;
            strIdxStart++;
        }
        if (strIdxStart > strIdxEnd) {
            return true;
        } else {
            if (patIdxStart > patIdxEnd) {
                return false;
            } else {
                return true;
            }
        }
    }

    public static  boolean matchPath( java.lang.String pattern, java.lang.String str )
    {
        java.lang.String[] patDirs = tokenizePathAsArray( pattern );
        return matchPath( patDirs, tokenizePathAsArray( str ), true );
    }

    public static  boolean matchPath( java.lang.String pattern, java.lang.String str, boolean isCaseSensitive )
    {
        java.lang.String[] patDirs = tokenizePathAsArray( pattern );
        return matchPath( patDirs, tokenizePathAsArray( str ), isCaseSensitive );
    }

    static  boolean matchPath( java.lang.String[] tokenizedPattern, java.lang.String[] strDirs, boolean isCaseSensitive )
    {
        int patIdxStart = 0;
        int patIdxEnd = tokenizedPattern.length - 1;
        int strIdxStart = 0;
        int strIdxEnd = strDirs.length - 1;
        while (patIdxStart <= patIdxEnd && strIdxStart <= strIdxEnd) {
            java.lang.String patDir = tokenizedPattern[patIdxStart];
            if (patDir.equals( DEEP_TREE_MATCH )) {
                break;
            }
            if (!match( patDir, strDirs[strIdxStart], isCaseSensitive )) {
                return false;
            }
            patIdxStart++;
            strIdxStart++;
        }
        if (strIdxStart > strIdxEnd) {
            for (int i = patIdxStart; i <= patIdxEnd; i++) {
                if (!tokenizedPattern[i].equals( DEEP_TREE_MATCH )) {
                    return false;
                }
            }
            return true;
        } else {
            if (patIdxStart > patIdxEnd) {
                return false;
            }
        }
        while (patIdxStart <= patIdxEnd && strIdxStart <= strIdxEnd) {
            java.lang.String patDir = tokenizedPattern[patIdxEnd];
            if (patDir.equals( DEEP_TREE_MATCH )) {
                break;
            }
            if (!match( patDir, strDirs[strIdxEnd], isCaseSensitive )) {
                return false;
            }
            patIdxEnd--;
            strIdxEnd--;
        }
        if (strIdxStart > strIdxEnd) {
            for (int i = patIdxStart; i <= patIdxEnd; i++) {
                if (!tokenizedPattern[i].equals( DEEP_TREE_MATCH )) {
                    return false;
                }
            }
            return true;
        }
        while (patIdxStart != patIdxEnd && strIdxStart <= strIdxEnd) {
            int patIdxTmp = -1;
            for (int i = patIdxStart + 1; i <= patIdxEnd; i++) {
                if (tokenizedPattern[i].equals( DEEP_TREE_MATCH )) {
                    patIdxTmp = i;
                    break;
                }
            }
            if (patIdxTmp == patIdxStart + 1) {
                patIdxStart++;
                continue;
            }
            int patLength = patIdxTmp - patIdxStart - 1;
            int strLength = strIdxEnd - strIdxStart + 1;
            int foundIdx = -1;
            strLoop : 
            for (int i = 0; i <= strLength - patLength; i++) {
                for (int j = 0; j < patLength; j++) {
                    java.lang.String subPat = tokenizedPattern[patIdxStart + j + 1];
                    java.lang.String subStr = strDirs[strIdxStart + i + j];
                    if (!match( subPat, subStr, isCaseSensitive )) {
                        continue strLoop;
                    }
                }
                foundIdx = strIdxStart + i;
                break;
            }
            if (foundIdx == -1) {
                return false;
            }
            patIdxStart = patIdxTmp;
            strIdxStart = foundIdx + patLength;
        }
        for (int i = patIdxStart; i <= patIdxEnd; i++) {
            if (!tokenizedPattern[i].equals( DEEP_TREE_MATCH )) {
                return false;
            }
        }
        return true;
    }

    public static  boolean match( java.lang.String pattern, java.lang.String str )
    {
        return match( pattern, str, true );
    }

    public static  boolean match( java.lang.String pattern, java.lang.String str, boolean caseSensitive )
    {
        char[] patArr = pattern.toCharArray();
        char[] strArr = str.toCharArray();
        int patIdxStart = 0;
        int patIdxEnd = patArr.length - 1;
        int strIdxStart = 0;
        int strIdxEnd = strArr.length - 1;
        char ch;
        boolean containsStar = false;
        for (int i = 0; i < patArr.length; i++) {
            if (patArr[i] == '*') {
                containsStar = true;
                break;
            }
        }
        if (!containsStar) {
            if (patIdxEnd != strIdxEnd) {
                return false;
            }
            for (int i = 0; i <= patIdxEnd; i++) {
                ch = patArr[i];
                if (ch != '?') {
                    if (different( caseSensitive, ch, strArr[i] )) {
                        return false;
                    }
                }
            }
            return true;
        }
        if (patIdxEnd == 0) {
            return true;
        }
        while (true) {
            ch = patArr[patIdxStart];
            if (ch == '*' || strIdxStart > strIdxEnd) {
                break;
            }
            if (ch != '?') {
                if (different( caseSensitive, ch, strArr[strIdxStart] )) {
                    return false;
                }
            }
            patIdxStart++;
            strIdxStart++;
        }
        if (strIdxStart > strIdxEnd) {
            return allStars( patArr, patIdxStart, patIdxEnd );
        }
        while (true) {
            ch = patArr[patIdxEnd];
            if (ch == '*' || strIdxStart > strIdxEnd) {
                break;
            }
            if (ch != '?') {
                if (different( caseSensitive, ch, strArr[strIdxEnd] )) {
                    return false;
                }
            }
            patIdxEnd--;
            strIdxEnd--;
        }
        if (strIdxStart > strIdxEnd) {
            return allStars( patArr, patIdxStart, patIdxEnd );
        }
        while (patIdxStart != patIdxEnd && strIdxStart <= strIdxEnd) {
            int patIdxTmp = -1;
            for (int i = patIdxStart + 1; i <= patIdxEnd; i++) {
                if (patArr[i] == '*') {
                    patIdxTmp = i;
                    break;
                }
            }
            if (patIdxTmp == patIdxStart + 1) {
                patIdxStart++;
                continue;
            }
            int patLength = patIdxTmp - patIdxStart - 1;
            int strLength = strIdxEnd - strIdxStart + 1;
            int foundIdx = -1;
            strLoop : 
            for (int i = 0; i <= strLength - patLength; i++) {
                for (int j = 0; j < patLength; j++) {
                    ch = patArr[patIdxStart + j + 1];
                    if (ch != '?') {
                        if (different( caseSensitive, ch, strArr[strIdxStart + i + j] )) {
                            continue strLoop;
                        }
                    }
                }
                foundIdx = strIdxStart + i;
                break;
            }
            if (foundIdx == -1) {
                return false;
            }
            patIdxStart = patIdxTmp;
            strIdxStart = foundIdx + patLength;
        }
        return allStars( patArr, patIdxStart, patIdxEnd );
    }

    private static  boolean allStars( char[] chars, int start, int end )
    {
        for (int i = start; i <= end; ++i) {
            if (chars[i] != '*') {
                return false;
            }
        }
        return true;
    }

    private static  boolean different( boolean caseSensitive, char ch, char other )
    {
        return caseSensitive ? ch != other : Character.toUpperCase( ch ) != Character.toUpperCase( other );
    }

    public static  java.util.Vector tokenizePath( java.lang.String path )
    {
        return tokenizePath( path, File.separator );
    }

    public static  java.util.Vector tokenizePath( java.lang.String path, java.lang.String separator )
    {
        java.util.Vector ret = new java.util.Vector();
        if (FileUtils.isAbsolutePath( path )) {
            java.lang.String[] s = FILE_UTILS.dissect( path );
            ret.add( s[0] );
            path = s[1];
        }
        java.util.StringTokenizer st = new java.util.StringTokenizer( path, separator );
        while (st.hasMoreTokens()) {
            ret.addElement( st.nextToken() );
        }
        return ret;
    }

    static  java.lang.String[] tokenizePathAsArray( java.lang.String path )
    {
        java.lang.String root = null;
        if (FileUtils.isAbsolutePath( path )) {
            java.lang.String[] s = FILE_UTILS.dissect( path );
            root = s[0];
            path = s[1];
        }
        char sep = File.separatorChar;
        int start = 0;
        int len = path.length();
        int count = 0;
        for (int pos = 0; pos < len; pos++) {
            if (path.charAt( pos ) == sep) {
                if (pos != start) {
                    count++;
                }
                start = pos + 1;
            }
        }
        if (len != start) {
            count++;
        }
        java.lang.String[] l = new java.lang.String[count + (root == null ? 0 : 1)];
        if (root != null) {
            l[0] = root;
            count = 1;
        } else {
            count = 0;
        }
        start = 0;
        for (int pos = 0; pos < len; pos++) {
            if (path.charAt( pos ) == sep) {
                if (pos != start) {
                    java.lang.String tok = path.substring( start, pos );
                    l[count++] = tok;
                }
                start = pos + 1;
            }
        }
        if (len != start) {
            java.lang.String tok = path.substring( start );
            l[count] = tok;
        }
        return l;
    }

    public static  boolean isOutOfDate( java.io.File src, java.io.File target, int granularity )
    {
        if (!src.exists()) {
            return false;
        }
        if (!target.exists()) {
            return true;
        }
        if (src.lastModified() - granularity > target.lastModified()) {
            return true;
        }
        return false;
    }

    public static  boolean isOutOfDate( org.apache.tools.ant.types.Resource src, org.apache.tools.ant.types.Resource target, int granularity )
    {
        return isOutOfDate( src, target, (long) granularity );
    }

    public static  boolean isOutOfDate( org.apache.tools.ant.types.Resource src, org.apache.tools.ant.types.Resource target, long granularity )
    {
        long sourceLastModified = src.getLastModified();
        long targetLastModified = target.getLastModified();
        return src.isExists() && (sourceLastModified == Resource.UNKNOWN_DATETIME || targetLastModified == Resource.UNKNOWN_DATETIME || sourceLastModified - granularity > targetLastModified);
    }

    public static  java.lang.String removeWhitespace( java.lang.String input )
    {
        java.lang.StringBuffer result = new java.lang.StringBuffer();
        if (input != null) {
            java.util.StringTokenizer st = new java.util.StringTokenizer( input );
            while (st.hasMoreTokens()) {
                result.append( st.nextToken() );
            }
        }
        return result.toString();
    }

    public static  boolean hasWildcards( java.lang.String input )
    {
        return input.indexOf( '*' ) != -1 || input.indexOf( '?' ) != -1;
    }

    public static  java.lang.String rtrimWildcardTokens( java.lang.String input )
    {
        return (new org.apache.tools.ant.types.selectors.TokenizedPattern( input )).rtrimWildcardTokens().toString();
    }

}
