// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.types.selectors;


import java.io.File;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.util.FileUtils;
import org.apache.tools.ant.util.SymbolicLinkUtils;


public class TokenizedPath
{

    public static final org.apache.tools.ant.types.selectors.TokenizedPath EMPTY_PATH = new org.apache.tools.ant.types.selectors.TokenizedPath( "", new java.lang.String[0] );

    private static final org.apache.tools.ant.util.FileUtils FILE_UTILS = FileUtils.getFileUtils();

    private static final org.apache.tools.ant.util.SymbolicLinkUtils SYMLINK_UTILS = SymbolicLinkUtils.getSymbolicLinkUtils();

    private static final boolean[] CS_SCAN_ONLY = new boolean[]{ true };

    private static final boolean[] CS_THEN_NON_CS = new boolean[]{ true, false };

    private final java.lang.String path;

    private final java.lang.String[] tokenizedPath;

    public TokenizedPath( java.lang.String path )
    {
        this( path, SelectorUtils.tokenizePathAsArray( path ) );
    }

    public TokenizedPath( org.apache.tools.ant.types.selectors.TokenizedPath parent, java.lang.String child )
    {
        if (parent.path.length() > 0 && parent.path.charAt( parent.path.length() - 1 ) != File.separatorChar) {
            path = parent.path + File.separatorChar + child;
        } else {
            path = parent.path + child;
        }
        tokenizedPath = new java.lang.String[parent.tokenizedPath.length + 1];
        System.arraycopy( parent.tokenizedPath, 0, tokenizedPath, 0, parent.tokenizedPath.length );
        tokenizedPath[parent.tokenizedPath.length] = child;
    }

    TokenizedPath( java.lang.String path, java.lang.String[] tokens )
    {
        this.path = path;
        this.tokenizedPath = tokens;
    }

    public  java.lang.String toString()
    {
        return path;
    }

    public  int depth()
    {
        return tokenizedPath.length;
    }

     java.lang.String[] getTokens()
    {
        return tokenizedPath;
    }

    public  java.io.File findFile( java.io.File base, final boolean cs )
    {
        java.lang.String[] tokens = tokenizedPath;
        if (FileUtils.isAbsolutePath( path )) {
            if (base == null) {
                java.lang.String[] s = FILE_UTILS.dissect( path );
                base = new java.io.File( s[0] );
                tokens = SelectorUtils.tokenizePathAsArray( s[1] );
            } else {
                java.io.File f = FILE_UTILS.normalize( path );
                java.lang.String s = FILE_UTILS.removeLeadingPath( base, f );
                if (s.equals( f.getAbsolutePath() )) {
                    return null;
                }
                tokens = SelectorUtils.tokenizePathAsArray( s );
            }
        }
        return findFile( base, tokens, cs );
    }

    public  boolean isSymlink( java.io.File base )
    {
        for (int i = 0; i < tokenizedPath.length; i++) {
            try {
                if (base != null && SYMLINK_UTILS.isSymbolicLink( base, tokenizedPath[i] ) || base == null && SYMLINK_UTILS.isSymbolicLink( tokenizedPath[i] )) {
                    return true;
                }
                base = new java.io.File( base, tokenizedPath[i] );
            } catch ( java.io.IOException ioe ) {
                java.lang.String msg = "IOException caught while checking " + "for links, couldn't get canonical path!";
                System.err.println( msg );
            }
        }
        return false;
    }

    public  boolean equals( java.lang.Object o )
    {
        return o instanceof org.apache.tools.ant.types.selectors.TokenizedPath && path.equals( ((org.apache.tools.ant.types.selectors.TokenizedPath) o).path );
    }

    public  int hashCode()
    {
        return path.hashCode();
    }

    private static  java.io.File findFile( java.io.File base, final java.lang.String[] pathElements, final boolean cs )
    {
        for (int current = 0; current < pathElements.length; current++) {
            if (!base.isDirectory()) {
                return null;
            }
            java.lang.String[] files = base.list();
            if (files == null) {
                throw new org.apache.tools.ant.BuildException( "IO error scanning directory " + base.getAbsolutePath() );
            }
            boolean found = false;
            boolean[] matchCase = cs ? CS_SCAN_ONLY : CS_THEN_NON_CS;
            for (int i = 0; !found && i < matchCase.length; i++) {
                for (int j = 0; !found && j < files.length; j++) {
                    if (matchCase[i] ? files[j].equals( pathElements[current] ) : files[j].equalsIgnoreCase( pathElements[current] )) {
                        base = new java.io.File( base, files[j] );
                        found = true;
                    }
                }
            }
            if (!found) {
                return null;
            }
        }
        return pathElements.length == 0 && !base.isDirectory() ? null : base;
    }

    public  org.apache.tools.ant.types.selectors.TokenizedPattern toPattern()
    {
        return new org.apache.tools.ant.types.selectors.TokenizedPattern( path, tokenizedPath );
    }

}
