// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import org.apache.tools.ant.AntClassLoader;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.ProjectComponent;
import org.apache.tools.ant.MagicNames;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.types.Reference;


public class ClasspathUtils
{

    public static final java.lang.String REUSE_LOADER_REF = MagicNames.REFID_CLASSPATH_REUSE_LOADER;

    public static  java.lang.ClassLoader getClassLoaderForPath( org.apache.tools.ant.Project p, org.apache.tools.ant.types.Reference ref )
    {
        return getClassLoaderForPath( p, ref, false );
    }

    public static  java.lang.ClassLoader getClassLoaderForPath( org.apache.tools.ant.Project p, org.apache.tools.ant.types.Reference ref, boolean reverseLoader )
    {
        java.lang.String pathId = ref.getRefId();
        java.lang.Object path = p.getReference( pathId );
        if (!(path instanceof org.apache.tools.ant.types.Path)) {
            throw new org.apache.tools.ant.BuildException( "The specified classpathref " + pathId + " does not reference a Path." );
        }
        java.lang.String loaderId = MagicNames.REFID_CLASSPATH_LOADER_PREFIX + pathId;
        return getClassLoaderForPath( p, (org.apache.tools.ant.types.Path) path, loaderId, reverseLoader );
    }

    public static  java.lang.ClassLoader getClassLoaderForPath( org.apache.tools.ant.Project p, org.apache.tools.ant.types.Path path, java.lang.String loaderId )
    {
        return getClassLoaderForPath( p, path, loaderId, false );
    }

    public static  java.lang.ClassLoader getClassLoaderForPath( org.apache.tools.ant.Project p, org.apache.tools.ant.types.Path path, java.lang.String loaderId, boolean reverseLoader )
    {
        return getClassLoaderForPath( p, path, loaderId, reverseLoader, isMagicPropertySet( p ) );
    }

    public static  java.lang.ClassLoader getClassLoaderForPath( org.apache.tools.ant.Project p, org.apache.tools.ant.types.Path path, java.lang.String loaderId, boolean reverseLoader, boolean reuseLoader )
    {
        java.lang.ClassLoader cl = null;
        if (loaderId != null && reuseLoader) {
            java.lang.Object reusedLoader = p.getReference( loaderId );
            if (reusedLoader != null && !(reusedLoader instanceof java.lang.ClassLoader)) {
                throw new org.apache.tools.ant.BuildException( "The specified loader id " + loaderId + " does not reference a class loader" );
            }
            cl = (java.lang.ClassLoader) reusedLoader;
        }
        if (cl == null) {
            cl = getUniqueClassLoaderForPath( p, path, reverseLoader );
            if (loaderId != null && reuseLoader) {
                p.addReference( loaderId, cl );
            }
        }
        return cl;
    }

    public static  java.lang.ClassLoader getUniqueClassLoaderForPath( org.apache.tools.ant.Project p, org.apache.tools.ant.types.Path path, boolean reverseLoader )
    {
        org.apache.tools.ant.AntClassLoader acl = p.createClassLoader( path );
        if (reverseLoader) {
            acl.setParentFirst( false );
            acl.addJavaLibraries();
        }
        return acl;
    }

    public static  java.lang.Object newInstance( java.lang.String className, java.lang.ClassLoader userDefinedLoader )
    {
        return newInstance( className, userDefinedLoader, java.lang.Object.class );
    }

    public static  java.lang.Object newInstance( java.lang.String className, java.lang.ClassLoader userDefinedLoader, java.lang.Class expectedType )
    {
        try {
            java.lang.Class clazz = Class.forName( className, true, userDefinedLoader );
            java.lang.Object o = clazz.newInstance();
            if (!expectedType.isInstance( o )) {
                throw new org.apache.tools.ant.BuildException( "Class of unexpected Type: " + className + " expected :" + expectedType );
            }
            return o;
        } catch ( java.lang.ClassNotFoundException e ) {
            throw new org.apache.tools.ant.BuildException( "Class not found: " + className, e );
        } catch ( java.lang.InstantiationException e ) {
            throw new org.apache.tools.ant.BuildException( "Could not instantiate " + className + ". Specified class should have a no " + "argument constructor.", e );
        } catch ( java.lang.IllegalAccessException e ) {
            throw new org.apache.tools.ant.BuildException( "Could not instantiate " + className + ". Specified class should have a " + "public constructor.", e );
        } catch ( java.lang.LinkageError e ) {
            throw new org.apache.tools.ant.BuildException( "Class " + className + " could not be loaded because of an invalid dependency.", e );
        }
    }

    public static  org.apache.tools.ant.util.ClasspathUtils.Delegate getDelegate( org.apache.tools.ant.ProjectComponent component )
    {
        return new org.apache.tools.ant.util.ClasspathUtils.Delegate( component );
    }

    private static  boolean isMagicPropertySet( org.apache.tools.ant.Project p )
    {
        return p.getProperty( REUSE_LOADER_REF ) != null;
    }

    public static class Delegate
    {

        private final org.apache.tools.ant.ProjectComponent component;

        private org.apache.tools.ant.types.Path classpath;

        private java.lang.String classpathId;

        private java.lang.String className;

        private java.lang.String loaderId;

        private boolean reverseLoader = false;

        Delegate( org.apache.tools.ant.ProjectComponent component )
        {
            this.component = component;
        }

        public  void setClasspath( org.apache.tools.ant.types.Path classpath )
        {
            if (this.classpath == null) {
                this.classpath = classpath;
            } else {
                this.classpath.append( classpath );
            }
        }

        public  org.apache.tools.ant.types.Path createClasspath()
        {
            if (this.classpath == null) {
                this.classpath = new org.apache.tools.ant.types.Path( component.getProject() );
            }
            return this.classpath.createPath();
        }

        public  void setClassname( java.lang.String fcqn )
        {
            this.className = fcqn;
        }

        public  void setClasspathref( org.apache.tools.ant.types.Reference r )
        {
            this.classpathId = r.getRefId();
            createClasspath().setRefid( r );
        }

        public  void setReverseLoader( boolean reverseLoader )
        {
            this.reverseLoader = reverseLoader;
        }

        public  void setLoaderRef( org.apache.tools.ant.types.Reference r )
        {
            this.loaderId = r.getRefId();
        }

        public  java.lang.ClassLoader getClassLoader()
        {
            return getClassLoaderForPath( getContextProject(), classpath, getClassLoadId(), reverseLoader, loaderId != null || isMagicPropertySet( getContextProject() ) );
        }

        private  org.apache.tools.ant.Project getContextProject()
        {
            return component.getProject();
        }

        public  java.lang.String getClassLoadId()
        {
            if (loaderId == null && classpathId != null) {
                return MagicNames.REFID_CLASSPATH_LOADER_PREFIX + classpathId;
            } else {
                return loaderId;
            }
        }

        public  java.lang.Object newInstance()
        {
            return ClasspathUtils.newInstance( this.className, getClassLoader() );
        }

        public  org.apache.tools.ant.types.Path getClasspath()
        {
            return classpath;
        }

        public  boolean isReverseLoader()
        {
            return reverseLoader;
        }

    }

}
