// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import org.w3c.dom.Attr;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;


public class DOMElementWriter
{

    private static final int HEX = 16;

    private static final java.lang.String[] WS_ENTITIES = new java.lang.String['\r' - '\t' + 1];

    static {
        for (int i = '\t'; i < '\r' + 1; i++) {
            WS_ENTITIES[i - '\t'] = "&#x" + Integer.toHexString( i ) + ";";
        }
    }

    private static final java.lang.String NS = "ns";

    private boolean xmlDeclaration = true;

    private org.apache.tools.ant.util.DOMElementWriter.XmlNamespacePolicy namespacePolicy = XmlNamespacePolicy.IGNORE;

    private java.util.HashMap nsPrefixMap = new java.util.HashMap();

    private int nextPrefix = 0;

    private java.util.HashMap nsURIByElement = new java.util.HashMap();

    public static class XmlNamespacePolicy
    {

        private boolean qualifyElements;

        private boolean qualifyAttributes;

        public static final org.apache.tools.ant.util.DOMElementWriter.XmlNamespacePolicy IGNORE = new org.apache.tools.ant.util.DOMElementWriter.XmlNamespacePolicy( false, false );

        public static final org.apache.tools.ant.util.DOMElementWriter.XmlNamespacePolicy ONLY_QUALIFY_ELEMENTS = new org.apache.tools.ant.util.DOMElementWriter.XmlNamespacePolicy( true, false );

        public static final org.apache.tools.ant.util.DOMElementWriter.XmlNamespacePolicy QUALIFY_ALL = new org.apache.tools.ant.util.DOMElementWriter.XmlNamespacePolicy( true, true );

        public XmlNamespacePolicy( boolean qualifyElements, boolean qualifyAttributes )
        {
            this.qualifyElements = qualifyElements;
            this.qualifyAttributes = qualifyAttributes;
        }

    }

    public DOMElementWriter()
    {
    }

    public DOMElementWriter( boolean xmlDeclaration )
    {
        this( xmlDeclaration, XmlNamespacePolicy.IGNORE );
    }

    public DOMElementWriter( boolean xmlDeclaration, org.apache.tools.ant.util.DOMElementWriter.XmlNamespacePolicy namespacePolicy )
    {
        this.xmlDeclaration = xmlDeclaration;
        this.namespacePolicy = namespacePolicy;
    }

    private static java.lang.String lSep = System.getProperty( "line.separator" );

    protected java.lang.String[] knownEntities = { "gt", "amp", "lt", "apos", "quot" };

    public  void write( org.w3c.dom.Element root, java.io.OutputStream out )
        throws java.io.IOException
    {
        java.io.Writer wri = new java.io.OutputStreamWriter( out, "UTF8" );
        writeXMLDeclaration( wri );
        write( root, wri, 0, "  " );
        wri.flush();
    }

    public  void writeXMLDeclaration( java.io.Writer wri )
        throws java.io.IOException
    {
        if (xmlDeclaration) {
            wri.write( "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" );
        }
    }

    public  void write( org.w3c.dom.Element element, java.io.Writer out, int indent, java.lang.String indentWith )
        throws java.io.IOException
    {
        org.w3c.dom.NodeList children = element.getChildNodes();
        boolean hasChildren = children.getLength() > 0;
        boolean hasChildElements = false;
        openElement( element, out, indent, indentWith, hasChildren );
        if (hasChildren) {
            for (int i = 0; i < children.getLength(); i++) {
                org.w3c.dom.Node child = children.item( i );
                switch (child.getNodeType()) {
                case Node.ELEMENT_NODE :
                    hasChildElements = true;
                    if (i == 0) {
                        out.write( lSep );
                    }
                    write( (org.w3c.dom.Element) child, out, indent + 1, indentWith );
                    break;

                case Node.TEXT_NODE :
                    out.write( encode( child.getNodeValue() ) );
                    break;

                case Node.COMMENT_NODE :
                    out.write( "<!--" );
                    out.write( encode( child.getNodeValue() ) );
                    out.write( "-->" );
                    break;

                case Node.CDATA_SECTION_NODE :
                    out.write( "<![CDATA[" );
                    out.write( encodedata( ((org.w3c.dom.Text) child).getData() ) );
                    out.write( "]]>" );
                    break;

                case Node.ENTITY_REFERENCE_NODE :
                    out.write( '&' );
                    out.write( child.getNodeName() );
                    out.write( ';' );
                    break;

                case Node.PROCESSING_INSTRUCTION_NODE :
                    out.write( "<?" );
                    out.write( child.getNodeName() );
                    java.lang.String data = child.getNodeValue();
                    if (data != null && data.length() > 0) {
                        out.write( ' ' );
                        out.write( data );
                    }
                    out.write( "?>" );
                    break;

                default  :

                }
            }
            closeElement( element, out, indent, indentWith, hasChildElements );
        }
    }

    public  void openElement( org.w3c.dom.Element element, java.io.Writer out, int indent, java.lang.String indentWith )
        throws java.io.IOException
    {
        openElement( element, out, indent, indentWith, true );
    }

    public  void openElement( org.w3c.dom.Element element, java.io.Writer out, int indent, java.lang.String indentWith, boolean hasChildren )
        throws java.io.IOException
    {
        for (int i = 0; i < indent; i++) {
            out.write( indentWith );
        }
        out.write( "<" );
        if (namespacePolicy.qualifyElements) {
            java.lang.String uri = getNamespaceURI( element );
            java.lang.String prefix = (java.lang.String) nsPrefixMap.get( uri );
            if (prefix == null) {
                if (nsPrefixMap.isEmpty()) {
                    prefix = "";
                } else {
                    prefix = NS + nextPrefix++;
                }
                nsPrefixMap.put( uri, prefix );
                addNSDefinition( element, uri );
            }
            if (!"".equals( prefix )) {
                out.write( prefix );
                out.write( ":" );
            }
        }
        out.write( element.getTagName() );
        org.w3c.dom.NamedNodeMap attrs = element.getAttributes();
        for (int i = 0; i < attrs.getLength(); i++) {
            org.w3c.dom.Attr attr = (org.w3c.dom.Attr) attrs.item( i );
            out.write( " " );
            if (namespacePolicy.qualifyAttributes) {
                java.lang.String uri = getNamespaceURI( attr );
                java.lang.String prefix = (java.lang.String) nsPrefixMap.get( uri );
                if (prefix == null) {
                    prefix = NS + nextPrefix++;
                    nsPrefixMap.put( uri, prefix );
                    addNSDefinition( element, uri );
                }
                out.write( prefix );
                out.write( ":" );
            }
            out.write( attr.getName() );
            out.write( "=\"" );
            out.write( encodeAttributeValue( attr.getValue() ) );
            out.write( "\"" );
        }
        java.util.ArrayList al = (java.util.ArrayList) nsURIByElement.get( element );
        if (al != null) {
            java.util.Iterator iter = al.iterator();
            while (iter.hasNext()) {
                java.lang.String uri = (java.lang.String) iter.next();
                java.lang.String prefix = (java.lang.String) nsPrefixMap.get( uri );
                out.write( " xmlns" );
                if (!"".equals( prefix )) {
                    out.write( ":" );
                    out.write( prefix );
                }
                out.write( "=\"" );
                out.write( uri );
                out.write( "\"" );
            }
        }
        if (hasChildren) {
            out.write( ">" );
        } else {
            removeNSDefinitions( element );
            out.write( " />" );
            out.write( lSep );
            out.flush();
        }
    }

    public  void closeElement( org.w3c.dom.Element element, java.io.Writer out, int indent, java.lang.String indentWith, boolean hasChildren )
        throws java.io.IOException
    {
        if (hasChildren) {
            for (int i = 0; i < indent; i++) {
                out.write( indentWith );
            }
        }
        out.write( "</" );
        if (namespacePolicy.qualifyElements) {
            java.lang.String uri = getNamespaceURI( element );
            java.lang.String prefix = (java.lang.String) nsPrefixMap.get( uri );
            if (prefix != null && !"".equals( prefix )) {
                out.write( prefix );
                out.write( ":" );
            }
            removeNSDefinitions( element );
        }
        out.write( element.getTagName() );
        out.write( ">" );
        out.write( lSep );
        out.flush();
    }

    public  java.lang.String encode( java.lang.String value )
    {
        return encode( value, false );
    }

    public  java.lang.String encodeAttributeValue( java.lang.String value )
    {
        return encode( value, true );
    }

    private  java.lang.String encode( final java.lang.String value, final boolean encodeWhitespace )
    {
        final int len = value.length();
        final java.lang.StringBuffer sb = new java.lang.StringBuffer( len );
        for (int i = 0; i < len; i++) {
            final char c = value.charAt( i );
            switch (c) {
            case '<' :
                sb.append( "&lt;" );
                break;

            case '>' :
                sb.append( "&gt;" );
                break;

            case '\'' :
                sb.append( "&apos;" );
                break;

            case '\"' :
                sb.append( "&quot;" );
                break;

            case '&' :
                sb.append( "&amp;" );
                break;

            case '\r' :
            case '\n' :
            case '\t' :
                if (encodeWhitespace) {
                    sb.append( WS_ENTITIES[c - '\t'] );
                } else {
                    sb.append( c );
                }
                break;

            default  :
                if (isLegalCharacter( c )) {
                    sb.append( c );
                }
                break;

            }
        }
        return sb.substring( 0 );
    }

    public  java.lang.String encodedata( final java.lang.String value )
    {
        final int len = value.length();
        java.lang.StringBuffer sb = new java.lang.StringBuffer( len );
        for (int i = 0; i < len; ++i) {
            final char c = value.charAt( i );
            if (isLegalCharacter( c )) {
                sb.append( c );
            }
        }
        return StringUtils.replace( sb.substring( 0 ), "]]>", "]]]]><![CDATA[>" );
    }

    public  boolean isReference( java.lang.String ent )
    {
        if (!(ent.charAt( 0 ) == '&') || !ent.endsWith( ";" )) {
            return false;
        }
        if (ent.charAt( 1 ) == '#') {
            if (ent.charAt( 2 ) == 'x') {
                try {
                    Integer.parseInt( ent.substring( 3, ent.length() - 1 ), HEX );
                    return true;
                } catch ( java.lang.NumberFormatException nfe ) {
                    return false;
                }
            } else {
                try {
                    Integer.parseInt( ent.substring( 2, ent.length() - 1 ) );
                    return true;
                } catch ( java.lang.NumberFormatException nfe ) {
                    return false;
                }
            }
        }
        java.lang.String name = ent.substring( 1, ent.length() - 1 );
        for (int i = 0; i < knownEntities.length; i++) {
            if (name.equals( knownEntities[i] )) {
                return true;
            }
        }
        return false;
    }

    public  boolean isLegalCharacter( final char c )
    {
        if (c == 0x9 || c == 0xA || c == 0xD) {
            return true;
        } else {
            if (c < 0x20) {
                return false;
            } else {
                if (c <= 0xD7FF) {
                    return true;
                } else {
                    if (c < 0xE000) {
                        return false;
                    } else {
                        if (c <= 0xFFFD) {
                            return true;
                        }
                    }
                }
            }
        }
        return false;
    }

    private  void removeNSDefinitions( org.w3c.dom.Element element )
    {
        java.util.ArrayList al = (java.util.ArrayList) nsURIByElement.get( element );
        if (al != null) {
            java.util.Iterator iter = al.iterator();
            while (iter.hasNext()) {
                nsPrefixMap.remove( iter.next() );
            }
            nsURIByElement.remove( element );
        }
    }

    private  void addNSDefinition( org.w3c.dom.Element element, java.lang.String uri )
    {
        java.util.ArrayList al = (java.util.ArrayList) nsURIByElement.get( element );
        if (al == null) {
            al = new java.util.ArrayList();
            nsURIByElement.put( element, al );
        }
        al.add( uri );
    }

    private static  java.lang.String getNamespaceURI( org.w3c.dom.Node n )
    {
        java.lang.String uri = n.getNamespaceURI();
        if (uri == null) {
            uri = "";
        }
        return uri;
    }

}
