// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import java.text.ChoiceFormat;
import java.text.DateFormat;
import java.text.MessageFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;
import java.util.TimeZone;


public final class DateUtils
{

    private static final int ONE_SECOND = 1000;

    private static final int ONE_MINUTE = 60;

    private static final int ONE_HOUR = 60;

    private static final int TEN = 10;

    public static final java.lang.String ISO8601_DATETIME_PATTERN = "yyyy-MM-dd'T'HH:mm:ss";

    public static final java.lang.String ISO8601_DATE_PATTERN = "yyyy-MM-dd";

    public static final java.lang.String ISO8601_TIME_PATTERN = "HH:mm:ss";

    public static final java.text.DateFormat DATE_HEADER_FORMAT = new java.text.SimpleDateFormat( "EEE, dd MMM yyyy HH:mm:ss ", Locale.US );

    private static final java.text.DateFormat DATE_HEADER_FORMAT_INT = new java.text.SimpleDateFormat( "EEE, dd MMM yyyy HH:mm:ss ", Locale.US );

    private static final java.text.MessageFormat MINUTE_SECONDS = new java.text.MessageFormat( "{0}{1}" );

    private static final double[] LIMITS = { 0, 1, 2 };

    private static final java.lang.String[] MINUTES_PART = { "", "1 minute ", "{0,number,###############} minutes " };

    private static final java.lang.String[] SECONDS_PART = { "0 seconds", "1 second", "{1,number} seconds" };

    private static final java.text.ChoiceFormat MINUTES_FORMAT = new java.text.ChoiceFormat( LIMITS, MINUTES_PART );

    private static final java.text.ChoiceFormat SECONDS_FORMAT = new java.text.ChoiceFormat( LIMITS, SECONDS_PART );

    static {
        MINUTE_SECONDS.setFormat( 0, MINUTES_FORMAT );
        MINUTE_SECONDS.setFormat( 1, SECONDS_FORMAT );
    }

    private DateUtils()
    {
    }

    public static  java.lang.String format( long date, java.lang.String pattern )
    {
        return format( new java.util.Date( date ), pattern );
    }

    public static  java.lang.String format( java.util.Date date, java.lang.String pattern )
    {
        java.text.DateFormat df = createDateFormat( pattern );
        return df.format( date );
    }

    public static  java.lang.String formatElapsedTime( long millis )
    {
        long seconds = millis / ONE_SECOND;
        long minutes = seconds / ONE_MINUTE;
        java.lang.Object[] args = { new java.lang.Long( minutes ), new java.lang.Long( seconds % ONE_MINUTE ) };
        return MINUTE_SECONDS.format( args );
    }

    private static  java.text.DateFormat createDateFormat( java.lang.String pattern )
    {
        java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat( pattern );
        java.util.TimeZone gmt = TimeZone.getTimeZone( "GMT" );
        sdf.setTimeZone( gmt );
        sdf.setLenient( true );
        return sdf;
    }

    public static  int getPhaseOfMoon( java.util.Calendar cal )
    {
        int dayOfTheYear = cal.get( Calendar.DAY_OF_YEAR );
        int yearInMetonicCycle = (cal.get( Calendar.YEAR ) - 1900) % 19 + 1;
        int epact = (11 * yearInMetonicCycle + 18) % 30;
        if (epact == 25 && yearInMetonicCycle > 11 || epact == 24) {
            epact++;
        }
        return ((dayOfTheYear + epact) * 6 + 11) % 177 / 22 & 7;
    }

    public static  java.lang.String getDateForHeader()
    {
        java.util.Calendar cal = Calendar.getInstance();
        java.util.TimeZone tz = cal.getTimeZone();
        int offset = tz.getOffset( cal.get( Calendar.ERA ), cal.get( Calendar.YEAR ), cal.get( Calendar.MONTH ), cal.get( Calendar.DAY_OF_MONTH ), cal.get( Calendar.DAY_OF_WEEK ), cal.get( Calendar.MILLISECOND ) );
        java.lang.StringBuffer tzMarker = new java.lang.StringBuffer( offset < 0 ? "-" : "+" );
        offset = Math.abs( offset );
        int hours = offset / (ONE_HOUR * ONE_MINUTE * ONE_SECOND);
        int minutes = offset / (ONE_MINUTE * ONE_SECOND) - ONE_HOUR * hours;
        if (hours < TEN) {
            tzMarker.append( "0" );
        }
        tzMarker.append( hours );
        if (minutes < TEN) {
            tzMarker.append( "0" );
        }
        tzMarker.append( minutes );
        synchronized (DATE_HEADER_FORMAT_INT)
{
            return DATE_HEADER_FORMAT_INT.format( cal.getTime() ) + tzMarker.toString();
        }
    }

    public static  java.util.Date parseDateFromHeader( java.lang.String datestr )
        throws java.text.ParseException
    {
        synchronized (DATE_HEADER_FORMAT_INT)
{
            return DATE_HEADER_FORMAT_INT.parse( datestr );
        }
    }

    public static  java.util.Date parseIso8601DateTime( java.lang.String datestr )
        throws java.text.ParseException
    {
        return (new java.text.SimpleDateFormat( ISO8601_DATETIME_PATTERN )).parse( datestr );
    }

    public static  java.util.Date parseIso8601Date( java.lang.String datestr )
        throws java.text.ParseException
    {
        return (new java.text.SimpleDateFormat( ISO8601_DATE_PATTERN )).parse( datestr );
    }

    public static  java.util.Date parseIso8601DateTimeOrDate( java.lang.String datestr )
        throws java.text.ParseException
    {
        try {
            return parseIso8601DateTime( datestr );
        } catch ( java.text.ParseException px ) {
            return parseIso8601Date( datestr );
        }
    }

}
