// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import java.util.StringTokenizer;


public class DeweyDecimal
{

    private int[] components;

    public DeweyDecimal( final int[] components )
    {
        this.components = new int[components.length];
        System.arraycopy( components, 0, this.components, 0, components.length );
    }

    public DeweyDecimal( final java.lang.String string )
        throws java.lang.NumberFormatException
    {
        final java.util.StringTokenizer tokenizer = new java.util.StringTokenizer( string, ".", true );
        final int size = tokenizer.countTokens();
        components = new int[(size + 1) / 2];
        for (int i = 0; i < components.length; i++) {
            final java.lang.String component = tokenizer.nextToken();
            if (component.equals( "" )) {
                throw new java.lang.NumberFormatException( "Empty component in string" );
            }
            components[i] = Integer.parseInt( component );
            if (tokenizer.hasMoreTokens()) {
                tokenizer.nextToken();
                if (!tokenizer.hasMoreTokens()) {
                    throw new java.lang.NumberFormatException( "DeweyDecimal ended in a '.'" );
                }
            }
        }
    }

    public  int getSize()
    {
        return components.length;
    }

    public  int get( final int index )
    {
        return components[index];
    }

    public  boolean isEqual( final org.apache.tools.ant.util.DeweyDecimal other )
    {
        final int max = Math.max( other.components.length, components.length );
        for (int i = 0; i < max; i++) {
            final int component1 = i < components.length ? components[i] : 0;
            final int component2 = i < other.components.length ? other.components[i] : 0;
            if (component2 != component1) {
                return false;
            }
        }
        return true;
    }

    public  boolean isLessThan( final org.apache.tools.ant.util.DeweyDecimal other )
    {
        return !isGreaterThanOrEqual( other );
    }

    public  boolean isLessThanOrEqual( final org.apache.tools.ant.util.DeweyDecimal other )
    {
        return !isGreaterThan( other );
    }

    public  boolean isGreaterThan( final org.apache.tools.ant.util.DeweyDecimal other )
    {
        final int max = Math.max( other.components.length, components.length );
        for (int i = 0; i < max; i++) {
            final int component1 = i < components.length ? components[i] : 0;
            final int component2 = i < other.components.length ? other.components[i] : 0;
            if (component2 > component1) {
                return false;
            }
            if (component2 < component1) {
                return true;
            }
        }
        return false;
    }

    public  boolean isGreaterThanOrEqual( final org.apache.tools.ant.util.DeweyDecimal other )
    {
        final int max = Math.max( other.components.length, components.length );
        for (int i = 0; i < max; i++) {
            final int component1 = i < components.length ? components[i] : 0;
            final int component2 = i < other.components.length ? other.components[i] : 0;
            if (component2 > component1) {
                return false;
            }
            if (component2 < component1) {
                return true;
            }
        }
        return true;
    }

    public  java.lang.String toString()
    {
        final java.lang.StringBuffer sb = new java.lang.StringBuffer();
        for (int i = 0; i < components.length; i++) {
            if (i != 0) {
                sb.append( '.' );
            }
            sb.append( components[i] );
        }
        return sb.toString();
    }

}
