// This is a mutant program.
// Author : ysma

package org.apache.tools.ant.util;


import java.io.IOException;
import java.io.OutputStream;


public class OutputStreamFunneler
{

    public static final long DEFAULT_TIMEOUT_MILLIS = 1000;

    private final class Funnel extends java.io.OutputStream
    {

        private boolean closed = false;

        private Funnel()
        {
            synchronized (OutputStreamFunneler.this)
{
                ++count;
            }
        }

        public  void flush()
                throws java.io.IOException
        {
            synchronized (OutputStreamFunneler.this)
{
                dieIfClosed();
                out.flush();
            }
        }

        public  void write( int b )
                throws java.io.IOException
        {
            synchronized (OutputStreamFunneler.this)
{
                dieIfClosed();
                out.write( b );
            }
        }

        public  void write( byte[] b )
                throws java.io.IOException
        {
            synchronized (OutputStreamFunneler.this)
{
                dieIfClosed();
                out.write( b );
            }
        }

        public  void write( byte[] b, int off, int len )
                throws java.io.IOException
        {
            synchronized (OutputStreamFunneler.this)
{
                dieIfClosed();
                out.write( b, off, len );
            }
        }

        public  void close()
                throws java.io.IOException
        {
            release( this );
        }

    }

    private java.io.OutputStream out;

    private int count = 0;

    private boolean closed;

    private long timeoutMillis;

    public OutputStreamFunneler( java.io.OutputStream out )
    {
        this( out, DEFAULT_TIMEOUT_MILLIS );
    }

    public OutputStreamFunneler( java.io.OutputStream out, long timeoutMillis )
    {
        if (out == null) {
            throw new java.lang.IllegalArgumentException( "OutputStreamFunneler.<init>:  out == null" );
        }
        this.out = out;
        this.closed = false;
        setTimeout( timeoutMillis );
    }

    public synchronized  void setTimeout( long timeoutMillis )
    {
        this.timeoutMillis = timeoutMillis;
    }

    public synchronized  java.io.OutputStream getFunnelInstance()
        throws java.io.IOException
    {
        dieIfClosed();
        try {
            return new org.apache.tools.ant.util.OutputStreamFunneler.Funnel();
        } finally 
{
            notifyAll();
        }
    }

    private synchronized  void release( org.apache.tools.ant.util.OutputStreamFunneler.Funnel funnel )
        throws java.io.IOException
    {
        if (!funnel.closed) {
            try {
                if (timeoutMillis > 0) {
                    try {
                        wait( timeoutMillis );
                    } catch ( java.lang.InterruptedException eyeEx ) {
                    }
                }
                if (--count == 0) {
                    close();
                }
            } finally 
{
                funnel.closed = true;
            }
        }
    }

    private synchronized  void close()
        throws java.io.IOException
    {
        try {
            dieIfClosed();
            out.close();
        } finally 
{
            closed = true;
        }
    }

    private synchronized  void dieIfClosed()
        throws java.io.IOException
    {
        if (closed) {
            throw new java.io.IOException( "The funneled OutputStream has been closed." );
        }
    }

}
