// This is a mutant program.
// Author : ysma

package org.apache.tools.mail;


import java.io.IOException;
import java.io.PrintStream;
import java.io.BufferedOutputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.net.InetAddress;
import java.util.Vector;
import java.util.Enumeration;


public class MailMessage
{

    public static final java.lang.String DEFAULT_HOST = "localhost";

    public static final int DEFAULT_PORT = 25;

    private java.lang.String host;

    private int port = DEFAULT_PORT;

    private java.lang.String from;

    private java.util.Vector replyto;

    private java.util.Vector to;

    private java.util.Vector cc;

    private java.util.Vector headersKeys;

    private java.util.Vector headersValues;

    private org.apache.tools.mail.MailPrintStream out;

    private org.apache.tools.mail.SmtpResponseReader in;

    private java.net.Socket socket;

    private static final int OK_READY = 220;

    private static final int OK_HELO = 250;

    private static final int OK_FROM = 250;

    private static final int OK_RCPT_1 = 250;

    private static final int OK_RCPT_2 = 251;

    private static final int OK_DATA = 354;

    private static final int OK_DOT = 250;

    private static final int OK_QUIT = 221;

    public MailMessage()
        throws java.io.IOException
    {
        this( DEFAULT_HOST, DEFAULT_PORT );
    }

    public MailMessage( java.lang.String host )
        throws java.io.IOException
    {
        this( host, DEFAULT_PORT );
    }

    public MailMessage( java.lang.String host, int port )
        throws java.io.IOException
    {
        this.port = port;
        this.host = host;
        replyto = new java.util.Vector();
        to = new java.util.Vector();
        cc = new java.util.Vector();
        headersKeys = new java.util.Vector();
        headersValues = new java.util.Vector();
        connect();
        sendHelo();
    }

    public  void setPort( int port )
    {
        this.port = port;
    }

    public  void from( java.lang.String from )
        throws java.io.IOException
    {
        sendFrom( from );
        this.from = from;
    }

    public  void replyto( java.lang.String rto )
    {
        this.replyto.addElement( rto );
    }

    public  void to( java.lang.String to )
        throws java.io.IOException
    {
        sendRcpt( to );
        this.to.addElement( to );
    }

    public  void cc( java.lang.String cc )
        throws java.io.IOException
    {
        sendRcpt( cc );
        this.cc.addElement( cc );
    }

    public  void bcc( java.lang.String bcc )
        throws java.io.IOException
    {
        sendRcpt( bcc );
    }

    public  void setSubject( java.lang.String subj )
    {
        setHeader( "Subject", subj );
    }

    public  void setHeader( java.lang.String name, java.lang.String value )
    {
        headersKeys.add( name );
        headersValues.add( value );
    }

    public  java.io.PrintStream getPrintStream()
        throws java.io.IOException
    {
        setFromHeader();
        setReplyToHeader();
        setToHeader();
        setCcHeader();
        setHeader( "X-Mailer", "org.apache.tools.mail.MailMessage (ant.apache.org)" );
        sendData();
        flushHeaders();
        return out;
    }

     void setFromHeader()
    {
        setHeader( "From", from );
    }

     void setReplyToHeader()
    {
        if (!replyto.isEmpty()) {
            setHeader( "Reply-To", vectorToList( replyto ) );
        }
    }

     void setToHeader()
    {
        if (!to.isEmpty()) {
            setHeader( "To", vectorToList( to ) );
        }
    }

     void setCcHeader()
    {
        if (!cc.isEmpty()) {
            setHeader( "Cc", vectorToList( cc ) );
        }
    }

     java.lang.String vectorToList( java.util.Vector v )
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer();
        java.util.Enumeration e = v.elements();
        while (e.hasMoreElements()) {
            buf.append( e.nextElement() );
            if (e.hasMoreElements()) {
                buf.append( ", " );
            }
        }
        return buf.toString();
    }

     void flushHeaders()
        throws java.io.IOException
    {
        final int size = headersKeys.size();
        for (int i = 0; i < size; i++) {
            java.lang.String name = (java.lang.String) headersKeys.elementAt( i );
            java.lang.String value = (java.lang.String) headersValues.elementAt( i );
            out.println( name + ": " + value );
        }
        out.println();
        out.flush();
    }

    public  void sendAndClose()
        throws java.io.IOException
    {
        try {
            sendDot();
            sendQuit();
        } finally 
{
            disconnect();
        }
    }

    static  java.lang.String sanitizeAddress( java.lang.String s )
    {
        int paramDepth = 0;
        int start = 0;
        int end = 0;
        int len = s.length();
        for (int i = 0; i < len; i++) {
            char c = s.charAt( i );
            if (c == '(') {
                paramDepth++;
                if (start == 0) {
                    end = i;
                }
            } else {
                if (c == ')') {
                    paramDepth--;
                    if (end == 0) {
                        start = i + 1;
                    }
                } else {
                    if (paramDepth == 0 && c == '<') {
                        start = i + 1;
                    } else {
                        if (paramDepth == 0 && c == '>') {
                            end = i;
                        }
                    }
                }
            }
        }
        if (end == 0) {
            end = len;
        }
        return s.substring( start, end );
    }

     void connect()
        throws java.io.IOException
    {
        socket = new java.net.Socket( host, port );
        out = new org.apache.tools.mail.MailPrintStream( new java.io.BufferedOutputStream( socket.getOutputStream() ) );
        in = new org.apache.tools.mail.SmtpResponseReader( socket.getInputStream() );
        getReady();
    }

     void getReady()
        throws java.io.IOException
    {
        java.lang.String response = in.getResponse();
        int[] ok = { OK_READY };
        if (!isResponseOK( response, ok )) {
            throw new java.io.IOException( "Didn't get introduction from server: " + response );
        }
    }

     void sendHelo()
        throws java.io.IOException
    {
        java.lang.String local = InetAddress.getLocalHost().getHostName();
        int[] ok = { OK_HELO };
        send( "HELO " + local, ok );
    }

     void sendFrom( java.lang.String from )
        throws java.io.IOException
    {
        int[] ok = { OK_FROM };
        send( "MAIL FROM: " + "<" + sanitizeAddress( from ) + ">", ok );
    }

     void sendRcpt( java.lang.String rcpt )
        throws java.io.IOException
    {
        int[] ok = { OK_RCPT_1, OK_RCPT_2 };
        send( "RCPT TO: " + "<" + sanitizeAddress( rcpt ) + ">", ok );
    }

     void sendData()
        throws java.io.IOException
    {
        int[] ok = { OK_DATA };
        send( "DATA", ok );
    }

     void sendDot()
        throws java.io.IOException
    {
        int[] ok = { OK_DOT };
        send( "\r\n.", ok );
    }

     void sendQuit()
        throws java.io.IOException
    {
        int[] ok = { OK_QUIT };
        try {
            send( "QUIT", ok );
        } catch ( java.io.IOException e ) {
            throw new org.apache.tools.mail.ErrorInQuitException( e );
        }
    }

     void send( java.lang.String msg, int[] ok )
        throws java.io.IOException
    {
        out.rawPrint( msg + "\r\n" );
        java.lang.String response = in.getResponse();
        if (!isResponseOK( response, ok )) {
            throw new java.io.IOException( "Unexpected reply to command: " + msg + ": " + response );
        }
    }

     boolean isResponseOK( java.lang.String response, int[] ok )
    {
        for (int i = 0; i < ok.length; i++) {
            if (response.startsWith( "" + ok[i] )) {
                return true;
            }
        }
        return false;
    }

     void disconnect()
        throws java.io.IOException
    {
        if (out != null) {
            out.close();
        }
        if (in != null) {
            try {
                in.close();
            } catch ( java.io.IOException e ) {
            }
        }
        if (socket != null) {
            try {
                socket.close();
            } catch ( java.io.IOException e ) {
            }
        }
    }

}

class MailPrintStream extends java.io.PrintStream
{

    private int lastChar;

    public MailPrintStream( java.io.OutputStream out )
    {
        super( out, true );
    }

    public  void write( int b )
    {
        if (b == '\n' && lastChar != '\r') {
            rawWrite( '\r' );
            rawWrite( b );
        } else {
            if (b == '.' && lastChar == '\n') {
                rawWrite( '.' );
                rawWrite( b );
            } else {
                rawWrite( b );
            }
        }
        lastChar = b;
    }

    public  void write( byte[] buf, int off, int len )
    {
        for (int i = 0; i < len; i++) {
            write( buf[off + i] );
        }
    }

     void rawWrite( int b )
    {
        super.write( b );
    }

     void rawPrint( java.lang.String s )
    {
        int len = s.length();
        for (int i = 0; i < len; i++) {
            rawWrite( s.charAt( i ) );
        }
    }

}
