// This is a mutant program.
// Author : ysma

package org.apache.tools.zip;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.zip.ZipException;


public class ExtraFieldUtils
{

    private static final int WORD = 4;

    private static final java.util.Map implementations;

    static {
        implementations = new java.util.HashMap();
        register( org.apache.tools.zip.AsiExtraField.class );
        register( org.apache.tools.zip.JarMarker.class );
        register( org.apache.tools.zip.UnicodePathExtraField.class );
        register( org.apache.tools.zip.UnicodeCommentExtraField.class );
    }

    public static  void register( java.lang.Class c )
    {
        try {
            org.apache.tools.zip.ZipExtraField ze = (org.apache.tools.zip.ZipExtraField) c.newInstance();
            implementations.put( ze.getHeaderId(), c );
        } catch ( java.lang.ClassCastException cc ) {
            throw new java.lang.RuntimeException( c + " doesn\'t implement ZipExtraField" );
        } catch ( java.lang.InstantiationException ie ) {
            throw new java.lang.RuntimeException( c + " is not a concrete class" );
        } catch ( java.lang.IllegalAccessException ie ) {
            throw new java.lang.RuntimeException( c + "\'s no-arg constructor is not public" );
        }
    }

    public static  org.apache.tools.zip.ZipExtraField createExtraField( org.apache.tools.zip.ZipShort headerId )
        throws java.lang.InstantiationException, java.lang.IllegalAccessException
    {
        java.lang.Class c = (java.lang.Class) implementations.get( headerId );
        if (c != null) {
            return (org.apache.tools.zip.ZipExtraField) c.newInstance();
        }
        org.apache.tools.zip.UnrecognizedExtraField u = new org.apache.tools.zip.UnrecognizedExtraField();
        u.setHeaderId( headerId );
        return u;
    }

    public static  org.apache.tools.zip.ZipExtraField[] parse( byte[] data )
        throws java.util.zip.ZipException
    {
        return parse( data, true, UnparseableExtraField.THROW );
    }

    public static  org.apache.tools.zip.ZipExtraField[] parse( byte[] data, boolean local )
        throws java.util.zip.ZipException
    {
        return parse( data, local, UnparseableExtraField.THROW );
    }

    public static  org.apache.tools.zip.ZipExtraField[] parse( byte[] data, boolean local, org.apache.tools.zip.ExtraFieldUtils.UnparseableExtraField onUnparseableData )
        throws java.util.zip.ZipException
    {
        java.util.List v = new java.util.ArrayList();
        int start = 0;
        LOOP : 
        while (start <= data.length - WORD) {
            org.apache.tools.zip.ZipShort headerId = new org.apache.tools.zip.ZipShort( data, start );
            int length = (new org.apache.tools.zip.ZipShort( data, start + 2 )).getValue();
            if (start + WORD + length > data.length) {
                switch (onUnparseableData.getKey()) {
                case UnparseableExtraField.THROW_KEY :
                    throw new java.util.zip.ZipException( "bad extra field starting at " + start + ".  Block length of " + length + " bytes exceeds remaining" + " data of " + (data.length - start - WORD) + " bytes." );

                case UnparseableExtraField.READ_KEY :
                    org.apache.tools.zip.UnparseableExtraFieldData field = new org.apache.tools.zip.UnparseableExtraFieldData();
                    if (local) {
                        field.parseFromLocalFileData( data, start, data.length - start );
                    } else {
                        field.parseFromCentralDirectoryData( data, start, data.length - start );
                    }
                    v.add( field );

                case UnparseableExtraField.SKIP_KEY :
                    break LOOP;

                default  :
                    throw new java.util.zip.ZipException( "unknown UnparseableExtraField key: " + onUnparseableData.getKey() );

                }
            }
            try {
                org.apache.tools.zip.ZipExtraField ze = createExtraField( headerId );
                if (local || !(ze instanceof org.apache.tools.zip.CentralDirectoryParsingZipExtraField)) {
                    ze.parseFromLocalFileData( data, start + WORD, length );
                } else {
                    ((org.apache.tools.zip.CentralDirectoryParsingZipExtraField) ze).parseFromCentralDirectoryData( data, start + WORD, length );
                }
                v.add( ze );
            } catch ( java.lang.InstantiationException ie ) {
                throw new java.util.zip.ZipException( ie.getMessage() );
            } catch ( java.lang.IllegalAccessException iae ) {
                throw new java.util.zip.ZipException( iae.getMessage() );
            }
            start += length + WORD;
        }
        org.apache.tools.zip.ZipExtraField[] result = new org.apache.tools.zip.ZipExtraField[v.size()];
        return (org.apache.tools.zip.ZipExtraField[]) v.toArray( result );
    }

    public static  byte[] mergeLocalFileDataData( org.apache.tools.zip.ZipExtraField[] data )
    {
        final boolean lastIsUnparseableHolder = data.length > 0 && data[data.length - 1] instanceof org.apache.tools.zip.UnparseableExtraFieldData;
        int regularExtraFieldCount = lastIsUnparseableHolder ? data.length - 1 : data.length;
        int sum = WORD * regularExtraFieldCount;
        for (int i = 0; i < data.length; i++) {
            sum += data[i].getLocalFileDataLength().getValue();
        }
        byte[] result = new byte[sum];
        int start = 0;
        for (int i = 0; i < regularExtraFieldCount; i++) {
            System.arraycopy( data[i].getHeaderId().getBytes(), 0, result, start, 2 );
            System.arraycopy( data[i].getLocalFileDataLength().getBytes(), 0, result, start + 2, 2 );
            byte[] local = data[i].getLocalFileDataData();
            System.arraycopy( local, 0, result, start + WORD, local.length );
            start += local.length + WORD;
        }
        if (lastIsUnparseableHolder) {
            byte[] local = data[data.length - 1].getLocalFileDataData();
            System.arraycopy( local, 0, result, start, local.length );
        }
        return result;
    }

    public static  byte[] mergeCentralDirectoryData( org.apache.tools.zip.ZipExtraField[] data )
    {
        final boolean lastIsUnparseableHolder = data.length > 0 && data[data.length - 1] instanceof org.apache.tools.zip.UnparseableExtraFieldData;
        int regularExtraFieldCount = lastIsUnparseableHolder ? data.length - 1 : data.length;
        int sum = WORD * regularExtraFieldCount;
        for (int i = 0; i < data.length; i++) {
            sum += data[i].getCentralDirectoryLength().getValue();
        }
        byte[] result = new byte[sum];
        int start = 0;
        for (int i = 0; i < regularExtraFieldCount; i++) {
            System.arraycopy( data[i].getHeaderId().getBytes(), 0, result, start, 2 );
            System.arraycopy( data[i].getCentralDirectoryLength().getBytes(), 0, result, start + 2, 2 );
            byte[] local = data[i].getCentralDirectoryData();
            System.arraycopy( local, 0, result, start + WORD, local.length );
            start += local.length + WORD;
        }
        if (lastIsUnparseableHolder) {
            byte[] local = data[data.length - 1].getCentralDirectoryData();
            System.arraycopy( local, 0, result, start, local.length );
        }
        return result;
    }

    public static final class UnparseableExtraField
    {

        public static final int THROW_KEY = 0;

        public static final int SKIP_KEY = 1;

        public static final int READ_KEY = 2;

        public static final org.apache.tools.zip.ExtraFieldUtils.UnparseableExtraField THROW = new org.apache.tools.zip.ExtraFieldUtils.UnparseableExtraField( THROW_KEY );

        public static final org.apache.tools.zip.ExtraFieldUtils.UnparseableExtraField SKIP = new org.apache.tools.zip.ExtraFieldUtils.UnparseableExtraField( SKIP_KEY );

        public static final org.apache.tools.zip.ExtraFieldUtils.UnparseableExtraField READ = new org.apache.tools.zip.ExtraFieldUtils.UnparseableExtraField( READ_KEY );

        private final int key;

        private UnparseableExtraField( int k )
        {
            key = k;
        }

        public  int getKey()
        {
            return key;
        }

    }

}
