// This is a mutant program.
// Author : ysma

package org.apache.bcel.classfile;


import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;
import org.apache.bcel.Constants;


public final class ClassParser
{

    private java.io.DataInputStream file;

    private boolean fileOwned;

    private java.lang.String file_name;

    private java.lang.String zip_file;

    private int class_name_index;

    private int superclass_name_index;

    private int major;

    private int minor;

    private int access_flags;

    private int[] interfaces;

    private org.apache.bcel.classfile.ConstantPool constant_pool;

    private org.apache.bcel.classfile.Field[] fields;

    private org.apache.bcel.classfile.Method[] methods;

    private org.apache.bcel.classfile.Attribute[] attributes;

    private boolean is_zip;

    private static final int BUFSIZE = 8192;

    public ClassParser( java.io.InputStream file, java.lang.String file_name )
    {
        this.file_name = file_name;
        fileOwned = false;
        java.lang.String clazz = file.getClass().getName();
        is_zip = clazz.startsWith( "java.util.zip." ) || clazz.startsWith( "java.util.jar." );
        if (file instanceof java.io.DataInputStream) {
            this.file = (java.io.DataInputStream) file;
        } else {
            this.file = new java.io.DataInputStream( new java.io.BufferedInputStream( file, BUFSIZE ) );
        }
    }

    public ClassParser( java.lang.String file_name )
        throws java.io.IOException
    {
        is_zip = false;
        this.file_name = file_name;
        fileOwned = true;
    }

    public ClassParser( java.lang.String zip_file, java.lang.String file_name )
    {
        is_zip = true;
        fileOwned = true;
        this.zip_file = zip_file;
        this.file_name = file_name;
    }

    public  org.apache.bcel.classfile.JavaClass parse()
        throws java.io.IOException, org.apache.bcel.classfile.ClassFormatException
    {
        java.util.zip.ZipFile zip = null;
        try {
            if (fileOwned) {
                if (is_zip) {
                    zip = new java.util.zip.ZipFile( zip_file );
                    java.util.zip.ZipEntry entry = zip.getEntry( file_name );
                    file = new java.io.DataInputStream( new java.io.BufferedInputStream( zip.getInputStream( entry ), BUFSIZE ) );
                } else {
                    file = new java.io.DataInputStream( new java.io.BufferedInputStream( new java.io.FileInputStream( file_name ), BUFSIZE ) );
                }
            }
            readID();
            readVersion();
            readConstantPool();
            readClassInfo();
            readInterfaces();
            readFields();
            readMethods();
            readAttributes();
        } finally 
{
            if (fileOwned) {
                file.close();
                if (zip != null) {
                    zip.close();
                }
            }
        }
        return new org.apache.bcel.classfile.JavaClass( class_name_index, superclass_name_index, file_name, major, minor, access_flags, constant_pool, interfaces, fields, methods, attributes, is_zip ? JavaClass.ZIP : JavaClass.FILE );
    }

    private final  void readAttributes()
        throws java.io.IOException, org.apache.bcel.classfile.ClassFormatException
    {
        int attributes_count;
        attributes_count = file.readUnsignedShort();
        attributes = new org.apache.bcel.classfile.Attribute[attributes_count];
        for (int i = 0; i < attributes_count; i++) {
            attributes[i] = Attribute.readAttribute( file, constant_pool );
        }
    }

    private final  void readClassInfo()
        throws java.io.IOException, org.apache.bcel.classfile.ClassFormatException
    {
        access_flags = file.readUnsignedShort();
        if ((access_flags & Constants.ACC_INTERFACE) != 0) {
            access_flags |= Constants.ACC_ABSTRACT;
        }
        if ((access_flags & Constants.ACC_ABSTRACT) != 0 && (access_flags & Constants.ACC_FINAL) != 0) {
            throw new org.apache.bcel.classfile.ClassFormatException( "Class can't be both final and abstract" );
        }
        class_name_index = file.readUnsignedShort();
        superclass_name_index = file.readUnsignedShort();
    }

    private final  void readConstantPool()
        throws java.io.IOException, org.apache.bcel.classfile.ClassFormatException
    {
        constant_pool = new org.apache.bcel.classfile.ConstantPool( file );
    }

    private final  void readFields()
        throws java.io.IOException, org.apache.bcel.classfile.ClassFormatException
    {
        int fields_count;
        fields_count = file.readUnsignedShort();
        fields = new org.apache.bcel.classfile.Field[fields_count];
        for (int i = 0; i < fields_count; i++) {
            fields[i] = new org.apache.bcel.classfile.Field( file, constant_pool );
        }
    }

    private final  void readID()
        throws java.io.IOException, org.apache.bcel.classfile.ClassFormatException
    {
        int magic = 0xCAFEBABE;
        if (file.readInt() != magic) {
            throw new org.apache.bcel.classfile.ClassFormatException( file_name + " is not a Java .class file" );
        }
    }

    private final  void readInterfaces()
        throws java.io.IOException, org.apache.bcel.classfile.ClassFormatException
    {
        int interfaces_count;
        interfaces_count = file.readUnsignedShort();
        interfaces = new int[interfaces_count];
        for (int i = 0; i < interfaces_count; i++) {
            interfaces[i] = file.readUnsignedShort();
        }
    }

    private final  void readMethods()
        throws java.io.IOException, org.apache.bcel.classfile.ClassFormatException
    {
        int methods_count;
        methods_count = file.readUnsignedShort();
        methods = new org.apache.bcel.classfile.Method[methods_count];
        for (int i = 0; i < methods_count; i++) {
            methods[i] = new org.apache.bcel.classfile.Method( file, constant_pool );
        }
    }

    private final  void readVersion()
        throws java.io.IOException, org.apache.bcel.classfile.ClassFormatException
    {
        minor = file.readUnsignedShort();
        major = file.readUnsignedShort();
    }

}
