// This is a mutant program.
// Author : ysma

package org.apache.bcel.classfile;


import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.Serializable;
import org.apache.bcel.Constants;


public class ConstantPool implements java.lang.Cloneable, org.apache.bcel.classfile.Node, java.io.Serializable
{

    private int constant_pool_count;

    private org.apache.bcel.classfile.Constant[] constant_pool;

    public ConstantPool( org.apache.bcel.classfile.Constant[] constant_pool )
    {
        setConstantPool( constant_pool );
    }

    ConstantPool( java.io.DataInputStream file )
        throws java.io.IOException, org.apache.bcel.classfile.ClassFormatException
    {
        byte tag;
        constant_pool_count = file.readUnsignedShort();
        constant_pool = new org.apache.bcel.classfile.Constant[constant_pool_count];
        for (int i = 1; i < constant_pool_count; i++) {
            constant_pool[i] = Constant.readConstant( file );
            tag = constant_pool[i].getTag();
            if (tag == Constants.CONSTANT_Double || tag == Constants.CONSTANT_Long) {
                i++;
            }
        }
    }

    public  void accept( org.apache.bcel.classfile.Visitor v )
    {
        v.visitConstantPool( this );
    }

    public  java.lang.String constantToString( org.apache.bcel.classfile.Constant c )
        throws org.apache.bcel.classfile.ClassFormatException
    {
        java.lang.String str;
        int i;
        byte tag = c.getTag();
        switch (tag) {
        case Constants.CONSTANT_Class :
            i = ((org.apache.bcel.classfile.ConstantClass) c).getNameIndex();
            c = getConstant( i, Constants.CONSTANT_Utf8 );
            str = Utility.compactClassName( ((org.apache.bcel.classfile.ConstantUtf8) c).getBytes(), false );
            break;

        case Constants.CONSTANT_String :
            i = ((org.apache.bcel.classfile.ConstantString) c).getStringIndex();
            c = getConstant( i, Constants.CONSTANT_Utf8 );
            str = "\"" + escape( ((org.apache.bcel.classfile.ConstantUtf8) c).getBytes() ) + "\"";
            break;

        case Constants.CONSTANT_Utf8 :
            str = ((org.apache.bcel.classfile.ConstantUtf8) c).getBytes();
            break;

        case Constants.CONSTANT_Double :
            str = "" + ((org.apache.bcel.classfile.ConstantDouble) c).getBytes();
            break;

        case Constants.CONSTANT_Float :
            str = "" + ((org.apache.bcel.classfile.ConstantFloat) c).getBytes();
            break;

        case Constants.CONSTANT_Long :
            str = "" + ((org.apache.bcel.classfile.ConstantLong) c).getBytes();
            break;

        case Constants.CONSTANT_Integer :
            str = "" + ((org.apache.bcel.classfile.ConstantInteger) c).getBytes();
            break;

        case Constants.CONSTANT_NameAndType :
            str = constantToString( ((org.apache.bcel.classfile.ConstantNameAndType) c).getNameIndex(), Constants.CONSTANT_Utf8 ) + " " + constantToString( ((org.apache.bcel.classfile.ConstantNameAndType) c).getSignatureIndex(), Constants.CONSTANT_Utf8 );
            break;

        case Constants.CONSTANT_InterfaceMethodref :
        case Constants.CONSTANT_Methodref :
        case Constants.CONSTANT_Fieldref :
            str = constantToString( ((org.apache.bcel.classfile.ConstantCP) c).getClassIndex(), Constants.CONSTANT_Class ) + "." + constantToString( ((org.apache.bcel.classfile.ConstantCP) c).getNameAndTypeIndex(), Constants.CONSTANT_NameAndType );
            break;

        default  :
            throw new java.lang.RuntimeException( "Unknown constant type " + tag );

        }
        return str;
    }

    private static final  java.lang.String escape( java.lang.String str )
    {
        int len = str.length();
        java.lang.StringBuffer buf = new java.lang.StringBuffer( len + 5 );
        char[] ch = str.toCharArray();
        for (int i = 0; i < len; i++) {
            switch (ch[i]) {
            case '\n' :
                buf.append( "\\n" );
                break;

            case '\r' :
                buf.append( "\\r" );
                break;

            case '\t' :
                buf.append( "\\t" );
                break;

            case '\b' :
                buf.append( "\\b" );
                break;

            case '"' :
                buf.append( "\\\"" );
                break;

            default  :
                buf.append( ch[i] );

            }
        }
        return buf.toString();
    }

    public  java.lang.String constantToString( int index, byte tag )
        throws org.apache.bcel.classfile.ClassFormatException
    {
        org.apache.bcel.classfile.Constant c = getConstant( index, tag );
        return constantToString( c );
    }

    public  void dump( java.io.DataOutputStream file )
        throws java.io.IOException
    {
        file.writeShort( constant_pool_count );
        for (int i = 1; i < constant_pool_count; i++) {
            if (constant_pool[i] != null) {
                constant_pool[i].dump( file );
            }
        }
    }

    public  org.apache.bcel.classfile.Constant getConstant( int index )
    {
        if (index >= constant_pool.length || index < 0) {
            throw new org.apache.bcel.classfile.ClassFormatException( "Invalid constant pool reference: " + index + ". Constant pool size is: " + constant_pool.length );
        }
        return constant_pool[index];
    }

    public  org.apache.bcel.classfile.Constant getConstant( int index, byte tag )
        throws org.apache.bcel.classfile.ClassFormatException
    {
        org.apache.bcel.classfile.Constant c;
        c = getConstant( index );
        if (c == null) {
            throw new org.apache.bcel.classfile.ClassFormatException( "Constant pool at index " + index + " is null." );
        }
        if (c.getTag() != tag) {
            throw new org.apache.bcel.classfile.ClassFormatException( "Expected class `" + Constants.CONSTANT_NAMES[tag] + "' at index " + index + " and got " + c );
        }
        return c;
    }

    public  org.apache.bcel.classfile.Constant[] getConstantPool()
    {
        return constant_pool;
    }

    public  java.lang.String getConstantString( int index, byte tag )
        throws org.apache.bcel.classfile.ClassFormatException
    {
        org.apache.bcel.classfile.Constant c;
        int i;
        c = getConstant( index, tag );
        switch (tag) {
        case Constants.CONSTANT_Class :
            i = ((org.apache.bcel.classfile.ConstantClass) c).getNameIndex();
            break;

        case Constants.CONSTANT_String :
            i = ((org.apache.bcel.classfile.ConstantString) c).getStringIndex();
            break;

        default  :
            throw new java.lang.RuntimeException( "getConstantString called with illegal tag " + tag );

        }
        c = getConstant( i, Constants.CONSTANT_Utf8 );
        return ((org.apache.bcel.classfile.ConstantUtf8) c).getBytes();
    }

    public  int getLength()
    {
        return constant_pool_count;
    }

    public  void setConstant( int index, org.apache.bcel.classfile.Constant constant )
    {
        constant_pool[index] = constant;
    }

    public  void setConstantPool( org.apache.bcel.classfile.Constant[] constant_pool )
    {
        this.constant_pool = constant_pool;
        constant_pool_count = constant_pool == null ? 0 : constant_pool.length;
    }

    public  java.lang.String toString()
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer();
        for (int i = 1; i < constant_pool_count; i++) {
            buf.append( i ).append( ")" ).append( constant_pool[i] ).append( "\n" );
        }
        return buf.toString();
    }

    public  org.apache.bcel.classfile.ConstantPool copy()
    {
        org.apache.bcel.classfile.ConstantPool c = null;
        try {
            c = (org.apache.bcel.classfile.ConstantPool) clone();
            c.constant_pool = new org.apache.bcel.classfile.Constant[constant_pool_count];
            for (int i = 1; i < constant_pool_count; i++) {
                if (constant_pool[i] != null) {
                    c.constant_pool[i] = constant_pool[i].copy();
                }
            }
        } catch ( java.lang.CloneNotSupportedException e ) {
        }
        return c;
    }

}
