// This is a mutant program.
// Author : ysma

package org.apache.bcel.classfile;


import java.util.Stack;


public class DescendingVisitor implements org.apache.bcel.classfile.Visitor
{

    private org.apache.bcel.classfile.JavaClass clazz;

    private org.apache.bcel.classfile.Visitor visitor;

    private java.util.Stack stack = new java.util.Stack();

    public  java.lang.Object predecessor()
    {
        return predecessor( 0 );
    }

    public  java.lang.Object predecessor( int level )
    {
        int size = stack.size();
        if (size < 2 || level < 0) {
            return null;
        } else {
            return stack.elementAt( size - (level + 2) );
        }
    }

    public  java.lang.Object current()
    {
        return stack.peek();
    }

    public DescendingVisitor( org.apache.bcel.classfile.JavaClass clazz, org.apache.bcel.classfile.Visitor visitor )
    {
        this.clazz = clazz;
        this.visitor = visitor;
    }

    public  void visit()
    {
        clazz.accept( this );
    }

    public  void visitJavaClass( org.apache.bcel.classfile.JavaClass _clazz )
    {
        stack.push( _clazz );
        _clazz.accept( visitor );
        org.apache.bcel.classfile.Field[] fields = _clazz.getFields();
        for (int i = 0; i < fields.length; i++) {
            fields[i].accept( this );
        }
        org.apache.bcel.classfile.Method[] methods = _clazz.getMethods();
        for (int i = 0; i < methods.length; i++) {
            methods[i].accept( this );
        }
        org.apache.bcel.classfile.Attribute[] attributes = _clazz.getAttributes();
        for (int i = 0; i < attributes.length; i++) {
            attributes[i].accept( this );
        }
        _clazz.getConstantPool().accept( this );
        stack.pop();
    }

    public  void visitField( org.apache.bcel.classfile.Field field )
    {
        stack.push( field );
        field.accept( visitor );
        org.apache.bcel.classfile.Attribute[] attributes = field.getAttributes();
        for (int i = 0; i < attributes.length; i++) {
            attributes[i].accept( this );
        }
        stack.pop();
    }

    public  void visitConstantValue( org.apache.bcel.classfile.ConstantValue cv )
    {
        stack.push( cv );
        cv.accept( visitor );
        stack.pop();
    }

    public  void visitMethod( org.apache.bcel.classfile.Method method )
    {
        stack.push( method );
        method.accept( visitor );
        org.apache.bcel.classfile.Attribute[] attributes = method.getAttributes();
        for (int i = 0; i < attributes.length; i++) {
            attributes[i].accept( this );
        }
        stack.pop();
    }

    public  void visitExceptionTable( org.apache.bcel.classfile.ExceptionTable table )
    {
        stack.push( table );
        table.accept( visitor );
        stack.pop();
    }

    public  void visitCode( org.apache.bcel.classfile.Code code )
    {
        stack.push( code );
        code.accept( visitor );
        org.apache.bcel.classfile.CodeException[] table = code.getExceptionTable();
        for (int i = 0; i < table.length; i++) {
            table[i].accept( this );
        }
        org.apache.bcel.classfile.Attribute[] attributes = code.getAttributes();
        for (int i = 0; i < attributes.length; i++) {
            attributes[i].accept( this );
        }
        stack.pop();
    }

    public  void visitCodeException( org.apache.bcel.classfile.CodeException ce )
    {
        stack.push( ce );
        ce.accept( visitor );
        stack.pop();
    }

    public  void visitLineNumberTable( org.apache.bcel.classfile.LineNumberTable table )
    {
        stack.push( table );
        table.accept( visitor );
        org.apache.bcel.classfile.LineNumber[] numbers = table.getLineNumberTable();
        for (int i = 0; i < numbers.length; i++) {
            numbers[i].accept( this );
        }
        stack.pop();
    }

    public  void visitLineNumber( org.apache.bcel.classfile.LineNumber number )
    {
        stack.push( number );
        number.accept( visitor );
        stack.pop();
    }

    public  void visitLocalVariableTable( org.apache.bcel.classfile.LocalVariableTable table )
    {
        stack.push( table );
        table.accept( visitor );
        org.apache.bcel.classfile.LocalVariable[] vars = table.getLocalVariableTable();
        for (int i = 0; i < vars.length; i++) {
            vars[i].accept( this );
        }
        stack.pop();
    }

    public  void visitStackMap( org.apache.bcel.classfile.StackMap table )
    {
        stack.push( table );
        table.accept( visitor );
        org.apache.bcel.classfile.StackMapEntry[] vars = table.getStackMap();
        for (int i = 0; i < vars.length; i++) {
            vars[i].accept( this );
        }
        stack.pop();
    }

    public  void visitStackMapEntry( org.apache.bcel.classfile.StackMapEntry var )
    {
        stack.push( var );
        var.accept( visitor );
        stack.pop();
    }

    public  void visitLocalVariable( org.apache.bcel.classfile.LocalVariable var )
    {
        stack.push( var );
        var.accept( visitor );
        stack.pop();
    }

    public  void visitConstantPool( org.apache.bcel.classfile.ConstantPool cp )
    {
        stack.push( cp );
        cp.accept( visitor );
        org.apache.bcel.classfile.Constant[] constants = cp.getConstantPool();
        for (int i = 1; i < constants.length; i++) {
            if (constants[i] != null) {
                constants[i].accept( this );
            }
        }
        stack.pop();
    }

    public  void visitConstantClass( org.apache.bcel.classfile.ConstantClass constant )
    {
        stack.push( constant );
        constant.accept( visitor );
        stack.pop();
    }

    public  void visitConstantDouble( org.apache.bcel.classfile.ConstantDouble constant )
    {
        stack.push( constant );
        constant.accept( visitor );
        stack.pop();
    }

    public  void visitConstantFieldref( org.apache.bcel.classfile.ConstantFieldref constant )
    {
        stack.push( constant );
        constant.accept( visitor );
        stack.pop();
    }

    public  void visitConstantFloat( org.apache.bcel.classfile.ConstantFloat constant )
    {
        stack.push( constant );
        constant.accept( visitor );
        stack.pop();
    }

    public  void visitConstantInteger( org.apache.bcel.classfile.ConstantInteger constant )
    {
        stack.push( constant );
        constant.accept( visitor );
        stack.pop();
    }

    public  void visitConstantInterfaceMethodref( org.apache.bcel.classfile.ConstantInterfaceMethodref constant )
    {
        stack.push( constant );
        constant.accept( visitor );
        stack.pop();
    }

    public  void visitConstantLong( org.apache.bcel.classfile.ConstantLong constant )
    {
        stack.push( constant );
        constant.accept( visitor );
        stack.pop();
    }

    public  void visitConstantMethodref( org.apache.bcel.classfile.ConstantMethodref constant )
    {
        stack.push( constant );
        constant.accept( visitor );
        stack.pop();
    }

    public  void visitConstantNameAndType( org.apache.bcel.classfile.ConstantNameAndType constant )
    {
        stack.push( constant );
        constant.accept( visitor );
        stack.pop();
    }

    public  void visitConstantString( org.apache.bcel.classfile.ConstantString constant )
    {
        stack.push( constant );
        constant.accept( visitor );
        stack.pop();
    }

    public  void visitConstantUtf8( org.apache.bcel.classfile.ConstantUtf8 constant )
    {
        stack.push( constant );
        constant.accept( visitor );
        stack.pop();
    }

    public  void visitInnerClasses( org.apache.bcel.classfile.InnerClasses ic )
    {
        stack.push( ic );
        ic.accept( visitor );
        org.apache.bcel.classfile.InnerClass[] ics = ic.getInnerClasses();
        for (int i = 0; i < ics.length; i++) {
            ics[i].accept( this );
        }
        stack.pop();
    }

    public  void visitInnerClass( org.apache.bcel.classfile.InnerClass inner )
    {
        stack.push( inner );
        inner.accept( visitor );
        stack.pop();
    }

    public  void visitDeprecated( org.apache.bcel.classfile.Deprecated attribute )
    {
        stack.push( attribute );
        attribute.accept( visitor );
        stack.pop();
    }

    public  void visitSignature( org.apache.bcel.classfile.Signature attribute )
    {
        stack.push( attribute );
        attribute.accept( visitor );
        stack.pop();
    }

    public  void visitSourceFile( org.apache.bcel.classfile.SourceFile attribute )
    {
        stack.push( attribute );
        attribute.accept( visitor );
        stack.pop();
    }

    public  void visitSynthetic( org.apache.bcel.classfile.Synthetic attribute )
    {
        stack.push( attribute );
        attribute.accept( visitor );
        stack.pop();
    }

    public  void visitUnknown( org.apache.bcel.classfile.Unknown attribute )
    {
        stack.push( attribute );
        attribute.accept( visitor );
        stack.pop();
    }

}
