// This is a mutant program.
// Author : ysma

package org.apache.bcel.classfile;


import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.Constants;


public final class LineNumberTable extends org.apache.bcel.classfile.Attribute
{

    private int line_number_table_length;

    private org.apache.bcel.classfile.LineNumber[] line_number_table;

    public LineNumberTable( org.apache.bcel.classfile.LineNumberTable c )
    {
        this( c.getNameIndex(), c.getLength(), c.getLineNumberTable(), c.getConstantPool() );
    }

    public LineNumberTable( int name_index, int length, org.apache.bcel.classfile.LineNumber[] line_number_table, org.apache.bcel.classfile.ConstantPool constant_pool )
    {
        super( Constants.ATTR_LINE_NUMBER_TABLE, name_index, length, constant_pool );
        setLineNumberTable( line_number_table );
    }

    LineNumberTable( int name_index, int length, java.io.DataInputStream file, org.apache.bcel.classfile.ConstantPool constant_pool )
        throws java.io.IOException
    {
        this( name_index, length, (org.apache.bcel.classfile.LineNumber[]) null, constant_pool );
        line_number_table_length = file.readUnsignedShort();
        line_number_table = new org.apache.bcel.classfile.LineNumber[line_number_table_length];
        for (int i = 0; i < line_number_table_length; i++) {
            line_number_table[i] = new org.apache.bcel.classfile.LineNumber( file );
        }
    }

    public  void accept( org.apache.bcel.classfile.Visitor v )
    {
        v.visitLineNumberTable( this );
    }

    public final  void dump( java.io.DataOutputStream file )
        throws java.io.IOException
    {
        super.dump( file );
        file.writeShort( line_number_table_length );
        for (int i = 0; i < line_number_table_length; i++) {
            line_number_table[i].dump( file );
        }
    }

    public final  org.apache.bcel.classfile.LineNumber[] getLineNumberTable()
    {
        return line_number_table;
    }

    public final  void setLineNumberTable( org.apache.bcel.classfile.LineNumber[] line_number_table )
    {
        this.line_number_table = line_number_table;
        line_number_table_length = line_number_table == null ? 0 : line_number_table.length;
    }

    public final  java.lang.String toString()
    {
        java.lang.StringBuffer buf = new java.lang.StringBuffer();
        java.lang.StringBuffer line = new java.lang.StringBuffer();
        java.lang.String newLine = System.getProperty( "line.separator", "\n" );
        for (int i = 0; i < line_number_table_length; i++) {
            line.append( line_number_table[i].toString() );
            if (i < line_number_table_length - 1) {
                line.append( ", " );
            }
            if (line.length() > 72) {
                line.append( newLine );
                buf.append( line.toString() );
                line.setLength( 0 );
            }
        }
        buf.append( line );
        return buf.toString();
    }

    public  int getSourceLine( int pos )
    {
        int l = 0;
        int r = line_number_table_length - 1;
        if (r < 0) {
            return -1;
        }
        int min_index = -1;
        int min = -1;
        do {
            int i = (l + r) / 2;
            int j = line_number_table[i].getStartPC();
            if (j == pos) {
                return line_number_table[i].getLineNumber();
            } else {
                if (pos < j) {
                    r = i - 1;
                } else {
                    l = i + 1;
                }
            }
            if (j < pos && j > min) {
                min = j;
                min_index = i;
            }
        } while (l <= r);
        if (min_index < 0) {
            return -1;
        }
        return line_number_table[min_index].getLineNumber();
    }

    public  org.apache.bcel.classfile.Attribute copy( org.apache.bcel.classfile.ConstantPool _constant_pool )
    {
        org.apache.bcel.classfile.LineNumberTable c = (org.apache.bcel.classfile.LineNumberTable) clone();
        c.line_number_table = new org.apache.bcel.classfile.LineNumber[line_number_table_length];
        for (int i = 0; i < line_number_table_length; i++) {
            c.line_number_table[i] = line_number_table[i].copy();
        }
        c.constant_pool = _constant_pool;
        return c;
    }

    public final  int getTableLength()
    {
        return line_number_table_length;
    }

}
