// This is a mutant program.
// Author : ysma

package org.apache.bcel.util;


import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.BitSet;
import org.apache.bcel.classfile.Attribute;
import org.apache.bcel.classfile.Code;
import org.apache.bcel.classfile.CodeException;
import org.apache.bcel.classfile.ConstantFieldref;
import org.apache.bcel.classfile.ConstantInterfaceMethodref;
import org.apache.bcel.classfile.ConstantMethodref;
import org.apache.bcel.classfile.ConstantNameAndType;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.LocalVariable;
import org.apache.bcel.classfile.LocalVariableTable;
import org.apache.bcel.classfile.Method;
import org.apache.bcel.classfile.Utility;


final class CodeHTML implements org.apache.bcel.Constants
{

    private java.lang.String class_name;

    private org.apache.bcel.classfile.Method[] methods;

    private java.io.PrintWriter file;

    private java.util.BitSet goto_set;

    private org.apache.bcel.classfile.ConstantPool constant_pool;

    private org.apache.bcel.util.ConstantHTML constant_html;

    private static boolean wide = false;

    CodeHTML( java.lang.String dir, java.lang.String class_name, org.apache.bcel.classfile.Method[] methods, org.apache.bcel.classfile.ConstantPool constant_pool, org.apache.bcel.util.ConstantHTML constant_html )
        throws java.io.IOException
    {
        this.class_name = class_name;
        this.methods = methods;
        this.constant_pool = constant_pool;
        this.constant_html = constant_html;
        file = new java.io.PrintWriter( new java.io.FileOutputStream( dir + class_name + "_code.html" ) );
        file.println( "<HTML><BODY BGCOLOR=\"#C0C0C0\">" );
        for (int i = 0; i < methods.length; i++) {
            writeMethod( methods[i], i );
        }
        file.println( "</BODY></HTML>" );
        file.close();
    }

    private final  java.lang.String codeToHTML( org.apache.bcel.util.ByteSequence bytes, int method_number )
        throws java.io.IOException
    {
        short opcode = (short) bytes.readUnsignedByte();
        java.lang.StringBuffer buf;
        java.lang.String name;
        java.lang.String signature;
        int default_offset = 0;
        int low;
        int high;
        int index;
        int class_index;
        int vindex;
        int constant;
        int[] jump_table;
        int no_pad_bytes = 0;
        int offset;
        buf = new java.lang.StringBuffer( 256 );
        buf.append( "<TT>" ).append( OPCODE_NAMES[opcode] ).append( "</TT></TD><TD>" );
        if (opcode == TABLESWITCH || opcode == LOOKUPSWITCH) {
            int remainder = bytes.getIndex() % 4;
            no_pad_bytes = remainder == 0 ? 0 : 4 - remainder;
            for (int i = 0; i < no_pad_bytes; i++) {
                bytes.readByte();
            }
            default_offset = bytes.readInt();
        }
        switch (opcode) {
        case TABLESWITCH :
            low = bytes.readInt();
            high = bytes.readInt();
            offset = bytes.getIndex() - 12 - no_pad_bytes - 1;
            default_offset += offset;
            buf.append( "<TABLE BORDER=1><TR>" );
            jump_table = new int[high - low + 1];
            for (int i = 0; i < jump_table.length; i++) {
                jump_table[i] = offset + bytes.readInt();
                buf.append( "<TH>" ).append( low + i ).append( "</TH>" );
            }
            buf.append( "<TH>default</TH></TR>\n<TR>" );
            for (int i = 0; i < jump_table.length; i++) {
                buf.append( "<TD><A HREF=\"#code" ).append( method_number ).append( "@" ).append( jump_table[i] ).append( "\">" ).append( jump_table[i] ).append( "</A></TD>" );
            }
            buf.append( "<TD><A HREF=\"#code" ).append( method_number ).append( "@" ).append( default_offset ).append( "\">" ).append( default_offset ).append( "</A></TD></TR>\n</TABLE>\n" );
            break;

        case LOOKUPSWITCH :
            int npairs = bytes.readInt();
            offset = bytes.getIndex() - 8 - no_pad_bytes - 1;
            jump_table = new int[npairs];
            default_offset += offset;
            buf.append( "<TABLE BORDER=1><TR>" );
            for (int i = 0; i < npairs; i++) {
                int match = bytes.readInt();
                jump_table[i] = offset + bytes.readInt();
                buf.append( "<TH>" ).append( match ).append( "</TH>" );
            }
            buf.append( "<TH>default</TH></TR>\n<TR>" );
            for (int i = 0; i < npairs; i++) {
                buf.append( "<TD><A HREF=\"#code" ).append( method_number ).append( "@" ).append( jump_table[i] ).append( "\">" ).append( jump_table[i] ).append( "</A></TD>" );
            }
            buf.append( "<TD><A HREF=\"#code" ).append( method_number ).append( "@" ).append( default_offset ).append( "\">" ).append( default_offset ).append( "</A></TD></TR>\n</TABLE>\n" );
            break;

        case GOTO :
        case IFEQ :
        case IFGE :
        case IFGT :
        case IFLE :
        case IFLT :
        case IFNE :
        case IFNONNULL :
        case IFNULL :
        case IF_ACMPEQ :
        case IF_ACMPNE :
        case IF_ICMPEQ :
        case IF_ICMPGE :
        case IF_ICMPGT :
        case IF_ICMPLE :
        case IF_ICMPLT :
        case IF_ICMPNE :
        case JSR :
            index = (int) (bytes.getIndex() + bytes.readShort() - 1);
            buf.append( "<A HREF=\"#code" ).append( method_number ).append( "@" ).append( index ).append( "\">" ).append( index ).append( "</A>" );
            break;

        case GOTO_W :
        case JSR_W :
            int windex = bytes.getIndex() + bytes.readInt() - 1;
            buf.append( "<A HREF=\"#code" ).append( method_number ).append( "@" ).append( windex ).append( "\">" ).append( windex ).append( "</A>" );
            break;

        case ALOAD :
        case ASTORE :
        case DLOAD :
        case DSTORE :
        case FLOAD :
        case FSTORE :
        case ILOAD :
        case ISTORE :
        case LLOAD :
        case LSTORE :
        case RET :
            if (wide) {
                vindex = bytes.readShort();
                wide = false;
            } else {
                vindex = bytes.readUnsignedByte();
            }
            buf.append( "%" ).append( vindex );
            break;

        case WIDE :
            wide = true;
            buf.append( "(wide)" );
            break;

        case NEWARRAY :
            buf.append( "<FONT COLOR=\"#00FF00\">" ).append( TYPE_NAMES[bytes.readByte()] ).append( "</FONT>" );
            break;

        case GETFIELD :
        case GETSTATIC :
        case PUTFIELD :
        case PUTSTATIC :
            index = bytes.readShort();
            org.apache.bcel.classfile.ConstantFieldref c1 = (org.apache.bcel.classfile.ConstantFieldref) constant_pool.getConstant( index, CONSTANT_Fieldref );
            class_index = c1.getClassIndex();
            name = constant_pool.getConstantString( class_index, CONSTANT_Class );
            name = Utility.compactClassName( name, false );
            index = c1.getNameAndTypeIndex();
            java.lang.String field_name = constant_pool.constantToString( index, CONSTANT_NameAndType );
            if (name.equals( class_name )) {
                buf.append( "<A HREF=\"" ).append( class_name ).append( "_methods.html#field" ).append( field_name ).append( "\" TARGET=Methods>" ).append( field_name ).append( "</A>\n" );
            } else {
                buf.append( constant_html.referenceConstant( class_index ) ).append( "." ).append( field_name );
            }
            break;

        case CHECKCAST :
        case INSTANCEOF :
        case NEW :
            index = bytes.readShort();
            buf.append( constant_html.referenceConstant( index ) );
            break;

        case INVOKESPECIAL :
        case INVOKESTATIC :
        case INVOKEVIRTUAL :
        case INVOKEINTERFACE :
            int m_index = bytes.readShort();
            java.lang.String str;
            if (opcode == INVOKEINTERFACE) {
                int nargs = bytes.readUnsignedByte();
                int reserved = bytes.readUnsignedByte();
                org.apache.bcel.classfile.ConstantInterfaceMethodref c = (org.apache.bcel.classfile.ConstantInterfaceMethodref) constant_pool.getConstant( m_index, CONSTANT_InterfaceMethodref );
                class_index = c.getClassIndex();
                str = constant_pool.constantToString( c );
                index = c.getNameAndTypeIndex();
            } else {
                org.apache.bcel.classfile.ConstantMethodref c = (org.apache.bcel.classfile.ConstantMethodref) constant_pool.getConstant( m_index, CONSTANT_Methodref );
                class_index = c.getClassIndex();
                str = constant_pool.constantToString( c );
                index = c.getNameAndTypeIndex();
            }
            name = Class2HTML.referenceClass( class_index );
            str = Class2HTML.toHTML( constant_pool.constantToString( constant_pool.getConstant( index, CONSTANT_NameAndType ) ) );
            org.apache.bcel.classfile.ConstantNameAndType c2 = (org.apache.bcel.classfile.ConstantNameAndType) constant_pool.getConstant( index, CONSTANT_NameAndType );
            signature = constant_pool.constantToString( c2.getSignatureIndex(), CONSTANT_Utf8 );
            java.lang.String[] args = Utility.methodSignatureArgumentTypes( signature, false );
            java.lang.String type = Utility.methodSignatureReturnType( signature, false );
            buf.append( name ).append( ".<A HREF=\"" ).append( class_name ).append( "_cp.html#cp" ).append( m_index ).append( "\" TARGET=ConstantPool>" ).append( str ).append( "</A>" ).append( "(" );
            for (int i = 0; i < args.length; i++) {
                buf.append( Class2HTML.referenceType( args[i] ) );
                if (i < args.length - 1) {
                    buf.append( ", " );
                }
            }
            buf.append( "):" ).append( Class2HTML.referenceType( type ) );
            break;

        case LDC_W :
        case LDC2_W :
            index = bytes.readShort();
            buf.append( "<A HREF=\"" ).append( class_name ).append( "_cp.html#cp" ).append( index ).append( "\" TARGET=\"ConstantPool\">" ).append( Class2HTML.toHTML( constant_pool.constantToString( index, constant_pool.getConstant( index ).getTag() ) ) ).append( "</a>" );
            break;

        case LDC :
            index = bytes.readUnsignedByte();
            buf.append( "<A HREF=\"" ).append( class_name ).append( "_cp.html#cp" ).append( index ).append( "\" TARGET=\"ConstantPool\">" ).append( Class2HTML.toHTML( constant_pool.constantToString( index, constant_pool.getConstant( index ).getTag() ) ) ).append( "</a>" );
            break;

        case ANEWARRAY :
            index = bytes.readShort();
            buf.append( constant_html.referenceConstant( index ) );
            break;

        case MULTIANEWARRAY :
            index = bytes.readShort();
            int dimensions = bytes.readByte();
            buf.append( constant_html.referenceConstant( index ) ).append( ":" ).append( dimensions ).append( "-dimensional" );
            break;

        case IINC :
            if (wide) {
                vindex = bytes.readShort();
                constant = bytes.readShort();
                wide = false;
            } else {
                vindex = bytes.readUnsignedByte();
                constant = bytes.readByte();
            }
            buf.append( "%" ).append( vindex ).append( " " ).append( constant );
            break;

        default  :
            if (NO_OF_OPERANDS[opcode] > 0) {
                for (int i = 0; i < TYPE_OF_OPERANDS[opcode].length; i++) {
                    switch (TYPE_OF_OPERANDS[opcode][i]) {
                    case T_BYTE :
                        buf.append( bytes.readUnsignedByte() );
                        break;

                    case T_SHORT :
                        buf.append( bytes.readShort() );
                        break;

                    case T_INT :
                        buf.append( bytes.readInt() );
                        break;

                    default  :
                        System.err.println( "Unreachable default case reached!" );
                        System.exit( -1 );

                    }
                    buf.append( "&nbsp;" );
                }
            }

        }
        buf.append( "</TD>" );
        return buf.toString();
    }

    private final  void findGotos( org.apache.bcel.util.ByteSequence bytes, org.apache.bcel.classfile.Method method, org.apache.bcel.classfile.Code code )
        throws java.io.IOException
    {
        int index;
        goto_set = new java.util.BitSet( bytes.available() );
        int opcode;
        if (code != null) {
            org.apache.bcel.classfile.CodeException[] ce = code.getExceptionTable();
            int len = ce.length;
            for (int i = 0; i < len; i++) {
                goto_set.set( ce[i].getStartPC() );
                goto_set.set( ce[i].getEndPC() );
                goto_set.set( ce[i].getHandlerPC() );
            }
            org.apache.bcel.classfile.Attribute[] attributes = code.getAttributes();
            for (int i = 0; i < attributes.length; i++) {
                if (attributes[i].getTag() == ATTR_LOCAL_VARIABLE_TABLE) {
                    org.apache.bcel.classfile.LocalVariable[] vars = ((org.apache.bcel.classfile.LocalVariableTable) attributes[i]).getLocalVariableTable();
                    for (int j = 0; j < vars.length; j++) {
                        int start = vars[j].getStartPC();
                        int end = (int) (start + vars[j].getLength());
                        goto_set.set( start );
                        goto_set.set( end );
                    }
                    break;
                }
            }
        }
        for (int i = 0; bytes.available() > 0; i++) {
            opcode = bytes.readUnsignedByte();
            switch (opcode) {
            case TABLESWITCH :
            case LOOKUPSWITCH :
                int remainder = bytes.getIndex() % 4;
                int no_pad_bytes = remainder == 0 ? 0 : 4 - remainder;
                int default_offset;
                int offset;
                for (int j = 0; j < no_pad_bytes; j++) {
                    bytes.readByte();
                }
                default_offset = bytes.readInt();
                if (opcode == TABLESWITCH) {
                    int low = bytes.readInt();
                    int high = bytes.readInt();
                    offset = bytes.getIndex() - 12 - no_pad_bytes - 1;
                    default_offset += offset;
                    goto_set.set( default_offset );
                    for (int j = 0; j < high - low + 1; j++) {
                        index = offset + bytes.readInt();
                        goto_set.set( index );
                    }
                } else {
                    int npairs = bytes.readInt();
                    offset = bytes.getIndex() - 8 - no_pad_bytes - 1;
                    default_offset += offset;
                    goto_set.set( default_offset );
                    for (int j = 0; j < npairs; j++) {
                        int match = bytes.readInt();
                        index = offset + bytes.readInt();
                        goto_set.set( index );
                    }
                }
                break;

            case GOTO :
            case IFEQ :
            case IFGE :
            case IFGT :
            case IFLE :
            case IFLT :
            case IFNE :
            case IFNONNULL :
            case IFNULL :
            case IF_ACMPEQ :
            case IF_ACMPNE :
            case IF_ICMPEQ :
            case IF_ICMPGE :
            case IF_ICMPGT :
            case IF_ICMPLE :
            case IF_ICMPLT :
            case IF_ICMPNE :
            case JSR :
                index = bytes.getIndex() + bytes.readShort() - 1;
                goto_set.set( index );
                break;

            case GOTO_W :
            case JSR_W :
                index = bytes.getIndex() + bytes.readInt() - 1;
                goto_set.set( index );
                break;

            default  :
                bytes.unreadByte();
                codeToHTML( bytes, 0 );

            }
        }
    }

    private  void writeMethod( org.apache.bcel.classfile.Method method, int method_number )
        throws java.io.IOException
    {
        java.lang.String signature = method.getSignature();
        java.lang.String[] args = Utility.methodSignatureArgumentTypes( signature, false );
        java.lang.String type = Utility.methodSignatureReturnType( signature, false );
        java.lang.String name = method.getName();
        java.lang.String html_name = Class2HTML.toHTML( name );
        java.lang.String access = Utility.accessToString( method.getAccessFlags() );
        access = Utility.replace( access, " ", "&nbsp;" );
        org.apache.bcel.classfile.Attribute[] attributes = method.getAttributes();
        file.print( "<P><B><FONT COLOR=\"#FF0000\">" + access + "</FONT>&nbsp;" + "<A NAME=method" + method_number + ">" + Class2HTML.referenceType( type ) + "</A>&nbsp<A HREF=\"" + class_name + "_methods.html#method" + method_number + "\" TARGET=Methods>" + html_name + "</A>(" );
        for (int i = 0; i < args.length; i++) {
            file.print( Class2HTML.referenceType( args[i] ) );
            if (i < args.length - 1) {
                file.print( ",&nbsp;" );
            }
        }
        file.println( ")</B></P>" );
        org.apache.bcel.classfile.Code c = null;
        byte[] code = null;
        if (attributes.length > 0) {
            file.print( "<H4>Attributes</H4><UL>\n" );
            for (int i = 0; i < attributes.length; i++) {
                byte tag = attributes[i].getTag();
                if (tag != ATTR_UNKNOWN) {
                    file.print( "<LI><A HREF=\"" + class_name + "_attributes.html#method" + method_number + "@" + i + "\" TARGET=Attributes>" + ATTRIBUTE_NAMES[tag] + "</A></LI>\n" );
                } else {
                    file.print( "<LI>" + attributes[i] + "</LI>" );
                }
                if (tag == ATTR_CODE) {
                    c = (org.apache.bcel.classfile.Code) attributes[i];
                    org.apache.bcel.classfile.Attribute[] attributes2 = c.getAttributes();
                    code = c.getCode();
                    file.print( "<UL>" );
                    for (int j = 0; j < attributes2.length; j++) {
                        tag = attributes2[j].getTag();
                        file.print( "<LI><A HREF=\"" + class_name + "_attributes.html#" + "method" + method_number + "@" + i + "@" + j + "\" TARGET=Attributes>" + ATTRIBUTE_NAMES[tag] + "</A></LI>\n" );
                    }
                    file.print( "</UL>" );
                }
            }
            file.println( "</UL>" );
        }
        if (code != null) {
            org.apache.bcel.util.ByteSequence stream = new org.apache.bcel.util.ByteSequence( code );
            stream.mark( stream.available() );
            findGotos( stream, method, c );
            stream.reset();
            file.println( "<TABLE BORDER=0><TR><TH ALIGN=LEFT>Byte<BR>offset</TH>" + "<TH ALIGN=LEFT>Instruction</TH><TH ALIGN=LEFT>Argument</TH>" );
            for (int i = 0; stream.available() > 0; i++) {
                int offset = stream.getIndex();
                java.lang.String str = codeToHTML( stream, method_number );
                java.lang.String anchor = "";
                if (goto_set.get( offset )) {
                    anchor = "<A NAME=code" + method_number + "@" + offset + "></A>";
                }
                java.lang.String anchor2;
                if (stream.getIndex() == code.length) {
                    anchor2 = "<A NAME=code" + method_number + "@" + code.length + ">" + offset + "</A>";
                } else {
                    anchor2 = "" + offset;
                }
                file.println( "<TR VALIGN=TOP><TD>" + anchor2 + "</TD><TD>" + anchor + str + "</TR>" );
            }
            file.println( "<TR><TD> </A></TD></TR>" );
            file.println( "</TABLE>" );
        }
    }

}
