// This is a mutant program.
// Author : ysma

package org.apache.bcel.verifier.structurals;


import org.apache.bcel.Constants;
import org.apache.bcel.Repository;
import org.apache.bcel.classfile.Constant;
import org.apache.bcel.classfile.ConstantClass;
import org.apache.bcel.classfile.ConstantDouble;
import org.apache.bcel.classfile.ConstantFieldref;
import org.apache.bcel.classfile.ConstantFloat;
import org.apache.bcel.classfile.ConstantInteger;
import org.apache.bcel.classfile.ConstantLong;
import org.apache.bcel.classfile.ConstantString;
import org.apache.bcel.classfile.Field;
import org.apache.bcel.classfile.JavaClass;
import org.apache.bcel.generic.*;
import org.apache.bcel.verifier.VerificationResult;
import org.apache.bcel.verifier.Verifier;
import org.apache.bcel.verifier.VerifierFactory;
import org.apache.bcel.verifier.exc.AssertionViolatedException;
import org.apache.bcel.verifier.exc.StructuralCodeConstraintException;


public class InstConstraintVisitor extends org.apache.bcel.generic.EmptyVisitor implements org.apache.bcel.generic.Visitor
{

    private static org.apache.bcel.generic.ObjectType GENERIC_ARRAY = new org.apache.bcel.generic.ObjectType( "org.apache.bcel.verifier.structurals.GenericArray" );

    public InstConstraintVisitor()
    {
    }

    private org.apache.bcel.verifier.structurals.Frame frame = null;

    private org.apache.bcel.generic.ConstantPoolGen cpg = null;

    private org.apache.bcel.generic.MethodGen mg = null;

    private  org.apache.bcel.verifier.structurals.OperandStack stack()
    {
        return frame.getStack();
    }

    private  org.apache.bcel.verifier.structurals.LocalVariables locals()
    {
        return frame.getLocals();
    }

    private  void constraintViolated( org.apache.bcel.generic.Instruction violator, java.lang.String description )
    {
        java.lang.String fq_classname = violator.getClass().getName();
        throw new org.apache.bcel.verifier.exc.StructuralCodeConstraintException( "Instruction " + fq_classname.substring( fq_classname.lastIndexOf( '.' ) + 1 ) + " constraint violated: " + description );
    }

    public  void setFrame( org.apache.bcel.verifier.structurals.Frame f )
    {
        this.frame = f;
    }

    public  void setConstantPoolGen( org.apache.bcel.generic.ConstantPoolGen cpg )
    {
        this.cpg = cpg;
    }

    public  void setMethodGen( org.apache.bcel.generic.MethodGen mg )
    {
        this.mg = mg;
    }

    private  void indexOfInt( org.apache.bcel.generic.Instruction o, org.apache.bcel.generic.Type index )
    {
        if (!index.equals( Type.INT )) {
            constraintViolated( o, "The 'index' is not of type int but of type " + index + "." );
        }
    }

    private  void referenceTypeIsInitialized( org.apache.bcel.generic.Instruction o, org.apache.bcel.generic.ReferenceType r )
    {
        if (r instanceof org.apache.bcel.verifier.structurals.UninitializedObjectType) {
            constraintViolated( o, "Working on an uninitialized object '" + r + "'." );
        }
    }

    private  void valueOfInt( org.apache.bcel.generic.Instruction o, org.apache.bcel.generic.Type value )
    {
        if (!value.equals( Type.INT )) {
            constraintViolated( o, "The 'value' is not of type int but of type " + value + "." );
        }
    }

    private  boolean arrayrefOfArrayType( org.apache.bcel.generic.Instruction o, org.apache.bcel.generic.Type arrayref )
    {
        if (!(arrayref instanceof org.apache.bcel.generic.ArrayType || arrayref.equals( Type.NULL ))) {
            constraintViolated( o, "The 'arrayref' does not refer to an array but is of type " + arrayref + "." );
        }
        return arrayref instanceof org.apache.bcel.generic.ArrayType;
    }

    private  void _visitStackAccessor( org.apache.bcel.generic.Instruction o )
    {
        int consume = o.consumeStack( cpg );
        if (consume > stack().slotsUsed()) {
            constraintViolated( (org.apache.bcel.generic.Instruction) o, "Cannot consume " + consume + " stack slots: only " + stack().slotsUsed() + " slot(s) left on stack!\nStack:\n" + stack() );
        }
        int produce = o.produceStack( cpg ) - ((org.apache.bcel.generic.Instruction) o).consumeStack( cpg );
        if (produce + stack().slotsUsed() > stack().maxStack()) {
            constraintViolated( (org.apache.bcel.generic.Instruction) o, "Cannot produce " + produce + " stack slots: only " + (stack().maxStack() - stack().slotsUsed()) + " free stack slot(s) left.\nStack:\n" + stack() );
        }
    }

    public  void visitLoadClass( org.apache.bcel.generic.LoadClass o )
    {
        org.apache.bcel.generic.ObjectType t = o.getLoadClassType( cpg );
        if (t != null) {
            org.apache.bcel.verifier.Verifier v = VerifierFactory.getVerifier( t.getClassName() );
            org.apache.bcel.verifier.VerificationResult vr = v.doPass2();
            if (vr.getStatus() != VerificationResult.VERIFIED_OK) {
                constraintViolated( (org.apache.bcel.generic.Instruction) o, "Class '" + o.getLoadClassType( cpg ).getClassName() + "' is referenced, but cannot be loaded and resolved: '" + vr + "'." );
            }
        }
    }

    public  void visitStackConsumer( org.apache.bcel.generic.StackConsumer o )
    {
        _visitStackAccessor( (org.apache.bcel.generic.Instruction) o );
    }

    public  void visitStackProducer( org.apache.bcel.generic.StackProducer o )
    {
        _visitStackAccessor( (org.apache.bcel.generic.Instruction) o );
    }

    public  void visitCPInstruction( org.apache.bcel.generic.CPInstruction o )
    {
        int idx = o.getIndex();
        if (idx < 0 || idx >= cpg.getSize()) {
            throw new org.apache.bcel.verifier.exc.AssertionViolatedException( "Huh?! Constant pool index of instruction '" + o + "' illegal? Pass 3a should have checked this!" );
        }
    }

    public  void visitFieldInstruction( org.apache.bcel.generic.FieldInstruction o )
    {
        org.apache.bcel.classfile.Constant c = cpg.getConstant( o.getIndex() );
        if (!(c instanceof org.apache.bcel.classfile.ConstantFieldref)) {
            constraintViolated( o, "Index '" + o.getIndex() + "' should refer to a CONSTANT_Fieldref_info structure, but refers to '" + c + "'." );
        }
        org.apache.bcel.generic.Type t = o.getType( cpg );
        if (t instanceof org.apache.bcel.generic.ObjectType) {
            java.lang.String name = ((org.apache.bcel.generic.ObjectType) t).getClassName();
            org.apache.bcel.verifier.Verifier v = VerifierFactory.getVerifier( name );
            org.apache.bcel.verifier.VerificationResult vr = v.doPass2();
            if (vr.getStatus() != VerificationResult.VERIFIED_OK) {
                constraintViolated( (org.apache.bcel.generic.Instruction) o, "Class '" + name + "' is referenced, but cannot be loaded and resolved: '" + vr + "'." );
            }
        }
    }

    public  void visitInvokeInstruction( org.apache.bcel.generic.InvokeInstruction o )
    {
    }

    public  void visitStackInstruction( org.apache.bcel.generic.StackInstruction o )
    {
        _visitStackAccessor( o );
    }

    public  void visitLocalVariableInstruction( org.apache.bcel.generic.LocalVariableInstruction o )
    {
        if (locals().maxLocals() <= (o.getType( cpg ).getSize() == 1 ? o.getIndex() : o.getIndex() + 1)) {
            constraintViolated( o, "The 'index' is not a valid index into the local variable array." );
        }
    }

    public  void visitLoadInstruction( org.apache.bcel.generic.LoadInstruction o )
    {
        if (locals().get( o.getIndex() ) == Type.UNKNOWN) {
            constraintViolated( o, "Read-Access on local variable " + o.getIndex() + " with unknown content." );
        }
        if (o.getType( cpg ).getSize() == 2) {
            if (locals().get( o.getIndex() + 1 ) != Type.UNKNOWN) {
                constraintViolated( o, "Reading a two-locals value from local variables " + o.getIndex() + " and " + (o.getIndex() + 1) + " where the latter one is destroyed." );
            }
        }
        if (!(o instanceof org.apache.bcel.generic.ALOAD)) {
            if (locals().get( o.getIndex() ) != o.getType( cpg )) {
                constraintViolated( o, "Local Variable type and LOADing Instruction type mismatch: Local Variable: '" + locals().get( o.getIndex() ) + "'; Instruction type: '" + o.getType( cpg ) + "'." );
            }
        } else {
            if (!(locals().get( o.getIndex() ) instanceof org.apache.bcel.generic.ReferenceType)) {
                constraintViolated( o, "Local Variable type and LOADing Instruction type mismatch: Local Variable: '" + locals().get( o.getIndex() ) + "'; Instruction expects a ReferenceType." );
            }
        }
        if (stack().maxStack() - stack().slotsUsed() < o.getType( cpg ).getSize()) {
            constraintViolated( o, "Not enough free stack slots to load a '" + o.getType( cpg ) + "' onto the OperandStack." );
        }
    }

    public  void visitStoreInstruction( org.apache.bcel.generic.StoreInstruction o )
    {
        if (stack().isEmpty()) {
            constraintViolated( o, "Cannot STORE: Stack to read from is empty." );
        }
        if (!(o instanceof org.apache.bcel.generic.ASTORE)) {
            if (!(stack().peek() == o.getType( cpg ))) {
                constraintViolated( o, "Stack top type and STOREing Instruction type mismatch: Stack top: '" + stack().peek() + "'; Instruction type: '" + o.getType( cpg ) + "'." );
            }
        } else {
            org.apache.bcel.generic.Type stacktop = stack().peek();
            if (!(stacktop instanceof org.apache.bcel.generic.ReferenceType) && !(stacktop instanceof org.apache.bcel.generic.ReturnaddressType)) {
                constraintViolated( o, "Stack top type and STOREing Instruction type mismatch: Stack top: '" + stack().peek() + "'; Instruction expects a ReferenceType or a ReturnadressType." );
            }
        }
    }

    public  void visitReturnInstruction( org.apache.bcel.generic.ReturnInstruction o )
    {
        org.apache.bcel.generic.Type method_type = mg.getType();
        if (method_type == Type.BOOLEAN || method_type == Type.BYTE || method_type == Type.SHORT || method_type == Type.CHAR) {
            method_type = Type.INT;
        }
        if (o instanceof org.apache.bcel.generic.RETURN) {
            if (method_type != Type.VOID) {
                constraintViolated( o, "RETURN instruction in non-void method." );
            } else {
                return;
            }
        }
        if (o instanceof org.apache.bcel.generic.ARETURN) {
            if (stack().peek() == Type.NULL) {
                return;
            } else {
                if (!(stack().peek() instanceof org.apache.bcel.generic.ReferenceType)) {
                    constraintViolated( o, "Reference type expected on top of stack, but is: '" + stack().peek() + "'." );
                }
                referenceTypeIsInitialized( o, (org.apache.bcel.generic.ReferenceType) stack().peek() );
            }
        } else {
            if (!method_type.equals( stack().peek() )) {
                constraintViolated( o, "Current method has return type of '" + mg.getType() + "' expecting a '" + method_type + "' on top of the stack. But stack top is a '" + stack().peek() + "'." );
            }
        }
    }

    public  void visitAALOAD( org.apache.bcel.generic.AALOAD o )
    {
        org.apache.bcel.generic.Type arrayref = stack().peek( 1 );
        org.apache.bcel.generic.Type index = stack().peek( 0 );
        indexOfInt( o, index );
        if (arrayrefOfArrayType( o, arrayref )) {
            if (!(((org.apache.bcel.generic.ArrayType) arrayref).getElementType() instanceof org.apache.bcel.generic.ReferenceType)) {
                constraintViolated( o, "The 'arrayref' does not refer to an array with elements of a ReferenceType but to an array of " + ((org.apache.bcel.generic.ArrayType) arrayref).getElementType() + "." );
            }
        }
    }

    public  void visitAASTORE( org.apache.bcel.generic.AASTORE o )
    {
        try {
            org.apache.bcel.generic.Type arrayref = stack().peek( 2 );
            org.apache.bcel.generic.Type index = stack().peek( 1 );
            org.apache.bcel.generic.Type value = stack().peek( 0 );
            indexOfInt( o, index );
            if (!(value instanceof org.apache.bcel.generic.ReferenceType)) {
                constraintViolated( o, "The 'value' is not of a ReferenceType but of type " + value + "." );
            }
            if (arrayrefOfArrayType( o, arrayref )) {
                if (!(((org.apache.bcel.generic.ArrayType) arrayref).getElementType() instanceof org.apache.bcel.generic.ReferenceType)) {
                    constraintViolated( o, "The 'arrayref' does not refer to an array with elements of a ReferenceType but to an array of " + ((org.apache.bcel.generic.ArrayType) arrayref).getElementType() + "." );
                }
                if (!((org.apache.bcel.generic.ReferenceType) value).isAssignmentCompatibleWith( (org.apache.bcel.generic.ReferenceType) ((org.apache.bcel.generic.ArrayType) arrayref).getElementType() )) {
                    constraintViolated( o, "The type of 'value' ('" + value + "') is not assignment compatible to the components of the array 'arrayref' refers to. ('" + ((org.apache.bcel.generic.ArrayType) arrayref).getElementType() + "')" );
                }
            }
        } catch ( java.lang.ClassNotFoundException e ) {
            throw new org.apache.bcel.verifier.exc.AssertionViolatedException( "Missing class: " + e.toString() );
        }
    }

    public  void visitACONST_NULL( org.apache.bcel.generic.ACONST_NULL o )
    {
    }

    public  void visitALOAD( org.apache.bcel.generic.ALOAD o )
    {
    }

    public  void visitANEWARRAY( org.apache.bcel.generic.ANEWARRAY o )
    {
        if (!stack().peek().equals( Type.INT )) {
            constraintViolated( o, "The 'count' at the stack top is not of type '" + Type.INT + "' but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitARETURN( org.apache.bcel.generic.ARETURN o )
    {
        if (!(stack().peek() instanceof org.apache.bcel.generic.ReferenceType)) {
            constraintViolated( o, "The 'objectref' at the stack top is not of a ReferenceType but of type '" + stack().peek() + "'." );
        }
        org.apache.bcel.generic.ReferenceType objectref = (org.apache.bcel.generic.ReferenceType) stack().peek();
        referenceTypeIsInitialized( o, objectref );
    }

    public  void visitARRAYLENGTH( org.apache.bcel.generic.ARRAYLENGTH o )
    {
        org.apache.bcel.generic.Type arrayref = stack().peek( 0 );
        arrayrefOfArrayType( o, arrayref );
    }

    public  void visitASTORE( org.apache.bcel.generic.ASTORE o )
    {
        if (!(stack().peek() instanceof org.apache.bcel.generic.ReferenceType || stack().peek() instanceof org.apache.bcel.generic.ReturnaddressType)) {
            constraintViolated( o, "The 'objectref' is not of a ReferenceType or of ReturnaddressType but of " + stack().peek() + "." );
        }
    }

    public  void visitATHROW( org.apache.bcel.generic.ATHROW o )
    {
        try {
            if (!(stack().peek() instanceof org.apache.bcel.generic.ObjectType || stack().peek().equals( Type.NULL ))) {
                constraintViolated( o, "The 'objectref' is not of an (initialized) ObjectType but of type " + stack().peek() + "." );
            }
            if (stack().peek().equals( Type.NULL )) {
                return;
            }
            org.apache.bcel.generic.ObjectType exc = (org.apache.bcel.generic.ObjectType) stack().peek();
            org.apache.bcel.generic.ObjectType throwable = (org.apache.bcel.generic.ObjectType) Type.getType( "Ljava/lang/Throwable;" );
            if (!exc.subclassOf( throwable ) && !exc.equals( throwable )) {
                constraintViolated( o, "The 'objectref' is not of class Throwable or of a subclass of Throwable, but of '" + stack().peek() + "'." );
            }
        } catch ( java.lang.ClassNotFoundException e ) {
            throw new org.apache.bcel.verifier.exc.AssertionViolatedException( "Missing class: " + e.toString() );
        }
    }

    public  void visitBALOAD( org.apache.bcel.generic.BALOAD o )
    {
        org.apache.bcel.generic.Type arrayref = stack().peek( 1 );
        org.apache.bcel.generic.Type index = stack().peek( 0 );
        indexOfInt( o, index );
        if (arrayrefOfArrayType( o, arrayref )) {
            if (!(((org.apache.bcel.generic.ArrayType) arrayref).getElementType().equals( Type.BOOLEAN ) || ((org.apache.bcel.generic.ArrayType) arrayref).getElementType().equals( Type.BYTE ))) {
                constraintViolated( o, "The 'arrayref' does not refer to an array with elements of a Type.BYTE or Type.BOOLEAN but to an array of '" + ((org.apache.bcel.generic.ArrayType) arrayref).getElementType() + "'." );
            }
        }
    }

    public  void visitBASTORE( org.apache.bcel.generic.BASTORE o )
    {
        org.apache.bcel.generic.Type arrayref = stack().peek( 2 );
        org.apache.bcel.generic.Type index = stack().peek( 1 );
        org.apache.bcel.generic.Type value = stack().peek( 0 );
        indexOfInt( o, index );
        valueOfInt( o, value );
        if (arrayrefOfArrayType( o, arrayref )) {
            if (!(((org.apache.bcel.generic.ArrayType) arrayref).getElementType().equals( Type.BOOLEAN ) || ((org.apache.bcel.generic.ArrayType) arrayref).getElementType().equals( Type.BYTE ))) {
                constraintViolated( o, "The 'arrayref' does not refer to an array with elements of a Type.BYTE or Type.BOOLEAN but to an array of '" + ((org.apache.bcel.generic.ArrayType) arrayref).getElementType() + "'." );
            }
        }
    }

    public  void visitBIPUSH( org.apache.bcel.generic.BIPUSH o )
    {
    }

    public  void visitBREAKPOINT( org.apache.bcel.generic.BREAKPOINT o )
    {
        throw new org.apache.bcel.verifier.exc.AssertionViolatedException( "In this JustIce verification pass there should not occur an illegal instruction such as BREAKPOINT." );
    }

    public  void visitCALOAD( org.apache.bcel.generic.CALOAD o )
    {
        org.apache.bcel.generic.Type arrayref = stack().peek( 1 );
        org.apache.bcel.generic.Type index = stack().peek( 0 );
        indexOfInt( o, index );
        arrayrefOfArrayType( o, arrayref );
    }

    public  void visitCASTORE( org.apache.bcel.generic.CASTORE o )
    {
        org.apache.bcel.generic.Type arrayref = stack().peek( 2 );
        org.apache.bcel.generic.Type index = stack().peek( 1 );
        org.apache.bcel.generic.Type value = stack().peek( 0 );
        indexOfInt( o, index );
        valueOfInt( o, value );
        if (arrayrefOfArrayType( o, arrayref )) {
            if (!((org.apache.bcel.generic.ArrayType) arrayref).getElementType().equals( Type.CHAR )) {
                constraintViolated( o, "The 'arrayref' does not refer to an array with elements of type char but to an array of type " + ((org.apache.bcel.generic.ArrayType) arrayref).getElementType() + "." );
            }
        }
    }

    public  void visitCHECKCAST( org.apache.bcel.generic.CHECKCAST o )
    {
        org.apache.bcel.generic.Type objectref = stack().peek( 0 );
        if (!(objectref instanceof org.apache.bcel.generic.ReferenceType)) {
            constraintViolated( o, "The 'objectref' is not of a ReferenceType but of type " + objectref + "." );
        }
        org.apache.bcel.classfile.Constant c = cpg.getConstant( o.getIndex() );
        if (!(c instanceof org.apache.bcel.classfile.ConstantClass)) {
            constraintViolated( o, "The Constant at 'index' is not a ConstantClass, but '" + c + "'." );
        }
    }

    public  void visitD2F( org.apache.bcel.generic.D2F o )
    {
        if (stack().peek() != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack top is not of type 'double', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitD2I( org.apache.bcel.generic.D2I o )
    {
        if (stack().peek() != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack top is not of type 'double', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitD2L( org.apache.bcel.generic.D2L o )
    {
        if (stack().peek() != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack top is not of type 'double', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitDADD( org.apache.bcel.generic.DADD o )
    {
        if (stack().peek() != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack top is not of type 'double', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'double', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitDALOAD( org.apache.bcel.generic.DALOAD o )
    {
        indexOfInt( o, stack().peek() );
        if (stack().peek( 1 ) == Type.NULL) {
            return;
        }
        if (!(stack().peek( 1 ) instanceof org.apache.bcel.generic.ArrayType)) {
            constraintViolated( o, "Stack next-to-top must be of type double[] but is '" + stack().peek( 1 ) + "'." );
        }
        org.apache.bcel.generic.Type t = ((org.apache.bcel.generic.ArrayType) stack().peek( 1 )).getBasicType();
        if (t != Type.DOUBLE) {
            constraintViolated( o, "Stack next-to-top must be of type double[] but is '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitDASTORE( org.apache.bcel.generic.DASTORE o )
    {
        if (stack().peek() != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack top is not of type 'double', but of type '" + stack().peek() + "'." );
        }
        indexOfInt( o, stack().peek( 1 ) );
        if (stack().peek( 2 ) == Type.NULL) {
            return;
        }
        if (!(stack().peek( 2 ) instanceof org.apache.bcel.generic.ArrayType)) {
            constraintViolated( o, "Stack next-to-next-to-top must be of type double[] but is '" + stack().peek( 2 ) + "'." );
        }
        org.apache.bcel.generic.Type t = ((org.apache.bcel.generic.ArrayType) stack().peek( 2 )).getBasicType();
        if (t != Type.DOUBLE) {
            constraintViolated( o, "Stack next-to-next-to-top must be of type double[] but is '" + stack().peek( 2 ) + "'." );
        }
    }

    public  void visitDCMPG( org.apache.bcel.generic.DCMPG o )
    {
        if (stack().peek() != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack top is not of type 'double', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'double', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitDCMPL( org.apache.bcel.generic.DCMPL o )
    {
        if (stack().peek() != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack top is not of type 'double', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'double', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitDCONST( org.apache.bcel.generic.DCONST o )
    {
    }

    public  void visitDDIV( org.apache.bcel.generic.DDIV o )
    {
        if (stack().peek() != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack top is not of type 'double', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'double', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitDLOAD( org.apache.bcel.generic.DLOAD o )
    {
    }

    public  void visitDMUL( org.apache.bcel.generic.DMUL o )
    {
        if (stack().peek() != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack top is not of type 'double', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'double', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitDNEG( org.apache.bcel.generic.DNEG o )
    {
        if (stack().peek() != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack top is not of type 'double', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitDREM( org.apache.bcel.generic.DREM o )
    {
        if (stack().peek() != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack top is not of type 'double', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'double', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitDRETURN( org.apache.bcel.generic.DRETURN o )
    {
        if (stack().peek() != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack top is not of type 'double', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitDSTORE( org.apache.bcel.generic.DSTORE o )
    {
    }

    public  void visitDSUB( org.apache.bcel.generic.DSUB o )
    {
        if (stack().peek() != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack top is not of type 'double', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.DOUBLE) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'double', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitDUP( org.apache.bcel.generic.DUP o )
    {
        if (stack().peek().getSize() != 1) {
            constraintViolated( o, "Won't DUP type on stack top '" + stack().peek() + "' because it must occupy exactly one slot, not '" + stack().peek().getSize() + "'." );
        }
    }

    public  void visitDUP_X1( org.apache.bcel.generic.DUP_X1 o )
    {
        if (stack().peek().getSize() != 1) {
            constraintViolated( o, "Type on stack top '" + stack().peek() + "' should occupy exactly one slot, not '" + stack().peek().getSize() + "'." );
        }
        if (stack().peek( 1 ).getSize() != 1) {
            constraintViolated( o, "Type on stack next-to-top '" + stack().peek( 1 ) + "' should occupy exactly one slot, not '" + stack().peek( 1 ).getSize() + "'." );
        }
    }

    public  void visitDUP_X2( org.apache.bcel.generic.DUP_X2 o )
    {
        if (stack().peek().getSize() != 1) {
            constraintViolated( o, "Stack top type must be of size 1, but is '" + stack().peek() + "' of size '" + stack().peek().getSize() + "'." );
        }
        if (stack().peek( 1 ).getSize() == 2) {
            return;
        } else {
            if (stack().peek( 2 ).getSize() != 1) {
                constraintViolated( o, "If stack top's size is 1 and stack next-to-top's size is 1, stack next-to-next-to-top's size must also be 1, but is: '" + stack().peek( 2 ) + "' of size '" + stack().peek( 2 ).getSize() + "'." );
            }
        }
    }

    public  void visitDUP2( org.apache.bcel.generic.DUP2 o )
    {
        if (stack().peek().getSize() == 2) {
            return;
        } else {
            if (stack().peek( 1 ).getSize() != 1) {
                constraintViolated( o, "If stack top's size is 1, then stack next-to-top's size must also be 1. But it is '" + stack().peek( 1 ) + "' of size '" + stack().peek( 1 ).getSize() + "'." );
            }
        }
    }

    public  void visitDUP2_X1( org.apache.bcel.generic.DUP2_X1 o )
    {
        if (stack().peek().getSize() == 2) {
            if (stack().peek( 1 ).getSize() != 1) {
                constraintViolated( o, "If stack top's size is 2, then stack next-to-top's size must be 1. But it is '" + stack().peek( 1 ) + "' of size '" + stack().peek( 1 ).getSize() + "'." );
            } else {
                return;
            }
        } else {
            if (stack().peek( 1 ).getSize() != 1) {
                constraintViolated( o, "If stack top's size is 1, then stack next-to-top's size must also be 1. But it is '" + stack().peek( 1 ) + "' of size '" + stack().peek( 1 ).getSize() + "'." );
            }
            if (stack().peek( 2 ).getSize() != 1) {
                constraintViolated( o, "If stack top's size is 1, then stack next-to-next-to-top's size must also be 1. But it is '" + stack().peek( 2 ) + "' of size '" + stack().peek( 2 ).getSize() + "'." );
            }
        }
    }

    public  void visitDUP2_X2( org.apache.bcel.generic.DUP2_X2 o )
    {
        if (stack().peek( 0 ).getSize() == 2) {
            if (stack().peek( 1 ).getSize() == 2) {
                return;
            } else {
                if (stack().peek( 2 ).getSize() != 1) {
                    constraintViolated( o, "If stack top's size is 2 and stack-next-to-top's size is 1, then stack next-to-next-to-top's size must also be 1. But it is '" + stack().peek( 2 ) + "' of size '" + stack().peek( 2 ).getSize() + "'." );
                } else {
                    return;
                }
            }
        } else {
            if (stack().peek( 1 ).getSize() == 1) {
                if (stack().peek( 2 ).getSize() == 2) {
                    return;
                } else {
                    if (stack().peek( 3 ).getSize() == 1) {
                        return;
                    }
                }
            }
        }
        constraintViolated( o, "The operand sizes on the stack do not match any of the four forms of usage of this instruction." );
    }

    public  void visitF2D( org.apache.bcel.generic.F2D o )
    {
        if (stack().peek() != Type.FLOAT) {
            constraintViolated( o, "The value at the stack top is not of type 'float', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitF2I( org.apache.bcel.generic.F2I o )
    {
        if (stack().peek() != Type.FLOAT) {
            constraintViolated( o, "The value at the stack top is not of type 'float', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitF2L( org.apache.bcel.generic.F2L o )
    {
        if (stack().peek() != Type.FLOAT) {
            constraintViolated( o, "The value at the stack top is not of type 'float', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitFADD( org.apache.bcel.generic.FADD o )
    {
        if (stack().peek() != Type.FLOAT) {
            constraintViolated( o, "The value at the stack top is not of type 'float', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.FLOAT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'float', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitFALOAD( org.apache.bcel.generic.FALOAD o )
    {
        indexOfInt( o, stack().peek() );
        if (stack().peek( 1 ) == Type.NULL) {
            return;
        }
        if (!(stack().peek( 1 ) instanceof org.apache.bcel.generic.ArrayType)) {
            constraintViolated( o, "Stack next-to-top must be of type float[] but is '" + stack().peek( 1 ) + "'." );
        }
        org.apache.bcel.generic.Type t = ((org.apache.bcel.generic.ArrayType) stack().peek( 1 )).getBasicType();
        if (t != Type.FLOAT) {
            constraintViolated( o, "Stack next-to-top must be of type float[] but is '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitFASTORE( org.apache.bcel.generic.FASTORE o )
    {
        if (stack().peek() != Type.FLOAT) {
            constraintViolated( o, "The value at the stack top is not of type 'float', but of type '" + stack().peek() + "'." );
        }
        indexOfInt( o, stack().peek( 1 ) );
        if (stack().peek( 2 ) == Type.NULL) {
            return;
        }
        if (!(stack().peek( 2 ) instanceof org.apache.bcel.generic.ArrayType)) {
            constraintViolated( o, "Stack next-to-next-to-top must be of type float[] but is '" + stack().peek( 2 ) + "'." );
        }
        org.apache.bcel.generic.Type t = ((org.apache.bcel.generic.ArrayType) stack().peek( 2 )).getBasicType();
        if (t != Type.FLOAT) {
            constraintViolated( o, "Stack next-to-next-to-top must be of type float[] but is '" + stack().peek( 2 ) + "'." );
        }
    }

    public  void visitFCMPG( org.apache.bcel.generic.FCMPG o )
    {
        if (stack().peek() != Type.FLOAT) {
            constraintViolated( o, "The value at the stack top is not of type 'float', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.FLOAT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'float', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitFCMPL( org.apache.bcel.generic.FCMPL o )
    {
        if (stack().peek() != Type.FLOAT) {
            constraintViolated( o, "The value at the stack top is not of type 'float', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.FLOAT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'float', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitFCONST( org.apache.bcel.generic.FCONST o )
    {
    }

    public  void visitFDIV( org.apache.bcel.generic.FDIV o )
    {
        if (stack().peek() != Type.FLOAT) {
            constraintViolated( o, "The value at the stack top is not of type 'float', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.FLOAT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'float', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitFLOAD( org.apache.bcel.generic.FLOAD o )
    {
    }

    public  void visitFMUL( org.apache.bcel.generic.FMUL o )
    {
        if (stack().peek() != Type.FLOAT) {
            constraintViolated( o, "The value at the stack top is not of type 'float', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.FLOAT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'float', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitFNEG( org.apache.bcel.generic.FNEG o )
    {
        if (stack().peek() != Type.FLOAT) {
            constraintViolated( o, "The value at the stack top is not of type 'float', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitFREM( org.apache.bcel.generic.FREM o )
    {
        if (stack().peek() != Type.FLOAT) {
            constraintViolated( o, "The value at the stack top is not of type 'float', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.FLOAT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'float', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitFRETURN( org.apache.bcel.generic.FRETURN o )
    {
        if (stack().peek() != Type.FLOAT) {
            constraintViolated( o, "The value at the stack top is not of type 'float', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitFSTORE( org.apache.bcel.generic.FSTORE o )
    {
    }

    public  void visitFSUB( org.apache.bcel.generic.FSUB o )
    {
        if (stack().peek() != Type.FLOAT) {
            constraintViolated( o, "The value at the stack top is not of type 'float', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.FLOAT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'float', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitGETFIELD( org.apache.bcel.generic.GETFIELD o )
    {
        try {
            org.apache.bcel.generic.Type objectref = stack().peek();
            if (!(objectref instanceof org.apache.bcel.generic.ObjectType || objectref == Type.NULL)) {
                constraintViolated( o, "Stack top should be an object reference that's not an array reference, but is '" + objectref + "'." );
            }
            java.lang.String field_name = o.getFieldName( cpg );
            org.apache.bcel.classfile.JavaClass jc = Repository.lookupClass( o.getClassType( cpg ).getClassName() );
            org.apache.bcel.classfile.Field[] fields = jc.getFields();
            org.apache.bcel.classfile.Field f = null;
            for (int i = 0; i < fields.length; i++) {
                if (fields[i].getName().equals( field_name )) {
                    org.apache.bcel.generic.Type f_type = Type.getType( fields[i].getSignature() );
                    org.apache.bcel.generic.Type o_type = o.getType( cpg );
                    if (f_type.equals( o_type )) {
                        f = fields[i];
                        break;
                    }
                }
            }
            if (f == null) {
                org.apache.bcel.classfile.JavaClass[] superclasses = jc.getSuperClasses();
                outer : 
                for (int j = 0; j < superclasses.length; j++) {
                    fields = superclasses[j].getFields();
                    for (int i = 0; i < fields.length; i++) {
                        if (fields[i].getName().equals( field_name )) {
                            org.apache.bcel.generic.Type f_type = Type.getType( fields[i].getSignature() );
                            org.apache.bcel.generic.Type o_type = o.getType( cpg );
                            if (f_type.equals( o_type )) {
                                f = fields[i];
                                if ((f.getAccessFlags() & (Constants.ACC_PUBLIC | Constants.ACC_PROTECTED)) == 0) {
                                    f = null;
                                }
                                break outer;
                            }
                        }
                    }
                }
                if (f == null) {
                    throw new org.apache.bcel.verifier.exc.AssertionViolatedException( "Field '" + field_name + "' not found?!?" );
                }
            }
            if (f.isProtected()) {
                org.apache.bcel.generic.ObjectType classtype = o.getClassType( cpg );
                org.apache.bcel.generic.ObjectType curr = new org.apache.bcel.generic.ObjectType( mg.getClassName() );
                if (classtype.equals( curr ) || curr.subclassOf( classtype )) {
                    org.apache.bcel.generic.Type t = stack().peek();
                    if (t == Type.NULL) {
                        return;
                    }
                    if (!(t instanceof org.apache.bcel.generic.ObjectType)) {
                        constraintViolated( o, "The 'objectref' must refer to an object that's not an array. Found instead: '" + t + "'." );
                    }
                    org.apache.bcel.generic.ObjectType objreftype = (org.apache.bcel.generic.ObjectType) t;
                    if (!(objreftype.equals( curr ) || objreftype.subclassOf( curr ))) {
                    }
                }
            }
            if (f.isStatic()) {
                constraintViolated( o, "Referenced field '" + f + "' is static which it shouldn't be." );
            }
        } catch ( java.lang.ClassNotFoundException e ) {
            throw new org.apache.bcel.verifier.exc.AssertionViolatedException( "Missing class: " + e.toString() );
        }
    }

    public  void visitGETSTATIC( org.apache.bcel.generic.GETSTATIC o )
    {
    }

    public  void visitGOTO( org.apache.bcel.generic.GOTO o )
    {
    }

    public  void visitGOTO_W( org.apache.bcel.generic.GOTO_W o )
    {
    }

    public  void visitI2B( org.apache.bcel.generic.I2B o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitI2C( org.apache.bcel.generic.I2C o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitI2D( org.apache.bcel.generic.I2D o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitI2F( org.apache.bcel.generic.I2F o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitI2L( org.apache.bcel.generic.I2L o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitI2S( org.apache.bcel.generic.I2S o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitIADD( org.apache.bcel.generic.IADD o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.INT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'int', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitIALOAD( org.apache.bcel.generic.IALOAD o )
    {
        indexOfInt( o, stack().peek() );
        if (stack().peek( 1 ) == Type.NULL) {
            return;
        }
        if (!(stack().peek( 1 ) instanceof org.apache.bcel.generic.ArrayType)) {
            constraintViolated( o, "Stack next-to-top must be of type int[] but is '" + stack().peek( 1 ) + "'." );
        }
        org.apache.bcel.generic.Type t = ((org.apache.bcel.generic.ArrayType) stack().peek( 1 )).getBasicType();
        if (t != Type.INT) {
            constraintViolated( o, "Stack next-to-top must be of type int[] but is '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitIAND( org.apache.bcel.generic.IAND o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.INT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'int', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitIASTORE( org.apache.bcel.generic.IASTORE o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        indexOfInt( o, stack().peek( 1 ) );
        if (stack().peek( 2 ) == Type.NULL) {
            return;
        }
        if (!(stack().peek( 2 ) instanceof org.apache.bcel.generic.ArrayType)) {
            constraintViolated( o, "Stack next-to-next-to-top must be of type int[] but is '" + stack().peek( 2 ) + "'." );
        }
        org.apache.bcel.generic.Type t = ((org.apache.bcel.generic.ArrayType) stack().peek( 2 )).getBasicType();
        if (t != Type.INT) {
            constraintViolated( o, "Stack next-to-next-to-top must be of type int[] but is '" + stack().peek( 2 ) + "'." );
        }
    }

    public  void visitICONST( org.apache.bcel.generic.ICONST o )
    {
    }

    public  void visitIDIV( org.apache.bcel.generic.IDIV o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.INT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'int', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitIF_ACMPEQ( org.apache.bcel.generic.IF_ACMPEQ o )
    {
        if (!(stack().peek() instanceof org.apache.bcel.generic.ReferenceType)) {
            constraintViolated( o, "The value at the stack top is not of a ReferenceType, but of type '" + stack().peek() + "'." );
        }
        if (!(stack().peek( 1 ) instanceof org.apache.bcel.generic.ReferenceType)) {
            constraintViolated( o, "The value at the stack next-to-top is not of a ReferenceType, but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitIF_ACMPNE( org.apache.bcel.generic.IF_ACMPNE o )
    {
        if (!(stack().peek() instanceof org.apache.bcel.generic.ReferenceType)) {
            constraintViolated( o, "The value at the stack top is not of a ReferenceType, but of type '" + stack().peek() + "'." );
        }
        if (!(stack().peek( 1 ) instanceof org.apache.bcel.generic.ReferenceType)) {
            constraintViolated( o, "The value at the stack next-to-top is not of a ReferenceType, but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitIF_ICMPEQ( org.apache.bcel.generic.IF_ICMPEQ o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.INT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'int', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitIF_ICMPGE( org.apache.bcel.generic.IF_ICMPGE o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.INT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'int', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitIF_ICMPGT( org.apache.bcel.generic.IF_ICMPGT o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.INT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'int', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitIF_ICMPLE( org.apache.bcel.generic.IF_ICMPLE o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.INT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'int', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitIF_ICMPLT( org.apache.bcel.generic.IF_ICMPLT o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.INT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'int', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitIF_ICMPNE( org.apache.bcel.generic.IF_ICMPNE o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.INT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'int', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitIFEQ( org.apache.bcel.generic.IFEQ o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitIFGE( org.apache.bcel.generic.IFGE o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitIFGT( org.apache.bcel.generic.IFGT o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitIFLE( org.apache.bcel.generic.IFLE o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitIFLT( org.apache.bcel.generic.IFLT o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitIFNE( org.apache.bcel.generic.IFNE o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitIFNONNULL( org.apache.bcel.generic.IFNONNULL o )
    {
        if (!(stack().peek() instanceof org.apache.bcel.generic.ReferenceType)) {
            constraintViolated( o, "The value at the stack top is not of a ReferenceType, but of type '" + stack().peek() + "'." );
        }
        referenceTypeIsInitialized( o, (org.apache.bcel.generic.ReferenceType) stack().peek() );
    }

    public  void visitIFNULL( org.apache.bcel.generic.IFNULL o )
    {
        if (!(stack().peek() instanceof org.apache.bcel.generic.ReferenceType)) {
            constraintViolated( o, "The value at the stack top is not of a ReferenceType, but of type '" + stack().peek() + "'." );
        }
        referenceTypeIsInitialized( o, (org.apache.bcel.generic.ReferenceType) stack().peek() );
    }

    public  void visitIINC( org.apache.bcel.generic.IINC o )
    {
        if (locals().maxLocals() <= (o.getType( cpg ).getSize() == 1 ? o.getIndex() : o.getIndex() + 1)) {
            constraintViolated( o, "The 'index' is not a valid index into the local variable array." );
        }
        indexOfInt( o, locals().get( o.getIndex() ) );
    }

    public  void visitILOAD( org.apache.bcel.generic.ILOAD o )
    {
    }

    public  void visitIMPDEP1( org.apache.bcel.generic.IMPDEP1 o )
    {
        throw new org.apache.bcel.verifier.exc.AssertionViolatedException( "In this JustIce verification pass there should not occur an illegal instruction such as IMPDEP1." );
    }

    public  void visitIMPDEP2( org.apache.bcel.generic.IMPDEP2 o )
    {
        throw new org.apache.bcel.verifier.exc.AssertionViolatedException( "In this JustIce verification pass there should not occur an illegal instruction such as IMPDEP2." );
    }

    public  void visitIMUL( org.apache.bcel.generic.IMUL o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.INT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'int', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitINEG( org.apache.bcel.generic.INEG o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitINSTANCEOF( org.apache.bcel.generic.INSTANCEOF o )
    {
        org.apache.bcel.generic.Type objectref = stack().peek( 0 );
        if (!(objectref instanceof org.apache.bcel.generic.ReferenceType)) {
            constraintViolated( o, "The 'objectref' is not of a ReferenceType but of type " + objectref + "." );
        }
        org.apache.bcel.classfile.Constant c = cpg.getConstant( o.getIndex() );
        if (!(c instanceof org.apache.bcel.classfile.ConstantClass)) {
            constraintViolated( o, "The Constant at 'index' is not a ConstantClass, but '" + c + "'." );
        }
    }

    public  void visitINVOKEINTERFACE( org.apache.bcel.generic.INVOKEINTERFACE o )
    {
        int count = o.getCount();
        if (count == 0) {
            constraintViolated( o, "The 'count' argument must not be 0." );
        }
        org.apache.bcel.generic.Type t = o.getType( cpg );
        if (t instanceof org.apache.bcel.generic.ObjectType) {
            java.lang.String name = ((org.apache.bcel.generic.ObjectType) t).getClassName();
            org.apache.bcel.verifier.Verifier v = VerifierFactory.getVerifier( name );
            org.apache.bcel.verifier.VerificationResult vr = v.doPass2();
            if (vr.getStatus() != VerificationResult.VERIFIED_OK) {
                constraintViolated( (org.apache.bcel.generic.Instruction) o, "Class '" + name + "' is referenced, but cannot be loaded and resolved: '" + vr + "'." );
            }
        }
        org.apache.bcel.generic.Type[] argtypes = o.getArgumentTypes( cpg );
        int nargs = argtypes.length;
        for (int i = nargs - 1; i >= 0; i--) {
            org.apache.bcel.generic.Type fromStack = stack().peek( nargs - 1 - i );
            org.apache.bcel.generic.Type fromDesc = argtypes[i];
            if (fromDesc == Type.BOOLEAN || fromDesc == Type.BYTE || fromDesc == Type.CHAR || fromDesc == Type.SHORT) {
                fromDesc = Type.INT;
            }
            if (!fromStack.equals( fromDesc )) {
                if (fromStack instanceof org.apache.bcel.generic.ReferenceType && fromDesc instanceof org.apache.bcel.generic.ReferenceType) {
                    org.apache.bcel.generic.ReferenceType rFromStack = (org.apache.bcel.generic.ReferenceType) fromStack;
                    referenceTypeIsInitialized( o, rFromStack );
                } else {
                    constraintViolated( o, "Expecting a '" + fromDesc + "' but found a '" + fromStack + "' on the stack." );
                }
            }
        }
        org.apache.bcel.generic.Type objref = stack().peek( nargs );
        if (objref == Type.NULL) {
            return;
        }
        if (!(objref instanceof org.apache.bcel.generic.ReferenceType)) {
            constraintViolated( o, "Expecting a reference type as 'objectref' on the stack, not a '" + objref + "'." );
        }
        referenceTypeIsInitialized( o, (org.apache.bcel.generic.ReferenceType) objref );
        if (!(objref instanceof org.apache.bcel.generic.ObjectType)) {
            if (!(objref instanceof org.apache.bcel.generic.ArrayType)) {
                constraintViolated( o, "Expecting an ObjectType as 'objectref' on the stack, not a '" + objref + "'." );
            } else {
                objref = GENERIC_ARRAY;
            }
        }
        int counted_count = 1;
        for (int i = 0; i < nargs; i++) {
            counted_count += argtypes[i].getSize();
        }
        if (count != counted_count) {
            constraintViolated( o, "The 'count' argument should probably read '" + counted_count + "' but is '" + count + "'." );
        }
    }

    public  void visitINVOKESPECIAL( org.apache.bcel.generic.INVOKESPECIAL o )
    {
        try {
            if (o.getMethodName( cpg ).equals( Constants.CONSTRUCTOR_NAME ) && !(stack().peek( o.getArgumentTypes( cpg ).length ) instanceof org.apache.bcel.verifier.structurals.UninitializedObjectType)) {
                constraintViolated( o, "Possibly initializing object twice. A valid instruction sequence must not have an uninitialized object on the operand stack or in a local variable during a backwards branch, or in a local variable in code protected by an exception handler. Please see The Java Virtual Machine Specification, Second Edition, 4.9.4 (pages 147 and 148) for details." );
            }
            org.apache.bcel.generic.Type t = o.getType( cpg );
            if (t instanceof org.apache.bcel.generic.ObjectType) {
                java.lang.String name = ((org.apache.bcel.generic.ObjectType) t).getClassName();
                org.apache.bcel.verifier.Verifier v = VerifierFactory.getVerifier( name );
                org.apache.bcel.verifier.VerificationResult vr = v.doPass2();
                if (vr.getStatus() != VerificationResult.VERIFIED_OK) {
                    constraintViolated( (org.apache.bcel.generic.Instruction) o, "Class '" + name + "' is referenced, but cannot be loaded and resolved: '" + vr + "'." );
                }
            }
            org.apache.bcel.generic.Type[] argtypes = o.getArgumentTypes( cpg );
            int nargs = argtypes.length;
            for (int i = nargs - 1; i >= 0; i--) {
                org.apache.bcel.generic.Type fromStack = stack().peek( nargs - 1 - i );
                org.apache.bcel.generic.Type fromDesc = argtypes[i];
                if (fromDesc == Type.BOOLEAN || fromDesc == Type.BYTE || fromDesc == Type.CHAR || fromDesc == Type.SHORT) {
                    fromDesc = Type.INT;
                }
                if (!fromStack.equals( fromDesc )) {
                    if (fromStack instanceof org.apache.bcel.generic.ReferenceType && fromDesc instanceof org.apache.bcel.generic.ReferenceType) {
                        org.apache.bcel.generic.ReferenceType rFromStack = (org.apache.bcel.generic.ReferenceType) fromStack;
                        org.apache.bcel.generic.ReferenceType rFromDesc = (org.apache.bcel.generic.ReferenceType) fromDesc;
                        if (!rFromStack.isAssignmentCompatibleWith( rFromDesc )) {
                            constraintViolated( o, "Expecting a '" + fromDesc + "' but found a '" + fromStack + "' on the stack (which is not assignment compatible)." );
                        }
                        referenceTypeIsInitialized( o, rFromStack );
                    } else {
                        constraintViolated( o, "Expecting a '" + fromDesc + "' but found a '" + fromStack + "' on the stack." );
                    }
                }
            }
            org.apache.bcel.generic.Type objref = stack().peek( nargs );
            if (objref == Type.NULL) {
                return;
            }
            if (!(objref instanceof org.apache.bcel.generic.ReferenceType)) {
                constraintViolated( o, "Expecting a reference type as 'objectref' on the stack, not a '" + objref + "'." );
            }
            java.lang.String objref_classname = null;
            if (!o.getMethodName( cpg ).equals( Constants.CONSTRUCTOR_NAME )) {
                referenceTypeIsInitialized( o, (org.apache.bcel.generic.ReferenceType) objref );
                if (!(objref instanceof org.apache.bcel.generic.ObjectType)) {
                    if (!(objref instanceof org.apache.bcel.generic.ArrayType)) {
                        constraintViolated( o, "Expecting an ObjectType as 'objectref' on the stack, not a '" + objref + "'." );
                    } else {
                        objref = GENERIC_ARRAY;
                    }
                }
                objref_classname = ((org.apache.bcel.generic.ObjectType) objref).getClassName();
            } else {
                if (!(objref instanceof org.apache.bcel.verifier.structurals.UninitializedObjectType)) {
                    constraintViolated( o, "Expecting an UninitializedObjectType as 'objectref' on the stack, not a '" + objref + "'. Otherwise, you couldn't invoke a method since an array has no methods (not to speak of a return address)." );
                }
                objref_classname = ((org.apache.bcel.verifier.structurals.UninitializedObjectType) objref).getInitialized().getClassName();
            }
            java.lang.String theClass = o.getClassName( cpg );
            if (!Repository.instanceOf( objref_classname, theClass )) {
                constraintViolated( o, "The 'objref' item '" + objref + "' does not implement '" + theClass + "' as expected." );
            }
        } catch ( java.lang.ClassNotFoundException e ) {
            throw new org.apache.bcel.verifier.exc.AssertionViolatedException( "Missing class: " + e.toString() );
        }
    }

    public  void visitINVOKESTATIC( org.apache.bcel.generic.INVOKESTATIC o )
    {
        try {
            org.apache.bcel.generic.Type t = o.getType( cpg );
            if (t instanceof org.apache.bcel.generic.ObjectType) {
                java.lang.String name = ((org.apache.bcel.generic.ObjectType) t).getClassName();
                org.apache.bcel.verifier.Verifier v = VerifierFactory.getVerifier( name );
                org.apache.bcel.verifier.VerificationResult vr = v.doPass2();
                if (vr.getStatus() != VerificationResult.VERIFIED_OK) {
                    constraintViolated( (org.apache.bcel.generic.Instruction) o, "Class '" + name + "' is referenced, but cannot be loaded and resolved: '" + vr + "'." );
                }
            }
            org.apache.bcel.generic.Type[] argtypes = o.getArgumentTypes( cpg );
            int nargs = argtypes.length;
            for (int i = nargs - 1; i >= 0; i--) {
                org.apache.bcel.generic.Type fromStack = stack().peek( nargs - 1 - i );
                org.apache.bcel.generic.Type fromDesc = argtypes[i];
                if (fromDesc == Type.BOOLEAN || fromDesc == Type.BYTE || fromDesc == Type.CHAR || fromDesc == Type.SHORT) {
                    fromDesc = Type.INT;
                }
                if (!fromStack.equals( fromDesc )) {
                    if (fromStack instanceof org.apache.bcel.generic.ReferenceType && fromDesc instanceof org.apache.bcel.generic.ReferenceType) {
                        org.apache.bcel.generic.ReferenceType rFromStack = (org.apache.bcel.generic.ReferenceType) fromStack;
                        org.apache.bcel.generic.ReferenceType rFromDesc = (org.apache.bcel.generic.ReferenceType) fromDesc;
                        if (!rFromStack.isAssignmentCompatibleWith( rFromDesc )) {
                            constraintViolated( o, "Expecting a '" + fromDesc + "' but found a '" + fromStack + "' on the stack (which is not assignment compatible)." );
                        }
                        referenceTypeIsInitialized( o, rFromStack );
                    } else {
                        constraintViolated( o, "Expecting a '" + fromDesc + "' but found a '" + fromStack + "' on the stack." );
                    }
                }
            }
        } catch ( java.lang.ClassNotFoundException e ) {
            throw new org.apache.bcel.verifier.exc.AssertionViolatedException( "Missing class: " + e.toString() );
        }
    }

    public  void visitINVOKEVIRTUAL( org.apache.bcel.generic.INVOKEVIRTUAL o )
    {
        try {
            org.apache.bcel.generic.Type t = o.getType( cpg );
            if (t instanceof org.apache.bcel.generic.ObjectType) {
                java.lang.String name = ((org.apache.bcel.generic.ObjectType) t).getClassName();
                org.apache.bcel.verifier.Verifier v = VerifierFactory.getVerifier( name );
                org.apache.bcel.verifier.VerificationResult vr = v.doPass2();
                if (vr.getStatus() != VerificationResult.VERIFIED_OK) {
                    constraintViolated( (org.apache.bcel.generic.Instruction) o, "Class '" + name + "' is referenced, but cannot be loaded and resolved: '" + vr + "'." );
                }
            }
            org.apache.bcel.generic.Type[] argtypes = o.getArgumentTypes( cpg );
            int nargs = argtypes.length;
            for (int i = nargs - 1; i >= 0; i--) {
                org.apache.bcel.generic.Type fromStack = stack().peek( nargs - 1 - i );
                org.apache.bcel.generic.Type fromDesc = argtypes[i];
                if (fromDesc == Type.BOOLEAN || fromDesc == Type.BYTE || fromDesc == Type.CHAR || fromDesc == Type.SHORT) {
                    fromDesc = Type.INT;
                }
                if (!fromStack.equals( fromDesc )) {
                    if (fromStack instanceof org.apache.bcel.generic.ReferenceType && fromDesc instanceof org.apache.bcel.generic.ReferenceType) {
                        org.apache.bcel.generic.ReferenceType rFromStack = (org.apache.bcel.generic.ReferenceType) fromStack;
                        org.apache.bcel.generic.ReferenceType rFromDesc = (org.apache.bcel.generic.ReferenceType) fromDesc;
                        if (!rFromStack.isAssignmentCompatibleWith( rFromDesc )) {
                            constraintViolated( o, "Expecting a '" + fromDesc + "' but found a '" + fromStack + "' on the stack (which is not assignment compatible)." );
                        }
                        referenceTypeIsInitialized( o, rFromStack );
                    } else {
                        constraintViolated( o, "Expecting a '" + fromDesc + "' but found a '" + fromStack + "' on the stack." );
                    }
                }
            }
            org.apache.bcel.generic.Type objref = stack().peek( nargs );
            if (objref == Type.NULL) {
                return;
            }
            if (!(objref instanceof org.apache.bcel.generic.ReferenceType)) {
                constraintViolated( o, "Expecting a reference type as 'objectref' on the stack, not a '" + objref + "'." );
            }
            referenceTypeIsInitialized( o, (org.apache.bcel.generic.ReferenceType) objref );
            if (!(objref instanceof org.apache.bcel.generic.ObjectType)) {
                if (!(objref instanceof org.apache.bcel.generic.ArrayType)) {
                    constraintViolated( o, "Expecting an ObjectType as 'objectref' on the stack, not a '" + objref + "'." );
                } else {
                    objref = GENERIC_ARRAY;
                }
            }
            java.lang.String objref_classname = ((org.apache.bcel.generic.ObjectType) objref).getClassName();
            java.lang.String theClass = o.getClassName( cpg );
            if (!Repository.instanceOf( objref_classname, theClass )) {
                constraintViolated( o, "The 'objref' item '" + objref + "' does not implement '" + theClass + "' as expected." );
            }
        } catch ( java.lang.ClassNotFoundException e ) {
            throw new org.apache.bcel.verifier.exc.AssertionViolatedException( "Missing class: " + e.toString() );
        }
    }

    public  void visitIOR( org.apache.bcel.generic.IOR o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.INT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'int', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitIREM( org.apache.bcel.generic.IREM o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.INT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'int', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitIRETURN( org.apache.bcel.generic.IRETURN o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitISHL( org.apache.bcel.generic.ISHL o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.INT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'int', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitISHR( org.apache.bcel.generic.ISHR o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.INT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'int', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitISTORE( org.apache.bcel.generic.ISTORE o )
    {
    }

    public  void visitISUB( org.apache.bcel.generic.ISUB o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.INT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'int', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitIUSHR( org.apache.bcel.generic.IUSHR o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.INT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'int', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitIXOR( org.apache.bcel.generic.IXOR o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.INT) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'int', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitJSR( org.apache.bcel.generic.JSR o )
    {
    }

    public  void visitJSR_W( org.apache.bcel.generic.JSR_W o )
    {
    }

    public  void visitL2D( org.apache.bcel.generic.L2D o )
    {
        if (stack().peek() != Type.LONG) {
            constraintViolated( o, "The value at the stack top is not of type 'long', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitL2F( org.apache.bcel.generic.L2F o )
    {
        if (stack().peek() != Type.LONG) {
            constraintViolated( o, "The value at the stack top is not of type 'long', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitL2I( org.apache.bcel.generic.L2I o )
    {
        if (stack().peek() != Type.LONG) {
            constraintViolated( o, "The value at the stack top is not of type 'long', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitLADD( org.apache.bcel.generic.LADD o )
    {
        if (stack().peek() != Type.LONG) {
            constraintViolated( o, "The value at the stack top is not of type 'long', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.LONG) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'long', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitLALOAD( org.apache.bcel.generic.LALOAD o )
    {
        indexOfInt( o, stack().peek() );
        if (stack().peek( 1 ) == Type.NULL) {
            return;
        }
        if (!(stack().peek( 1 ) instanceof org.apache.bcel.generic.ArrayType)) {
            constraintViolated( o, "Stack next-to-top must be of type long[] but is '" + stack().peek( 1 ) + "'." );
        }
        org.apache.bcel.generic.Type t = ((org.apache.bcel.generic.ArrayType) stack().peek( 1 )).getBasicType();
        if (t != Type.LONG) {
            constraintViolated( o, "Stack next-to-top must be of type long[] but is '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitLAND( org.apache.bcel.generic.LAND o )
    {
        if (stack().peek() != Type.LONG) {
            constraintViolated( o, "The value at the stack top is not of type 'long', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.LONG) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'long', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitLASTORE( org.apache.bcel.generic.LASTORE o )
    {
        if (stack().peek() != Type.LONG) {
            constraintViolated( o, "The value at the stack top is not of type 'long', but of type '" + stack().peek() + "'." );
        }
        indexOfInt( o, stack().peek( 1 ) );
        if (stack().peek( 2 ) == Type.NULL) {
            return;
        }
        if (!(stack().peek( 2 ) instanceof org.apache.bcel.generic.ArrayType)) {
            constraintViolated( o, "Stack next-to-next-to-top must be of type long[] but is '" + stack().peek( 2 ) + "'." );
        }
        org.apache.bcel.generic.Type t = ((org.apache.bcel.generic.ArrayType) stack().peek( 2 )).getBasicType();
        if (t != Type.LONG) {
            constraintViolated( o, "Stack next-to-next-to-top must be of type long[] but is '" + stack().peek( 2 ) + "'." );
        }
    }

    public  void visitLCMP( org.apache.bcel.generic.LCMP o )
    {
        if (stack().peek() != Type.LONG) {
            constraintViolated( o, "The value at the stack top is not of type 'long', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.LONG) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'long', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitLCONST( org.apache.bcel.generic.LCONST o )
    {
    }

    public  void visitLDC( org.apache.bcel.generic.LDC o )
    {
        org.apache.bcel.classfile.Constant c = cpg.getConstant( o.getIndex() );
        if (!(c instanceof org.apache.bcel.classfile.ConstantInteger || c instanceof org.apache.bcel.classfile.ConstantFloat || c instanceof org.apache.bcel.classfile.ConstantString)) {
            constraintViolated( o, "Referenced constant should be a CONSTANT_Integer, a CONSTANT_Float or a CONSTANT_String, but is '" + c + "'." );
        }
    }

    public  void visitLDC_W( org.apache.bcel.generic.LDC_W o )
    {
        org.apache.bcel.classfile.Constant c = cpg.getConstant( o.getIndex() );
        if (!(c instanceof org.apache.bcel.classfile.ConstantInteger || c instanceof org.apache.bcel.classfile.ConstantFloat || c instanceof org.apache.bcel.classfile.ConstantString)) {
            constraintViolated( o, "Referenced constant should be a CONSTANT_Integer, a CONSTANT_Float or a CONSTANT_String, but is '" + c + "'." );
        }
    }

    public  void visitLDC2_W( org.apache.bcel.generic.LDC2_W o )
    {
        org.apache.bcel.classfile.Constant c = cpg.getConstant( o.getIndex() );
        if (!(c instanceof org.apache.bcel.classfile.ConstantLong || c instanceof org.apache.bcel.classfile.ConstantDouble)) {
            constraintViolated( o, "Referenced constant should be a CONSTANT_Integer, a CONSTANT_Float or a CONSTANT_String, but is '" + c + "'." );
        }
    }

    public  void visitLDIV( org.apache.bcel.generic.LDIV o )
    {
        if (stack().peek() != Type.LONG) {
            constraintViolated( o, "The value at the stack top is not of type 'long', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.LONG) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'long', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitLLOAD( org.apache.bcel.generic.LLOAD o )
    {
    }

    public  void visitLMUL( org.apache.bcel.generic.LMUL o )
    {
        if (stack().peek() != Type.LONG) {
            constraintViolated( o, "The value at the stack top is not of type 'long', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.LONG) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'long', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitLNEG( org.apache.bcel.generic.LNEG o )
    {
        if (stack().peek() != Type.LONG) {
            constraintViolated( o, "The value at the stack top is not of type 'long', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitLOOKUPSWITCH( org.apache.bcel.generic.LOOKUPSWITCH o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitLOR( org.apache.bcel.generic.LOR o )
    {
        if (stack().peek() != Type.LONG) {
            constraintViolated( o, "The value at the stack top is not of type 'long', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.LONG) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'long', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitLREM( org.apache.bcel.generic.LREM o )
    {
        if (stack().peek() != Type.LONG) {
            constraintViolated( o, "The value at the stack top is not of type 'long', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.LONG) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'long', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitLRETURN( org.apache.bcel.generic.LRETURN o )
    {
        if (stack().peek() != Type.LONG) {
            constraintViolated( o, "The value at the stack top is not of type 'long', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitLSHL( org.apache.bcel.generic.LSHL o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.LONG) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'long', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitLSHR( org.apache.bcel.generic.LSHR o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.LONG) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'long', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitLSTORE( org.apache.bcel.generic.LSTORE o )
    {
    }

    public  void visitLSUB( org.apache.bcel.generic.LSUB o )
    {
        if (stack().peek() != Type.LONG) {
            constraintViolated( o, "The value at the stack top is not of type 'long', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.LONG) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'long', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitLUSHR( org.apache.bcel.generic.LUSHR o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.LONG) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'long', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitLXOR( org.apache.bcel.generic.LXOR o )
    {
        if (stack().peek() != Type.LONG) {
            constraintViolated( o, "The value at the stack top is not of type 'long', but of type '" + stack().peek() + "'." );
        }
        if (stack().peek( 1 ) != Type.LONG) {
            constraintViolated( o, "The value at the stack next-to-top is not of type 'long', but of type '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitMONITORENTER( org.apache.bcel.generic.MONITORENTER o )
    {
        if (!(stack().peek() instanceof org.apache.bcel.generic.ReferenceType)) {
            constraintViolated( o, "The stack top should be of a ReferenceType, but is '" + stack().peek() + "'." );
        }
    }

    public  void visitMONITOREXIT( org.apache.bcel.generic.MONITOREXIT o )
    {
        if (!(stack().peek() instanceof org.apache.bcel.generic.ReferenceType)) {
            constraintViolated( o, "The stack top should be of a ReferenceType, but is '" + stack().peek() + "'." );
        }
    }

    public  void visitMULTIANEWARRAY( org.apache.bcel.generic.MULTIANEWARRAY o )
    {
        int dimensions = o.getDimensions();
        for (int i = 0; i < dimensions; i++) {
            if (stack().peek( i ) != Type.INT) {
                constraintViolated( o, "The '" + dimensions + "' upper stack types should be 'int' but aren't." );
            }
        }
    }

    public  void visitNEW( org.apache.bcel.generic.NEW o )
    {
        org.apache.bcel.generic.Type t = o.getType( cpg );
        if (!(t instanceof org.apache.bcel.generic.ReferenceType)) {
            throw new org.apache.bcel.verifier.exc.AssertionViolatedException( "NEW.getType() returning a non-reference type?!" );
        }
        if (!(t instanceof org.apache.bcel.generic.ObjectType)) {
            constraintViolated( o, "Expecting a class type (ObjectType) to work on. Found: '" + t + "'." );
        }
        org.apache.bcel.generic.ObjectType obj = (org.apache.bcel.generic.ObjectType) t;
        if (!obj.referencesClass()) {
            constraintViolated( o, "Expecting a class type (ObjectType) to work on. Found: '" + obj + "'." );
        }
    }

    public  void visitNEWARRAY( org.apache.bcel.generic.NEWARRAY o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
    }

    public  void visitNOP( org.apache.bcel.generic.NOP o )
    {
    }

    public  void visitPOP( org.apache.bcel.generic.POP o )
    {
        if (stack().peek().getSize() != 1) {
            constraintViolated( o, "Stack top size should be 1 but stack top is '" + stack().peek() + "' of size '" + stack().peek().getSize() + "'." );
        }
    }

    public  void visitPOP2( org.apache.bcel.generic.POP2 o )
    {
        if (stack().peek().getSize() != 2) {
            constraintViolated( o, "Stack top size should be 2 but stack top is '" + stack().peek() + "' of size '" + stack().peek().getSize() + "'." );
        }
    }

    public  void visitPUTFIELD( org.apache.bcel.generic.PUTFIELD o )
    {
        try {
            org.apache.bcel.generic.Type objectref = stack().peek( 1 );
            if (!(objectref instanceof org.apache.bcel.generic.ObjectType || objectref == Type.NULL)) {
                constraintViolated( o, "Stack next-to-top should be an object reference that's not an array reference, but is '" + objectref + "'." );
            }
            java.lang.String field_name = o.getFieldName( cpg );
            org.apache.bcel.classfile.JavaClass jc = Repository.lookupClass( o.getClassType( cpg ).getClassName() );
            org.apache.bcel.classfile.Field[] fields = jc.getFields();
            org.apache.bcel.classfile.Field f = null;
            for (int i = 0; i < fields.length; i++) {
                if (fields[i].getName().equals( field_name )) {
                    org.apache.bcel.generic.Type f_type = Type.getType( fields[i].getSignature() );
                    org.apache.bcel.generic.Type o_type = o.getType( cpg );
                    if (f_type.equals( o_type )) {
                        f = fields[i];
                        break;
                    }
                }
            }
            if (f == null) {
                throw new org.apache.bcel.verifier.exc.AssertionViolatedException( "Field not found?!?" );
            }
            org.apache.bcel.generic.Type value = stack().peek();
            org.apache.bcel.generic.Type t = Type.getType( f.getSignature() );
            org.apache.bcel.generic.Type shouldbe = t;
            if (shouldbe == Type.BOOLEAN || shouldbe == Type.BYTE || shouldbe == Type.CHAR || shouldbe == Type.SHORT) {
                shouldbe = Type.INT;
            }
            if (t instanceof org.apache.bcel.generic.ReferenceType) {
                org.apache.bcel.generic.ReferenceType rvalue = null;
                if (value instanceof org.apache.bcel.generic.ReferenceType) {
                    rvalue = (org.apache.bcel.generic.ReferenceType) value;
                    referenceTypeIsInitialized( o, rvalue );
                } else {
                    constraintViolated( o, "The stack top type '" + value + "' is not of a reference type as expected." );
                }
                if (!rvalue.isAssignmentCompatibleWith( shouldbe )) {
                    constraintViolated( o, "The stack top type '" + value + "' is not assignment compatible with '" + shouldbe + "'." );
                }
            } else {
                if (shouldbe != value) {
                    constraintViolated( o, "The stack top type '" + value + "' is not of type '" + shouldbe + "' as expected." );
                }
            }
            if (f.isProtected()) {
                org.apache.bcel.generic.ObjectType classtype = o.getClassType( cpg );
                org.apache.bcel.generic.ObjectType curr = new org.apache.bcel.generic.ObjectType( mg.getClassName() );
                if (classtype.equals( curr ) || curr.subclassOf( classtype )) {
                    org.apache.bcel.generic.Type tp = stack().peek( 1 );
                    if (tp == Type.NULL) {
                        return;
                    }
                    if (!(tp instanceof org.apache.bcel.generic.ObjectType)) {
                        constraintViolated( o, "The 'objectref' must refer to an object that's not an array. Found instead: '" + tp + "'." );
                    }
                    org.apache.bcel.generic.ObjectType objreftype = (org.apache.bcel.generic.ObjectType) tp;
                    if (!(objreftype.equals( curr ) || objreftype.subclassOf( curr ))) {
                        constraintViolated( o, "The referenced field has the ACC_PROTECTED modifier, and it's a member of the current class or a superclass of the current class. However, the referenced object type '" + stack().peek() + "' is not the current class or a subclass of the current class." );
                    }
                }
            }
            if (f.isStatic()) {
                constraintViolated( o, "Referenced field '" + f + "' is static which it shouldn't be." );
            }
        } catch ( java.lang.ClassNotFoundException e ) {
            throw new org.apache.bcel.verifier.exc.AssertionViolatedException( "Missing class: " + e.toString() );
        }
    }

    public  void visitPUTSTATIC( org.apache.bcel.generic.PUTSTATIC o )
    {
        try {
            java.lang.String field_name = o.getFieldName( cpg );
            org.apache.bcel.classfile.JavaClass jc = Repository.lookupClass( o.getClassType( cpg ).getClassName() );
            org.apache.bcel.classfile.Field[] fields = jc.getFields();
            org.apache.bcel.classfile.Field f = null;
            for (int i = 0; i < fields.length; i++) {
                if (fields[i].getName().equals( field_name )) {
                    org.apache.bcel.generic.Type f_type = Type.getType( fields[i].getSignature() );
                    org.apache.bcel.generic.Type o_type = o.getType( cpg );
                    if (f_type.equals( o_type )) {
                        f = fields[i];
                        break;
                    }
                }
            }
            if (f == null) {
                throw new org.apache.bcel.verifier.exc.AssertionViolatedException( "Field not found?!?" );
            }
            org.apache.bcel.generic.Type value = stack().peek();
            org.apache.bcel.generic.Type t = Type.getType( f.getSignature() );
            org.apache.bcel.generic.Type shouldbe = t;
            if (shouldbe == Type.BOOLEAN || shouldbe == Type.BYTE || shouldbe == Type.CHAR || shouldbe == Type.SHORT) {
                shouldbe = Type.INT;
            }
            if (t instanceof org.apache.bcel.generic.ReferenceType) {
                org.apache.bcel.generic.ReferenceType rvalue = null;
                if (value instanceof org.apache.bcel.generic.ReferenceType) {
                    rvalue = (org.apache.bcel.generic.ReferenceType) value;
                    referenceTypeIsInitialized( o, rvalue );
                } else {
                    constraintViolated( o, "The stack top type '" + value + "' is not of a reference type as expected." );
                }
                if (!rvalue.isAssignmentCompatibleWith( shouldbe )) {
                    constraintViolated( o, "The stack top type '" + value + "' is not assignment compatible with '" + shouldbe + "'." );
                }
            } else {
                if (shouldbe != value) {
                    constraintViolated( o, "The stack top type '" + value + "' is not of type '" + shouldbe + "' as expected." );
                }
            }
        } catch ( java.lang.ClassNotFoundException e ) {
            throw new org.apache.bcel.verifier.exc.AssertionViolatedException( "Missing class: " + e.toString() );
        }
    }

    public  void visitRET( org.apache.bcel.generic.RET o )
    {
        if (!(locals().get( o.getIndex() ) instanceof org.apache.bcel.generic.ReturnaddressType)) {
            constraintViolated( o, "Expecting a ReturnaddressType in local variable " + o.getIndex() + "." );
        }
        if (locals().get( o.getIndex() ) == ReturnaddressType.NO_TARGET) {
            throw new org.apache.bcel.verifier.exc.AssertionViolatedException( "Oops: RET expecting a target!" );
        }
    }

    public  void visitRETURN( org.apache.bcel.generic.RETURN o )
    {
        if (mg.getName().equals( Constants.CONSTRUCTOR_NAME )) {
            if (Frame._this != null && !mg.getClassName().equals( Type.OBJECT.getClassName() )) {
                constraintViolated( o, "Leaving a constructor that itself did not call a constructor." );
            }
        }
    }

    public  void visitSALOAD( org.apache.bcel.generic.SALOAD o )
    {
        indexOfInt( o, stack().peek() );
        if (stack().peek( 1 ) == Type.NULL) {
            return;
        }
        if (!(stack().peek( 1 ) instanceof org.apache.bcel.generic.ArrayType)) {
            constraintViolated( o, "Stack next-to-top must be of type short[] but is '" + stack().peek( 1 ) + "'." );
        }
        org.apache.bcel.generic.Type t = ((org.apache.bcel.generic.ArrayType) stack().peek( 1 )).getBasicType();
        if (t != Type.SHORT) {
            constraintViolated( o, "Stack next-to-top must be of type short[] but is '" + stack().peek( 1 ) + "'." );
        }
    }

    public  void visitSASTORE( org.apache.bcel.generic.SASTORE o )
    {
        if (stack().peek() != Type.INT) {
            constraintViolated( o, "The value at the stack top is not of type 'int', but of type '" + stack().peek() + "'." );
        }
        indexOfInt( o, stack().peek( 1 ) );
        if (stack().peek( 2 ) == Type.NULL) {
            return;
        }
        if (!(stack().peek( 2 ) instanceof org.apache.bcel.generic.ArrayType)) {
            constraintViolated( o, "Stack next-to-next-to-top must be of type short[] but is '" + stack().peek( 2 ) + "'." );
        }
        org.apache.bcel.generic.Type t = ((org.apache.bcel.generic.ArrayType) stack().peek( 2 )).getBasicType();
        if (t != Type.SHORT) {
            constraintViolated( o, "Stack next-to-next-to-top must be of type short[] but is '" + stack().peek( 2 ) + "'." );
        }
    }

    public  void visitSIPUSH( org.apache.bcel.generic.SIPUSH o )
    {
    }

    public  void visitSWAP( org.apache.bcel.generic.SWAP o )
    {
        if (stack().peek().getSize() != 1) {
            constraintViolated( o, "The value at the stack top is not of size '1', but of size '" + stack().peek().getSize() + "'." );
        }
        if (stack().peek( 1 ).getSize() != 1) {
            constraintViolated( o, "The value at the stack next-to-top is not of size '1', but of size '" + stack().peek( 1 ).getSize() + "'." );
        }
    }

    public  void visitTABLESWITCH( org.apache.bcel.generic.TABLESWITCH o )
    {
        indexOfInt( o, stack().peek() );
    }

}
