// This is a mutant program.
// Author : ysma

package com.mongodb;


import org.bson.BSONException;
import org.bson.io.OutputBuffer;
import org.bson.types.BSONTimestamp;
import org.bson.types.Binary;
import org.bson.types.ObjectId;
import java.util.Stack;
import static org.bson.util.Assertions.*;


class BSONBinaryWriter extends com.mongodb.BSONWriter
{

    private final com.mongodb.BSONBinaryWriterSettings binaryWriterSettings;

    private final org.bson.io.OutputBuffer buffer;

    private final java.util.Stack<Integer> maxDocumentSizeStack = new java.util.Stack<Integer>();

    private com.mongodb.BSONBinaryWriter.Mark mark;

    public BSONBinaryWriter( final org.bson.io.OutputBuffer buffer )
    {
        this( new com.mongodb.BSONWriterSettings(), new com.mongodb.BSONBinaryWriterSettings(), buffer );
    }

    public BSONBinaryWriter( final com.mongodb.BSONWriterSettings settings, final com.mongodb.BSONBinaryWriterSettings binaryWriterSettings, final org.bson.io.OutputBuffer buffer )
    {
        super( settings );
        this.binaryWriterSettings = binaryWriterSettings;
        this.buffer = buffer;
        maxDocumentSizeStack.push( binaryWriterSettings.getMaxDocumentSize() );
    }

    public  void close()
    {
        super.close();
    }

    public  org.bson.io.OutputBuffer getBuffer()
    {
        return buffer;
    }

    public  void flush()
    {
    }

    protected  com.mongodb.BSONBinaryWriter.Context getContext()
    {
        return (com.mongodb.BSONBinaryWriter.Context) super.getContext();
    }

    public  void writeBinaryData( final org.bson.types.Binary binary )
    {
        checkPreconditions( "writeBinaryData", State.VALUE );
        buffer.write( BSONType.BINARY.getValue() );
        writeCurrentName();
        int totalLen = binary.length();
        if (binary.getType() == BSONBinarySubType.OldBinary.getValue()) {
            totalLen += 4;
        }
        buffer.writeInt( totalLen );
        buffer.write( binary.getType() );
        if (binary.getType() == BSONBinarySubType.OldBinary.getValue()) {
            buffer.writeInt( totalLen - 4 );
        }
        buffer.write( binary.getData() );
        setState( getNextState() );
    }

    public  void writeBoolean( final boolean value )
    {
        checkPreconditions( "writeBoolean", State.VALUE );
        buffer.write( BSONType.BOOLEAN.getValue() );
        writeCurrentName();
        buffer.write( value ? 1 : 0 );
        setState( getNextState() );
    }

    public  void writeDateTime( final long value )
    {
        checkPreconditions( "writeDateTime", State.VALUE );
        buffer.write( BSONType.DATE_TIME.getValue() );
        writeCurrentName();
        buffer.writeLong( value );
        setState( getNextState() );
    }

    public  void writeDouble( final double value )
    {
        checkPreconditions( "writeDouble", State.VALUE );
        buffer.write( BSONType.DOUBLE.getValue() );
        writeCurrentName();
        buffer.writeDouble( value );
        setState( getNextState() );
    }

    public  void writeInt32( final int value )
    {
        checkPreconditions( "writeInt32", State.VALUE );
        buffer.write( BSONType.INT32.getValue() );
        writeCurrentName();
        buffer.writeInt( value );
        setState( getNextState() );
    }

    public  void writeInt64( final long value )
    {
        checkPreconditions( "writeInt64", State.VALUE );
        buffer.write( BSONType.INT64.getValue() );
        writeCurrentName();
        buffer.writeLong( value );
        setState( getNextState() );
    }

    public  void writeJavaScript( final java.lang.String code )
    {
        checkPreconditions( "writeJavaScript", State.VALUE );
        buffer.write( BSONType.JAVASCRIPT.getValue() );
        writeCurrentName();
        buffer.writeString( code );
        setState( getNextState() );
    }

    public  void writeJavaScriptWithScope( final java.lang.String code )
    {
        checkPreconditions( "writeJavaScriptWithScope", State.VALUE );
        buffer.write( BSONType.JAVASCRIPT_WITH_SCOPE.getValue() );
        writeCurrentName();
        setContext( new com.mongodb.BSONBinaryWriter.Context( getContext(), BSONContextType.JAVASCRIPT_WITH_SCOPE, buffer.getPosition() ) );
        buffer.writeInt( 0 );
        buffer.writeString( code );
        setState( State.SCOPE_DOCUMENT );
    }

    public  void writeMaxKey()
    {
        checkPreconditions( "writeMaxKey", State.VALUE );
        buffer.write( BSONType.MAX_KEY.getValue() );
        writeCurrentName();
        setState( getNextState() );
    }

    public  void writeMinKey()
    {
        checkPreconditions( "writeMinKey", State.VALUE );
        buffer.write( BSONType.MIN_KEY.getValue() );
        writeCurrentName();
        setState( getNextState() );
    }

    public  void writeNull()
    {
        checkPreconditions( "writeNull", State.VALUE );
        buffer.write( BSONType.NULL.getValue() );
        writeCurrentName();
        setState( getNextState() );
    }

    public  void writeObjectId( final org.bson.types.ObjectId objectId )
    {
        checkPreconditions( "writeObjectId", State.VALUE );
        buffer.write( BSONType.OBJECT_ID.getValue() );
        writeCurrentName();
        buffer.write( objectId.toByteArray() );
        setState( getNextState() );
    }

    public  void writeString( final java.lang.String value )
    {
        checkPreconditions( "writeString", State.VALUE );
        buffer.write( BSONType.STRING.getValue() );
        writeCurrentName();
        buffer.writeString( value );
        setState( getNextState() );
    }

    public  void writeSymbol( final java.lang.String value )
    {
        checkPreconditions( "writeSymbol", State.VALUE );
        buffer.write( BSONType.SYMBOL.getValue() );
        writeCurrentName();
        buffer.writeString( value );
        setState( getNextState() );
    }

    public  void writeTimestamp( final org.bson.types.BSONTimestamp value )
    {
        checkPreconditions( "writeTimestamp", State.VALUE );
        buffer.write( BSONType.TIMESTAMP.getValue() );
        writeCurrentName();
        buffer.writeInt( value.getInc() );
        buffer.writeInt( value.getTime() );
        setState( getNextState() );
    }

    public  void writeUndefined()
    {
        checkPreconditions( "writeUndefined", State.VALUE );
        buffer.write( BSONType.UNDEFINED.getValue() );
        writeCurrentName();
        setState( getNextState() );
    }

    public  void writeStartArray()
    {
        checkPreconditions( "writeStartArray", State.VALUE );
        super.writeStartArray();
        buffer.write( BSONType.ARRAY.getValue() );
        writeCurrentName();
        setContext( new com.mongodb.BSONBinaryWriter.Context( getContext(), BSONContextType.ARRAY, buffer.getPosition() ) );
        buffer.writeInt( 0 );
        setState( State.VALUE );
    }

    public  void writeStartDocument()
    {
        checkPreconditions( "writeStartDocument", State.INITIAL, State.VALUE, State.SCOPE_DOCUMENT, State.DONE );
        super.writeStartDocument();
        if (getState() == State.VALUE) {
            buffer.write( BSONType.DOCUMENT.getValue() );
            writeCurrentName();
        }
        setContext( new com.mongodb.BSONBinaryWriter.Context( getContext(), BSONContextType.DOCUMENT, buffer.getPosition() ) );
        buffer.writeInt( 0 );
        setState( State.NAME );
    }

    public  void writeEndArray()
    {
        checkPreconditions( "writeEndArray", State.VALUE );
        if (getContext().getContextType() != BSONContextType.ARRAY) {
            throwInvalidContextType( "WriteEndArray", getContext().getContextType(), BSONContextType.ARRAY );
        }
        super.writeEndArray();
        buffer.write( 0 );
        backpatchSize();
        setContext( getContext().getParentContext() );
        setState( getNextState() );
    }

    public  void writeEndDocument()
    {
        checkPreconditions( "writeEndDocument", State.NAME );
        com.mongodb.BSONContextType contextType = getContext().getContextType();
        if (contextType != BSONContextType.DOCUMENT && contextType != BSONContextType.SCOPE_DOCUMENT) {
            throwInvalidContextType( "WriteEndDocument", contextType, BSONContextType.DOCUMENT, BSONContextType.SCOPE_DOCUMENT );
        }
        super.writeEndDocument();
        buffer.write( 0 );
        backpatchSize();
        setContext( getContext().getParentContext() );
        if (getContext() == null) {
            setState( State.DONE );
        } else {
            if (getContext().getContextType() == BSONContextType.JAVASCRIPT_WITH_SCOPE) {
                backpatchSize();
                setContext( getContext().getParentContext() );
            }
            setState( getNextState() );
        }
    }

    public  void encodeDocument( final com.mongodb.DBEncoder encoder, final com.mongodb.DBObject dbObject )
    {
        checkPreconditions( "writeStartDocument", State.INITIAL, State.VALUE, State.SCOPE_DOCUMENT, State.DONE );
        org.bson.util.Assertions.isTrue( "state is VALUE", getState() == State.VALUE );
        org.bson.util.Assertions.isTrue( "context not null", getContext() != null );
        org.bson.util.Assertions.isTrue( "context is not JAVASCRIPT_WITH_SCOPE", getContext().getContextType() != BSONContextType.JAVASCRIPT_WITH_SCOPE );
        buffer.write( BSONType.DOCUMENT.getValue() );
        writeCurrentName();
        int startPos = buffer.getPosition();
        encoder.writeObject( buffer, dbObject );
        throwIfSizeExceedsLimit( buffer.getPosition() - startPos );
        setState( getNextState() );
    }

    public  void pushMaxDocumentSize( final int maxDocumentSize )
    {
        maxDocumentSizeStack.push( maxDocumentSize );
    }

    public  void popMaxDocumentSize()
    {
        maxDocumentSizeStack.pop();
    }

    public  void mark()
    {
        mark = new com.mongodb.BSONBinaryWriter.Mark();
    }

    public  void reset()
    {
        if (mark == null) {
            throw new java.lang.IllegalStateException( "Can not reset without first marking" );
        }
        mark.reset();
        mark = null;
    }

    private  void writeCurrentName()
    {
        if (getContext().getContextType() == BSONContextType.ARRAY) {
            buffer.writeCString( Integer.toString( getContext().index++ ) );
        } else {
            buffer.writeCString( getName() );
        }
    }

    private  void backpatchSize()
    {
        final int size = buffer.getPosition() - getContext().startPosition;
        throwIfSizeExceedsLimit( size );
        buffer.backpatchSize( size );
    }

    private  void throwIfSizeExceedsLimit( final int size )
    {
        if (size > maxDocumentSizeStack.peek()) {
            final java.lang.String message = String.format( "Size %d is larger than MaxDocumentSize %d.", buffer.getPosition() - getContext().startPosition, binaryWriterSettings.getMaxDocumentSize() );
            throw new com.mongodb.MongoInternalException( message );
        }
    }

    public class Context extends com.mongodb.BSONWriter.Context
    {

        private final int startPosition;

        private int index;

        public Context( final com.mongodb.BSONBinaryWriter.Context parentContext, final com.mongodb.BSONContextType contextType, final int startPosition )
        {
            super( parentContext, contextType );
            this.startPosition = startPosition;
        }

        public Context( final com.mongodb.BSONBinaryWriter.Context from )
        {
            super( from );
            startPosition = from.startPosition;
            index = from.index;
        }

        public  com.mongodb.BSONBinaryWriter.Context getParentContext()
        {
            return (com.mongodb.BSONBinaryWriter.Context) super.getParentContext();
        }

        public  com.mongodb.BSONBinaryWriter.Context copy()
        {
            return new com.mongodb.BSONBinaryWriter.Context( this );
        }

    }

    protected class Mark extends com.mongodb.BSONWriter.Mark
    {

        private final int position;

        protected Mark()
        {
            this.position = buffer.getPosition();
        }

        protected  void reset()
        {
            super.reset();
            buffer.truncateToPosition( mark.position );
        }

    }

}
