// This is a mutant program.
// Author : ysma

package com.mongodb;


import com.mongodb.DBApiLayer.Result;
import org.bson.util.annotations.NotThreadSafe;
import java.io.Closeable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.concurrent.TimeUnit;
import static java.util.concurrent.TimeUnit.MILLISECONDS;


public class DBCursor implements java.util.Iterator<DBObject>, java.lang.Iterable<DBObject>, java.io.Closeable
{

    public DBCursor( com.mongodb.DBCollection collection, com.mongodb.DBObject q, com.mongodb.DBObject k, com.mongodb.ReadPreference preference )
    {
        if (collection == null) {
            throw new java.lang.IllegalArgumentException( "collection is null" );
        }
        _collection = collection;
        _query = q == null ? new com.mongodb.BasicDBObject() : q;
        _keysWanted = k;
        _options = _collection.getOptions();
        _readPref = preference;
        _decoderFact = collection.getDBDecoderFactory();
    }

    static enum CursorType 
    {
        ITERATOR,
        ARRAY;

    }

    public  com.mongodb.DBCursor copy()
    {
        com.mongodb.DBCursor c = new com.mongodb.DBCursor( _collection, _query, _keysWanted, _readPref );
        c._orderBy = _orderBy;
        c._hint = _hint;
        c._hintDBObj = _hintDBObj;
        c._limit = _limit;
        c._skip = _skip;
        c._options = _options;
        c._batchSize = _batchSize;
        c._snapshot = _snapshot;
        c._explain = _explain;
        c._maxTimeMS = _maxTimeMS;
        if (_specialFields != null) {
            c._specialFields = new com.mongodb.BasicDBObject( _specialFields.toMap() );
        }
        return c;
    }

    public  java.util.Iterator<DBObject> iterator()
    {
        return this.copy();
    }

    public  com.mongodb.DBCursor sort( com.mongodb.DBObject orderBy )
    {
        if (_it != null) {
            throw new java.lang.IllegalStateException( "can't sort after executing query" );
        }
        _orderBy = orderBy;
        return this;
    }

    public  com.mongodb.DBCursor addSpecial( java.lang.String name, java.lang.Object o )
    {
        if (_specialFields == null) {
            _specialFields = new com.mongodb.BasicDBObject();
        }
        _specialFields.put( name, o );
        return this;
    }

    public  com.mongodb.DBCursor hint( com.mongodb.DBObject indexKeys )
    {
        if (_it != null) {
            throw new java.lang.IllegalStateException( "can't hint after executing query" );
        }
        _hintDBObj = indexKeys;
        return this;
    }

    public  com.mongodb.DBCursor hint( java.lang.String indexName )
    {
        if (_it != null) {
            throw new java.lang.IllegalStateException( "can't hint after executing query" );
        }
        _hint = indexName;
        return this;
    }

    public  com.mongodb.DBCursor maxTime( final long maxTime, final java.util.concurrent.TimeUnit timeUnit )
    {
        _maxTimeMS = MILLISECONDS.convert( maxTime, timeUnit );
        return this;
    }

    public  com.mongodb.DBCursor snapshot()
    {
        if (_it != null) {
            throw new java.lang.IllegalStateException( "can't snapshot after executing the query" );
        }
        _snapshot = true;
        return this;
    }

    public  com.mongodb.DBObject explain()
    {
        com.mongodb.DBCursor c = copy();
        c._explain = true;
        if (c._limit > 0) {
            c._batchSize = c._limit * -1;
            c._limit = 0;
        }
        return c.next();
    }

    public  com.mongodb.DBCursor limit( int n )
    {
        if (_it != null) {
            throw new java.lang.IllegalStateException( "can't set limit after executing query" );
        }
        if (n > 0) {
            _limit = n;
        } else {
            if (n < 0) {
                batchSize( n );
            }
        }
        return this;
    }

    public  com.mongodb.DBCursor batchSize( int n )
    {
        if (n == 1) {
            n = 2;
        }
        if (_it != null) {
            if (_it instanceof com.mongodb.DBApiLayer.Result) {
                ((com.mongodb.DBApiLayer.Result) _it).setBatchSize( n );
            }
        }
        _batchSize = n;
        return this;
    }

    public  com.mongodb.DBCursor skip( int n )
    {
        if (_it != null) {
            throw new java.lang.IllegalStateException( "can't set skip after executing query" );
        }
        _skip = n;
        return this;
    }

    public  long getCursorId()
    {
        if (_it instanceof com.mongodb.DBApiLayer.Result) {
            return ((com.mongodb.DBApiLayer.Result) _it).getCursorId();
        }
        return 0;
    }

    public  void close()
    {
        if (_it instanceof com.mongodb.DBApiLayer.Result) {
            ((com.mongodb.DBApiLayer.Result) _it).close();
        }
    }

    public  com.mongodb.DBCursor slaveOk()
    {
        return addOption( Bytes.QUERYOPTION_SLAVEOK );
    }

    public  com.mongodb.DBCursor addOption( int option )
    {
        if (option == Bytes.QUERYOPTION_EXHAUST) {
            throw new java.lang.IllegalArgumentException( "The exhaust option is not user settable." );
        }
        _options |= option;
        return this;
    }

    public  com.mongodb.DBCursor setOptions( int options )
    {
        _options = options;
        return this;
    }

    public  com.mongodb.DBCursor resetOptions()
    {
        _options = 0;
        return this;
    }

    public  int getOptions()
    {
        return _options;
    }

    private  void _check()
    {
        if (_it != null) {
            return;
        }
        _lookForHints();
        com.mongodb.QueryOpBuilder builder = (new com.mongodb.QueryOpBuilder()).addQuery( _query ).addOrderBy( _orderBy ).addHint( _hintDBObj ).addHint( _hint ).addExplain( _explain ).addSnapshot( _snapshot ).addSpecialFields( _specialFields ).addMaxTimeMS( _maxTimeMS );
        if (_collection.getDB().getMongo().isMongosConnection()) {
            builder.addReadPreference( _readPref );
        }
        _it = _collection.__find( builder.get(), _keysWanted, _skip, _batchSize, _limit, _options, _readPref, getDecoder() );
    }

    private  com.mongodb.DBDecoder getDecoder()
    {
        return _decoderFact != null ? _decoderFact.create() : null;
    }

    private  void _lookForHints()
    {
        if (_hint != null) {
            return;
        }
        if (_collection._hintFields == null) {
            return;
        }
        java.util.Set<String> mykeys = _query.keySet();
        for (com.mongodb.DBObject o: _collection._hintFields) {
            java.util.Set<String> hintKeys = o.keySet();
            if (!mykeys.containsAll( hintKeys )) {
                continue;
            }
            hint( o );
            return;
        }
    }

     void _checkType( com.mongodb.DBCursor.CursorType type )
    {
        if (_cursorType == null) {
            _cursorType = type;
            return;
        }
        if (type == _cursorType) {
            return;
        }
        throw new java.lang.IllegalArgumentException( "can't switch cursor access methods" );
    }

    private  com.mongodb.DBObject _next()
    {
        if (_cursorType == null) {
            _checkType( CursorType.ITERATOR );
        }
        _check();
        _cur = _it.next();
        _num++;
        if (_keysWanted != null && _keysWanted.keySet().size() > 0) {
            _cur.markAsPartialObject();
        }
        if (_cursorType == CursorType.ARRAY) {
            _all.add( _cur );
        }
        return _cur;
    }

    public  int numGetMores()
    {
        if (_it instanceof com.mongodb.DBApiLayer.Result) {
            return ((com.mongodb.DBApiLayer.Result) _it).numGetMores();
        }
        throw new java.lang.IllegalArgumentException( "_it not a real result" );
    }

    public  java.util.List<Integer> getSizes()
    {
        if (_it instanceof com.mongodb.DBApiLayer.Result) {
            return ((com.mongodb.DBApiLayer.Result) _it).getSizes();
        }
        throw new java.lang.IllegalArgumentException( "_it not a real result" );
    }

    private  boolean _hasNext()
    {
        _check();
        if (_limit > 0 && _num >= _limit) {
            return false;
        }
        return _it.hasNext();
    }

    public  int numSeen()
    {
        return _num;
    }

    public  boolean hasNext()
    {
        _checkType( CursorType.ITERATOR );
        return _hasNext();
    }

    public  com.mongodb.DBObject next()
    {
        _checkType( CursorType.ITERATOR );
        return _next();
    }

    public  com.mongodb.DBObject curr()
    {
        _checkType( CursorType.ITERATOR );
        return _cur;
    }

    public  void remove()
    {
        throw new java.lang.UnsupportedOperationException( "can't remove from a cursor" );
    }

     void _fill( int n )
    {
        _checkType( CursorType.ARRAY );
        while (n >= _all.size() && _hasNext()) {
            _next();
        }
    }

    public  int length()
    {
        _checkType( CursorType.ARRAY );
        _fill( Integer.MAX_VALUE );
        return _all.size();
    }

    public  java.util.List<DBObject> toArray()
    {
        return toArray( Integer.MAX_VALUE );
    }

    public  java.util.List<DBObject> toArray( int max )
    {
        _checkType( CursorType.ARRAY );
        _fill( max - 1 );
        return _all;
    }

    public  int itcount()
    {
        int n = 0;
        while (this.hasNext()) {
            this.next();
            n++;
        }
        return n;
    }

    public  int count()
    {
        if (_collection == null) {
            throw new java.lang.IllegalArgumentException( "why is _collection null" );
        }
        if (_collection._db == null) {
            throw new java.lang.IllegalArgumentException( "why is _collection._db null" );
        }
        return (int) _collection.getCount( this._query, this._keysWanted, 0, 0, getReadPreference(), _maxTimeMS, java.util.concurrent.TimeUnit.MILLISECONDS );
    }

    public  com.mongodb.DBObject one()
    {
        return _collection.findOne( _query, _keysWanted, _orderBy, getReadPreference(), _maxTimeMS, java.util.concurrent.TimeUnit.MILLISECONDS );
    }

    public  int size()
    {
        if (_collection == null) {
            throw new java.lang.IllegalArgumentException( "why is _collection null" );
        }
        if (_collection._db == null) {
            throw new java.lang.IllegalArgumentException( "why is _collection._db null" );
        }
        return (int) _collection.getCount( this._query, this._keysWanted, this._limit, this._skip, getReadPreference(), _maxTimeMS, java.util.concurrent.TimeUnit.MILLISECONDS );
    }

    public  com.mongodb.DBObject getKeysWanted()
    {
        return _keysWanted;
    }

    public  com.mongodb.DBObject getQuery()
    {
        return _query;
    }

    public  com.mongodb.DBCollection getCollection()
    {
        return _collection;
    }

    public  com.mongodb.ServerAddress getServerAddress()
    {
        if (_it != null && _it instanceof com.mongodb.DBApiLayer.Result) {
            return ((com.mongodb.DBApiLayer.Result) _it).getServerAddress();
        }
        return null;
    }

    public  com.mongodb.DBCursor setReadPreference( com.mongodb.ReadPreference preference )
    {
        _readPref = preference;
        return this;
    }

    public  com.mongodb.ReadPreference getReadPreference()
    {
        return _readPref;
    }

    public  com.mongodb.DBCursor setDecoderFactory( com.mongodb.DBDecoderFactory fact )
    {
        _decoderFact = fact;
        return this;
    }

    public  com.mongodb.DBDecoderFactory getDecoderFactory()
    {
        return _decoderFact;
    }

    public  java.lang.String toString()
    {
        java.lang.StringBuilder sb = new java.lang.StringBuilder();
        sb.append( "Cursor id=" ).append( getCursorId() );
        sb.append( ", ns=" ).append( getCollection().getFullName() );
        sb.append( ", query=" ).append( getQuery() );
        if (getKeysWanted() != null) {
            sb.append( ", fields=" ).append( getKeysWanted() );
        }
        sb.append( ", numIterated=" ).append( _num );
        if (_skip != 0) {
            sb.append( ", skip=" ).append( _skip );
        }
        if (_limit != 0) {
            sb.append( ", limit=" ).append( _limit );
        }
        if (_batchSize != 0) {
            sb.append( ", batchSize=" ).append( _batchSize );
        }
        com.mongodb.ServerAddress addr = getServerAddress();
        if (addr != null) {
            sb.append( ", addr=" ).append( addr );
        }
        if (_readPref != null) {
            sb.append( ", readPreference=" ).append( _readPref.toString() );
        }
        return sb.toString();
    }

     boolean hasFinalizer()
    {
        if (_it == null || !(_it instanceof com.mongodb.DBApiLayer.Result)) {
            return false;
        }
        return ((com.mongodb.DBApiLayer.Result) _it).hasFinalizer();
    }

    private final com.mongodb.DBCollection _collection;

    private final com.mongodb.DBObject _query;

    private final com.mongodb.DBObject _keysWanted;

    private com.mongodb.DBObject _orderBy = null;

    private java.lang.String _hint = null;

    private com.mongodb.DBObject _hintDBObj = null;

    private boolean _explain = false;

    private int _limit = 0;

    private int _batchSize = 0;

    private int _skip = 0;

    private boolean _snapshot = false;

    private int _options = 0;

    private long _maxTimeMS;

    private com.mongodb.ReadPreference _readPref;

    private com.mongodb.DBDecoderFactory _decoderFact;

    private com.mongodb.DBObject _specialFields;

    private java.util.Iterator<DBObject> _it = null;

    private com.mongodb.DBCursor.CursorType _cursorType = null;

    private com.mongodb.DBObject _cur = null;

    private int _num = 0;

    private final java.util.ArrayList<DBObject> _all = new java.util.ArrayList<DBObject>();

}
