// This is a mutant program.
// Author : ysma

package com.mongodb;


import java.util.Collections;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import static com.mongodb.ServerConnectionState.Connecting;
import static com.mongodb.ServerConnectionState.Unconnected;
import static java.util.concurrent.TimeUnit.MILLISECONDS;
import static org.bson.util.Assertions.isTrue;
import static org.bson.util.Assertions.notNull;


class DefaultServer implements com.mongodb.ClusterableServer
{

    private final java.util.concurrent.ScheduledExecutorService scheduledExecutorService;

    private final com.mongodb.ServerAddress serverAddress;

    private final com.mongodb.ServerStateNotifier stateNotifier;

    private final java.util.concurrent.ScheduledFuture<?> scheduledFuture;

    private final java.util.Set<ChangeListener<ServerDescription>> changeListeners = Collections.newSetFromMap( new java.util.concurrent.ConcurrentHashMap<ChangeListener<ServerDescription>,Boolean>() );

    private final com.mongodb.ServerSettings settings;

    private final com.mongodb.ChangeListener<ServerDescription> serverStateListener;

    private volatile com.mongodb.ServerDescription description;

    private volatile boolean isClosed;

    public DefaultServer( final com.mongodb.ServerAddress serverAddress, final com.mongodb.ServerSettings settings, final java.util.concurrent.ScheduledExecutorService scheduledExecutorService, com.mongodb.Mongo mongo )
    {
        this.settings = org.bson.util.Assertions.notNull( "settings", settings );
        this.scheduledExecutorService = org.bson.util.Assertions.notNull( "scheduledExecutorService", scheduledExecutorService );
        this.serverAddress = org.bson.util.Assertions.notNull( "serverAddress", serverAddress );
        this.description = ServerDescription.builder().state( com.mongodb.ServerConnectionState.Connecting ).address( serverAddress ).build();
        serverStateListener = new com.mongodb.DefaultServer.DefaultServerStateListener();
        this.stateNotifier = new com.mongodb.ServerStateNotifier( serverAddress, serverStateListener, settings.getHeartbeatSocketSettings(), mongo );
        this.scheduledFuture = scheduledExecutorService.scheduleAtFixedRate( stateNotifier, 0, settings.getHeartbeatFrequency( java.util.concurrent.TimeUnit.MILLISECONDS ), java.util.concurrent.TimeUnit.MILLISECONDS );
    }

    public  com.mongodb.ServerDescription getDescription()
    {
        org.bson.util.Assertions.isTrue( "open", !isClosed() );
        return description;
    }

    public  void addChangeListener( final com.mongodb.ChangeListener<ServerDescription> changeListener )
    {
        org.bson.util.Assertions.isTrue( "open", !isClosed() );
        changeListeners.add( changeListener );
    }

    public  void invalidate()
    {
        org.bson.util.Assertions.isTrue( "open", !isClosed() );
        serverStateListener.stateChanged( new com.mongodb.ChangeEvent<ServerDescription>( description, ServerDescription.builder().state( com.mongodb.ServerConnectionState.Connecting ).address( serverAddress ).build() ) );
        scheduledExecutorService.submit( stateNotifier );
    }

    public  void close()
    {
        if (!isClosed()) {
            scheduledFuture.cancel( true );
            stateNotifier.close();
            isClosed = true;
        }
    }

    public  boolean isClosed()
    {
        return isClosed;
    }

    private  void handleException()
    {
        invalidate();
    }

    private final class DefaultServerStateListener implements com.mongodb.ChangeListener<ServerDescription>
    {

        public synchronized  void stateChanged( final com.mongodb.ChangeEvent<ServerDescription> event )
        {
            description = event.getNewValue();
            for (com.mongodb.ChangeListener<ServerDescription> listener: changeListeners) {
                listener.stateChanged( event );
            }
            if (event.getNewValue().getState() == com.mongodb.ServerConnectionState.Unconnected) {
                scheduledExecutorService.schedule( stateNotifier, settings.getHeartbeatConnectRetryFrequency( java.util.concurrent.TimeUnit.MILLISECONDS ), java.util.concurrent.TimeUnit.MILLISECONDS );
            }
        }

    }

}
