// This is a mutant program.
// Author : ysma

package com.mongodb;


import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.concurrent.TimeUnit;


class LatencyMinimizingServerSelector implements com.mongodb.ServerSelector
{

    private final long acceptableLatencyDifference;

    private final java.util.concurrent.TimeUnit timeUnit;

    LatencyMinimizingServerSelector( final long acceptableLatencyDifference, final java.util.concurrent.TimeUnit timeUnit )
    {
        this.acceptableLatencyDifference = acceptableLatencyDifference;
        this.timeUnit = timeUnit;
    }

    public  java.util.List<ServerDescription> choose( final com.mongodb.ClusterDescription clusterDescription )
    {
        return getServersWithAcceptableLatencyDifference( clusterDescription.getAll(), getBestPingTimeNanos( clusterDescription.getAll() ) );
    }

    public  java.lang.String toString()
    {
        return "LatencyMinimizingServerSelector{" + "acceptableLatencyDifference=" + acceptableLatencyDifference + ", timeUnit=" + timeUnit + '}';
    }

    private  long getBestPingTimeNanos( final java.util.Set<ServerDescription> members )
    {
        long bestPingTime = Long.MAX_VALUE;
        for (final com.mongodb.ServerDescription cur: members) {
            if (!cur.isOk()) {
                continue;
            }
            if (cur.getAveragePingTimeNanos() < bestPingTime) {
                bestPingTime = cur.getAveragePingTimeNanos();
            }
        }
        return bestPingTime;
    }

    private  java.util.List<ServerDescription> getServersWithAcceptableLatencyDifference( final java.util.Set<ServerDescription> servers, final long bestPingTime )
    {
        final java.util.List<ServerDescription> goodSecondaries = new java.util.ArrayList<ServerDescription>( servers.size() );
        for (final com.mongodb.ServerDescription cur: servers) {
            if (!cur.isOk()) {
                continue;
            }
            if (cur.getAveragePingTimeNanos() - TimeUnit.NANOSECONDS.convert( acceptableLatencyDifference, timeUnit ) <= bestPingTime) {
                goodSecondaries.add( cur );
            }
        }
        return goodSecondaries;
    }

}
