// This is a mutant program.
// Author : ysma

package com.mongodb;


import org.bson.util.annotations.Immutable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;


class MongoAuthority
{

    private final com.mongodb.MongoAuthority.Type type;

    private final java.util.List<ServerAddress> serverAddresses;

    private final com.mongodb.MongoCredentialsStore credentialsStore;

    enum Type 
    {
        Direct,
        Set;

    }

    public static  com.mongodb.MongoAuthority direct( com.mongodb.ServerAddress serverAddress )
    {
        return direct( serverAddress, (com.mongodb.MongoCredential) null );
    }

    public static  com.mongodb.MongoAuthority direct( com.mongodb.ServerAddress serverAddress, com.mongodb.MongoCredential credentials )
    {
        return direct( serverAddress, new com.mongodb.MongoCredentialsStore( credentials ) );
    }

    public static  com.mongodb.MongoAuthority direct( com.mongodb.ServerAddress serverAddress, com.mongodb.MongoCredentialsStore credentialsStore )
    {
        return new com.mongodb.MongoAuthority( serverAddress, credentialsStore );
    }

    public static  com.mongodb.MongoAuthority dynamicSet( java.util.List<ServerAddress> serverAddresses )
    {
        return dynamicSet( serverAddresses, (com.mongodb.MongoCredential) null );
    }

    public static  com.mongodb.MongoAuthority dynamicSet( java.util.List<ServerAddress> serverAddresses, com.mongodb.MongoCredential credentials )
    {
        return dynamicSet( serverAddresses, new com.mongodb.MongoCredentialsStore( credentials ) );
    }

    public static  com.mongodb.MongoAuthority dynamicSet( java.util.List<ServerAddress> serverAddresses, com.mongodb.MongoCredentialsStore credentialsStore )
    {
        return new com.mongodb.MongoAuthority( serverAddresses, Type.Set, credentialsStore );
    }

    private MongoAuthority( final com.mongodb.ServerAddress serverAddress, com.mongodb.MongoCredentialsStore credentialsStore )
    {
        if (serverAddress == null) {
            throw new java.lang.IllegalArgumentException( "serverAddress can not be null" );
        }
        if (credentialsStore == null) {
            throw new java.lang.IllegalArgumentException( "credentialsStore can not be null" );
        }
        this.serverAddresses = Arrays.asList( serverAddress );
        this.credentialsStore = credentialsStore;
        this.type = Type.Direct;
    }

    private MongoAuthority( final java.util.List<ServerAddress> serverAddresses, com.mongodb.MongoAuthority.Type type, com.mongodb.MongoCredentialsStore credentialsStore )
    {
        if (serverAddresses == null) {
            throw new java.lang.IllegalArgumentException( "serverAddresses can not be null" );
        }
        if (credentialsStore == null) {
            throw new java.lang.IllegalArgumentException( "credentialsStore can not be null" );
        }
        if (type == null) {
            throw new java.lang.IllegalArgumentException( "type can not be null" );
        }
        if (type == Type.Direct) {
            throw new java.lang.IllegalArgumentException( "type can not be Direct with a list of server addresses" );
        }
        this.type = type;
        this.serverAddresses = new java.util.ArrayList<ServerAddress>( serverAddresses );
        this.credentialsStore = credentialsStore;
    }

    public  java.util.List<ServerAddress> getServerAddresses()
    {
        return serverAddresses == null ? null : Collections.unmodifiableList( serverAddresses );
    }

    public  com.mongodb.MongoCredentialsStore getCredentialsStore()
    {
        return credentialsStore;
    }

    public  com.mongodb.MongoAuthority.Type getType()
    {
        return type;
    }

    public  boolean equals( final java.lang.Object o )
    {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        final com.mongodb.MongoAuthority that = (com.mongodb.MongoAuthority) o;
        if (!credentialsStore.equals( that.credentialsStore )) {
            return false;
        }
        if (!serverAddresses.equals( that.serverAddresses )) {
            return false;
        }
        if (type != that.type) {
            return false;
        }
        return true;
    }

    public  int hashCode()
    {
        int result = credentialsStore.hashCode();
        result = 31 * result + serverAddresses.hashCode();
        result = 31 * result + type.hashCode();
        return result;
    }

    public  java.lang.String toString()
    {
        return "MongoAuthority{" + "type=" + type + ", serverAddresses=" + serverAddresses + ", credentials=" + credentialsStore + '}';
    }

}
