// This is a mutant program.
// Author : ysma

package com.mongodb;


import org.bson.BSONObject;
import org.bson.BasicBSONEncoder;
import org.bson.io.PoolOutputBuffer;
import org.bson.types.ObjectId;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Collection;
import java.util.concurrent.atomic.AtomicInteger;


class OutMessage extends org.bson.BasicBSONEncoder
{

    enum OpCode 
    {
        OP_UPDATE( 2001 ),
        OP_INSERT( 2002 ),
        OP_QUERY( 2004 ),
        OP_GETMORE( 2005 ),
        OP_DELETE( 2006 ),
        OP_KILL_CURSORS( 2007 );
        OpCode( int value )
        {
            this.value = value;
        }

        private final int value;

        public  int getValue()
        {
            return value;
        }

    }

    static java.util.concurrent.atomic.AtomicInteger REQUEST_ID = new java.util.concurrent.atomic.AtomicInteger( 1 );

    public static  com.mongodb.OutMessage insert( final com.mongodb.DBCollection collection, final com.mongodb.DBEncoder encoder, com.mongodb.WriteConcern concern )
    {
        com.mongodb.OutMessage om = new com.mongodb.OutMessage( collection, OpCode.OP_INSERT, encoder );
        om.writeInsertPrologue( concern );
        return om;
    }

    public static  com.mongodb.OutMessage update( final com.mongodb.DBCollection collection, final com.mongodb.DBEncoder encoder, final boolean upsert, final boolean multi, final com.mongodb.DBObject query, final com.mongodb.DBObject o )
    {
        com.mongodb.OutMessage om = new com.mongodb.OutMessage( collection, OpCode.OP_UPDATE, encoder, query );
        om.writeUpdate( upsert, multi, query, o );
        return om;
    }

    public static  com.mongodb.OutMessage remove( final com.mongodb.DBCollection collection, final com.mongodb.DBEncoder encoder, final com.mongodb.DBObject query )
    {
        com.mongodb.OutMessage om = new com.mongodb.OutMessage( collection, OpCode.OP_DELETE, encoder, query );
        om.writeRemove();
        return om;
    }

    static  com.mongodb.OutMessage query( com.mongodb.DBCollection collection, int options, int numToSkip, int batchSize, com.mongodb.DBObject query, com.mongodb.DBObject fields, int maxBSONObjectSize )
    {
        return query( collection, options, numToSkip, batchSize, query, fields, ReadPreference.primary(), DefaultDBEncoder.FACTORY.create(), maxBSONObjectSize );
    }

    static  com.mongodb.OutMessage query( com.mongodb.DBCollection collection, int options, int numToSkip, int batchSize, com.mongodb.DBObject query, com.mongodb.DBObject fields, com.mongodb.ReadPreference readPref, com.mongodb.DBEncoder enc )
    {
        return query( collection, options, numToSkip, batchSize, query, fields, readPref, enc, 0 );
    }

    static  com.mongodb.OutMessage query( com.mongodb.DBCollection collection, int options, int numToSkip, int batchSize, com.mongodb.DBObject query, com.mongodb.DBObject fields, com.mongodb.ReadPreference readPref, com.mongodb.DBEncoder enc, int maxBSONObjectSize )
    {
        com.mongodb.OutMessage om = new com.mongodb.OutMessage( collection, enc, query, options, readPref, maxBSONObjectSize );
        om.writeQuery( fields, numToSkip, batchSize );
        return om;
    }

    static  com.mongodb.OutMessage getMore( com.mongodb.DBCollection collection, long cursorId, int batchSize )
    {
        com.mongodb.OutMessage om = new com.mongodb.OutMessage( collection, OpCode.OP_GETMORE );
        om.writeGetMore( cursorId, batchSize );
        return om;
    }

    static  com.mongodb.OutMessage killCursors( com.mongodb.Mongo mongo, int numCursors )
    {
        com.mongodb.OutMessage om = new com.mongodb.OutMessage( mongo, OpCode.OP_KILL_CURSORS );
        om.writeKillCursorsPrologue( numCursors );
        return om;
    }

    private OutMessage( com.mongodb.Mongo m, com.mongodb.OutMessage.OpCode opCode )
    {
        this( null, m, opCode, null );
    }

    private OutMessage( final com.mongodb.DBCollection collection, final com.mongodb.OutMessage.OpCode opCode )
    {
        this( collection, opCode, null );
    }

    private OutMessage( final com.mongodb.DBCollection collection, final com.mongodb.OutMessage.OpCode opCode, final com.mongodb.DBEncoder enc )
    {
        this( collection, collection.getDB().getMongo(), opCode, enc );
    }

    private OutMessage( final com.mongodb.DBCollection collection, final com.mongodb.Mongo m, final com.mongodb.OutMessage.OpCode opCode, final com.mongodb.DBEncoder enc )
    {
        this( collection, m, opCode, enc, null, -1, null, 0 );
    }

    private OutMessage( final com.mongodb.DBCollection collection, final com.mongodb.OutMessage.OpCode opCode, final com.mongodb.DBEncoder enc, final com.mongodb.DBObject query )
    {
        this( collection, collection.getDB().getMongo(), opCode, enc, query, 0, null, 0 );
    }

    private OutMessage( final com.mongodb.DBCollection collection, final com.mongodb.DBEncoder enc, final com.mongodb.DBObject query, final int options, final com.mongodb.ReadPreference readPref, int maxBSONObjectSize )
    {
        this( collection, collection.getDB().getMongo(), OpCode.OP_QUERY, enc, query, options, readPref, maxBSONObjectSize );
    }

    private OutMessage( final com.mongodb.DBCollection collection, final com.mongodb.Mongo m, com.mongodb.OutMessage.OpCode opCode, final com.mongodb.DBEncoder enc, final com.mongodb.DBObject query, final int options, final com.mongodb.ReadPreference readPref, int maxBSONObjectSize )
    {
        _collection = collection;
        _mongo = m;
        _encoder = enc;
        _maxBSONObjectSize = maxBSONObjectSize;
        _buffer = _mongo._bufferPool.get();
        _buffer.reset();
        set( _buffer );
        _id = REQUEST_ID.getAndIncrement();
        _opCode = opCode;
        writeMessagePrologue( opCode );
        if (query == null) {
            _query = null;
            _queryOptions = 0;
        } else {
            _query = query;
            int allOptions = options;
            if (readPref != null && readPref.isSlaveOk()) {
                allOptions |= Bytes.QUERYOPTION_SLAVEOK;
            }
            _queryOptions = allOptions;
        }
    }

    private  void writeInsertPrologue( final com.mongodb.WriteConcern concern )
    {
        int flags = 0;
        if (concern.getContinueOnErrorForInsert()) {
            flags |= 1;
        }
        writeInt( flags );
        writeCString( _collection.getFullName() );
    }

    private  void writeUpdate( final boolean upsert, final boolean multi, final com.mongodb.DBObject query, final com.mongodb.DBObject o )
    {
        writeInt( 0 );
        writeCString( _collection.getFullName() );
        int flags = 0;
        if (upsert) {
            flags |= 1;
        }
        if (multi) {
            flags |= 2;
        }
        writeInt( flags );
        putObject( query );
        putObject( o );
    }

    private  void writeRemove()
    {
        writeInt( 0 );
        writeCString( _collection.getFullName() );
        java.util.Collection<String> keys = _query.keySet();
        if (keys.size() == 1 && keys.iterator().next().equals( "_id" ) && _query.get( keys.iterator().next() ) instanceof org.bson.types.ObjectId) {
            writeInt( 1 );
        } else {
            writeInt( 0 );
        }
        putObject( _query );
    }

    private  void writeGetMore( final long cursorId, final int batchSize )
    {
        writeInt( 0 );
        writeCString( _collection.getFullName() );
        writeInt( batchSize );
        writeLong( cursorId );
    }

    private  void writeKillCursorsPrologue( final int numCursors )
    {
        writeInt( 0 );
        writeInt( numCursors );
    }

    private  void writeQuery( final com.mongodb.DBObject fields, final int numToSkip, final int batchSize )
    {
        writeInt( _queryOptions );
        writeCString( _collection.getFullName() );
        writeInt( numToSkip );
        writeInt( batchSize );
        putObject( _query );
        if (fields != null) {
            putObject( fields );
        }
    }

    private  void writeMessagePrologue( final com.mongodb.OutMessage.OpCode opCode )
    {
        writeInt( 0 );
        writeInt( _id );
        writeInt( 0 );
        writeInt( opCode.getValue() );
    }

     void prepare()
    {
        if (_buffer == null) {
            throw new java.lang.IllegalStateException( "Already closed" );
        }
        _buffer.writeInt( 0, _buffer.size() );
    }

     void pipe( java.io.OutputStream out )
        throws java.io.IOException
    {
        if (_buffer == null) {
            throw new java.lang.IllegalStateException( "Already closed" );
        }
        _buffer.pipe( out );
    }

     int size()
    {
        if (_buffer == null) {
            throw new java.lang.IllegalStateException( "Already closed" );
        }
        return _buffer.size();
    }

     void doneWithMessage()
    {
        if (_buffer == null) {
            throw new java.lang.IllegalStateException( "Only call this once per instance" );
        }
        _buffer.reset();
        _mongo._bufferPool.done( _buffer );
        _buffer = null;
        done();
    }

     boolean hasOption( int option )
    {
        return (_queryOptions & option) != 0;
    }

     int getId()
    {
        return _id;
    }

     com.mongodb.OutMessage.OpCode getOpCode()
    {
        return _opCode;
    }

     com.mongodb.DBObject getQuery()
    {
        return _query;
    }

     java.lang.String getNamespace()
    {
        return _collection != null ? _collection.getFullName() : null;
    }

     int getNumDocuments()
    {
        return _numDocuments;
    }

    public  int putObject( org.bson.BSONObject o )
    {
        if (_buffer == null) {
            throw new java.lang.IllegalStateException( "Already closed" );
        }
        int objectSize = _encoder.writeObject( _buf, o );
        if (objectSize > Math.max( _maxBSONObjectSize != 0 ? _maxBSONObjectSize : _mongo.getMaxBsonObjectSize(), Bytes.MAX_OBJECT_SIZE )) {
            throw new com.mongodb.MongoInternalException( "DBObject of size " + objectSize + " is over Max BSON size " + _mongo.getMaxBsonObjectSize() );
        }
        _numDocuments++;
        return objectSize;
    }

    private final com.mongodb.Mongo _mongo;

    private final com.mongodb.DBCollection _collection;

    private org.bson.io.PoolOutputBuffer _buffer;

    private final int _id;

    private final com.mongodb.OutMessage.OpCode _opCode;

    private final int _queryOptions;

    private final com.mongodb.DBObject _query;

    private final com.mongodb.DBEncoder _encoder;

    private final int _maxBSONObjectSize;

    private volatile int _numDocuments;

}
