// This is a mutant program.
// Author : ysma

package com.mongodb;


import java.io.Serializable;
import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.util.HashMap;
import java.util.Map;


public class WriteConcern implements java.io.Serializable
{

    private static final long serialVersionUID = 1884671104750417011L;

    public static final com.mongodb.WriteConcern ERRORS_IGNORED = new com.mongodb.WriteConcern( -1 );

    public static final com.mongodb.WriteConcern ACKNOWLEDGED = new com.mongodb.WriteConcern( 1 );

    public static final com.mongodb.WriteConcern UNACKNOWLEDGED = new com.mongodb.WriteConcern( 0 );

    public static final com.mongodb.WriteConcern FSYNCED = new com.mongodb.WriteConcern( true );

    public static final com.mongodb.WriteConcern JOURNALED = new com.mongodb.WriteConcern( 1, 0, false, true );

    public static final com.mongodb.WriteConcern REPLICA_ACKNOWLEDGED = new com.mongodb.WriteConcern( 2 );

    public static final com.mongodb.WriteConcern NONE = new com.mongodb.WriteConcern( -1 );

    public static final com.mongodb.WriteConcern NORMAL = new com.mongodb.WriteConcern( 0 );

    public static final com.mongodb.WriteConcern SAFE = new com.mongodb.WriteConcern( 1 );

    public static final com.mongodb.WriteConcern MAJORITY = new com.mongodb.WriteConcern.Majority();

    public static final com.mongodb.WriteConcern FSYNC_SAFE = new com.mongodb.WriteConcern( true );

    public static final com.mongodb.WriteConcern JOURNAL_SAFE = new com.mongodb.WriteConcern( 1, 0, false, true );

    public static final com.mongodb.WriteConcern REPLICAS_SAFE = new com.mongodb.WriteConcern( 2 );

    private static java.util.Map<String,WriteConcern> _namedConcerns = null;

    public WriteConcern()
    {
        this( 0 );
    }

    public WriteConcern( int w )
    {
        this( w, 0, false );
    }

    public WriteConcern( java.lang.String w )
    {
        this( w, 0, false, false );
    }

    public WriteConcern( int w, int wtimeout )
    {
        this( w, wtimeout, false );
    }

    public WriteConcern( boolean fsync )
    {
        this( 1, 0, fsync );
    }

    public WriteConcern( int w, int wtimeout, boolean fsync )
    {
        this( w, wtimeout, fsync, false );
    }

    public WriteConcern( int w, int wtimeout, boolean fsync, boolean j )
    {
        this( w, wtimeout, fsync, j, false );
    }

    public WriteConcern( int w, int wtimeout, boolean fsync, boolean j, boolean continueOnError )
    {
        _w = w;
        _wtimeout = wtimeout;
        _fsync = fsync;
        _j = j;
        _continueOnError = continueOnError;
    }

    public WriteConcern( java.lang.String w, int wtimeout, boolean fsync, boolean j )
    {
        this( w, wtimeout, fsync, j, false );
    }

    public WriteConcern( java.lang.String w, int wtimeout, boolean fsync, boolean j, boolean continueOnError )
    {
        if (w == null) {
            throw new java.lang.IllegalArgumentException( "w can not be null" );
        }
        _w = w;
        _wtimeout = wtimeout;
        _fsync = fsync;
        _j = j;
        _continueOnError = continueOnError;
    }

    public  com.mongodb.BasicDBObject getCommand()
    {
        com.mongodb.BasicDBObject _command = new com.mongodb.BasicDBObject( "getlasterror", 1 );
        if (_w instanceof java.lang.Integer && (java.lang.Integer) _w > 1 || _w instanceof java.lang.String) {
            _command.put( "w", _w );
        }
        if (_wtimeout > 0) {
            _command.put( "wtimeout", _wtimeout );
        }
        if (_fsync) {
            _command.put( "fsync", true );
        }
        if (_j) {
            _command.put( "j", true );
        }
        return _command;
    }

    public  void setWObject( java.lang.Object w )
    {
        if (!(w instanceof java.lang.Integer) && !(w instanceof java.lang.String)) {
            throw new java.lang.IllegalArgumentException( "The w parameter must be an int or a String" );
        }
        this._w = w;
    }

    public  java.lang.Object getWObject()
    {
        return _w;
    }

    public  int getW()
    {
        return (java.lang.Integer) _w;
    }

    public  java.lang.String getWString()
    {
        return _w.toString();
    }

    public  int getWtimeout()
    {
        return _wtimeout;
    }

    public  boolean getFsync()
    {
        return _fsync;
    }

    public  boolean fsync()
    {
        return _fsync;
    }

    public  boolean raiseNetworkErrors()
    {
        if (_w instanceof java.lang.Integer) {
            return (java.lang.Integer) _w >= 0;
        }
        return _w != null;
    }

    public  boolean callGetLastError()
    {
        if (_w instanceof java.lang.Integer) {
            return (java.lang.Integer) _w > 0;
        }
        return _w != null;
    }

    public static  com.mongodb.WriteConcern valueOf( java.lang.String name )
    {
        if (_namedConcerns == null) {
            java.util.HashMap<String,WriteConcern> newMap = new java.util.HashMap<String,WriteConcern>( 8, 1 );
            for (java.lang.reflect.Field f: (com.mongodb.WriteConcern.class).getFields()) {
                if (Modifier.isStatic( f.getModifiers() ) && f.getType().equals( com.mongodb.WriteConcern.class )) {
                    try {
                        java.lang.String key = f.getName().toLowerCase();
                        newMap.put( key, (com.mongodb.WriteConcern) f.get( null ) );
                    } catch ( java.lang.Exception e ) {
                        throw new java.lang.RuntimeException( e );
                    }
                }
            }
            _namedConcerns = newMap;
        }
        return _namedConcerns.get( name.toLowerCase() );
    }

    public  java.lang.String toString()
    {
        return "WriteConcern " + getCommand() + " / (Continue on error? " + getContinueOnErrorForInsert() + ")";
    }

    public  boolean equals( java.lang.Object o )
    {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        com.mongodb.WriteConcern that = (com.mongodb.WriteConcern) o;
        if (_continueOnError != that._continueOnError) {
            return false;
        }
        if (_fsync != that._fsync) {
            return false;
        }
        if (_j != that._j) {
            return false;
        }
        if (_wtimeout != that._wtimeout) {
            return false;
        }
        if (!_w.equals( that._w )) {
            return false;
        }
        return true;
    }

    public  int hashCode()
    {
        int result = _w.hashCode();
        result = 31 * result + _wtimeout;
        result = 31 * result + (_fsync ? 1 : 0);
        result = 31 * result + (_j ? 1 : 0);
        result = 31 * result + (_continueOnError ? 1 : 0);
        return result;
    }

    public  boolean getJ()
    {
        return _j;
    }

    public  com.mongodb.WriteConcern continueOnError( boolean continueOnError )
    {
        if (_w instanceof java.lang.Integer) {
            return new com.mongodb.WriteConcern( (java.lang.Integer) _w, _wtimeout, _fsync, _j, continueOnError );
        } else {
            if (_w instanceof java.lang.String) {
                return new com.mongodb.WriteConcern( (java.lang.String) _w, _wtimeout, _fsync, _j, continueOnError );
            } else {
                throw new java.lang.IllegalStateException( "The w parameter must be an int or a String" );
            }
        }
    }

    public  boolean getContinueOnError()
    {
        return _continueOnError;
    }

    public  com.mongodb.WriteConcern continueOnErrorForInsert( boolean continueOnErrorForInsert )
    {
        return continueOnError( continueOnErrorForInsert );
    }

    public  boolean getContinueOnErrorForInsert()
    {
        return getContinueOnError();
    }

    public static  com.mongodb.WriteConcern.Majority majorityWriteConcern( int wtimeout, boolean fsync, boolean j )
    {
        return new com.mongodb.WriteConcern.Majority( wtimeout, fsync, j );
    }

    java.lang.Object _w;

    final int _wtimeout;

    final boolean _fsync;

    final boolean _j;

    final boolean _continueOnError;

    public static class Majority extends com.mongodb.WriteConcern
    {

        private static final long serialVersionUID = -4128295115883875212L;

        public Majority()
        {
            super( "majority", 0, false, false );
        }

        public Majority( int wtimeout, boolean fsync, boolean j )
        {
            super( "majority", wtimeout, fsync, j );
        }

        public  java.lang.String toString()
        {
            return "[Majority] WriteConcern " + getCommand();
        }

    }

}
