// This is a mutant program.
// Author : ysma

package com.mongodb.gridfs;


import com.mongodb.DBObject;
import com.mongodb.Mongo;
import com.mongodb.MongoClient;
import com.mongodb.MongoClientURI;
import com.mongodb.ReadPreference;
import com.mongodb.util.Util;
import java.io.File;
import java.security.DigestInputStream;
import java.security.MessageDigest;


public class CLI
{

    private static  void printUsage()
    {
        System.out.println( "Usage : [--db database] action" );
        System.out.println( "  where  action is one of:" );
        System.out.println( "      list                      : lists all files in the store" );
        System.out.println( "      put filename              : puts the file filename into the store" );
        System.out.println( "      get filename1 filename2   : gets filename1 from store and sends to filename2" );
        System.out.println( "      md5 filename              : does an md5 hash on a file in the db (for testing)" );
    }

    private static java.lang.String db = "test";

    private static java.lang.String uri = "mongodb://127.0.0.1";

    private static com.mongodb.Mongo _mongo = null;

    private static  com.mongodb.Mongo getMongo()
        throws java.lang.Exception
    {
        if (_mongo == null) {
            _mongo = new com.mongodb.MongoClient( new com.mongodb.MongoClientURI( uri ) );
        }
        return _mongo;
    }

    private static com.mongodb.gridfs.GridFS _gridfs;

    private static  com.mongodb.gridfs.GridFS getGridFS()
        throws java.lang.Exception
    {
        if (_gridfs == null) {
            _gridfs = new com.mongodb.gridfs.GridFS( getMongo().getDB( db ) );
        }
        return _gridfs;
    }

    public static  void main( java.lang.String[] args )
        throws java.lang.Exception
    {
        if (args.length < 1) {
            printUsage();
            return;
        }
        for (int i = 0; i < args.length; i++) {
            java.lang.String s = args[i];
            if (s.equals( "--db" )) {
                db = args[i + 1];
                i++;
                continue;
            }
            if (s.equals( "--host" )) {
                uri = "mongodb://" + args[i + 1];
                i++;
                continue;
            }
            if (s.equals( "--uri" )) {
                uri = args[i + 1];
                i++;
                continue;
            }
            if (s.equals( "help" )) {
                printUsage();
                return;
            }
            if (s.equals( "list" )) {
                com.mongodb.gridfs.GridFS fs = getGridFS();
                System.out.printf( "%-60s %-10s\n", "Filename", "Length" );
                for (com.mongodb.DBObject o: fs.getFileList()) {
                    System.out.printf( "%-60s %-10d\n", o.get( "filename" ), ((java.lang.Number) o.get( "length" )).longValue() );
                }
                return;
            }
            if (s.equals( "get" )) {
                com.mongodb.gridfs.GridFS fs = getGridFS();
                java.lang.String fn = args[i + 1];
                com.mongodb.gridfs.GridFSDBFile f = fs.findOne( fn );
                if (f == null) {
                    System.err.println( "can't find file: " + fn );
                    return;
                }
                f.writeTo( f.getFilename() );
                return;
            }
            if (s.equals( "put" )) {
                com.mongodb.gridfs.GridFS fs = getGridFS();
                java.lang.String fn = args[i + 1];
                com.mongodb.gridfs.GridFSInputFile f = fs.createFile( new java.io.File( fn ) );
                f.save();
                f.validate();
                return;
            }
            if (s.equals( "md5" )) {
                com.mongodb.gridfs.GridFS fs = getGridFS();
                java.lang.String fn = args[i + 1];
                com.mongodb.gridfs.GridFSDBFile f = fs.findOne( fn );
                if (f == null) {
                    System.err.println( "can't find file: " + fn );
                    return;
                }
                java.security.MessageDigest md5 = MessageDigest.getInstance( "MD5" );
                md5.reset();
                java.security.DigestInputStream is = new java.security.DigestInputStream( f.getInputStream(), md5 );
                int read = 0;
                while (is.read() >= 0) {
                    read++;
                    int r = is.read( new byte[17] );
                    if (r < 0) {
                        break;
                    }
                    read += r;
                }
                byte[] digest = md5.digest();
                System.out.println( "length: " + read + " md5: " + Util.toHex( digest ) );
                return;
            }
            System.err.println( "unknown option: " + s );
            return;
        }
    }

}
