// This is a mutant program.
// Author : ysma

package com.mongodb.gridfs;


import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import com.mongodb.BasicDBObject;
import com.mongodb.BasicDBObjectBuilder;
import com.mongodb.DBObject;
import com.mongodb.MongoException;


public class GridFSDBFile extends com.mongodb.gridfs.GridFSFile
{

    public  java.io.InputStream getInputStream()
    {
        return new com.mongodb.gridfs.GridFSDBFile.MyInputStream();
    }

    public  long writeTo( java.lang.String filename )
        throws java.io.IOException
    {
        return writeTo( new java.io.File( filename ) );
    }

    public  long writeTo( java.io.File f )
        throws java.io.IOException
    {
        java.io.FileOutputStream out = null;
        try {
            out = new java.io.FileOutputStream( f );
            return writeTo( out );
        } finally 
{
            if (out != null) {
                out.close();
            }
        }
    }

    public  long writeTo( java.io.OutputStream out )
        throws java.io.IOException
    {
        final int nc = numChunks();
        for (int i = 0; i < nc; i++) {
            out.write( getChunk( i ) );
        }
        return _length;
    }

     byte[] getChunk( int i )
    {
        if (_fs == null) {
            throw new java.lang.RuntimeException( "no gridfs!" );
        }
        com.mongodb.DBObject chunk = _fs._chunkCollection.findOne( BasicDBObjectBuilder.start( "files_id", _id ).add( "n", i ).get() );
        if (chunk == null) {
            throw new com.mongodb.MongoException( "can't find a chunk!  file id: " + _id + " chunk: " + i );
        }
        return (byte[]) chunk.get( "data" );
    }

    class MyInputStream extends java.io.InputStream
    {

        MyInputStream()
        {
            _numChunks = numChunks();
        }

        public  int available()
        {
            if (_data == null) {
                return 0;
            }
            return _data.length - _offset;
        }

        public  void close()
        {
        }

        public  void mark( int readlimit )
        {
            throw new java.lang.RuntimeException( "mark not supported" );
        }

        public  void reset()
        {
            throw new java.lang.RuntimeException( "mark not supported" );
        }

        public  boolean markSupported()
        {
            return false;
        }

        public  int read()
        {
            byte[] b = new byte[1];
            int res = read( b );
            if (res < 0) {
                return -1;
            }
            return b[0] & 0xFF;
        }

        public  int read( byte[] b )
        {
            return read( b, 0, b.length );
        }

        public  int read( byte[] b, int off, int len )
        {
            if (_data == null || _offset >= _data.length) {
                if (_currentChunkIdx + 1 >= _numChunks) {
                    return -1;
                }
                _data = getChunk( ++_currentChunkIdx );
                _offset = 0;
            }
            int r = Math.min( len, _data.length - _offset );
            System.arraycopy( _data, _offset, b, off, r );
            _offset += r;
            return r;
        }

        public  long skip( long numBytesToSkip )
                throws java.io.IOException
        {
            if (numBytesToSkip <= 0) {
                return 0;
            }
            if (_currentChunkIdx == _numChunks) {
                return 0;
            }
            long offsetInFile = 0;
            if (_currentChunkIdx >= 0) {
                offsetInFile = _currentChunkIdx * _chunkSize + _offset;
            }
            if (numBytesToSkip + offsetInFile >= _length) {
                _currentChunkIdx = _numChunks;
                _data = null;
                return _length - offsetInFile;
            }
            int temp = _currentChunkIdx;
            _currentChunkIdx = (int) ((numBytesToSkip + offsetInFile) / _chunkSize);
            if (temp != _currentChunkIdx) {
                _data = getChunk( _currentChunkIdx );
            }
            _offset = (int) ((numBytesToSkip + offsetInFile) % _chunkSize);
            return numBytesToSkip;
        }

        final int _numChunks;

        int _currentChunkIdx = -1;

        int _offset = 0;

        byte[] _data = null;

    }

     void remove()
    {
        _fs._filesCollection.remove( new com.mongodb.BasicDBObject( "_id", _id ) );
        _fs._chunkCollection.remove( new com.mongodb.BasicDBObject( "files_id", _id ) );
    }

}
