// This is a mutant program.
// Author : ysma

package com.mongodb.tools;


import javax.management.AttributeNotFoundException;
import javax.management.InstanceNotFoundException;
import javax.management.JMException;
import javax.management.MBeanException;
import javax.management.MBeanServerConnection;
import javax.management.ObjectName;
import javax.management.ReflectionException;
import javax.management.openmbean.CompositeData;
import javax.management.remote.JMXConnector;
import javax.management.remote.JMXConnectorFactory;
import javax.management.remote.JMXServiceURL;
import java.io.CharArrayWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.lang.management.ManagementFactory;
import java.util.Set;


public class ConnectionPoolStat
{

    public ConnectionPoolStat( javax.management.MBeanServerConnection mBeanConnection )
    {
        this.mBeanConnection = mBeanConnection;
    }

    public ConnectionPoolStat()
    {
        this.mBeanConnection = ManagementFactory.getPlatformMBeanServer();
    }

    public  java.lang.String getStats()
        throws javax.management.JMException, java.io.IOException
    {
        java.io.CharArrayWriter charArrayWriter = new java.io.CharArrayWriter();
        java.io.PrintWriter printWriter = new java.io.PrintWriter( charArrayWriter );
        print( printWriter );
        return charArrayWriter.toString();
    }

    public static  void main( java.lang.String[] args )
        throws java.lang.Exception
    {
        java.lang.String host = "localhost";
        int port = -1;
        long rowCount = 0;
        int sleepTime = 1000;
        int pos = 0;
        for (; pos < args.length; pos++) {
            if (args[pos].equals( "--help" )) {
                printUsage();
                System.exit( 0 );
            } else {
                if (args[pos].equals( "--host" ) || args[pos].equals( "-h" )) {
                    host = args[++pos];
                } else {
                    if (args[pos].equals( "--port" )) {
                        port = getIntegerArg( args[++pos], "--port" );
                    } else {
                        if (args[pos].equals( "--rowcount" ) || args[pos].equals( "-n" )) {
                            rowCount = getIntegerArg( args[++pos], "--rowCount" );
                        } else {
                            if (args[pos].startsWith( "-" )) {
                                printErrorAndUsageAndExit( "unknown option " + args[pos] );
                            } else {
                                sleepTime = getIntegerArg( args[pos++], "sleep time" ) * 1000;
                                break;
                            }
                        }
                    }
                }
            }
        }
        if (pos != args.length) {
            printErrorAndUsageAndExit( "too many positional options" );
        }
        if (port == -1 && !host.contains( ":" )) {
            printErrorAndUsageAndExit( "port is required" );
        }
        java.lang.String hostAndPort = port != -1 ? host + ":" + port : host;
        if (rowCount == 0) {
            rowCount = Long.MAX_VALUE;
        }
        javax.management.remote.JMXServiceURL u = new javax.management.remote.JMXServiceURL( "service:jmx:rmi:///jndi/rmi://" + hostAndPort + "/jmxrmi" );
        javax.management.remote.JMXConnector connector = JMXConnectorFactory.connect( u );
        javax.management.MBeanServerConnection mBeanConnection = connector.getMBeanServerConnection();
        try {
            com.mongodb.tools.ConnectionPoolStat printer = new com.mongodb.tools.ConnectionPoolStat( mBeanConnection );
            for (int i = 0; i < rowCount; i++) {
                System.out.println( printer.getStats() );
                if (i != rowCount - 1) {
                    Thread.sleep( sleepTime );
                }
            }
        } finally 
{
            connector.close();
        }
    }

    private static  int getIntegerArg( java.lang.String arg, java.lang.String argName )
    {
        try {
            return Integer.parseInt( arg );
        } catch ( java.lang.NumberFormatException e ) {
            printErrorAndUsageAndExit( argName + " arg must be an integer" );
        }
        throw new java.lang.IllegalStateException();
    }

    private static  void printErrorAndUsageAndExit( final java.lang.String error )
    {
        System.err.println( "ERROR: " + error );
        System.out.println();
        printUsage();
        System.exit( 1 );
    }

    private static  void printUsage()
    {
        System.out.println( "View live MongoDB connection pool statistics from a remote JMX server." );
        System.out.println();
        System.out.println( "usage: java com.mongodb.tools.ConnectionPoolStat [options] [sleep time" );
        System.out.println( "sleep time: time to wait (in seconds) between calls. Defaults to 1" );
        System.out.println( "options:" );
        System.out.println( "  --help                 produce help message" );
        System.out.println( "  --port arg             JMX remote port. Required. Can also use --host hostname:port" );
        System.out.println( "  -h [ --host ] arg      JMX remote host. Defaults to localhost" );
        System.out.println( "  -n [ --rowcount ] arg  number of times to print stats (0 for indefinite)" );
        System.out.println();
        System.out.println( "Fields" );
        System.out.println( "  objectName                     - name of the JMX bean for this connection pool" );
        System.out.println( "  host                           - host of the mongod/mongos server" );
        System.out.println( "  port                           - port of the mongod/mongos server" );
        System.out.println( "  maxSize                        - max # of connections allowed" );
        System.out.println( "  total                          - # of connections allocated" );
        System.out.println( "  inUse                          - # of connections in use" );
        System.out.println( "  inUseConnections               - list of all in use connections" );
        System.out.println( "  inUseConnections.namespace     - namespace on which connection is operating" );
        System.out.println( "  inUseConnections.opCode        - operation connection is executing" );
        System.out.println( "  inUseConnections.query         - query the connection is executing (for query/update/remove)" );
        System.out.println( "  inUseConnections.numDocuments  - # of documents in the message (mostly relevant for batch inserts)" );
        System.out.println( "  inUseConnections.threadName    - name of thread on which connection is executing" );
        System.out.println( "  inUseConnections.durationMS    - duration that the operation has been executing so far" );
        System.out.println( "  inUseConnections.localPort     - local port of the connection" );
    }

    private  void print( java.io.PrintWriter pw )
        throws javax.management.JMException, java.io.IOException
    {
        java.util.Set<ObjectName> beanSet = mBeanConnection.queryNames( new javax.management.ObjectName( "com.mongodb:type=ConnectionPool,*" ), null );
        pw.println( "{ pools : [" );
        int i = 0;
        for (javax.management.ObjectName objectName: beanSet) {
            pw.print( "   { " );
            printAttribute( "ObjectName", objectName.toString(), pw );
            pw.println();
            pw.print( "     " );
            printAttribute( "Host", objectName, pw );
            printAttribute( "Port", objectName, pw );
            printAttribute( "MaxSize", objectName, pw );
            printStatistics( pw, objectName );
            pw.println( "   }" + (i == beanSet.size() - 1 ? "" : ",") );
            i++;
        }
        pw.println( "  ]" );
        pw.println( "}" );
    }

    private  void printStatistics( final java.io.PrintWriter pw, final javax.management.ObjectName objectName )
        throws javax.management.InstanceNotFoundException, java.io.IOException, javax.management.ReflectionException, javax.management.AttributeNotFoundException, javax.management.MBeanException
    {
        java.lang.String key = "Statistics";
        javax.management.openmbean.CompositeData statistics = (javax.management.openmbean.CompositeData) mBeanConnection.getAttribute( objectName, key );
        printSimpleStatistics( pw, statistics );
        printInUseConnections( statistics, pw );
    }

    private  void printSimpleStatistics( final java.io.PrintWriter pw, final javax.management.openmbean.CompositeData statistics )
        throws javax.management.InstanceNotFoundException, java.io.IOException, javax.management.ReflectionException, javax.management.AttributeNotFoundException, javax.management.MBeanException
    {
        printCompositeDataAttribute( "total", statistics, pw );
        printCompositeDataAttribute( "inUse", statistics, pw );
        pw.println();
    }

    private  void printInUseConnections( final javax.management.openmbean.CompositeData statistics, final java.io.PrintWriter pw )
        throws javax.management.InstanceNotFoundException, java.io.IOException, javax.management.ReflectionException, javax.management.AttributeNotFoundException, javax.management.MBeanException
    {
        java.lang.String key = "inUseConnections";
        javax.management.openmbean.CompositeData[] compositeDataArray = (javax.management.openmbean.CompositeData[]) statistics.get( key );
        pw.println( "     " + getKeyString( key ) + ": [" );
        for (int i = 0; i < compositeDataArray.length; i++) {
            javax.management.openmbean.CompositeData compositeData = compositeDataArray[i];
            pw.print( "      { " );
            printCompositeDataAttribute( "namespace", compositeData, pw );
            printCompositeDataAttribute( "opCode", compositeData, pw );
            printCompositeDataAttribute( "query", compositeData, pw, StringType.JSON );
            printCompositeDataAttribute( "numDocuments", compositeData, pw );
            printCompositeDataAttribute( "threadName", compositeData, pw );
            printCompositeDataAttribute( "durationMS", compositeData, pw );
            printCompositeDataAttribute( "localPort", compositeData, pw, Position.LAST );
            pw.println( " }" + (i == compositeDataArray.length - 1 ? "" : ", ") );
        }
        pw.println( "     ]" );
    }

    private  void printCompositeDataAttribute( java.lang.String key, final javax.management.openmbean.CompositeData compositeData, final java.io.PrintWriter pw )
    {
        printCompositeDataAttribute( key, compositeData, pw, Position.REGULAR );
    }

    private  void printCompositeDataAttribute( java.lang.String key, final javax.management.openmbean.CompositeData compositeData, final java.io.PrintWriter pw, com.mongodb.tools.ConnectionPoolStat.Position position )
    {
        printCompositeDataAttribute( key, compositeData, pw, position, StringType.REGULAR );
    }

    private  void printCompositeDataAttribute( final java.lang.String key, final javax.management.openmbean.CompositeData compositeData, final java.io.PrintWriter pw, final com.mongodb.tools.ConnectionPoolStat.StringType stringType )
    {
        printCompositeDataAttribute( key, compositeData, pw, Position.REGULAR, stringType );
    }

    private  void printCompositeDataAttribute( java.lang.String key, final javax.management.openmbean.CompositeData compositeData, final java.io.PrintWriter pw, com.mongodb.tools.ConnectionPoolStat.Position position, com.mongodb.tools.ConnectionPoolStat.StringType stringType )
    {
        printAttribute( key, compositeData.get( key ), pw, position, stringType );
    }

    private  void printAttribute( final java.lang.String key, final javax.management.ObjectName objectName, final java.io.PrintWriter pw )
        throws javax.management.InstanceNotFoundException, java.io.IOException, javax.management.ReflectionException, javax.management.AttributeNotFoundException, javax.management.MBeanException
    {
        printAttribute( key, mBeanConnection.getAttribute( objectName, key ), pw );
    }

    private  void printAttribute( final java.lang.String key, final java.lang.Object value, final java.io.PrintWriter pw )
    {
        printAttribute( key, value, pw, Position.REGULAR, StringType.REGULAR );
    }

    private  void printAttribute( final java.lang.String key, final java.lang.Object value, final java.io.PrintWriter pw, com.mongodb.tools.ConnectionPoolStat.Position position, com.mongodb.tools.ConnectionPoolStat.StringType stringType )
    {
        if (value != null) {
            pw.print( getKeyString( key ) + ": " + getValueString( value, stringType ) + (position == Position.LAST ? "" : ", ") );
        }
    }

    private  java.lang.String getKeyString( final java.lang.String key )
    {
        return Character.toLowerCase( key.charAt( 0 ) ) + key.substring( 1 );
    }

    private  java.lang.String getValueString( final java.lang.Object value, final com.mongodb.tools.ConnectionPoolStat.StringType stringType )
    {
        if (value instanceof java.lang.String && stringType == StringType.REGULAR) {
            return "" + "'" + value + "'";
        }
        return value.toString();
    }

    enum StringType 
    {
        REGULAR,
        JSON;

    }

    enum Position 
    {
        REGULAR,
        LAST;

    }

    private final javax.management.MBeanServerConnection mBeanConnection;

}
