// This is a mutant program.
// Author : ysma

package com.mongodb.util;


import com.mongodb.BasicDBObject;
import com.mongodb.Bytes;
import com.mongodb.DBObject;
import com.mongodb.DBRefBase;
import org.bson.types.*;
import java.lang.reflect.Array;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.Map.Entry;
import java.util.regex.Pattern;


public class JSONSerializers
{

    private JSONSerializers()
    {
    }

    public static  com.mongodb.util.ObjectSerializer getLegacy()
    {
        com.mongodb.util.ClassMapBasedObjectSerializer serializer = addCommonSerializers();
        serializer.addObjectSerializer( java.util.Date.class, new com.mongodb.util.JSONSerializers.LegacyDateSerializer( serializer ) );
        serializer.addObjectSerializer( org.bson.types.BSONTimestamp.class, new com.mongodb.util.JSONSerializers.LegacyBSONTimestampSerializer( serializer ) );
        serializer.addObjectSerializer( org.bson.types.Binary.class, new com.mongodb.util.JSONSerializers.LegacyBinarySerializer() );
        serializer.addObjectSerializer( byte[].class, new com.mongodb.util.JSONSerializers.LegacyBinarySerializer() );
        return serializer;
    }

    public static  com.mongodb.util.ObjectSerializer getStrict()
    {
        com.mongodb.util.ClassMapBasedObjectSerializer serializer = addCommonSerializers();
        serializer.addObjectSerializer( java.util.Date.class, new com.mongodb.util.JSONSerializers.DateSerializer( serializer ) );
        serializer.addObjectSerializer( org.bson.types.BSONTimestamp.class, new com.mongodb.util.JSONSerializers.BSONTimestampSerializer( serializer ) );
        serializer.addObjectSerializer( org.bson.types.Binary.class, new com.mongodb.util.JSONSerializers.BinarySerializer( serializer ) );
        serializer.addObjectSerializer( byte[].class, new com.mongodb.util.JSONSerializers.ByteArraySerializer( serializer ) );
        return serializer;
    }

    static  com.mongodb.util.ClassMapBasedObjectSerializer addCommonSerializers()
    {
        com.mongodb.util.ClassMapBasedObjectSerializer serializer = new com.mongodb.util.ClassMapBasedObjectSerializer();
        serializer.addObjectSerializer( java.lang.Object[].class, new com.mongodb.util.JSONSerializers.ObjectArraySerializer( serializer ) );
        serializer.addObjectSerializer( java.lang.Boolean.class, new com.mongodb.util.JSONSerializers.ToStringSerializer() );
        serializer.addObjectSerializer( org.bson.types.Code.class, new com.mongodb.util.JSONSerializers.CodeSerializer( serializer ) );
        serializer.addObjectSerializer( org.bson.types.CodeWScope.class, new com.mongodb.util.JSONSerializers.CodeWScopeSerializer( serializer ) );
        serializer.addObjectSerializer( com.mongodb.DBObject.class, new com.mongodb.util.JSONSerializers.DBObjectSerializer( serializer ) );
        serializer.addObjectSerializer( com.mongodb.DBRefBase.class, new com.mongodb.util.JSONSerializers.DBRefBaseSerializer( serializer ) );
        serializer.addObjectSerializer( java.lang.Iterable.class, new com.mongodb.util.JSONSerializers.IterableSerializer( serializer ) );
        serializer.addObjectSerializer( java.util.Map.class, new com.mongodb.util.JSONSerializers.MapSerializer( serializer ) );
        serializer.addObjectSerializer( org.bson.types.MaxKey.class, new com.mongodb.util.JSONSerializers.MaxKeySerializer( serializer ) );
        serializer.addObjectSerializer( org.bson.types.MinKey.class, new com.mongodb.util.JSONSerializers.MinKeySerializer( serializer ) );
        serializer.addObjectSerializer( java.lang.Number.class, new com.mongodb.util.JSONSerializers.ToStringSerializer() );
        serializer.addObjectSerializer( org.bson.types.ObjectId.class, new com.mongodb.util.JSONSerializers.ObjectIdSerializer( serializer ) );
        serializer.addObjectSerializer( java.util.regex.Pattern.class, new com.mongodb.util.JSONSerializers.PatternSerializer( serializer ) );
        serializer.addObjectSerializer( java.lang.String.class, new com.mongodb.util.JSONSerializers.StringSerializer() );
        serializer.addObjectSerializer( java.util.UUID.class, new com.mongodb.util.JSONSerializers.UUIDSerializer( serializer ) );
        return serializer;
    }

    private abstract static class CompoundObjectSerializer extends com.mongodb.util.AbstractObjectSerializer
    {

        protected final com.mongodb.util.ObjectSerializer serializer;

        CompoundObjectSerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            this.serializer = serializer;
        }

    }

    private static class LegacyBinarySerializer extends com.mongodb.util.AbstractObjectSerializer
    {

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            buf.append( "<Binary Data>" );
        }

    }

    private static class ObjectArraySerializer extends com.mongodb.util.JSONSerializers.CompoundObjectSerializer
    {

        ObjectArraySerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            buf.append( "[ " );
            for (int i = 0; i < Array.getLength( obj ); i++) {
                if (i > 0) {
                    buf.append( " , " );
                }
                serializer.serialize( Array.get( obj, i ), buf );
            }
            buf.append( "]" );
        }

    }

    private static class ToStringSerializer extends com.mongodb.util.AbstractObjectSerializer
    {

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            buf.append( obj.toString() );
        }

    }

    private static class LegacyBSONTimestampSerializer extends com.mongodb.util.JSONSerializers.CompoundObjectSerializer
    {

        LegacyBSONTimestampSerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            org.bson.types.BSONTimestamp t = (org.bson.types.BSONTimestamp) obj;
            com.mongodb.BasicDBObject temp = new com.mongodb.BasicDBObject();
            temp.put( "$ts", Integer.valueOf( t.getTime() ) );
            temp.put( "$inc", Integer.valueOf( t.getInc() ) );
            serializer.serialize( temp, buf );
        }

    }

    private static class CodeSerializer extends com.mongodb.util.JSONSerializers.CompoundObjectSerializer
    {

        CodeSerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            org.bson.types.Code c = (org.bson.types.Code) obj;
            com.mongodb.BasicDBObject temp = new com.mongodb.BasicDBObject();
            temp.put( "$code", c.getCode() );
            serializer.serialize( temp, buf );
        }

    }

    private static class CodeWScopeSerializer extends com.mongodb.util.JSONSerializers.CompoundObjectSerializer
    {

        CodeWScopeSerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            org.bson.types.CodeWScope c = (org.bson.types.CodeWScope) obj;
            com.mongodb.BasicDBObject temp = new com.mongodb.BasicDBObject();
            temp.put( "$code", c.getCode() );
            temp.put( "$scope", c.getScope() );
            serializer.serialize( temp, buf );
        }

    }

    private static class LegacyDateSerializer extends com.mongodb.util.JSONSerializers.CompoundObjectSerializer
    {

        LegacyDateSerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            java.util.Date d = (java.util.Date) obj;
            java.text.SimpleDateFormat format = new java.text.SimpleDateFormat( "yyyy-MM-dd'T'HH:mm:ss.SSS'Z'" );
            format.setCalendar( new java.util.GregorianCalendar( new java.util.SimpleTimeZone( 0, "GMT" ) ) );
            serializer.serialize( new com.mongodb.BasicDBObject( "$date", format.format( d ) ), buf );
        }

    }

    private static class DBObjectSerializer extends com.mongodb.util.JSONSerializers.CompoundObjectSerializer
    {

        DBObjectSerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            boolean first = true;
            buf.append( "{ " );
            com.mongodb.DBObject dbo = (com.mongodb.DBObject) obj;
            java.lang.String name;
            for (final java.lang.String s: dbo.keySet()) {
                name = s;
                if (first) {
                    first = false;
                } else {
                    buf.append( " , " );
                }
                JSON.string( buf, name );
                buf.append( " : " );
                serializer.serialize( dbo.get( name ), buf );
            }
            buf.append( "}" );
        }

    }

    private static class DBRefBaseSerializer extends com.mongodb.util.JSONSerializers.CompoundObjectSerializer
    {

        DBRefBaseSerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            com.mongodb.DBRefBase ref = (com.mongodb.DBRefBase) obj;
            com.mongodb.BasicDBObject temp = new com.mongodb.BasicDBObject();
            temp.put( "$ref", ref.getRef() );
            temp.put( "$id", ref.getId() );
            serializer.serialize( temp, buf );
        }

    }

    private static class IterableSerializer extends com.mongodb.util.JSONSerializers.CompoundObjectSerializer
    {

        IterableSerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            boolean first = true;
            buf.append( "[ " );
            for (final java.lang.Object o: (java.lang.Iterable) obj) {
                if (first) {
                    first = false;
                } else {
                    buf.append( " , " );
                }
                serializer.serialize( o, buf );
            }
            buf.append( "]" );
        }

    }

    private static class MapSerializer extends com.mongodb.util.JSONSerializers.CompoundObjectSerializer
    {

        MapSerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            boolean first = true;
            buf.append( "{ " );
            java.util.Map m = (java.util.Map) obj;
            java.util.Map.Entry entry;
            for (final java.lang.Object o: m.entrySet()) {
                entry = (java.util.Map.Entry) o;
                if (first) {
                    first = false;
                } else {
                    buf.append( " , " );
                }
                JSON.string( buf, entry.getKey().toString() );
                buf.append( " : " );
                serializer.serialize( entry.getValue(), buf );
            }
            buf.append( "}" );
        }

    }

    private static class MaxKeySerializer extends com.mongodb.util.JSONSerializers.CompoundObjectSerializer
    {

        MaxKeySerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            serializer.serialize( new com.mongodb.BasicDBObject( "$maxKey", 1 ), buf );
        }

    }

    private static class MinKeySerializer extends com.mongodb.util.JSONSerializers.CompoundObjectSerializer
    {

        MinKeySerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            serializer.serialize( new com.mongodb.BasicDBObject( "$minKey", 1 ), buf );
        }

    }

    private static class ObjectIdSerializer extends com.mongodb.util.JSONSerializers.CompoundObjectSerializer
    {

        ObjectIdSerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            serializer.serialize( new com.mongodb.BasicDBObject( "$oid", obj.toString() ), buf );
        }

    }

    private static class PatternSerializer extends com.mongodb.util.JSONSerializers.CompoundObjectSerializer
    {

        PatternSerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            com.mongodb.DBObject externalForm = new com.mongodb.BasicDBObject();
            externalForm.put( "$regex", obj.toString() );
            if (((java.util.regex.Pattern) obj).flags() != 0) {
                externalForm.put( "$options", Bytes.regexFlags( ((java.util.regex.Pattern) obj).flags() ) );
            }
            serializer.serialize( externalForm, buf );
        }

    }

    private static class StringSerializer extends com.mongodb.util.AbstractObjectSerializer
    {

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            JSON.string( buf, (java.lang.String) obj );
        }

    }

    private static class UUIDSerializer extends com.mongodb.util.JSONSerializers.CompoundObjectSerializer
    {

        UUIDSerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            java.util.UUID uuid = (java.util.UUID) obj;
            com.mongodb.BasicDBObject temp = new com.mongodb.BasicDBObject();
            temp.put( "$uuid", uuid.toString() );
            serializer.serialize( temp, buf );
        }

    }

    private static class BSONTimestampSerializer extends com.mongodb.util.JSONSerializers.CompoundObjectSerializer
    {

        BSONTimestampSerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            org.bson.types.BSONTimestamp t = (org.bson.types.BSONTimestamp) obj;
            com.mongodb.BasicDBObject temp = new com.mongodb.BasicDBObject();
            temp.put( "t", Integer.valueOf( t.getTime() ) );
            temp.put( "i", Integer.valueOf( t.getInc() ) );
            com.mongodb.BasicDBObject timestampObj = new com.mongodb.BasicDBObject();
            timestampObj.put( "$timestamp", temp );
            serializer.serialize( timestampObj, buf );
        }

    }

    private static class DateSerializer extends com.mongodb.util.JSONSerializers.CompoundObjectSerializer
    {

        DateSerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            java.util.Date d = (java.util.Date) obj;
            serializer.serialize( new com.mongodb.BasicDBObject( "$date", d.getTime() ), buf );
        }

    }

    private abstract static class BinarySerializerBase extends com.mongodb.util.JSONSerializers.CompoundObjectSerializer
    {

        BinarySerializerBase( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        protected  void serialize( byte[] bytes, byte type, java.lang.StringBuilder buf )
        {
            com.mongodb.DBObject temp = new com.mongodb.BasicDBObject();
            temp.put( "$binary", (new com.mongodb.util.Base64Codec()).encode( bytes ) );
            temp.put( "$type", type );
            serializer.serialize( temp, buf );
        }

    }

    private static class BinarySerializer extends com.mongodb.util.JSONSerializers.BinarySerializerBase
    {

        BinarySerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            org.bson.types.Binary bin = (org.bson.types.Binary) obj;
            serialize( bin.getData(), bin.getType(), buf );
        }

    }

    private static class ByteArraySerializer extends com.mongodb.util.JSONSerializers.BinarySerializerBase
    {

        ByteArraySerializer( com.mongodb.util.ObjectSerializer serializer )
        {
            super( serializer );
        }

        public  void serialize( java.lang.Object obj, java.lang.StringBuilder buf )
        {
            serialize( (byte[]) obj, (byte) 0, buf );
        }

    }

}
