package com.mongodb;


import com.mongodb.ClusterDescription;
import com.mongodb.util.TestCase;
import com.mongodb.ClusterConnectionMode;
import com.mongodb.ServerConnectionState;
import com.mongodb.ServerDescription;
import com.mongodb.ServerType;
import com.mongodb.ClusterType;
import java.util.List;
import java.lang.String;
import com.mongodb.ReadPreference;
import com.mongodb.ServerAddress;
import org.testng.annotations.Test;
import com.mongodb.ServerDescription.Builder;
import static com.mongodb.ClusterConnectionMode.Multiple;
import static com.mongodb.ClusterType.ReplicaSet;
import static com.mongodb.ServerConnectionState.Connected;
import static java.util.Arrays.asList;
import static org.testng.Assert.assertEquals;

public class ReadPreferenceServerSelectorGenTest extends TestCase{
	/**
	 * Test method for the class com.mongodb.ReadPreferenceServerSelector
	 */
	@Test
	public void testReadPreferenceServerSelector650() throws Exception {
		ReadPreferenceServerSelector var868 = new ReadPreferenceServerSelector(
				ReadPreference.primary());
		var868.getReadPreference();
		var868.toString();
		ServerDescription var870 = ServerDescription.builder().state(Connected)
				.address(new ServerAddress("localhost:27018")).ok(true)
				.type(ServerType.ReplicaSetSecondary).build();
		ServerDescription var871 = ServerDescription.builder().state(Connected)
				.address(new ServerAddress()).ok(true)
				.type(ServerType.ReplicaSetPrimary).build();
		var868.choose(new ClusterDescription(Multiple, ReplicaSet, asList(
				var870, var871)));
		var868.getReadPreference();
		var868.toString();
		var868.choose(new ClusterDescription(Multiple, ReplicaSet, asList(
				var870, var871)));
	}

	/**
	 * Test method for the class com.mongodb.ReadPreferenceServerSelector
	 */
	@Test
	public void testReadPreferenceServerSelector651() throws Exception {
		ReadPreferenceServerSelector var868 = new ReadPreferenceServerSelector(
				ReadPreference.primary());
		var868.getReadPreference();
		var868.toString();
		ServerDescription var870 = ServerDescription.builder().state(Connected)
				.address(new ServerAddress("localhost:27018")).ok(true)
				.type(ServerType.ReplicaSetSecondary).build();
		ServerDescription var871 = ServerDescription.builder().state(Connected)
				.address(new ServerAddress()).ok(true)
				.type(ServerType.ReplicaSetPrimary).build();
		var868.choose(new ClusterDescription(Multiple, ReplicaSet, asList(
				var870, var871)));
		var868.getReadPreference();
		var868.toString();
		var868.choose(new ClusterDescription(Multiple, ReplicaSet, asList(
				var870, var871)));
	}

	/**
	 * Test method for the class com.mongodb.ReadPreferenceServerSelector
	 */
	@Test
	public void testReadPreferenceServerSelector652() throws Exception {
		ReadPreferenceServerSelector var868 = new ReadPreferenceServerSelector(
				ReadPreference.primary());
		var868.getReadPreference();
		var868.toString();
		ServerDescription var870 = ServerDescription.builder().state(Connected)
				.address(new ServerAddress("localhost:27018")).ok(true)
				.type(ServerType.ReplicaSetSecondary).build();
		ServerDescription var871 = ServerDescription.builder().state(Connected)
				.address(new ServerAddress()).ok(true)
				.type(ServerType.ReplicaSetPrimary).build();
		var868.choose(new ClusterDescription(Multiple, ReplicaSet, asList(
				var870, var871)));
		var868.getReadPreference();
		var868.toString();
		var868.choose(new ClusterDescription(Multiple, ReplicaSet, asList(
				var870, var871)));
	}

	/**
	 * Test method for the class com.mongodb.ReadPreferenceServerSelector
	 */
	@Test
	public void testReadPreferenceServerSelector653() throws Exception {
		ReadPreferenceServerSelector var868 = new ReadPreferenceServerSelector(
				ReadPreference.primary());
		var868.getReadPreference();
		var868.toString();
		ServerDescription var870 = ServerDescription.builder().state(Connected)
				.address(new ServerAddress("localhost:27018")).ok(true)
				.type(ServerType.ReplicaSetSecondary).build();
		ServerDescription var871 = ServerDescription.builder().state(Connected)
				.address(new ServerAddress()).ok(true)
				.type(ServerType.ReplicaSetPrimary).build();
		var868.choose(new ClusterDescription(Multiple, ReplicaSet, asList(
				var870, var871)));
		var868.getReadPreference();
		var868.toString();
		var868.choose(new ClusterDescription(Multiple, ReplicaSet, asList(
				var870, var871)));
	}

	/**
	 * Test method for the class com.mongodb.ReadPreferenceServerSelector
	 */
	@Test
	public void testReadPreferenceServerSelector654() throws Exception {
		ReadPreferenceServerSelector var868 = new ReadPreferenceServerSelector(
				ReadPreference.primary());
		var868.getReadPreference();
		var868.toString();
		ServerDescription var870 = ServerDescription.builder().state(Connected)
				.address(new ServerAddress("localhost:27018")).ok(true)
				.type(ServerType.ReplicaSetSecondary).build();
		ServerDescription var871 = ServerDescription.builder().state(Connected)
				.address(new ServerAddress()).ok(true)
				.type(ServerType.ReplicaSetPrimary).build();
		var868.choose(new ClusterDescription(Multiple, ReplicaSet, asList(
				var870, var871)));
		var868.getReadPreference();
		var868.toString();
		var868.choose(new ClusterDescription(Multiple, ReplicaSet, asList(
				var870, var871)));
	}
}